<?php

namespace Losc\CucmBundle\Model\Webservice\EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for XPhoneServiceCategory EnumType
 * Meta information extracted from the WSDL
 * - union: string
 * @subpackage Enumerations
 */
class XPhoneServiceCategory extends AbstractStructEnumBase
{
    /**
     * Constant for value 'XML Service'
     * @return string 'XML Service'
     */
    const VALUE_XML_SERVICE = 'XML Service';
    /**
     * Constant for value 'Java MIDlet'
     * @return string 'Java MIDlet'
     */
    const VALUE_JAVA_MIDLET = 'Java MIDlet';
    /**
     * Constant for value 'Web Widget'
     * @return string 'Web Widget'
     */
    const VALUE_WEB_WIDGET = 'Web Widget';
    /**
     * Constant for value 'Web Link'
     * @return string 'Web Link'
     */
    const VALUE_WEB_LINK = 'Web Link';
    /**
     * Constant for value 'Android APK'
     * @return string 'Android APK'
     */
    const VALUE_ANDROID_APK = 'Android APK';
    /**
     * Return allowed values
     * @uses self::VALUE_XML_SERVICE
     * @uses self::VALUE_JAVA_MIDLET
     * @uses self::VALUE_WEB_WIDGET
     * @uses self::VALUE_WEB_LINK
     * @uses self::VALUE_ANDROID_APK
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_XML_SERVICE,
            self::VALUE_JAVA_MIDLET,
            self::VALUE_WEB_WIDGET,
            self::VALUE_WEB_LINK,
            self::VALUE_ANDROID_APK,
        );
    }
}
