<?php

namespace Losc\CucmBundle\Model\Webservice\EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for XWiFiAuthenticationMethod EnumType
 * Meta information extracted from the WSDL
 * - union: string
 * @subpackage Enumerations
 */
class XWiFiAuthenticationMethod extends AbstractStructEnumBase
{
    /**
     * Constant for value 'None'
     * @return string 'None'
     */
    const VALUE_NONE = 'None';
    /**
     * Constant for value 'WEP'
     * @return string 'WEP'
     */
    const VALUE_WEP = 'WEP';
    /**
     * Constant for value 'PSK'
     * @return string 'PSK'
     */
    const VALUE_PSK = 'PSK';
    /**
     * Constant for value 'EAP-FAST'
     * @return string 'EAP-FAST'
     */
    const VALUE_EAP_FAST = 'EAP-FAST';
    /**
     * Constant for value 'PEAP-MSCHAPv2'
     * @return string 'PEAP-MSCHAPv2'
     */
    const VALUE_PEAP_MSCHAPV_2 = 'PEAP-MSCHAPv2';
    /**
     * Constant for value 'PEAP-GTC'
     * @return string 'PEAP-GTC'
     */
    const VALUE_PEAP_GTC = 'PEAP-GTC';
    /**
     * Return allowed values
     * @uses self::VALUE_NONE
     * @uses self::VALUE_WEP
     * @uses self::VALUE_PSK
     * @uses self::VALUE_EAP_FAST
     * @uses self::VALUE_PEAP_MSCHAPV_2
     * @uses self::VALUE_PEAP_GTC
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_NONE,
            self::VALUE_WEP,
            self::VALUE_PSK,
            self::VALUE_EAP_FAST,
            self::VALUE_PEAP_MSCHAPV_2,
            self::VALUE_PEAP_GTC,
        );
    }
}
