<?php

namespace Losc\CucmBundle\Model\Webservice\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Restart ServiceType
 * @subpackage Services
 */
class Restart extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named restartSipProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartSipProfile(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartSipProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named restartRoutePartition
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartRoutePartition(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartRoutePartition($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named restartCallManager
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartCallManager(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartCallManager($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named restartRegion
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartRegion(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartRegion($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named restartDevicePool
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartDevicePool(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartDevicePool($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named restartSoftKeyTemplate
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartSoftKeyTemplate(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartSoftKeyTemplate($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named restartResourcePriorityNamespace
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RestartResourcePriorityNamespaceReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartResourcePriorityNamespace(\Losc\CucmBundle\Model\Webservice\StructType\RestartResourcePriorityNamespaceReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartResourcePriorityNamespace($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * restartResourcePriorityNamespaceList
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartResourcePriorityNamespaceList(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartResourcePriorityNamespaceList($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named restartSrst
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartSrst(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartSrst($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named restartVoiceMailProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartVoiceMailProfile(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartVoiceMailProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named restartVoiceMailPort
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartVoiceMailPort(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartVoiceMailPort($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named restartGatekeeper
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartGatekeeper(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartGatekeeper($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named restartPhoneButtonTemplate
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartPhoneButtonTemplate(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartPhoneButtonTemplate($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named restartCtiRoutePoint
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartCtiRoutePoint(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartCtiRoutePoint($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named restartConferenceBridge
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartConferenceBridge(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartConferenceBridge($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named restartMtp
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartMtp(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartMtp($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named restartLine
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RestartLineReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartLine(\Losc\CucmBundle\Model\Webservice\StructType\RestartLineReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartLine($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named restartH323Phone
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartH323Phone(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartH323Phone($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named restartH323Trunk
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartH323Trunk(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartH323Trunk($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named restartPhone
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartPhone(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartPhone($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named restartH323Gateway
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartH323Gateway(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartH323Gateway($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * restartCiscoCatalyst600024PortFXSGateway
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartCiscoCatalyst600024PortFXSGateway(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartCiscoCatalyst600024PortFXSGateway($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * restartCiscoCatalyst6000E1VoIPGateway
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartCiscoCatalyst6000E1VoIPGateway(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartCiscoCatalyst6000E1VoIPGateway($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * restartCiscoCatalyst6000T1VoIPGatewayPri
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartCiscoCatalyst6000T1VoIPGatewayPri(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartCiscoCatalyst6000T1VoIPGatewayPri($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * restartCiscoCatalyst6000T1VoIPGatewayT1
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartCiscoCatalyst6000T1VoIPGatewayT1(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartCiscoCatalyst6000T1VoIPGatewayT1($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named restartSipTrunk
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse|bool
     */
    public function restartSipTrunk(\Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->restartSipTrunk($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \Losc\CucmBundle\Model\Webservice\StructType\StandardResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
