<?php

namespace Losc\CucmBundle\Model\Webservice\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for List ServiceType
 * @subpackage Services
 */
class _List extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named listSipProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListSipProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListSipProfileRes|bool
     */
    public function listSipProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListSipProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listSipProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listSipTrunkSecurityProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListSipTrunkSecurityProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListSipTrunkSecurityProfileRes|bool
     */
    public function listSipTrunkSecurityProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListSipTrunkSecurityProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listSipTrunkSecurityProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listTimePeriod
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListTimePeriodReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListTimePeriodRes|bool
     */
    public function listTimePeriod(\Losc\CucmBundle\Model\Webservice\StructType\ListTimePeriodReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listTimePeriod($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listTimeSchedule
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListTimeScheduleReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListTimeScheduleRes|bool
     */
    public function listTimeSchedule(\Losc\CucmBundle\Model\Webservice\StructType\ListTimeScheduleReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listTimeSchedule($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listTodAccess
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListTodAccessReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListTodAccessRes|bool
     */
    public function listTodAccess(\Losc\CucmBundle\Model\Webservice\StructType\ListTodAccessReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listTodAccess($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listVoiceMailPilot
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListVoiceMailPilotReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListVoiceMailPilotRes|bool
     */
    public function listVoiceMailPilot(\Losc\CucmBundle\Model\Webservice\StructType\ListVoiceMailPilotReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listVoiceMailPilot($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listProcessNode
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListProcessNodeReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListProcessNodeRes|bool
     */
    public function listProcessNode(\Losc\CucmBundle\Model\Webservice\StructType\ListProcessNodeReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listProcessNode($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listCallerFilterList
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCallerFilterListReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCallerFilterListRes|bool
     */
    public function listCallerFilterList(\Losc\CucmBundle\Model\Webservice\StructType\ListCallerFilterListReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCallerFilterList($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listRoutePartition
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListRoutePartitionReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListRoutePartitionRes|bool
     */
    public function listRoutePartition(\Losc\CucmBundle\Model\Webservice\StructType\ListRoutePartitionReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listRoutePartition($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listCss
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCssReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCssRes|bool
     */
    public function listCss(\Losc\CucmBundle\Model\Webservice\StructType\ListCssReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCss($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listCallManager
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCallManagerReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCallManagerRes|bool
     */
    public function listCallManager(\Losc\CucmBundle\Model\Webservice\StructType\ListCallManagerReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCallManager($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listMediaResourceGroup
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListMediaResourceGroupReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListMediaResourceGroupRes|bool
     */
    public function listMediaResourceGroup(\Losc\CucmBundle\Model\Webservice\StructType\ListMediaResourceGroupReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listMediaResourceGroup($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listMediaResourceList
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListMediaResourceListReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListMediaResourceListRes|bool
     */
    public function listMediaResourceList(\Losc\CucmBundle\Model\Webservice\StructType\ListMediaResourceListReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listMediaResourceList($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listRegion
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListRegionReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListRegionRes|bool
     */
    public function listRegion(\Losc\CucmBundle\Model\Webservice\StructType\ListRegionReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listRegion($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listAarGroup
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListAarGroupReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListAarGroupRes|bool
     */
    public function listAarGroup(\Losc\CucmBundle\Model\Webservice\StructType\ListAarGroupReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listAarGroup($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listPhysicalLocation
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListPhysicalLocationReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListPhysicalLocationRes|bool
     */
    public function listPhysicalLocation(\Losc\CucmBundle\Model\Webservice\StructType\ListPhysicalLocationReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listPhysicalLocation($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listRouteGroup
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListRouteGroupReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListRouteGroupRes|bool
     */
    public function listRouteGroup(\Losc\CucmBundle\Model\Webservice\StructType\ListRouteGroupReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listRouteGroup($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listDevicePool
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListDevicePoolReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListDevicePoolRes|bool
     */
    public function listDevicePool(\Losc\CucmBundle\Model\Webservice\StructType\ListDevicePoolReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listDevicePool($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listDeviceMobilityGroup
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListDeviceMobilityGroupReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListDeviceMobilityGroupRes|bool
     */
    public function listDeviceMobilityGroup(\Losc\CucmBundle\Model\Webservice\StructType\ListDeviceMobilityGroupReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listDeviceMobilityGroup($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listLocation
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListLocationReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListLocationRes|bool
     */
    public function listLocation(\Losc\CucmBundle\Model\Webservice\StructType\ListLocationReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listLocation($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listSoftKeyTemplate
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListSoftKeyTemplateReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListSoftKeyTemplateRes|bool
     */
    public function listSoftKeyTemplate(\Losc\CucmBundle\Model\Webservice\StructType\ListSoftKeyTemplateReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listSoftKeyTemplate($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listTranscoder
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListTranscoderReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListTranscoderRes|bool
     */
    public function listTranscoder(\Losc\CucmBundle\Model\Webservice\StructType\ListTranscoderReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listTranscoder($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listCommonDeviceConfig
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCommonDeviceConfigReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCommonDeviceConfigRes|bool
     */
    public function listCommonDeviceConfig(\Losc\CucmBundle\Model\Webservice\StructType\ListCommonDeviceConfigReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCommonDeviceConfig($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listResourcePriorityNamespace
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListResourcePriorityNamespaceReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListResourcePriorityNamespaceRes|bool
     */
    public function listResourcePriorityNamespace(\Losc\CucmBundle\Model\Webservice\StructType\ListResourcePriorityNamespaceReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listResourcePriorityNamespace($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listResourcePriorityNamespaceList
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListResourcePriorityNamespaceListReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListResourcePriorityNamespaceListRes|bool
     */
    public function listResourcePriorityNamespaceList(\Losc\CucmBundle\Model\Webservice\StructType\ListResourcePriorityNamespaceListReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listResourcePriorityNamespaceList($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listDeviceMobility
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListDeviceMobilityReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListDeviceMobilityRes|bool
     */
    public function listDeviceMobility(\Losc\CucmBundle\Model\Webservice\StructType\ListDeviceMobilityReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listDeviceMobility($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listCmcInfo
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCmcInfoReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCmcInfoRes|bool
     */
    public function listCmcInfo(\Losc\CucmBundle\Model\Webservice\StructType\ListCmcInfoReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCmcInfo($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listCredentialPolicy
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCredentialPolicyReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCredentialPolicyRes|bool
     */
    public function listCredentialPolicy(\Losc\CucmBundle\Model\Webservice\StructType\ListCredentialPolicyReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCredentialPolicy($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listFacInfo
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListFacInfoReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListFacInfoRes|bool
     */
    public function listFacInfo(\Losc\CucmBundle\Model\Webservice\StructType\ListFacInfoReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listFacInfo($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listHuntList
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListHuntListReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListHuntListRes|bool
     */
    public function listHuntList(\Losc\CucmBundle\Model\Webservice\StructType\ListHuntListReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listHuntList($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listIvrUserLocale
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListIvrUserLocaleReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListIvrUserLocaleRes|bool
     */
    public function listIvrUserLocale(\Losc\CucmBundle\Model\Webservice\StructType\ListIvrUserLocaleReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listIvrUserLocale($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listLineGroup
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListLineGroupReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListLineGroupRes|bool
     */
    public function listLineGroup(\Losc\CucmBundle\Model\Webservice\StructType\ListLineGroupReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listLineGroup($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listRecordingProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListRecordingProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListRecordingProfileRes|bool
     */
    public function listRecordingProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListRecordingProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listRecordingProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listRouteFilter
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListRouteFilterReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListRouteFilterRes|bool
     */
    public function listRouteFilter(\Losc\CucmBundle\Model\Webservice\StructType\ListRouteFilterReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listRouteFilter($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listCallManagerGroup
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCallManagerGroupReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCallManagerGroupRes|bool
     */
    public function listCallManagerGroup(\Losc\CucmBundle\Model\Webservice\StructType\ListCallManagerGroupReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCallManagerGroup($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listUserGroup
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListUserGroupReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListUserGroupRes|bool
     */
    public function listUserGroup(\Losc\CucmBundle\Model\Webservice\StructType\ListUserGroupReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listUserGroup($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listDialPlan
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListDialPlanReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListDialPlanRes|bool
     */
    public function listDialPlan(\Losc\CucmBundle\Model\Webservice\StructType\ListDialPlanReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listDialPlan($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listDialPlanTag
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListDialPlanTagReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListDialPlanTagRes|bool
     */
    public function listDialPlanTag(\Losc\CucmBundle\Model\Webservice\StructType\ListDialPlanTagReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listDialPlanTag($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listDdi
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListDdiReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListDdiRes|bool
     */
    public function listDdi(\Losc\CucmBundle\Model\Webservice\StructType\ListDdiReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listDdi($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listMobileSmartClientProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListMobileSmartClientProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListMobileSmartClientProfileRes|bool
     */
    public function listMobileSmartClientProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListMobileSmartClientProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listMobileSmartClientProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listProcessNodeService
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListProcessNodeServiceReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListProcessNodeServiceRes|bool
     */
    public function listProcessNodeService(\Losc\CucmBundle\Model\Webservice\StructType\ListProcessNodeServiceReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listProcessNodeService($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listMohAudioSource
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListMohAudioSourceReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListMohAudioSourceRes|bool
     */
    public function listMohAudioSource(\Losc\CucmBundle\Model\Webservice\StructType\ListMohAudioSourceReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listMohAudioSource($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listDhcpServer
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListDhcpServerReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListDhcpServerRes|bool
     */
    public function listDhcpServer(\Losc\CucmBundle\Model\Webservice\StructType\ListDhcpServerReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listDhcpServer($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listDhcpSubnet
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListDhcpSubnetReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListDhcpSubnetRes|bool
     */
    public function listDhcpSubnet(\Losc\CucmBundle\Model\Webservice\StructType\ListDhcpSubnetReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listDhcpSubnet($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listCallPark
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCallParkReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCallParkRes|bool
     */
    public function listCallPark(\Losc\CucmBundle\Model\Webservice\StructType\ListCallParkReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCallPark($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listDirectedCallPark
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListDirectedCallParkReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListDirectedCallParkRes|bool
     */
    public function listDirectedCallPark(\Losc\CucmBundle\Model\Webservice\StructType\ListDirectedCallParkReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listDirectedCallPark($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listMeetMe
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListMeetMeReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListMeetMeRes|bool
     */
    public function listMeetMe(\Losc\CucmBundle\Model\Webservice\StructType\ListMeetMeReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listMeetMe($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listRouteList
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListRouteListReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListRouteListRes|bool
     */
    public function listRouteList(\Losc\CucmBundle\Model\Webservice\StructType\ListRouteListReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listRouteList($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listUser
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListUserReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListUserRes|bool
     */
    public function listUser(\Losc\CucmBundle\Model\Webservice\StructType\ListUserReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listUser($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listAppUser
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListAppUserReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListAppUserRes|bool
     */
    public function listAppUser(\Losc\CucmBundle\Model\Webservice\StructType\ListAppUserReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listAppUser($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listSipRealm
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListSipRealmReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListSipRealmRes|bool
     */
    public function listSipRealm(\Losc\CucmBundle\Model\Webservice\StructType\ListSipRealmReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listSipRealm($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listPhoneNtp
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListPhoneNtpReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListPhoneNtpRes|bool
     */
    public function listPhoneNtp(\Losc\CucmBundle\Model\Webservice\StructType\ListPhoneNtpReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listPhoneNtp($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listDateTimeGroup
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListDateTimeGroupReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListDateTimeGroupRes|bool
     */
    public function listDateTimeGroup(\Losc\CucmBundle\Model\Webservice\StructType\ListDateTimeGroupReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listDateTimeGroup($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listPresenceGroup
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListPresenceGroupReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListPresenceGroupRes|bool
     */
    public function listPresenceGroup(\Losc\CucmBundle\Model\Webservice\StructType\ListPresenceGroupReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listPresenceGroup($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listGeoLocation
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListGeoLocationReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListGeoLocationRes|bool
     */
    public function listGeoLocation(\Losc\CucmBundle\Model\Webservice\StructType\ListGeoLocationReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listGeoLocation($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listSrst
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListSrstReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListSrstRes|bool
     */
    public function listSrst(\Losc\CucmBundle\Model\Webservice\StructType\ListSrstReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listSrst($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listMlppDomain
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListMlppDomainReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListMlppDomainRes|bool
     */
    public function listMlppDomain(\Losc\CucmBundle\Model\Webservice\StructType\ListMlppDomainReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listMlppDomain($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listCumaServerSecurityProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCumaServerSecurityProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCumaServerSecurityProfileRes|bool
     */
    public function listCumaServerSecurityProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListCumaServerSecurityProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCumaServerSecurityProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listApplicationServer
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListApplicationServerReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListApplicationServerRes|bool
     */
    public function listApplicationServer(\Losc\CucmBundle\Model\Webservice\StructType\ListApplicationServerReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listApplicationServer($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listApplicationUserCapfProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListApplicationUserCapfProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListApplicationUserCapfProfileRes|bool
     */
    public function listApplicationUserCapfProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListApplicationUserCapfProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listApplicationUserCapfProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listEndUserCapfProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListEndUserCapfProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListEndUserCapfProfileRes|bool
     */
    public function listEndUserCapfProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListEndUserCapfProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listEndUserCapfProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listServiceParameter
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListServiceParameterReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListServiceParameterRes|bool
     */
    public function listServiceParameter(\Losc\CucmBundle\Model\Webservice\StructType\ListServiceParameterReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listServiceParameter($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listGeoLocationFilter
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListGeoLocationFilterReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListGeoLocationFilterRes|bool
     */
    public function listGeoLocationFilter(\Losc\CucmBundle\Model\Webservice\StructType\ListGeoLocationFilterReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listGeoLocationFilter($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listVoiceMailProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListVoiceMailProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListVoiceMailProfileRes|bool
     */
    public function listVoiceMailProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListVoiceMailProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listVoiceMailProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listVoiceMailPort
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListVoiceMailPortReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListVoiceMailPortRes|bool
     */
    public function listVoiceMailPort(\Losc\CucmBundle\Model\Webservice\StructType\ListVoiceMailPortReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listVoiceMailPort($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listGatekeeper
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListGatekeeperReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListGatekeeperRes|bool
     */
    public function listGatekeeper(\Losc\CucmBundle\Model\Webservice\StructType\ListGatekeeperReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listGatekeeper($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listPhoneButtonTemplate
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListPhoneButtonTemplateReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListPhoneButtonTemplateRes|bool
     */
    public function listPhoneButtonTemplate(\Losc\CucmBundle\Model\Webservice\StructType\ListPhoneButtonTemplateReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listPhoneButtonTemplate($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listCommonPhoneConfig
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCommonPhoneConfigReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCommonPhoneConfigRes|bool
     */
    public function listCommonPhoneConfig(\Losc\CucmBundle\Model\Webservice\StructType\ListCommonPhoneConfigReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCommonPhoneConfig($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listMessageWaiting
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListMessageWaitingReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListMessageWaitingRes|bool
     */
    public function listMessageWaiting(\Losc\CucmBundle\Model\Webservice\StructType\ListMessageWaitingReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listMessageWaiting($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listIpPhoneServices
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListIpPhoneServicesReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListIpPhoneServicesRes|bool
     */
    public function listIpPhoneServices(\Losc\CucmBundle\Model\Webservice\StructType\ListIpPhoneServicesReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listIpPhoneServices($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listCtiRoutePoint
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCtiRoutePointReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCtiRoutePointRes|bool
     */
    public function listCtiRoutePoint(\Losc\CucmBundle\Model\Webservice\StructType\ListCtiRoutePointReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCtiRoutePoint($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listTransPattern
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListTransPatternReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListTransPatternRes|bool
     */
    public function listTransPattern(\Losc\CucmBundle\Model\Webservice\StructType\ListTransPatternReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listTransPattern($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * listCallingPartyTransformationPattern
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCallingPartyTransformationPatternReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCallingPartyTransformationPatternRes|bool
     */
    public function listCallingPartyTransformationPattern(\Losc\CucmBundle\Model\Webservice\StructType\ListCallingPartyTransformationPatternReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCallingPartyTransformationPattern($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listSipRoutePattern
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListSipRoutePatternReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListSipRoutePatternRes|bool
     */
    public function listSipRoutePattern(\Losc\CucmBundle\Model\Webservice\StructType\ListSipRoutePatternReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listSipRoutePattern($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listHuntPilot
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListHuntPilotReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListHuntPilotRes|bool
     */
    public function listHuntPilot(\Losc\CucmBundle\Model\Webservice\StructType\ListHuntPilotReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listHuntPilot($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listRoutePattern
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListRoutePatternReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListRoutePatternRes|bool
     */
    public function listRoutePattern(\Losc\CucmBundle\Model\Webservice\StructType\ListRoutePatternReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listRoutePattern($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listApplicationDialRules
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListApplicationDialRulesReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListApplicationDialRulesRes|bool
     */
    public function listApplicationDialRules(\Losc\CucmBundle\Model\Webservice\StructType\ListApplicationDialRulesReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listApplicationDialRules($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listDirectoryLookupDialRules
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListDirectoryLookupDialRulesReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListDirectoryLookupDialRulesRes|bool
     */
    public function listDirectoryLookupDialRules(\Losc\CucmBundle\Model\Webservice\StructType\ListDirectoryLookupDialRulesReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listDirectoryLookupDialRules($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listPhoneSecurityProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListPhoneSecurityProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListPhoneSecurityProfileRes|bool
     */
    public function listPhoneSecurityProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListPhoneSecurityProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listPhoneSecurityProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listSipDialRules
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListSipDialRulesReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListSipDialRulesRes|bool
     */
    public function listSipDialRules(\Losc\CucmBundle\Model\Webservice\StructType\ListSipDialRulesReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listSipDialRules($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listConferenceBridge
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListConferenceBridgeReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListConferenceBridgeRes|bool
     */
    public function listConferenceBridge(\Losc\CucmBundle\Model\Webservice\StructType\ListConferenceBridgeReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listConferenceBridge($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listAnnunciator
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListAnnunciatorReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListAnnunciatorRes|bool
     */
    public function listAnnunciator(\Losc\CucmBundle\Model\Webservice\StructType\ListAnnunciatorReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listAnnunciator($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listMtp
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListMtpReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListMtpRes|bool
     */
    public function listMtp(\Losc\CucmBundle\Model\Webservice\StructType\ListMtpReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listMtp($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listRemoteDestinationProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListRemoteDestinationProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListRemoteDestinationProfileRes|bool
     */
    public function listRemoteDestinationProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListRemoteDestinationProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listRemoteDestinationProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listLine
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListLineReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListLineRes|bool
     */
    public function listLine(\Losc\CucmBundle\Model\Webservice\StructType\ListLineReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listLine($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listDefaultDeviceProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListDefaultDeviceProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListDefaultDeviceProfileRes|bool
     */
    public function listDefaultDeviceProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListDefaultDeviceProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listDefaultDeviceProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listH323Phone
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListH323PhoneReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListH323PhoneRes|bool
     */
    public function listH323Phone(\Losc\CucmBundle\Model\Webservice\StructType\ListH323PhoneReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listH323Phone($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listMohServer
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListMohServerReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListMohServerRes|bool
     */
    public function listMohServer(\Losc\CucmBundle\Model\Webservice\StructType\ListMohServerReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listMohServer($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listH323Trunk
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListH323TrunkReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListH323TrunkRes|bool
     */
    public function listH323Trunk(\Losc\CucmBundle\Model\Webservice\StructType\ListH323TrunkReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listH323Trunk($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listPhone
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListPhoneReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListPhoneRes|bool
     */
    public function listPhone(\Losc\CucmBundle\Model\Webservice\StructType\ListPhoneReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listPhone($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listH323Gateway
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListH323GatewayReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListH323GatewayRes|bool
     */
    public function listH323Gateway(\Losc\CucmBundle\Model\Webservice\StructType\ListH323GatewayReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listH323Gateway($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listDeviceProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListDeviceProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListDeviceProfileRes|bool
     */
    public function listDeviceProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListDeviceProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listDeviceProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listRemoteDestination
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListRemoteDestinationReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListRemoteDestinationRes|bool
     */
    public function listRemoteDestination(\Losc\CucmBundle\Model\Webservice\StructType\ListRemoteDestinationReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listRemoteDestination($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listGateway
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListGatewayReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListGatewayRes|bool
     */
    public function listGateway(\Losc\CucmBundle\Model\Webservice\StructType\ListGatewayReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listGateway($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * listCiscoCatalyst600024PortFXSGateway
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCiscoCatalyst600024PortFXSGatewayReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCiscoCatalyst600024PortFXSGatewayRes|bool
     */
    public function listCiscoCatalyst600024PortFXSGateway(\Losc\CucmBundle\Model\Webservice\StructType\ListCiscoCatalyst600024PortFXSGatewayReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCiscoCatalyst600024PortFXSGateway($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listCiscoCatalyst6000E1VoIPGateway
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCiscoCatalyst6000E1VoIPGatewayReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCiscoCatalyst6000E1VoIPGatewayRes|bool
     */
    public function listCiscoCatalyst6000E1VoIPGateway(\Losc\CucmBundle\Model\Webservice\StructType\ListCiscoCatalyst6000E1VoIPGatewayReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCiscoCatalyst6000E1VoIPGateway($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * listCiscoCatalyst6000T1VoIPGatewayPri
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCiscoCatalyst6000T1VoIPGatewayPriReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCiscoCatalyst6000T1VoIPGatewayPriRes|bool
     */
    public function listCiscoCatalyst6000T1VoIPGatewayPri(\Losc\CucmBundle\Model\Webservice\StructType\ListCiscoCatalyst6000T1VoIPGatewayPriReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCiscoCatalyst6000T1VoIPGatewayPri($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * listCiscoCatalyst6000T1VoIPGatewayT1
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCiscoCatalyst6000T1VoIPGatewayT1Req $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCiscoCatalyst6000T1VoIPGatewayT1Res|bool
     */
    public function listCiscoCatalyst6000T1VoIPGatewayT1(\Losc\CucmBundle\Model\Webservice\StructType\ListCiscoCatalyst6000T1VoIPGatewayT1Req $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCiscoCatalyst6000T1VoIPGatewayT1($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listCallPickupGroup
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCallPickupGroupReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCallPickupGroupRes|bool
     */
    public function listCallPickupGroup(\Losc\CucmBundle\Model\Webservice\StructType\ListCallPickupGroupReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCallPickupGroup($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listRoutePlan
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListRoutePlanReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListRoutePlanRes|bool
     */
    public function listRoutePlan(\Losc\CucmBundle\Model\Webservice\StructType\ListRoutePlanReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listRoutePlan($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listGeoLocationPolicy
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListGeoLocationPolicyReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListGeoLocationPolicyRes|bool
     */
    public function listGeoLocationPolicy(\Losc\CucmBundle\Model\Webservice\StructType\ListGeoLocationPolicyReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listGeoLocationPolicy($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listSipTrunk
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListSipTrunkReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListSipTrunkRes|bool
     */
    public function listSipTrunk(\Losc\CucmBundle\Model\Webservice\StructType\ListSipTrunkReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listSipTrunk($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * listCalledPartyTransformationPattern
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCalledPartyTransformationPatternReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCalledPartyTransformationPatternRes|bool
     */
    public function listCalledPartyTransformationPattern(\Losc\CucmBundle\Model\Webservice\StructType\ListCalledPartyTransformationPatternReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCalledPartyTransformationPattern($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listExternalCallControlProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListExternalCallControlProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListExternalCallControlProfileRes|bool
     */
    public function listExternalCallControlProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListExternalCallControlProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listExternalCallControlProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listSafSecurityProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListSafSecurityProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListSafSecurityProfileRes|bool
     */
    public function listSafSecurityProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListSafSecurityProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listSafSecurityProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listSafForwarder
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListSafForwarderReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListSafForwarderRes|bool
     */
    public function listSafForwarder(\Losc\CucmBundle\Model\Webservice\StructType\ListSafForwarderReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listSafForwarder($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listCcdHostedDN
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCcdHostedDNReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCcdHostedDNRes|bool
     */
    public function listCcdHostedDN(\Losc\CucmBundle\Model\Webservice\StructType\ListCcdHostedDNReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCcdHostedDN($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listCcdHostedDNGroup
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCcdHostedDNGroupReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCcdHostedDNGroupRes|bool
     */
    public function listCcdHostedDNGroup(\Losc\CucmBundle\Model\Webservice\StructType\ListCcdHostedDNGroupReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCcdHostedDNGroup($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listRemoteCluster
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListRemoteClusterReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListRemoteClusterRes|bool
     */
    public function listRemoteCluster(\Losc\CucmBundle\Model\Webservice\StructType\ListRemoteClusterReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listRemoteCluster($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listCcdAdvertisingService
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCcdAdvertisingServiceReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCcdAdvertisingServiceRes|bool
     */
    public function listCcdAdvertisingService(\Losc\CucmBundle\Model\Webservice\StructType\ListCcdAdvertisingServiceReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCcdAdvertisingService($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listLdapDirectory
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListLdapDirectoryReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListLdapDirectoryRes|bool
     */
    public function listLdapDirectory(\Losc\CucmBundle\Model\Webservice\StructType\ListLdapDirectoryReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listLdapDirectory($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listSafCcdPurgeBlockLearnedRoutes
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListSafCcdPurgeBlockLearnedRoutesReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListSafCcdPurgeBlockLearnedRoutesRes|bool
     */
    public function listSafCcdPurgeBlockLearnedRoutes(\Losc\CucmBundle\Model\Webservice\StructType\ListSafCcdPurgeBlockLearnedRoutesReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listSafCcdPurgeBlockLearnedRoutes($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listVpnGateway
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListVpnGatewayReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListVpnGatewayRes|bool
     */
    public function listVpnGateway(\Losc\CucmBundle\Model\Webservice\StructType\ListVpnGatewayReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listVpnGateway($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listVpnGroup
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListVpnGroupReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListVpnGroupRes|bool
     */
    public function listVpnGroup(\Losc\CucmBundle\Model\Webservice\StructType\ListVpnGroupReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listVpnGroup($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listVpnProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListVpnProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListVpnProfileRes|bool
     */
    public function listVpnProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListVpnProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listVpnProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listImeServer
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListImeServerReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListImeServerRes|bool
     */
    public function listImeServer(\Losc\CucmBundle\Model\Webservice\StructType\ListImeServerReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listImeServer($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listImeRouteFilterGroup
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListImeRouteFilterGroupReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListImeRouteFilterGroupRes|bool
     */
    public function listImeRouteFilterGroup(\Losc\CucmBundle\Model\Webservice\StructType\ListImeRouteFilterGroupReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listImeRouteFilterGroup($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listImeRouteFilterElement
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListImeRouteFilterElementReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListImeRouteFilterElementRes|bool
     */
    public function listImeRouteFilterElement(\Losc\CucmBundle\Model\Webservice\StructType\ListImeRouteFilterElementReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listImeRouteFilterElement($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listImeClient
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListImeClientReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListImeClientRes|bool
     */
    public function listImeClient(\Losc\CucmBundle\Model\Webservice\StructType\ListImeClientReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listImeClient($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listImeEnrolledPattern
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListImeEnrolledPatternReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListImeEnrolledPatternRes|bool
     */
    public function listImeEnrolledPattern(\Losc\CucmBundle\Model\Webservice\StructType\ListImeEnrolledPatternReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listImeEnrolledPattern($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listImeEnrolledPatternGroup
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListImeEnrolledPatternGroupReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListImeEnrolledPatternGroupRes|bool
     */
    public function listImeEnrolledPatternGroup(\Losc\CucmBundle\Model\Webservice\StructType\ListImeEnrolledPatternGroupReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listImeEnrolledPatternGroup($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listImeExclusionNumber
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListImeExclusionNumberReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListImeExclusionNumberRes|bool
     */
    public function listImeExclusionNumber(\Losc\CucmBundle\Model\Webservice\StructType\ListImeExclusionNumberReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listImeExclusionNumber($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listImeExclusionNumberGroup
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListImeExclusionNumberGroupReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListImeExclusionNumberGroupRes|bool
     */
    public function listImeExclusionNumberGroup(\Losc\CucmBundle\Model\Webservice\StructType\ListImeExclusionNumberGroupReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listImeExclusionNumberGroup($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listImeFirewall
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListImeFirewallReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListImeFirewallRes|bool
     */
    public function listImeFirewall(\Losc\CucmBundle\Model\Webservice\StructType\ListImeFirewallReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listImeFirewall($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listImeE164Transformation
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListImeE164TransformationReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListImeE164TransformationRes|bool
     */
    public function listImeE164Transformation(\Losc\CucmBundle\Model\Webservice\StructType\ListImeE164TransformationReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listImeE164Transformation($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listTransformationProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListTransformationProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListTransformationProfileRes|bool
     */
    public function listTransformationProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListTransformationProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listTransformationProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listFallbackProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListFallbackProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListFallbackProfileRes|bool
     */
    public function listFallbackProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListFallbackProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listFallbackProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listLdapFilter
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListLdapFilterReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListLdapFilterRes|bool
     */
    public function listLdapFilter(\Losc\CucmBundle\Model\Webservice\StructType\ListLdapFilterReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listLdapFilter($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listTvsCertificate
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListTvsCertificateReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListTvsCertificateRes|bool
     */
    public function listTvsCertificate(\Losc\CucmBundle\Model\Webservice\StructType\ListTvsCertificateReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listTvsCertificate($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listFeatureControlPolicy
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListFeatureControlPolicyReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListFeatureControlPolicyRes|bool
     */
    public function listFeatureControlPolicy(\Losc\CucmBundle\Model\Webservice\StructType\ListFeatureControlPolicyReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listFeatureControlPolicy($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listMobilityProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListMobilityProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListMobilityProfileRes|bool
     */
    public function listMobilityProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListMobilityProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listMobilityProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * listEnterpriseFeatureAccessConfiguration
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListEnterpriseFeatureAccessConfigurationReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListEnterpriseFeatureAccessConfigurationRes|bool
     */
    public function listEnterpriseFeatureAccessConfiguration(\Losc\CucmBundle\Model\Webservice\StructType\ListEnterpriseFeatureAccessConfigurationReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listEnterpriseFeatureAccessConfiguration($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listCalledPartyTracing
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCalledPartyTracingReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCalledPartyTracingRes|bool
     */
    public function listCalledPartyTracing(\Losc\CucmBundle\Model\Webservice\StructType\ListCalledPartyTracingReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCalledPartyTracing($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listSIPNormalizationScript
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListSIPNormalizationScriptReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListSIPNormalizationScriptRes|bool
     */
    public function listSIPNormalizationScript(\Losc\CucmBundle\Model\Webservice\StructType\ListSIPNormalizationScriptReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listSIPNormalizationScript($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listCustomUserField
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCustomUserFieldReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCustomUserFieldRes|bool
     */
    public function listCustomUserField(\Losc\CucmBundle\Model\Webservice\StructType\ListCustomUserFieldReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCustomUserField($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listBillingServer
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListBillingServerReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListBillingServerRes|bool
     */
    public function listBillingServer(\Losc\CucmBundle\Model\Webservice\StructType\ListBillingServerReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listBillingServer($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listLbmGroup
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListLbmGroupReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListLbmGroupRes|bool
     */
    public function listLbmGroup(\Losc\CucmBundle\Model\Webservice\StructType\ListLbmGroupReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listLbmGroup($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listAnnouncement
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListAnnouncementReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListAnnouncementRes|bool
     */
    public function listAnnouncement(\Losc\CucmBundle\Model\Webservice\StructType\ListAnnouncementReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listAnnouncement($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listServiceProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListServiceProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListServiceProfileRes|bool
     */
    public function listServiceProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListServiceProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listServiceProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listAudioCodecPreferenceList
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListAudioCodecPreferenceListReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListAudioCodecPreferenceListRes|bool
     */
    public function listAudioCodecPreferenceList(\Losc\CucmBundle\Model\Webservice\StructType\ListAudioCodecPreferenceListReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listAudioCodecPreferenceList($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listUcService
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListUcServiceReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListUcServiceRes|bool
     */
    public function listUcService(\Losc\CucmBundle\Model\Webservice\StructType\ListUcServiceReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listUcService($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listLbmHubGroup
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListLbmHubGroupReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListLbmHubGroupRes|bool
     */
    public function listLbmHubGroup(\Losc\CucmBundle\Model\Webservice\StructType\ListLbmHubGroupReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listLbmHubGroup($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listImportedDirectoryUriCatalogs
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListImportedDirectoryUriCatalogsReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListImportedDirectoryUriCatalogsRes|bool
     */
    public function listImportedDirectoryUriCatalogs(\Losc\CucmBundle\Model\Webservice\StructType\ListImportedDirectoryUriCatalogsReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listImportedDirectoryUriCatalogs($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listVohServer
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListVohServerReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListVohServerRes|bool
     */
    public function listVohServer(\Losc\CucmBundle\Model\Webservice\StructType\ListVohServerReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listVohServer($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listSdpTransparencyProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListSdpTransparencyProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListSdpTransparencyProfileRes|bool
     */
    public function listSdpTransparencyProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListSdpTransparencyProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listSdpTransparencyProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listFeatureGroupTemplate
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListFeatureGroupTemplateReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListFeatureGroupTemplateRes|bool
     */
    public function listFeatureGroupTemplate(\Losc\CucmBundle\Model\Webservice\StructType\ListFeatureGroupTemplateReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listFeatureGroupTemplate($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listDirNumberAliasLookupandSync
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListDirNumberAliasLookupandSyncReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListDirNumberAliasLookupandSyncRes|bool
     */
    public function listDirNumberAliasLookupandSync(\Losc\CucmBundle\Model\Webservice\StructType\ListDirNumberAliasLookupandSyncReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listDirNumberAliasLookupandSync($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listLocalRouteGroup
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListLocalRouteGroupReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListLocalRouteGroupRes|bool
     */
    public function listLocalRouteGroup(\Losc\CucmBundle\Model\Webservice\StructType\ListLocalRouteGroupReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listLocalRouteGroup($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listAdvertisedPatterns
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListAdvertisedPatternsReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListAdvertisedPatternsRes|bool
     */
    public function listAdvertisedPatterns(\Losc\CucmBundle\Model\Webservice\StructType\ListAdvertisedPatternsReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listAdvertisedPatterns($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listBlockedLearnedPatterns
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListBlockedLearnedPatternsReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListBlockedLearnedPatternsRes|bool
     */
    public function listBlockedLearnedPatterns(\Losc\CucmBundle\Model\Webservice\StructType\ListBlockedLearnedPatternsReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listBlockedLearnedPatterns($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listCCAProfiles
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListCCAProfilesReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListCCAProfilesRes|bool
     */
    public function listCCAProfiles(\Losc\CucmBundle\Model\Webservice\StructType\ListCCAProfilesReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listCCAProfiles($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listUniversalDeviceTemplate
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListUniversalDeviceTemplateReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListUniversalDeviceTemplateRes|bool
     */
    public function listUniversalDeviceTemplate(\Losc\CucmBundle\Model\Webservice\StructType\ListUniversalDeviceTemplateReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listUniversalDeviceTemplate($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listUserProfileProvision
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListUserProfileProvisionReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListUserProfileProvisionRes|bool
     */
    public function listUserProfileProvision(\Losc\CucmBundle\Model\Webservice\StructType\ListUserProfileProvisionReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listUserProfileProvision($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listPresenceRedundancyGroup
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListPresenceRedundancyGroupReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListPresenceRedundancyGroupRes|bool
     */
    public function listPresenceRedundancyGroup(\Losc\CucmBundle\Model\Webservice\StructType\ListPresenceRedundancyGroupReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listPresenceRedundancyGroup($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listAssignedPresenceServers
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListAssignedPresenceServersReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListAssignedPresenceServersRes|bool
     */
    public function listAssignedPresenceServers(\Losc\CucmBundle\Model\Webservice\StructType\ListAssignedPresenceServersReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listAssignedPresenceServers($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listUnassignedPresenceServers
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListUnassignedPresenceServersReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListUnassignedPresenceServersRes|bool
     */
    public function listUnassignedPresenceServers(\Losc\CucmBundle\Model\Webservice\StructType\ListUnassignedPresenceServersReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listUnassignedPresenceServers($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listAssignedPresenceUsers
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListAssignedPresenceUsersReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListAssignedPresenceUsersRes|bool
     */
    public function listAssignedPresenceUsers(\Losc\CucmBundle\Model\Webservice\StructType\ListAssignedPresenceUsersReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listAssignedPresenceUsers($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listUnassignedPresenceUsers
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListUnassignedPresenceUsersReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListUnassignedPresenceUsersRes|bool
     */
    public function listUnassignedPresenceUsers(\Losc\CucmBundle\Model\Webservice\StructType\ListUnassignedPresenceUsersReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listUnassignedPresenceUsers($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listWifiHotspot
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListWifiHotspotReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListWifiHotspotRes|bool
     */
    public function listWifiHotspot(\Losc\CucmBundle\Model\Webservice\StructType\ListWifiHotspotReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listWifiHotspot($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listWlanProfileGroup
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListWlanProfileGroupReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListWlanProfileGroupRes|bool
     */
    public function listWlanProfileGroup(\Losc\CucmBundle\Model\Webservice\StructType\ListWlanProfileGroupReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listWlanProfileGroup($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listWLANProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListWLANProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListWLANProfileRes|bool
     */
    public function listWLANProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListWLANProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listWLANProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listUniversalLineTemplate
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListUniversalLineTemplateReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListUniversalLineTemplateRes|bool
     */
    public function listUniversalLineTemplate(\Losc\CucmBundle\Model\Webservice\StructType\ListUniversalLineTemplateReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listUniversalLineTemplate($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listNetworkAccessProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListNetworkAccessProfileReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListNetworkAccessProfileRes|bool
     */
    public function listNetworkAccessProfile(\Losc\CucmBundle\Model\Webservice\StructType\ListNetworkAccessProfileReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listNetworkAccessProfile($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listLdapSyncCustomField
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListLdapSyncCustomFieldReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListLdapSyncCustomFieldRes|bool
     */
    public function listLdapSyncCustomField(\Losc\CucmBundle\Model\Webservice\StructType\ListLdapSyncCustomFieldReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listLdapSyncCustomField($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listChange
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ListChangeReq $axlParams
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListChangeRes|bool
     */
    public function listChange(\Losc\CucmBundle\Model\Webservice\StructType\ListChangeReq $axlParams)
    {
        try {
            $this->setResult($this->getSoapClient()->listChange($axlParams));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListAarGroupRes|\Losc\CucmBundle\Model\Webservice\StructType\ListAdvertisedPatternsRes|\Losc\CucmBundle\Model\Webservice\StructType\ListAnnouncementRes|\Losc\CucmBundle\Model\Webservice\StructType\ListAnnunciatorRes|\Losc\CucmBundle\Model\Webservice\StructType\ListApplicationDialRulesRes|\Losc\CucmBundle\Model\Webservice\StructType\ListApplicationServerRes|\Losc\CucmBundle\Model\Webservice\StructType\ListApplicationUserCapfProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListAppUserRes|\Losc\CucmBundle\Model\Webservice\StructType\ListAssignedPresenceServersRes|\Losc\CucmBundle\Model\Webservice\StructType\ListAssignedPresenceUsersRes|\Losc\CucmBundle\Model\Webservice\StructType\ListAudioCodecPreferenceListRes|\Losc\CucmBundle\Model\Webservice\StructType\ListBillingServerRes|\Losc\CucmBundle\Model\Webservice\StructType\ListBlockedLearnedPatternsRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCalledPartyTracingRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCalledPartyTransformationPatternRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCallerFilterListRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCallingPartyTransformationPatternRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCallManagerGroupRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCallManagerRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCallParkRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCallPickupGroupRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCCAProfilesRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCcdAdvertisingServiceRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCcdHostedDNGroupRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCcdHostedDNRes|\Losc\CucmBundle\Model\Webservice\StructType\ListChangeRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCiscoCatalyst6000E1VoIPGatewayRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCiscoCatalyst6000T1VoIPGatewayPriRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCiscoCatalyst6000T1VoIPGatewayT1Res|\Losc\CucmBundle\Model\Webservice\StructType\ListCiscoCatalyst600024PortFXSGatewayRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCmcInfoRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCommonDeviceConfigRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCommonPhoneConfigRes|\Losc\CucmBundle\Model\Webservice\StructType\ListConferenceBridgeRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCredentialPolicyRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCssRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCtiRoutePointRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCumaServerSecurityProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListCustomUserFieldRes|\Losc\CucmBundle\Model\Webservice\StructType\ListDateTimeGroupRes|\Losc\CucmBundle\Model\Webservice\StructType\ListDdiRes|\Losc\CucmBundle\Model\Webservice\StructType\ListDefaultDeviceProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListDeviceMobilityGroupRes|\Losc\CucmBundle\Model\Webservice\StructType\ListDeviceMobilityRes|\Losc\CucmBundle\Model\Webservice\StructType\ListDevicePoolRes|\Losc\CucmBundle\Model\Webservice\StructType\ListDeviceProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListDhcpServerRes|\Losc\CucmBundle\Model\Webservice\StructType\ListDhcpSubnetRes|\Losc\CucmBundle\Model\Webservice\StructType\ListDialPlanRes|\Losc\CucmBundle\Model\Webservice\StructType\ListDialPlanTagRes|\Losc\CucmBundle\Model\Webservice\StructType\ListDirectedCallParkRes|\Losc\CucmBundle\Model\Webservice\StructType\ListDirectoryLookupDialRulesRes|\Losc\CucmBundle\Model\Webservice\StructType\ListDirNumberAliasLookupandSyncRes|\Losc\CucmBundle\Model\Webservice\StructType\ListEndUserCapfProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListEnterpriseFeatureAccessConfigurationRes|\Losc\CucmBundle\Model\Webservice\StructType\ListExternalCallControlProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListFacInfoRes|\Losc\CucmBundle\Model\Webservice\StructType\ListFallbackProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListFeatureControlPolicyRes|\Losc\CucmBundle\Model\Webservice\StructType\ListFeatureGroupTemplateRes|\Losc\CucmBundle\Model\Webservice\StructType\ListGatekeeperRes|\Losc\CucmBundle\Model\Webservice\StructType\ListGatewayRes|\Losc\CucmBundle\Model\Webservice\StructType\ListGeoLocationFilterRes|\Losc\CucmBundle\Model\Webservice\StructType\ListGeoLocationPolicyRes|\Losc\CucmBundle\Model\Webservice\StructType\ListGeoLocationRes|\Losc\CucmBundle\Model\Webservice\StructType\ListH323GatewayRes|\Losc\CucmBundle\Model\Webservice\StructType\ListH323PhoneRes|\Losc\CucmBundle\Model\Webservice\StructType\ListH323TrunkRes|\Losc\CucmBundle\Model\Webservice\StructType\ListHuntListRes|\Losc\CucmBundle\Model\Webservice\StructType\ListHuntPilotRes|\Losc\CucmBundle\Model\Webservice\StructType\ListImeClientRes|\Losc\CucmBundle\Model\Webservice\StructType\ListImeE164TransformationRes|\Losc\CucmBundle\Model\Webservice\StructType\ListImeEnrolledPatternGroupRes|\Losc\CucmBundle\Model\Webservice\StructType\ListImeEnrolledPatternRes|\Losc\CucmBundle\Model\Webservice\StructType\ListImeExclusionNumberGroupRes|\Losc\CucmBundle\Model\Webservice\StructType\ListImeExclusionNumberRes|\Losc\CucmBundle\Model\Webservice\StructType\ListImeFirewallRes|\Losc\CucmBundle\Model\Webservice\StructType\ListImeRouteFilterElementRes|\Losc\CucmBundle\Model\Webservice\StructType\ListImeRouteFilterGroupRes|\Losc\CucmBundle\Model\Webservice\StructType\ListImeServerRes|\Losc\CucmBundle\Model\Webservice\StructType\ListImportedDirectoryUriCatalogsRes|\Losc\CucmBundle\Model\Webservice\StructType\ListIpPhoneServicesRes|\Losc\CucmBundle\Model\Webservice\StructType\ListIvrUserLocaleRes|\Losc\CucmBundle\Model\Webservice\StructType\ListLbmGroupRes|\Losc\CucmBundle\Model\Webservice\StructType\ListLbmHubGroupRes|\Losc\CucmBundle\Model\Webservice\StructType\ListLdapDirectoryRes|\Losc\CucmBundle\Model\Webservice\StructType\ListLdapFilterRes|\Losc\CucmBundle\Model\Webservice\StructType\ListLdapSyncCustomFieldRes|\Losc\CucmBundle\Model\Webservice\StructType\ListLineGroupRes|\Losc\CucmBundle\Model\Webservice\StructType\ListLineRes|\Losc\CucmBundle\Model\Webservice\StructType\ListLocalRouteGroupRes|\Losc\CucmBundle\Model\Webservice\StructType\ListLocationRes|\Losc\CucmBundle\Model\Webservice\StructType\ListMediaResourceGroupRes|\Losc\CucmBundle\Model\Webservice\StructType\ListMediaResourceListRes|\Losc\CucmBundle\Model\Webservice\StructType\ListMeetMeRes|\Losc\CucmBundle\Model\Webservice\StructType\ListMessageWaitingRes|\Losc\CucmBundle\Model\Webservice\StructType\ListMlppDomainRes|\Losc\CucmBundle\Model\Webservice\StructType\ListMobileSmartClientProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListMobilityProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListMohAudioSourceRes|\Losc\CucmBundle\Model\Webservice\StructType\ListMohServerRes|\Losc\CucmBundle\Model\Webservice\StructType\ListMtpRes|\Losc\CucmBundle\Model\Webservice\StructType\ListNetworkAccessProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListPhoneButtonTemplateRes|\Losc\CucmBundle\Model\Webservice\StructType\ListPhoneNtpRes|\Losc\CucmBundle\Model\Webservice\StructType\ListPhoneRes|\Losc\CucmBundle\Model\Webservice\StructType\ListPhoneSecurityProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListPhysicalLocationRes|\Losc\CucmBundle\Model\Webservice\StructType\ListPresenceGroupRes|\Losc\CucmBundle\Model\Webservice\StructType\ListPresenceRedundancyGroupRes|\Losc\CucmBundle\Model\Webservice\StructType\ListProcessNodeRes|\Losc\CucmBundle\Model\Webservice\StructType\ListProcessNodeServiceRes|\Losc\CucmBundle\Model\Webservice\StructType\ListRecordingProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListRegionRes|\Losc\CucmBundle\Model\Webservice\StructType\ListRemoteClusterRes|\Losc\CucmBundle\Model\Webservice\StructType\ListRemoteDestinationProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListRemoteDestinationRes|\Losc\CucmBundle\Model\Webservice\StructType\ListResourcePriorityNamespaceListRes|\Losc\CucmBundle\Model\Webservice\StructType\ListResourcePriorityNamespaceRes|\Losc\CucmBundle\Model\Webservice\StructType\ListRouteFilterRes|\Losc\CucmBundle\Model\Webservice\StructType\ListRouteGroupRes|\Losc\CucmBundle\Model\Webservice\StructType\ListRouteListRes|\Losc\CucmBundle\Model\Webservice\StructType\ListRoutePartitionRes|\Losc\CucmBundle\Model\Webservice\StructType\ListRoutePatternRes|\Losc\CucmBundle\Model\Webservice\StructType\ListRoutePlanRes|\Losc\CucmBundle\Model\Webservice\StructType\ListSafCcdPurgeBlockLearnedRoutesRes|\Losc\CucmBundle\Model\Webservice\StructType\ListSafForwarderRes|\Losc\CucmBundle\Model\Webservice\StructType\ListSafSecurityProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListSdpTransparencyProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListServiceParameterRes|\Losc\CucmBundle\Model\Webservice\StructType\ListServiceProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListSipDialRulesRes|\Losc\CucmBundle\Model\Webservice\StructType\ListSIPNormalizationScriptRes|\Losc\CucmBundle\Model\Webservice\StructType\ListSipProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListSipRealmRes|\Losc\CucmBundle\Model\Webservice\StructType\ListSipRoutePatternRes|\Losc\CucmBundle\Model\Webservice\StructType\ListSipTrunkRes|\Losc\CucmBundle\Model\Webservice\StructType\ListSipTrunkSecurityProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListSoftKeyTemplateRes|\Losc\CucmBundle\Model\Webservice\StructType\ListSrstRes|\Losc\CucmBundle\Model\Webservice\StructType\ListTimePeriodRes|\Losc\CucmBundle\Model\Webservice\StructType\ListTimeScheduleRes|\Losc\CucmBundle\Model\Webservice\StructType\ListTodAccessRes|\Losc\CucmBundle\Model\Webservice\StructType\ListTranscoderRes|\Losc\CucmBundle\Model\Webservice\StructType\ListTransformationProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListTransPatternRes|\Losc\CucmBundle\Model\Webservice\StructType\ListTvsCertificateRes|\Losc\CucmBundle\Model\Webservice\StructType\ListUcServiceRes|\Losc\CucmBundle\Model\Webservice\StructType\ListUnassignedPresenceServersRes|\Losc\CucmBundle\Model\Webservice\StructType\ListUnassignedPresenceUsersRes|\Losc\CucmBundle\Model\Webservice\StructType\ListUniversalDeviceTemplateRes|\Losc\CucmBundle\Model\Webservice\StructType\ListUniversalLineTemplateRes|\Losc\CucmBundle\Model\Webservice\StructType\ListUserGroupRes|\Losc\CucmBundle\Model\Webservice\StructType\ListUserProfileProvisionRes|\Losc\CucmBundle\Model\Webservice\StructType\ListUserRes|\Losc\CucmBundle\Model\Webservice\StructType\ListVohServerRes|\Losc\CucmBundle\Model\Webservice\StructType\ListVoiceMailPilotRes|\Losc\CucmBundle\Model\Webservice\StructType\ListVoiceMailPortRes|\Losc\CucmBundle\Model\Webservice\StructType\ListVoiceMailProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListVpnGatewayRes|\Losc\CucmBundle\Model\Webservice\StructType\ListVpnGroupRes|\Losc\CucmBundle\Model\Webservice\StructType\ListVpnProfileRes|\Losc\CucmBundle\Model\Webservice\StructType\ListWifiHotspotRes|\Losc\CucmBundle\Model\Webservice\StructType\ListWlanProfileGroupRes|\Losc\CucmBundle\Model\Webservice\StructType\ListWLANProfileRes
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
