<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for addDns StructType
 * @subpackage Structs
 */
class AddDns extends AbstractStructBase
{
    /**
     * The addDn
     * Meta information extracted from the WSDL
     * - maxOccurs: 3
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\AddDn[]
     */
    public $addDn;
    /**
     * Constructor method for addDns
     * @uses AddDns::setAddDn()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\AddDn[] $addDn
     */
    public function __construct(array $addDn = array())
    {
        $this
            ->setAddDn($addDn);
    }
    /**
     * Get addDn value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\AddDn[]|null
     */
    public function getAddDn()
    {
        return $this->addDn;
    }
    /**
     * This method is responsible for validating the values passed to the setAddDn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAddDn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAddDnForArrayConstraintsFromSetAddDn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $addDnsAddDnItem) {
            // validation for constraint: itemType
            if (!$addDnsAddDnItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\AddDn) {
                $invalidValues[] = is_object($addDnsAddDnItem) ? get_class($addDnsAddDnItem) : sprintf('%s(%s)', gettype($addDnsAddDnItem), var_export($addDnsAddDnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The addDn property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\AddDn, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set addDn value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\AddDn[] $addDn
     * @return \Losc\CucmBundle\Model\Webservice\StructType\AddDns
     */
    public function setAddDn(array $addDn = array())
    {
        // validation for constraint: array
        if ('' !== ($addDnArrayErrorMessage = self::validateAddDnForArrayConstraintsFromSetAddDn($addDn))) {
            throw new \InvalidArgumentException($addDnArrayErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(3)
        if (is_array($addDn) && count($addDn) > 3) {
            throw new \InvalidArgumentException(sprintf('Invalid count of %s, the number of elements contained by the property must be less than or equal to 3', count($addDn)), __LINE__);
        }
        $this->addDn = $addDn;
        return $this;
    }
    /**
     * Add item to addDn value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\AddDn $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\AddDns
     */
    public function addToAddDn(\Losc\CucmBundle\Model\Webservice\StructType\AddDn $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\AddDn) {
            throw new \InvalidArgumentException(sprintf('The addDn property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\AddDn, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: maxOccurs(3)
        if (is_array($this->addDn) && count($this->addDn) >= 3) {
            throw new \InvalidArgumentException(sprintf('You can\'t add anymore element to this property that already contains %s elements, the number of elements contained by the property must be less than or equal to 3', count($this->addDn)), __LINE__);
        }
        $this->addDn[] = $item;
        return $this;
    }
}
