<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for addLocales StructType
 * @subpackage Structs
 */
class AddLocales extends XCommonMembersExtension
{
    /**
     * The locale
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XMobileVoiceMember[]
     */
    public $locale;
    /**
     * Constructor method for addLocales
     * @uses AddLocales::setLocale()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XMobileVoiceMember[] $locale
     */
    public function __construct(array $locale = array())
    {
        $this
            ->setLocale($locale);
    }
    /**
     * Get locale value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XMobileVoiceMember[]
     */
    public function getLocale()
    {
        return $this->locale;
    }
    /**
     * This method is responsible for validating the values passed to the setLocale method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLocale method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLocaleForArrayConstraintsFromSetLocale(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $addLocalesLocaleItem) {
            // validation for constraint: itemType
            if (!$addLocalesLocaleItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\XMobileVoiceMember) {
                $invalidValues[] = is_object($addLocalesLocaleItem) ? get_class($addLocalesLocaleItem) : sprintf('%s(%s)', gettype($addLocalesLocaleItem), var_export($addLocalesLocaleItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The locale property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XMobileVoiceMember, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set locale value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XMobileVoiceMember[] $locale
     * @return \Losc\CucmBundle\Model\Webservice\StructType\AddLocales
     */
    public function setLocale(array $locale = array())
    {
        // validation for constraint: array
        if ('' !== ($localeArrayErrorMessage = self::validateLocaleForArrayConstraintsFromSetLocale($locale))) {
            throw new \InvalidArgumentException($localeArrayErrorMessage, __LINE__);
        }
        $this->locale = $locale;
        return $this;
    }
    /**
     * Add item to locale value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XMobileVoiceMember $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\AddLocales
     */
    public function addToLocale(\Losc\CucmBundle\Model\Webservice\StructType\XMobileVoiceMember $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\XMobileVoiceMember) {
            throw new \InvalidArgumentException(sprintf('The locale property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XMobileVoiceMember, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->locale[] = $item;
        return $this;
    }
}
