<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for addOnModules StructType
 * Meta information extracted from the WSDL
 * - documentation: Additional modules attached to the Phone.There can be 0,1 or 2. | Additional modules attached to the Phone.There can be 0,1, 2 or 3.
 * @subpackage Structs
 */
class AddOnModules extends AbstractStructBase
{
    /**
     * The addOnModule
     * Meta information extracted from the WSDL
     * - maxOccurs: 2
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XAddOnModule[]
     */
    public $addOnModule;
    /**
     * Constructor method for addOnModules
     * @uses AddOnModules::setAddOnModule()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XAddOnModule[] $addOnModule
     */
    public function __construct(array $addOnModule = array())
    {
        $this
            ->setAddOnModule($addOnModule);
    }
    /**
     * Get addOnModule value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XAddOnModule[]|null
     */
    public function getAddOnModule()
    {
        return $this->addOnModule;
    }
    /**
     * This method is responsible for validating the values passed to the setAddOnModule method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAddOnModule method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAddOnModuleForArrayConstraintsFromSetAddOnModule(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $addOnModulesAddOnModuleItem) {
            // validation for constraint: itemType
            if (!$addOnModulesAddOnModuleItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\XAddOnModule) {
                $invalidValues[] = is_object($addOnModulesAddOnModuleItem) ? get_class($addOnModulesAddOnModuleItem) : sprintf('%s(%s)', gettype($addOnModulesAddOnModuleItem), var_export($addOnModulesAddOnModuleItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The addOnModule property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XAddOnModule, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set addOnModule value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XAddOnModule[] $addOnModule
     * @return \Losc\CucmBundle\Model\Webservice\StructType\AddOnModules
     */
    public function setAddOnModule(array $addOnModule = array())
    {
        // validation for constraint: array
        if ('' !== ($addOnModuleArrayErrorMessage = self::validateAddOnModuleForArrayConstraintsFromSetAddOnModule($addOnModule))) {
            throw new \InvalidArgumentException($addOnModuleArrayErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(2)
        if (is_array($addOnModule) && count($addOnModule) > 2) {
            throw new \InvalidArgumentException(sprintf('Invalid count of %s, the number of elements contained by the property must be less than or equal to 2', count($addOnModule)), __LINE__);
        }
        $this->addOnModule = $addOnModule;
        return $this;
    }
    /**
     * Add item to addOnModule value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XAddOnModule $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\AddOnModules
     */
    public function addToAddOnModule(\Losc\CucmBundle\Model\Webservice\StructType\XAddOnModule $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\XAddOnModule) {
            throw new \InvalidArgumentException(sprintf('The addOnModule property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XAddOnModule, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: maxOccurs(2)
        if (is_array($this->addOnModule) && count($this->addOnModule) >= 2) {
            throw new \InvalidArgumentException(sprintf('You can\'t add anymore element to this property that already contains %s elements, the number of elements contained by the property must be less than or equal to 2', count($this->addOnModule)), __LINE__);
        }
        $this->addOnModule[] = $item;
        return $this;
    }
}
