<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for addParameters StructType
 * @subpackage Structs
 */
class AddParameters extends XCommonMembersExtension
{
    /**
     * The parameter
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XIpPhoneServicesParameter[]
     */
    public $parameter;
    /**
     * Constructor method for addParameters
     * @uses AddParameters::setParameter()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XIpPhoneServicesParameter[] $parameter
     */
    public function __construct(array $parameter = array())
    {
        $this
            ->setParameter($parameter);
    }
    /**
     * Get parameter value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XIpPhoneServicesParameter[]
     */
    public function getParameter()
    {
        return $this->parameter;
    }
    /**
     * This method is responsible for validating the values passed to the setParameter method
     * This method is willingly generated in order to preserve the one-line inline validation within the setParameter method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateParameterForArrayConstraintsFromSetParameter(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $addParametersParameterItem) {
            // validation for constraint: itemType
            if (!$addParametersParameterItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\XIpPhoneServicesParameter) {
                $invalidValues[] = is_object($addParametersParameterItem) ? get_class($addParametersParameterItem) : sprintf('%s(%s)', gettype($addParametersParameterItem), var_export($addParametersParameterItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The parameter property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XIpPhoneServicesParameter, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set parameter value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XIpPhoneServicesParameter[] $parameter
     * @return \Losc\CucmBundle\Model\Webservice\StructType\AddParameters
     */
    public function setParameter(array $parameter = array())
    {
        // validation for constraint: array
        if ('' !== ($parameterArrayErrorMessage = self::validateParameterForArrayConstraintsFromSetParameter($parameter))) {
            throw new \InvalidArgumentException($parameterArrayErrorMessage, __LINE__);
        }
        $this->parameter = $parameter;
        return $this;
    }
    /**
     * Add item to parameter value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XIpPhoneServicesParameter $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\AddParameters
     */
    public function addToParameter(\Losc\CucmBundle\Model\Webservice\StructType\XIpPhoneServicesParameter $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\XIpPhoneServicesParameter) {
            throw new \InvalidArgumentException(sprintf('The parameter property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XIpPhoneServicesParameter, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->parameter[] = $item;
        return $this;
    }
}
