<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for associatedEndusers StructType
 * @subpackage Structs
 */
class AssociatedEndusers extends AbstractStructBase
{
    /**
     * The enduser
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\LEnduserMember[]
     */
    public $enduser;
    /**
     * Constructor method for associatedEndusers
     * @uses AssociatedEndusers::setEnduser()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\LEnduserMember[] $enduser
     */
    public function __construct(array $enduser = array())
    {
        $this
            ->setEnduser($enduser);
    }
    /**
     * Get enduser value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\LEnduserMember[]|null
     */
    public function getEnduser()
    {
        return $this->enduser;
    }
    /**
     * This method is responsible for validating the values passed to the setEnduser method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEnduser method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEnduserForArrayConstraintsFromSetEnduser(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $associatedEndusersEnduserItem) {
            // validation for constraint: itemType
            if (!$associatedEndusersEnduserItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\LEnduserMember) {
                $invalidValues[] = is_object($associatedEndusersEnduserItem) ? get_class($associatedEndusersEnduserItem) : sprintf('%s(%s)', gettype($associatedEndusersEnduserItem), var_export($associatedEndusersEnduserItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The enduser property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\LEnduserMember, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set enduser value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\LEnduserMember[] $enduser
     * @return \Losc\CucmBundle\Model\Webservice\StructType\AssociatedEndusers
     */
    public function setEnduser(array $enduser = array())
    {
        // validation for constraint: array
        if ('' !== ($enduserArrayErrorMessage = self::validateEnduserForArrayConstraintsFromSetEnduser($enduser))) {
            throw new \InvalidArgumentException($enduserArrayErrorMessage, __LINE__);
        }
        $this->enduser = $enduser;
        return $this;
    }
    /**
     * Add item to enduser value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\LEnduserMember $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\AssociatedEndusers
     */
    public function addToEnduser(\Losc\CucmBundle\Model\Webservice\StructType\LEnduserMember $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\LEnduserMember) {
            throw new \InvalidArgumentException(sprintf('The enduser property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\LEnduserMember, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->enduser[] = $item;
        return $this;
    }
}
