<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for associatedGroups StructType
 * @subpackage Structs
 */
class AssociatedGroups extends AbstractStructBase
{
    /**
     * The userGroup
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\UserGroup[]
     */
    public $userGroup;
    /**
     * Constructor method for associatedGroups
     * @uses AssociatedGroups::setUserGroup()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\UserGroup[] $userGroup
     */
    public function __construct(array $userGroup = array())
    {
        $this
            ->setUserGroup($userGroup);
    }
    /**
     * Get userGroup value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UserGroup[]|null
     */
    public function getUserGroup()
    {
        return $this->userGroup;
    }
    /**
     * This method is responsible for validating the values passed to the setUserGroup method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUserGroup method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUserGroupForArrayConstraintsFromSetUserGroup(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $associatedGroupsUserGroupItem) {
            // validation for constraint: itemType
            if (!$associatedGroupsUserGroupItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\UserGroup) {
                $invalidValues[] = is_object($associatedGroupsUserGroupItem) ? get_class($associatedGroupsUserGroupItem) : sprintf('%s(%s)', gettype($associatedGroupsUserGroupItem), var_export($associatedGroupsUserGroupItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The userGroup property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\UserGroup, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set userGroup value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\UserGroup[] $userGroup
     * @return \Losc\CucmBundle\Model\Webservice\StructType\AssociatedGroups
     */
    public function setUserGroup(array $userGroup = array())
    {
        // validation for constraint: array
        if ('' !== ($userGroupArrayErrorMessage = self::validateUserGroupForArrayConstraintsFromSetUserGroup($userGroup))) {
            throw new \InvalidArgumentException($userGroupArrayErrorMessage, __LINE__);
        }
        $this->userGroup = $userGroup;
        return $this;
    }
    /**
     * Add item to userGroup value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\UserGroup $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\AssociatedGroups
     */
    public function addToUserGroup(\Losc\CucmBundle\Model\Webservice\StructType\UserGroup $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\UserGroup) {
            throw new \InvalidArgumentException(sprintf('The userGroup property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\UserGroup, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->userGroup[] = $item;
        return $this;
    }
}
