<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for audioSources StructType
 * Meta information extracted from the WSDL
 * - documentation: If isMultiCastEnabled is false then these elements are not necessary.MOHServer will be added to the database without the values of these tags. ie. The table MOHServerMulticastInfo table will be empty.
 * @subpackage Structs
 */
class AudioSources extends AbstractStructBase
{
    /**
     * The audioSource
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\AudioSource[]
     */
    public $audioSource;
    /**
     * Constructor method for audioSources
     * @uses AudioSources::setAudioSource()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\AudioSource[] $audioSource
     */
    public function __construct(array $audioSource = array())
    {
        $this
            ->setAudioSource($audioSource);
    }
    /**
     * Get audioSource value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\AudioSource[]|null
     */
    public function getAudioSource()
    {
        return $this->audioSource;
    }
    /**
     * This method is responsible for validating the values passed to the setAudioSource method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAudioSource method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAudioSourceForArrayConstraintsFromSetAudioSource(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $audioSourcesAudioSourceItem) {
            // validation for constraint: itemType
            if (!$audioSourcesAudioSourceItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\AudioSource) {
                $invalidValues[] = is_object($audioSourcesAudioSourceItem) ? get_class($audioSourcesAudioSourceItem) : sprintf('%s(%s)', gettype($audioSourcesAudioSourceItem), var_export($audioSourcesAudioSourceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The audioSource property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\AudioSource, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set audioSource value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\AudioSource[] $audioSource
     * @return \Losc\CucmBundle\Model\Webservice\StructType\AudioSources
     */
    public function setAudioSource(array $audioSource = array())
    {
        // validation for constraint: array
        if ('' !== ($audioSourceArrayErrorMessage = self::validateAudioSourceForArrayConstraintsFromSetAudioSource($audioSource))) {
            throw new \InvalidArgumentException($audioSourceArrayErrorMessage, __LINE__);
        }
        $this->audioSource = $audioSource;
        return $this;
    }
    /**
     * Add item to audioSource value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\AudioSource $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\AudioSources
     */
    public function addToAudioSource(\Losc\CucmBundle\Model\Webservice\StructType\AudioSource $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\AudioSource) {
            throw new \InvalidArgumentException(sprintf('The audioSource property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\AudioSource, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->audioSource[] = $item;
        return $this;
    }
}
