<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for betweenLocations StructType
 * @subpackage Structs
 */
class BetweenLocations extends AbstractStructBase
{
    /**
     * The betweenLocation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XLocationBetween[]
     */
    public $betweenLocation;
    /**
     * Constructor method for betweenLocations
     * @uses BetweenLocations::setBetweenLocation()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XLocationBetween[] $betweenLocation
     */
    public function __construct(array $betweenLocation = array())
    {
        $this
            ->setBetweenLocation($betweenLocation);
    }
    /**
     * Get betweenLocation value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XLocationBetween[]|null
     */
    public function getBetweenLocation()
    {
        return $this->betweenLocation;
    }
    /**
     * This method is responsible for validating the values passed to the setBetweenLocation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBetweenLocation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBetweenLocationForArrayConstraintsFromSetBetweenLocation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $betweenLocationsBetweenLocationItem) {
            // validation for constraint: itemType
            if (!$betweenLocationsBetweenLocationItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\XLocationBetween) {
                $invalidValues[] = is_object($betweenLocationsBetweenLocationItem) ? get_class($betweenLocationsBetweenLocationItem) : sprintf('%s(%s)', gettype($betweenLocationsBetweenLocationItem), var_export($betweenLocationsBetweenLocationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The betweenLocation property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XLocationBetween, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set betweenLocation value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XLocationBetween[] $betweenLocation
     * @return \Losc\CucmBundle\Model\Webservice\StructType\BetweenLocations
     */
    public function setBetweenLocation(array $betweenLocation = array())
    {
        // validation for constraint: array
        if ('' !== ($betweenLocationArrayErrorMessage = self::validateBetweenLocationForArrayConstraintsFromSetBetweenLocation($betweenLocation))) {
            throw new \InvalidArgumentException($betweenLocationArrayErrorMessage, __LINE__);
        }
        $this->betweenLocation = $betweenLocation;
        return $this;
    }
    /**
     * Add item to betweenLocation value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XLocationBetween $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\BetweenLocations
     */
    public function addToBetweenLocation(\Losc\CucmBundle\Model\Webservice\StructType\XLocationBetween $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\XLocationBetween) {
            throw new \InvalidArgumentException(sprintf('The betweenLocation property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XLocationBetween, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->betweenLocation[] = $item;
        return $this;
    }
}
