<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for buttons StructType
 * Meta information extracted from the WSDL
 * - documentation: The list of buttons on this model of Phone.The feature and label of first button cannot be modified.
 * @subpackage Structs
 */
class Buttons extends AbstractStructBase
{
    /**
     * The button
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XButton[]
     */
    public $button;
    /**
     * Constructor method for buttons
     * @uses Buttons::setButton()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XButton[] $button
     */
    public function __construct(array $button = array())
    {
        $this
            ->setButton($button);
    }
    /**
     * Get button value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XButton[]|null
     */
    public function getButton()
    {
        return $this->button;
    }
    /**
     * This method is responsible for validating the values passed to the setButton method
     * This method is willingly generated in order to preserve the one-line inline validation within the setButton method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateButtonForArrayConstraintsFromSetButton(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $buttonsButtonItem) {
            // validation for constraint: itemType
            if (!$buttonsButtonItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\XButton) {
                $invalidValues[] = is_object($buttonsButtonItem) ? get_class($buttonsButtonItem) : sprintf('%s(%s)', gettype($buttonsButtonItem), var_export($buttonsButtonItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The button property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XButton, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set button value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XButton[] $button
     * @return \Losc\CucmBundle\Model\Webservice\StructType\Buttons
     */
    public function setButton(array $button = array())
    {
        // validation for constraint: array
        if ('' !== ($buttonArrayErrorMessage = self::validateButtonForArrayConstraintsFromSetButton($button))) {
            throw new \InvalidArgumentException($buttonArrayErrorMessage, __LINE__);
        }
        $this->button = $button;
        return $this;
    }
    /**
     * Add item to button value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XButton $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\Buttons
     */
    public function addToButton(\Losc\CucmBundle\Model\Webservice\StructType\XButton $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\XButton) {
            throw new \InvalidArgumentException(sprintf('The button property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XButton, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->button[] = $item;
        return $this;
    }
}
