<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for changedTags StructType
 * @subpackage Structs
 */
class ChangedTags extends AbstractStructBase
{
    /**
     * The changedTag
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ChangedTag[]
     */
    public $changedTag;
    /**
     * Constructor method for changedTags
     * @uses ChangedTags::setChangedTag()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ChangedTag[] $changedTag
     */
    public function __construct(array $changedTag = array())
    {
        $this
            ->setChangedTag($changedTag);
    }
    /**
     * Get changedTag value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ChangedTag[]|null
     */
    public function getChangedTag()
    {
        return $this->changedTag;
    }
    /**
     * This method is responsible for validating the values passed to the setChangedTag method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChangedTag method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateChangedTagForArrayConstraintsFromSetChangedTag(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $changedTagsChangedTagItem) {
            // validation for constraint: itemType
            if (!$changedTagsChangedTagItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\ChangedTag) {
                $invalidValues[] = is_object($changedTagsChangedTagItem) ? get_class($changedTagsChangedTagItem) : sprintf('%s(%s)', gettype($changedTagsChangedTagItem), var_export($changedTagsChangedTagItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The changedTag property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\ChangedTag, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set changedTag value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ChangedTag[] $changedTag
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ChangedTags
     */
    public function setChangedTag(array $changedTag = array())
    {
        // validation for constraint: array
        if ('' !== ($changedTagArrayErrorMessage = self::validateChangedTagForArrayConstraintsFromSetChangedTag($changedTag))) {
            throw new \InvalidArgumentException($changedTagArrayErrorMessage, __LINE__);
        }
        $this->changedTag = $changedTag;
        return $this;
    }
    /**
     * Add item to changedTag value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ChangedTag $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ChangedTags
     */
    public function addToChangedTag(\Losc\CucmBundle\Model\Webservice\StructType\ChangedTag $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\ChangedTag) {
            throw new \InvalidArgumentException(sprintf('The changedTag property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\ChangedTag, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->changedTag[] = $item;
        return $this;
    }
}
