<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for changes StructType
 * @subpackage Structs
 */
class Changes extends AbstractStructBase
{
    /**
     * The change
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\Change[]
     */
    public $change;
    /**
     * Constructor method for changes
     * @uses Changes::setChange()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\Change[] $change
     */
    public function __construct(array $change = array())
    {
        $this
            ->setChange($change);
    }
    /**
     * Get change value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\Change[]|null
     */
    public function getChange()
    {
        return $this->change;
    }
    /**
     * This method is responsible for validating the values passed to the setChange method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChange method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateChangeForArrayConstraintsFromSetChange(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $changesChangeItem) {
            // validation for constraint: itemType
            if (!$changesChangeItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\Change) {
                $invalidValues[] = is_object($changesChangeItem) ? get_class($changesChangeItem) : sprintf('%s(%s)', gettype($changesChangeItem), var_export($changesChangeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The change property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\Change, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set change value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\Change[] $change
     * @return \Losc\CucmBundle\Model\Webservice\StructType\Changes
     */
    public function setChange(array $change = array())
    {
        // validation for constraint: array
        if ('' !== ($changeArrayErrorMessage = self::validateChangeForArrayConstraintsFromSetChange($change))) {
            throw new \InvalidArgumentException($changeArrayErrorMessage, __LINE__);
        }
        $this->change = $change;
        return $this;
    }
    /**
     * Add item to change value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\Change $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\Changes
     */
    public function addToChange(\Losc\CucmBundle\Model\Webservice\StructType\Change $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\Change) {
            throw new \InvalidArgumentException(sprintf('The change property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\Change, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->change[] = $item;
        return $this;
    }
}
