<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for customUserFields StructType
 * @subpackage Structs
 */
class CustomUserFields extends AbstractStructBase
{
    /**
     * The customUserField
     * Meta information extracted from the WSDL
     * - documentation: This Tag is valid only for GetUser
     * - choice: customUserField | customUserField | customUserField
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 0
     * - maxOccurs: 5
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XUserCustomUserField[]
     */
    public $customUserField;
    /**
     * Constructor method for customUserFields
     * @uses CustomUserFields::setCustomUserField()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XUserCustomUserField[] $customUserField
     */
    public function __construct(array $customUserField = array())
    {
        $this
            ->setCustomUserField($customUserField);
    }
    /**
     * Get customUserField value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XUserCustomUserField[]|null
     */
    public function getCustomUserField()
    {
        return isset($this->customUserField) ? $this->customUserField : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomUserField method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomUserField method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomUserFieldForArrayConstraintsFromSetCustomUserField(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customUserFieldsCustomUserFieldItem) {
            // validation for constraint: itemType
            if (!$customUserFieldsCustomUserFieldItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\XUserCustomUserField) {
                $invalidValues[] = is_object($customUserFieldsCustomUserFieldItem) ? get_class($customUserFieldsCustomUserFieldItem) : sprintf('%s(%s)', gettype($customUserFieldsCustomUserFieldItem), var_export($customUserFieldsCustomUserFieldItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customUserField property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XUserCustomUserField, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * This method is responsible for validating the value passed to the setCustomUserField method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomUserField method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateCustomUserFieldForChoiceConstraintsFromSetCustomUserField($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property customUserField can\'t be set as the property %s is already set. Only one property must be set among these properties: customUserField, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set customUserField value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XUserCustomUserField[] $customUserField
     * @return \Losc\CucmBundle\Model\Webservice\StructType\CustomUserFields
     */
    public function setCustomUserField(array $customUserField = array())
    {
        // validation for constraint: array
        if ('' !== ($customUserFieldArrayErrorMessage = self::validateCustomUserFieldForArrayConstraintsFromSetCustomUserField($customUserField))) {
            throw new \InvalidArgumentException($customUserFieldArrayErrorMessage, __LINE__);
        }
        // validation for constraint: choice(customUserField, customUserField, customUserField)
        if ('' !== ($customUserFieldChoiceErrorMessage = self::validateCustomUserFieldForChoiceConstraintsFromSetCustomUserField($customUserField))) {
            throw new \InvalidArgumentException($customUserFieldChoiceErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(5)
        if (is_array($customUserField) && count($customUserField) > 5) {
            throw new \InvalidArgumentException(sprintf('Invalid count of %s, the number of elements contained by the property must be less than or equal to 5', count($customUserField)), __LINE__);
        }
        if (is_null($customUserField) || (is_array($customUserField) && empty($customUserField))) {
            unset($this->customUserField);
        } else {
            $this->customUserField = $customUserField;
        }
        return $this;
    }
    /**
     * This method is responsible for validating the value passed to the addToCustomUserField method
     * This method is willingly generated in order to preserve the one-line inline validation within the addToCustomUserField method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateItemForChoiceConstraintsFromAddToCustomUserField($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property customUserField can\'t be set as the property %s is already set. Only one property must be set among these properties: customUserField, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Add item to customUserField value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XUserCustomUserField $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\CustomUserFields
     */
    public function addToCustomUserField(\Losc\CucmBundle\Model\Webservice\StructType\XUserCustomUserField $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\XUserCustomUserField) {
            throw new \InvalidArgumentException(sprintf('The customUserField property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XUserCustomUserField, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: choice(customUserField, customUserField, customUserField)
        if ('' !== ($itemChoiceErrorMessage = self::validateItemForChoiceConstraintsFromAddToCustomUserField($item))) {
            throw new \InvalidArgumentException($itemChoiceErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(5)
        if (is_array($this->customUserField) && count($this->customUserField) >= 5) {
            throw new \InvalidArgumentException(sprintf('You can\'t add anymore element to this property that already contains %s elements, the number of elements contained by the property must be less than or equal to 5', count($this->customUserField)), __LINE__);
        }
        $this->customUserField[] = $item;
        return $this;
    }
}
