<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for destination StructType
 * @subpackage Structs
 */
class Destination extends AbstractStructBase
{
    /**
     * The gatewayName
     * Meta information extracted from the WSDL
     * - choice: gatewayName | routeListName | gatewayName | routeListName | gatewayName | routeListName
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $gatewayName;
    /**
     * The routeListName
     * Meta information extracted from the WSDL
     * - choice: gatewayName | routeListName | gatewayName | routeListName | gatewayName | routeListName
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $routeListName;
    /**
     * Constructor method for destination
     * @uses Destination::setGatewayName()
     * @uses Destination::setRouteListName()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $gatewayName
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $routeListName
     */
    public function __construct(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $gatewayName = null, \Losc\CucmBundle\Model\Webservice\StructType\XFkType $routeListName = null)
    {
        $this
            ->setGatewayName($gatewayName)
            ->setRouteListName($routeListName);
    }
    /**
     * Get gatewayName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getGatewayName()
    {
        return isset($this->gatewayName) ? $this->gatewayName : null;
    }
    /**
     * This method is responsible for validating the value passed to the setGatewayName method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGatewayName method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateGatewayNameForChoiceConstraintsFromSetGatewayName($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'routeListName',
            'routeListName',
            'routeListName',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property gatewayName can\'t be set as the property %s is already set. Only one property must be set among these properties: gatewayName, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set gatewayName value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $gatewayName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\Destination
     */
    public function setGatewayName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $gatewayName = null)
    {
        // validation for constraint: choice(gatewayName, routeListName, gatewayName, routeListName, gatewayName, routeListName)
        if ('' !== ($gatewayNameChoiceErrorMessage = self::validateGatewayNameForChoiceConstraintsFromSetGatewayName($gatewayName))) {
            throw new \InvalidArgumentException($gatewayNameChoiceErrorMessage, __LINE__);
        }
        if (is_null($gatewayName) || (is_array($gatewayName) && empty($gatewayName))) {
            unset($this->gatewayName);
        } else {
            $this->gatewayName = $gatewayName;
        }
        return $this;
    }
    /**
     * Get routeListName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getRouteListName()
    {
        return isset($this->routeListName) ? $this->routeListName : null;
    }
    /**
     * This method is responsible for validating the value passed to the setRouteListName method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRouteListName method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateRouteListNameForChoiceConstraintsFromSetRouteListName($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'gatewayName',
            'gatewayName',
            'gatewayName',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property routeListName can\'t be set as the property %s is already set. Only one property must be set among these properties: routeListName, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set routeListName value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $routeListName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\Destination
     */
    public function setRouteListName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $routeListName = null)
    {
        // validation for constraint: choice(gatewayName, routeListName, gatewayName, routeListName, gatewayName, routeListName)
        if ('' !== ($routeListNameChoiceErrorMessage = self::validateRouteListNameForChoiceConstraintsFromSetRouteListName($routeListName))) {
            throw new \InvalidArgumentException($routeListNameChoiceErrorMessage, __LINE__);
        }
        if (is_null($routeListName) || (is_array($routeListName) && empty($routeListName))) {
            unset($this->routeListName);
        } else {
            $this->routeListName = $routeListName;
        }
        return $this;
    }
}
