<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for dialParameters StructType
 * @subpackage Structs
 */
class DialParameters extends AbstractStructBase
{
    /**
     * The dialParameter
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \Losc\CucmBundle\Model\Webservice\StructType\LParameterMember[]
     */
    public $dialParameter;
    /**
     * Constructor method for dialParameters
     * @uses DialParameters::setDialParameter()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\LParameterMember[] $dialParameter
     */
    public function __construct(array $dialParameter = array())
    {
        $this
            ->setDialParameter($dialParameter);
    }
    /**
     * Get dialParameter value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\LParameterMember[]
     */
    public function getDialParameter()
    {
        return $this->dialParameter;
    }
    /**
     * This method is responsible for validating the values passed to the setDialParameter method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDialParameter method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDialParameterForArrayConstraintsFromSetDialParameter(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $dialParametersDialParameterItem) {
            // validation for constraint: itemType
            if (!$dialParametersDialParameterItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\LParameterMember) {
                $invalidValues[] = is_object($dialParametersDialParameterItem) ? get_class($dialParametersDialParameterItem) : sprintf('%s(%s)', gettype($dialParametersDialParameterItem), var_export($dialParametersDialParameterItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The dialParameter property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\LParameterMember, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set dialParameter value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\LParameterMember[] $dialParameter
     * @return \Losc\CucmBundle\Model\Webservice\StructType\DialParameters
     */
    public function setDialParameter(array $dialParameter = array())
    {
        // validation for constraint: array
        if ('' !== ($dialParameterArrayErrorMessage = self::validateDialParameterForArrayConstraintsFromSetDialParameter($dialParameter))) {
            throw new \InvalidArgumentException($dialParameterArrayErrorMessage, __LINE__);
        }
        $this->dialParameter = $dialParameter;
        return $this;
    }
    /**
     * Add item to dialParameter value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\LParameterMember $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\DialParameters
     */
    public function addToDialParameter(\Losc\CucmBundle\Model\Webservice\StructType\LParameterMember $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\LParameterMember) {
            throw new \InvalidArgumentException(sprintf('The dialParameter property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\LParameterMember, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->dialParameter[] = $item;
        return $this;
    }
}
