<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DoDeviceLogoutReq StructType
 * Meta information extracted from the WSDL
 * - documentation: This method logs-out whichever user is logged-into the device.
 * @subpackage Structs
 */
class DoDeviceLogoutReq extends APIRequest
{
    /**
     * The deviceName
     * Meta information extracted from the WSDL
     * - documentation: The name or uuid of the device to perform the log-out on.
     * - nillable: false
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $deviceName;
    /**
     * Constructor method for DoDeviceLogoutReq
     * @uses DoDeviceLogoutReq::setDeviceName()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $deviceName
     */
    public function __construct(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $deviceName = null)
    {
        $this
            ->setDeviceName($deviceName);
    }
    /**
     * Get deviceName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getDeviceName()
    {
        return $this->deviceName;
    }
    /**
     * Set deviceName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $deviceName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\DoDeviceLogoutReq
     */
    public function setDeviceName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $deviceName = null)
    {
        $this->deviceName = $deviceName;
        return $this;
    }
}
