<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for extensionsInfo StructType
 * Meta information extracted from the WSDL
 * - documentation: These tags are for Quick User/Phone Add page
 * @subpackage Structs
 */
class ExtensionsInfo extends XCommonMembersExtension
{
    /**
     * The extension
     * Meta information extracted from the WSDL
     * - documentation: These tags are for Quick User/Phone Add page
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XExtension[]
     */
    public $extension;
    /**
     * Constructor method for extensionsInfo
     * @uses ExtensionsInfo::setExtension()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XExtension[] $extension
     */
    public function __construct(array $extension = array())
    {
        $this
            ->setExtension($extension);
    }
    /**
     * Get extension value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XExtension[]|null
     */
    public function getExtension()
    {
        return $this->extension;
    }
    /**
     * This method is responsible for validating the values passed to the setExtension method
     * This method is willingly generated in order to preserve the one-line inline validation within the setExtension method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateExtensionForArrayConstraintsFromSetExtension(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $extensionsInfoExtensionItem) {
            // validation for constraint: itemType
            if (!$extensionsInfoExtensionItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\XExtension) {
                $invalidValues[] = is_object($extensionsInfoExtensionItem) ? get_class($extensionsInfoExtensionItem) : sprintf('%s(%s)', gettype($extensionsInfoExtensionItem), var_export($extensionsInfoExtensionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The extension property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XExtension, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set extension value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XExtension[] $extension
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ExtensionsInfo
     */
    public function setExtension(array $extension = array())
    {
        // validation for constraint: array
        if ('' !== ($extensionArrayErrorMessage = self::validateExtensionForArrayConstraintsFromSetExtension($extension))) {
            throw new \InvalidArgumentException($extensionArrayErrorMessage, __LINE__);
        }
        $this->extension = $extension;
        return $this;
    }
    /**
     * Add item to extension value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XExtension $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ExtensionsInfo
     */
    public function addToExtension(\Losc\CucmBundle\Model\Webservice\StructType\XExtension $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\XExtension) {
            throw new \InvalidArgumentException(sprintf('The extension property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XExtension, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->extension[] = $item;
        return $this;
    }
}
