<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetCredentialPolicyDefaultReq StructType
 * @subpackage Structs
 */
class GetCredentialPolicyDefaultReq extends AbstractStructBase
{
    /**
     * The credentialUser
     * Meta information extracted from the WSDL
     * - choice: credentialUser | credentialType | credPolicyName
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $credentialUser;
    /**
     * The credentialType
     * Meta information extracted from the WSDL
     * - choice: credentialUser | credentialType | credPolicyName
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $credentialType;
    /**
     * The credPolicyName
     * Meta information extracted from the WSDL
     * - choice: credentialUser | credentialType | credPolicyName
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $credPolicyName;
    /**
     * The returnedTags
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\RCredentialPolicyDefault
     */
    public $returnedTags;
    /**
     * The sequence
     * Meta information extracted from the WSDL
     * - use: optional
     * @var int
     */
    public $sequence;
    /**
     * Constructor method for GetCredentialPolicyDefaultReq
     * @uses GetCredentialPolicyDefaultReq::setCredentialUser()
     * @uses GetCredentialPolicyDefaultReq::setCredentialType()
     * @uses GetCredentialPolicyDefaultReq::setCredPolicyName()
     * @uses GetCredentialPolicyDefaultReq::setReturnedTags()
     * @uses GetCredentialPolicyDefaultReq::setSequence()
     * @param string $credentialUser
     * @param string $credentialType
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $credPolicyName
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RCredentialPolicyDefault $returnedTags
     * @param int $sequence
     */
    public function __construct($credentialUser = null, $credentialType = null, \Losc\CucmBundle\Model\Webservice\StructType\XFkType $credPolicyName = null, \Losc\CucmBundle\Model\Webservice\StructType\RCredentialPolicyDefault $returnedTags = null, $sequence = null)
    {
        $this
            ->setCredentialUser($credentialUser)
            ->setCredentialType($credentialType)
            ->setCredPolicyName($credPolicyName)
            ->setReturnedTags($returnedTags)
            ->setSequence($sequence);
    }
    /**
     * Get credentialUser value
     * @return string
     */
    public function getCredentialUser()
    {
        return isset($this->credentialUser) ? $this->credentialUser : null;
    }
    /**
     * This method is responsible for validating the value passed to the setCredentialUser method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCredentialUser method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateCredentialUserForChoiceConstraintsFromSetCredentialUser($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'credentialType',
            'credPolicyName',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property credentialUser can\'t be set as the property %s is already set. Only one property must be set among these properties: credentialUser, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set credentialUser value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XCredentialUser::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XCredentialUser::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $credentialUser
     * @return \Losc\CucmBundle\Model\Webservice\StructType\GetCredentialPolicyDefaultReq
     */
    public function setCredentialUser($credentialUser = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XCredentialUser::valueIsValid($credentialUser)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XCredentialUser', is_array($credentialUser) ? implode(', ', $credentialUser) : var_export($credentialUser, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XCredentialUser::getValidValues())), __LINE__);
        }
        // validation for constraint: choice(credentialUser, credentialType, credPolicyName)
        if ('' !== ($credentialUserChoiceErrorMessage = self::validateCredentialUserForChoiceConstraintsFromSetCredentialUser($credentialUser))) {
            throw new \InvalidArgumentException($credentialUserChoiceErrorMessage, __LINE__);
        }
        if (is_null($credentialUser) || (is_array($credentialUser) && empty($credentialUser))) {
            unset($this->credentialUser);
        } else {
            $this->credentialUser = $credentialUser;
        }
        return $this;
    }
    /**
     * Get credentialType value
     * @return string
     */
    public function getCredentialType()
    {
        return isset($this->credentialType) ? $this->credentialType : null;
    }
    /**
     * This method is responsible for validating the value passed to the setCredentialType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCredentialType method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateCredentialTypeForChoiceConstraintsFromSetCredentialType($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'credentialUser',
            'credPolicyName',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property credentialType can\'t be set as the property %s is already set. Only one property must be set among these properties: credentialType, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set credentialType value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XCredential::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XCredential::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $credentialType
     * @return \Losc\CucmBundle\Model\Webservice\StructType\GetCredentialPolicyDefaultReq
     */
    public function setCredentialType($credentialType = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XCredential::valueIsValid($credentialType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XCredential', is_array($credentialType) ? implode(', ', $credentialType) : var_export($credentialType, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XCredential::getValidValues())), __LINE__);
        }
        // validation for constraint: choice(credentialUser, credentialType, credPolicyName)
        if ('' !== ($credentialTypeChoiceErrorMessage = self::validateCredentialTypeForChoiceConstraintsFromSetCredentialType($credentialType))) {
            throw new \InvalidArgumentException($credentialTypeChoiceErrorMessage, __LINE__);
        }
        if (is_null($credentialType) || (is_array($credentialType) && empty($credentialType))) {
            unset($this->credentialType);
        } else {
            $this->credentialType = $credentialType;
        }
        return $this;
    }
    /**
     * Get credPolicyName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public function getCredPolicyName()
    {
        return isset($this->credPolicyName) ? $this->credPolicyName : null;
    }
    /**
     * This method is responsible for validating the value passed to the setCredPolicyName method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCredPolicyName method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateCredPolicyNameForChoiceConstraintsFromSetCredPolicyName($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'credentialUser',
            'credentialType',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property credPolicyName can\'t be set as the property %s is already set. Only one property must be set among these properties: credPolicyName, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set credPolicyName value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $credPolicyName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\GetCredentialPolicyDefaultReq
     */
    public function setCredPolicyName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $credPolicyName = null)
    {
        // validation for constraint: choice(credentialUser, credentialType, credPolicyName)
        if ('' !== ($credPolicyNameChoiceErrorMessage = self::validateCredPolicyNameForChoiceConstraintsFromSetCredPolicyName($credPolicyName))) {
            throw new \InvalidArgumentException($credPolicyNameChoiceErrorMessage, __LINE__);
        }
        if (is_null($credPolicyName) || (is_array($credPolicyName) && empty($credPolicyName))) {
            unset($this->credPolicyName);
        } else {
            $this->credPolicyName = $credPolicyName;
        }
        return $this;
    }
    /**
     * Get returnedTags value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RCredentialPolicyDefault|null
     */
    public function getReturnedTags()
    {
        return $this->returnedTags;
    }
    /**
     * Set returnedTags value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RCredentialPolicyDefault $returnedTags
     * @return \Losc\CucmBundle\Model\Webservice\StructType\GetCredentialPolicyDefaultReq
     */
    public function setReturnedTags(\Losc\CucmBundle\Model\Webservice\StructType\RCredentialPolicyDefault $returnedTags = null)
    {
        $this->returnedTags = $returnedTags;
        return $this;
    }
    /**
     * Get sequence value
     * @return int|null
     */
    public function getSequence()
    {
        return $this->sequence;
    }
    /**
     * Set sequence value
     * @param int $sequence
     * @return \Losc\CucmBundle\Model\Webservice\StructType\GetCredentialPolicyDefaultReq
     */
    public function setSequence($sequence = null)
    {
        // validation for constraint: int
        if (!is_null($sequence) && !(is_int($sequence) || ctype_digit($sequence))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sequence, true), gettype($sequence)), __LINE__);
        }
        $this->sequence = $sequence;
        return $this;
    }
}
