<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetMobilityReq StructType
 * Meta information extracted from the WSDL
 * - documentation: It is mandatory to give either handoffNumber or DTMFNumber tag in the request. Both can't be null. | Retrieves mobility configuration information.
 * @subpackage Structs
 */
class GetMobilityReq extends AbstractStructBase
{
    /**
     * The handoffNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $handoffNumber;
    /**
     * The DTMFNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $DTMFNumber;
    /**
     * The returnedTags
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\RMobility
     */
    public $returnedTags;
    /**
     * Constructor method for GetMobilityReq
     * @uses GetMobilityReq::setHandoffNumber()
     * @uses GetMobilityReq::setDTMFNumber()
     * @uses GetMobilityReq::setReturnedTags()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $handoffNumber
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $dTMFNumber
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RMobility $returnedTags
     */
    public function __construct(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $handoffNumber = null, \Losc\CucmBundle\Model\Webservice\StructType\XFkType $dTMFNumber = null, \Losc\CucmBundle\Model\Webservice\StructType\RMobility $returnedTags = null)
    {
        $this
            ->setHandoffNumber($handoffNumber)
            ->setDTMFNumber($dTMFNumber)
            ->setReturnedTags($returnedTags);
    }
    /**
     * Get handoffNumber value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getHandoffNumber()
    {
        return $this->handoffNumber;
    }
    /**
     * Set handoffNumber value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $handoffNumber
     * @return \Losc\CucmBundle\Model\Webservice\StructType\GetMobilityReq
     */
    public function setHandoffNumber(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $handoffNumber = null)
    {
        $this->handoffNumber = $handoffNumber;
        return $this;
    }
    /**
     * Get DTMFNumber value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getDTMFNumber()
    {
        return $this->DTMFNumber;
    }
    /**
     * Set DTMFNumber value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $dTMFNumber
     * @return \Losc\CucmBundle\Model\Webservice\StructType\GetMobilityReq
     */
    public function setDTMFNumber(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $dTMFNumber = null)
    {
        $this->DTMFNumber = $dTMFNumber;
        return $this;
    }
    /**
     * Get returnedTags value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RMobility|null
     */
    public function getReturnedTags()
    {
        return $this->returnedTags;
    }
    /**
     * Set returnedTags value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RMobility $returnedTags
     * @return \Losc\CucmBundle\Model\Webservice\StructType\GetMobilityReq
     */
    public function setReturnedTags(\Losc\CucmBundle\Model\Webservice\StructType\RMobility $returnedTags = null)
    {
        $this->returnedTags = $returnedTags;
        return $this;
    }
}
