<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetNumDevicesReq StructType
 * Meta information extracted from the WSDL
 * - documentation: This method returns the number of devices found. The caller specifies what class of device they want counted.
 * @subpackage Structs
 */
class GetNumDevicesReq extends APIRequest
{
    /**
     * The class
     * Meta information extracted from the WSDL
     * - documentation: The class of device that is to be counted. Cannot be null.
     * - nillable: false
     * @var string
     */
    public $class;
    /**
     * Constructor method for GetNumDevicesReq
     * @uses GetNumDevicesReq::setClass()
     * @param string $class
     */
    public function __construct($class = null)
    {
        $this
            ->setClass($class);
    }
    /**
     * Get class value
     * @return string|null
     */
    public function getClass()
    {
        return $this->class;
    }
    /**
     * Set class value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XClass::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XClass::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $class
     * @return \Losc\CucmBundle\Model\Webservice\StructType\GetNumDevicesReq
     */
    public function setClass($class = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XClass::valueIsValid($class)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XClass', is_array($class) ? implode(', ', $class) : var_export($class, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XClass::getValidValues())), __LINE__);
        }
        $this->class = $class;
        return $this;
    }
}
