<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LAarGroupMatrix StructType
 * @subpackage Structs
 */
class LAarGroupMatrix extends AbstractStructBase
{
    /**
     * The prefixDigit
     * Meta information extracted from the WSDL
     * - documentation: The new prefixDigit value for this particular AARGroup relationship.
     * - base: xsd:string
     * - maxLength: 255
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $prefixDigit;
    /**
     * The aarGroupFromName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $aarGroupFromName;
    /**
     * The aarGroupToName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $aarGroupToName;
    /**
     * Constructor method for LAarGroupMatrix
     * @uses LAarGroupMatrix::setPrefixDigit()
     * @uses LAarGroupMatrix::setAarGroupFromName()
     * @uses LAarGroupMatrix::setAarGroupToName()
     * @param string $prefixDigit
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $aarGroupFromName
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $aarGroupToName
     */
    public function __construct($prefixDigit = null, \Losc\CucmBundle\Model\Webservice\StructType\XFkType $aarGroupFromName = null, \Losc\CucmBundle\Model\Webservice\StructType\XFkType $aarGroupToName = null)
    {
        $this
            ->setPrefixDigit($prefixDigit)
            ->setAarGroupFromName($aarGroupFromName)
            ->setAarGroupToName($aarGroupToName);
    }
    /**
     * Get prefixDigit value
     * @return string|null
     */
    public function getPrefixDigit()
    {
        return $this->prefixDigit;
    }
    /**
     * Set prefixDigit value
     * @param string $prefixDigit
     * @return \Losc\CucmBundle\Model\Webservice\StructType\LAarGroupMatrix
     */
    public function setPrefixDigit($prefixDigit = null)
    {
        // validation for constraint: string
        if (!is_null($prefixDigit) && !is_string($prefixDigit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($prefixDigit, true), gettype($prefixDigit)), __LINE__);
        }
        // validation for constraint: maxLength(255)
        if (!is_null($prefixDigit) && mb_strlen($prefixDigit) > 255) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 255', mb_strlen($prefixDigit)), __LINE__);
        }
        $this->prefixDigit = $prefixDigit;
        return $this;
    }
    /**
     * Get aarGroupFromName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getAarGroupFromName()
    {
        return $this->aarGroupFromName;
    }
    /**
     * Set aarGroupFromName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $aarGroupFromName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\LAarGroupMatrix
     */
    public function setAarGroupFromName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $aarGroupFromName = null)
    {
        $this->aarGroupFromName = $aarGroupFromName;
        return $this;
    }
    /**
     * Get aarGroupToName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getAarGroupToName()
    {
        return $this->aarGroupToName;
    }
    /**
     * Set aarGroupToName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $aarGroupToName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\LAarGroupMatrix
     */
    public function setAarGroupToName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $aarGroupToName = null)
    {
        $this->aarGroupToName = $aarGroupToName;
        return $this;
    }
}
