<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LTODAccessMember StructType
 * @subpackage Structs
 */
class LTODAccessMember extends AbstractStructBase
{
    /**
     * The timeScheduleName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $timeScheduleName;
    /**
     * The accessListName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $accessListName;
    /**
     * The uuid
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - pattern: \{........-....-....-....-............\}
     * @var string
     */
    public $uuid;
    /**
     * Constructor method for LTODAccessMember
     * @uses LTODAccessMember::setTimeScheduleName()
     * @uses LTODAccessMember::setAccessListName()
     * @uses LTODAccessMember::setUuid()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $timeScheduleName
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $accessListName
     * @param string $uuid
     */
    public function __construct(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $timeScheduleName = null, \Losc\CucmBundle\Model\Webservice\StructType\XFkType $accessListName = null, $uuid = null)
    {
        $this
            ->setTimeScheduleName($timeScheduleName)
            ->setAccessListName($accessListName)
            ->setUuid($uuid);
    }
    /**
     * Get timeScheduleName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getTimeScheduleName()
    {
        return $this->timeScheduleName;
    }
    /**
     * Set timeScheduleName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $timeScheduleName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\LTODAccessMember
     */
    public function setTimeScheduleName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $timeScheduleName = null)
    {
        $this->timeScheduleName = $timeScheduleName;
        return $this;
    }
    /**
     * Get accessListName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getAccessListName()
    {
        return $this->accessListName;
    }
    /**
     * Set accessListName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $accessListName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\LTODAccessMember
     */
    public function setAccessListName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $accessListName = null)
    {
        $this->accessListName = $accessListName;
        return $this;
    }
    /**
     * Get uuid value
     * @return string|null
     */
    public function getUuid()
    {
        return $this->uuid;
    }
    /**
     * Set uuid value
     * @param string $uuid
     * @return \Losc\CucmBundle\Model\Webservice\StructType\LTODAccessMember
     */
    public function setUuid($uuid = null)
    {
        // validation for constraint: string
        if (!is_null($uuid) && !is_string($uuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uuid, true), gettype($uuid)), __LINE__);
        }
        // validation for constraint: pattern(\{........-....-....-....-............\})
        if (!is_null($uuid) && !preg_match('/\\{........-....-....-....-............\\}/', $uuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression \{........-....-....-....-............\}', var_export($uuid, true)), __LINE__);
        }
        $this->uuid = $uuid;
        return $this;
    }
}
