<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ListSafForwarderReq StructType
 * @subpackage Structs
 */
class ListSafForwarderReq extends AbstractStructBase
{
    /**
     * The returnedTags
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var \Losc\CucmBundle\Model\Webservice\StructType\LSafForwarder
     */
    public $returnedTags;
    /**
     * The searchCriteria
     * @var \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public $searchCriteria;
    /**
     * The skip
     * Meta information extracted from the WSDL
     * - documentation: It will be used only when first tag is specified.
     * - minOccurs: 0
     * @var int
     */
    public $skip;
    /**
     * The first
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $first;
    /**
     * The sequence
     * Meta information extracted from the WSDL
     * - use: optional
     * @var int
     */
    public $sequence;
    /**
     * Constructor method for ListSafForwarderReq
     * @uses ListSafForwarderReq::setReturnedTags()
     * @uses ListSafForwarderReq::setSearchCriteria()
     * @uses ListSafForwarderReq::setSkip()
     * @uses ListSafForwarderReq::setFirst()
     * @uses ListSafForwarderReq::setSequence()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\LSafForwarder $returnedTags
     * @param \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria $searchCriteria
     * @param int $skip
     * @param int $first
     * @param int $sequence
     */
    public function __construct(\Losc\CucmBundle\Model\Webservice\StructType\LSafForwarder $returnedTags = null, \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria $searchCriteria = null, $skip = null, $first = null, $sequence = null)
    {
        $this
            ->setReturnedTags($returnedTags)
            ->setSearchCriteria($searchCriteria)
            ->setSkip($skip)
            ->setFirst($first)
            ->setSequence($sequence);
    }
    /**
     * Get returnedTags value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\LSafForwarder
     */
    public function getReturnedTags()
    {
        return $this->returnedTags;
    }
    /**
     * Set returnedTags value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\LSafForwarder $returnedTags
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListSafForwarderReq
     */
    public function setReturnedTags(\Losc\CucmBundle\Model\Webservice\StructType\LSafForwarder $returnedTags = null)
    {
        $this->returnedTags = $returnedTags;
        return $this;
    }
    /**
     * Get searchCriteria value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria|null
     */
    public function getSearchCriteria()
    {
        return $this->searchCriteria;
    }
    /**
     * Set searchCriteria value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria $searchCriteria
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListSafForwarderReq
     */
    public function setSearchCriteria(\Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria $searchCriteria = null)
    {
        $this->searchCriteria = $searchCriteria;
        return $this;
    }
    /**
     * Get skip value
     * @return int|null
     */
    public function getSkip()
    {
        return $this->skip;
    }
    /**
     * Set skip value
     * @param int $skip
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListSafForwarderReq
     */
    public function setSkip($skip = null)
    {
        // validation for constraint: int
        if (!is_null($skip) && !(is_int($skip) || ctype_digit($skip))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($skip, true), gettype($skip)), __LINE__);
        }
        $this->skip = $skip;
        return $this;
    }
    /**
     * Get first value
     * @return int|null
     */
    public function getFirst()
    {
        return $this->first;
    }
    /**
     * Set first value
     * @param int $first
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListSafForwarderReq
     */
    public function setFirst($first = null)
    {
        // validation for constraint: int
        if (!is_null($first) && !(is_int($first) || ctype_digit($first))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($first, true), gettype($first)), __LINE__);
        }
        $this->first = $first;
        return $this;
    }
    /**
     * Get sequence value
     * @return int|null
     */
    public function getSequence()
    {
        return $this->sequence;
    }
    /**
     * Set sequence value
     * @param int $sequence
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ListSafForwarderReq
     */
    public function setSequence($sequence = null)
    {
        // validation for constraint: int
        if (!is_null($sequence) && !(is_int($sequence) || ctype_digit($sequence))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sequence, true), gettype($sequence)), __LINE__);
        }
        $this->sequence = $sequence;
        return $this;
    }
}
