<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for members StructType
 * Meta information extracted from the WSDL
 * - documentation: On Addition always the first member added is itself. Do not specify the first member as itself in an Add request . Also make sure that the priority always starts with 1. It will internally be taken care of during Addition and
 * Updation.
 * @subpackage Structs
 */
class Members extends XCommonMembersExtension
{
    /**
     * The member
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XTimeScheduleTimePeriod[]
     */
    public $member;
    /**
     * Constructor method for members
     * @uses Members::setMember()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XTimeScheduleTimePeriod[] $member
     */
    public function __construct(array $member = array())
    {
        $this
            ->setMember($member);
    }
    /**
     * Get member value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XTimeScheduleTimePeriod[]|null
     */
    public function getMember()
    {
        return $this->member;
    }
    /**
     * This method is responsible for validating the values passed to the setMember method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMember method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMemberForArrayConstraintsFromSetMember(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $membersMemberItem) {
            // validation for constraint: itemType
            if (!$membersMemberItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\XTimeScheduleTimePeriod) {
                $invalidValues[] = is_object($membersMemberItem) ? get_class($membersMemberItem) : sprintf('%s(%s)', gettype($membersMemberItem), var_export($membersMemberItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The member property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XTimeScheduleTimePeriod, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set member value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XTimeScheduleTimePeriod[] $member
     * @return \Losc\CucmBundle\Model\Webservice\StructType\Members
     */
    public function setMember(array $member = array())
    {
        // validation for constraint: array
        if ('' !== ($memberArrayErrorMessage = self::validateMemberForArrayConstraintsFromSetMember($member))) {
            throw new \InvalidArgumentException($memberArrayErrorMessage, __LINE__);
        }
        $this->member = $member;
        return $this;
    }
    /**
     * Add item to member value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XTimeScheduleTimePeriod $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\Members
     */
    public function addToMember(\Losc\CucmBundle\Model\Webservice\StructType\XTimeScheduleTimePeriod $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\XTimeScheduleTimePeriod) {
            throw new \InvalidArgumentException(sprintf('The member property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XTimeScheduleTimePeriod, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->member[] = $item;
        return $this;
    }
}
