<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for normalizationScriptInfos StructType
 * Meta information extracted from the WSDL
 * - documentation: Adding parameters for normalization script Info
 * @subpackage Structs
 */
class NormalizationScriptInfos extends AbstractStructBase
{
    /**
     * The normalizationScriptInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XNormalizationScriptInfo[]
     */
    public $normalizationScriptInfo;
    /**
     * Constructor method for normalizationScriptInfos
     * @uses NormalizationScriptInfos::setNormalizationScriptInfo()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XNormalizationScriptInfo[] $normalizationScriptInfo
     */
    public function __construct(array $normalizationScriptInfo = array())
    {
        $this
            ->setNormalizationScriptInfo($normalizationScriptInfo);
    }
    /**
     * Get normalizationScriptInfo value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XNormalizationScriptInfo[]|null
     */
    public function getNormalizationScriptInfo()
    {
        return $this->normalizationScriptInfo;
    }
    /**
     * This method is responsible for validating the values passed to the setNormalizationScriptInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setNormalizationScriptInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateNormalizationScriptInfoForArrayConstraintsFromSetNormalizationScriptInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $normalizationScriptInfosNormalizationScriptInfoItem) {
            // validation for constraint: itemType
            if (!$normalizationScriptInfosNormalizationScriptInfoItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\XNormalizationScriptInfo) {
                $invalidValues[] = is_object($normalizationScriptInfosNormalizationScriptInfoItem) ? get_class($normalizationScriptInfosNormalizationScriptInfoItem) : sprintf('%s(%s)', gettype($normalizationScriptInfosNormalizationScriptInfoItem), var_export($normalizationScriptInfosNormalizationScriptInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The normalizationScriptInfo property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XNormalizationScriptInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set normalizationScriptInfo value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XNormalizationScriptInfo[] $normalizationScriptInfo
     * @return \Losc\CucmBundle\Model\Webservice\StructType\NormalizationScriptInfos
     */
    public function setNormalizationScriptInfo(array $normalizationScriptInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($normalizationScriptInfoArrayErrorMessage = self::validateNormalizationScriptInfoForArrayConstraintsFromSetNormalizationScriptInfo($normalizationScriptInfo))) {
            throw new \InvalidArgumentException($normalizationScriptInfoArrayErrorMessage, __LINE__);
        }
        $this->normalizationScriptInfo = $normalizationScriptInfo;
        return $this;
    }
    /**
     * Add item to normalizationScriptInfo value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XNormalizationScriptInfo $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\NormalizationScriptInfos
     */
    public function addToNormalizationScriptInfo(\Losc\CucmBundle\Model\Webservice\StructType\XNormalizationScriptInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\XNormalizationScriptInfo) {
            throw new \InvalidArgumentException(sprintf('The normalizationScriptInfo property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XNormalizationScriptInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->normalizationScriptInfo[] = $item;
        return $this;
    }
}
