<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ORDeviceProfile StructType
 * @subpackage Structs
 */
class ORDeviceProfile extends AbstractStructBase
{
    /**
     * The product
     * Meta information extracted from the WSDL
     * - documentation: Product ID string. read-only except when creating a device.
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public $product;
    /**
     * The class
     * Meta information extracted from the WSDL
     * - documentation: Class ID string. Class information is read-only except when creating a device.
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public $class;
    /**
     * The protocol
     * Meta information extracted from the WSDL
     * - documentation: Protocol option is read-only,except when creating a device.
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public $protocol;
    /**
     * The protocolSide
     * Meta information extracted from the WSDL
     * - documentation: Side information is read-only except when creating a device
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public $protocolSide;
    /**
     * The userHoldMohAudioSourceId
     * Meta information extracted from the WSDL
     * - documentation: This tag is not valid for H323Phone,H323trunk and SIPTrunk
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public $userHoldMohAudioSourceId;
    /**
     * The mlppIndicationStatus
     * Meta information extracted from the WSDL
     * - documentation: This setting only affects devices that support MLPP.
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public $mlppIndicationStatus;
    /**
     * The preemption
     * Meta information extracted from the WSDL
     * - documentation: This setting only affects devices that support MLPP.
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public $preemption;
    /**
     * The lines
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\Lines
     */
    public $lines;
    /**
     * The phoneTemplateName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public $phoneTemplateName;
    /**
     * The blfDirectedCallParks
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\BlfDirectedCallParks
     */
    public $blfDirectedCallParks;
    /**
     * The addOnModules
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\AddOnModules
     */
    public $addOnModules;
    /**
     * The userLocale
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public $userLocale;
    /**
     * The singleButtonBarge
     * Meta information extracted from the WSDL
     * - documentation: This tag is valid only for devices that support SBB.
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public $singleButtonBarge;
    /**
     * The joinAcrossLines
     * Meta information extracted from the WSDL
     * - documentation: This tag is valid only for devices that support JAL..
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public $joinAcrossLines;
    /**
     * The loginUserId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public $loginUserId;
    /**
     * The dndOption
     * Meta information extracted from the WSDL
     * - documentation: This tag is valid only for devices that support DND.
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public $dndOption;
    /**
     * The dndRingSetting
     * Meta information extracted from the WSDL
     * - documentation: This tag is valid only for devices that support DND.
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public $dndRingSetting;
    /**
     * The emccCallingSearchSpace
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public $emccCallingSearchSpace;
    /**
     * The alwaysUsePrimeLine
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public $alwaysUsePrimeLine;
    /**
     * The alwaysUsePrimeLineForVoiceMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public $alwaysUsePrimeLineForVoiceMessage;
    /**
     * The softkeyTemplateName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public $softkeyTemplateName;
    /**
     * The callInfoPrivacyStatus
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public $callInfoPrivacyStatus;
    /**
     * The services
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\Services
     */
    public $services;
    /**
     * The featureControlPolicy
     * Meta information extracted from the WSDL
     * - documentation: This tag is valid only for RT Phones.
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public $featureControlPolicy;
    /**
     * The ctiid
     * @var int
     */
    public $ctiid;
    /**
     * The uuid
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - pattern: \{........-....-....-....-............\}
     * @var string
     */
    public $uuid;
    /**
     * Constructor method for ORDeviceProfile
     * @uses ORDeviceProfile::setProduct()
     * @uses ORDeviceProfile::setClass()
     * @uses ORDeviceProfile::setProtocol()
     * @uses ORDeviceProfile::setProtocolSide()
     * @uses ORDeviceProfile::setUserHoldMohAudioSourceId()
     * @uses ORDeviceProfile::setMlppIndicationStatus()
     * @uses ORDeviceProfile::setPreemption()
     * @uses ORDeviceProfile::setLines()
     * @uses ORDeviceProfile::setPhoneTemplateName()
     * @uses ORDeviceProfile::setBlfDirectedCallParks()
     * @uses ORDeviceProfile::setAddOnModules()
     * @uses ORDeviceProfile::setUserLocale()
     * @uses ORDeviceProfile::setSingleButtonBarge()
     * @uses ORDeviceProfile::setJoinAcrossLines()
     * @uses ORDeviceProfile::setLoginUserId()
     * @uses ORDeviceProfile::setDndOption()
     * @uses ORDeviceProfile::setDndRingSetting()
     * @uses ORDeviceProfile::setEmccCallingSearchSpace()
     * @uses ORDeviceProfile::setAlwaysUsePrimeLine()
     * @uses ORDeviceProfile::setAlwaysUsePrimeLineForVoiceMessage()
     * @uses ORDeviceProfile::setSoftkeyTemplateName()
     * @uses ORDeviceProfile::setCallInfoPrivacyStatus()
     * @uses ORDeviceProfile::setServices()
     * @uses ORDeviceProfile::setFeatureControlPolicy()
     * @uses ORDeviceProfile::setCtiid()
     * @uses ORDeviceProfile::setUuid()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $product
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $class
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $protocol
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $protocolSide
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $userHoldMohAudioSourceId
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $mlppIndicationStatus
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $preemption
     * @param \Losc\CucmBundle\Model\Webservice\StructType\Lines $lines
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $phoneTemplateName
     * @param \Losc\CucmBundle\Model\Webservice\StructType\BlfDirectedCallParks $blfDirectedCallParks
     * @param \Losc\CucmBundle\Model\Webservice\StructType\AddOnModules $addOnModules
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $userLocale
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $singleButtonBarge
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $joinAcrossLines
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $loginUserId
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $dndOption
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $dndRingSetting
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $emccCallingSearchSpace
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $alwaysUsePrimeLine
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $alwaysUsePrimeLineForVoiceMessage
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $softkeyTemplateName
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $callInfoPrivacyStatus
     * @param \Losc\CucmBundle\Model\Webservice\StructType\Services $services
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $featureControlPolicy
     * @param int $ctiid
     * @param string $uuid
     */
    public function __construct(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $product = null, \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $class = null, \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $protocol = null, \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $protocolSide = null, \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $userHoldMohAudioSourceId = null, \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $mlppIndicationStatus = null, \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $preemption = null, \Losc\CucmBundle\Model\Webservice\StructType\Lines $lines = null, \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $phoneTemplateName = null, \Losc\CucmBundle\Model\Webservice\StructType\BlfDirectedCallParks $blfDirectedCallParks = null, \Losc\CucmBundle\Model\Webservice\StructType\AddOnModules $addOnModules = null, \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $userLocale = null, \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $singleButtonBarge = null, \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $joinAcrossLines = null, \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $loginUserId = null, \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $dndOption = null, \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $dndRingSetting = null, \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $emccCallingSearchSpace = null, \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $alwaysUsePrimeLine = null, \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $alwaysUsePrimeLineForVoiceMessage = null, \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $softkeyTemplateName = null, \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $callInfoPrivacyStatus = null, \Losc\CucmBundle\Model\Webservice\StructType\Services $services = null, \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $featureControlPolicy = null, $ctiid = null, $uuid = null)
    {
        $this
            ->setProduct($product)
            ->setClass($class)
            ->setProtocol($protocol)
            ->setProtocolSide($protocolSide)
            ->setUserHoldMohAudioSourceId($userHoldMohAudioSourceId)
            ->setMlppIndicationStatus($mlppIndicationStatus)
            ->setPreemption($preemption)
            ->setLines($lines)
            ->setPhoneTemplateName($phoneTemplateName)
            ->setBlfDirectedCallParks($blfDirectedCallParks)
            ->setAddOnModules($addOnModules)
            ->setUserLocale($userLocale)
            ->setSingleButtonBarge($singleButtonBarge)
            ->setJoinAcrossLines($joinAcrossLines)
            ->setLoginUserId($loginUserId)
            ->setDndOption($dndOption)
            ->setDndRingSetting($dndRingSetting)
            ->setEmccCallingSearchSpace($emccCallingSearchSpace)
            ->setAlwaysUsePrimeLine($alwaysUsePrimeLine)
            ->setAlwaysUsePrimeLineForVoiceMessage($alwaysUsePrimeLineForVoiceMessage)
            ->setSoftkeyTemplateName($softkeyTemplateName)
            ->setCallInfoPrivacyStatus($callInfoPrivacyStatus)
            ->setServices($services)
            ->setFeatureControlPolicy($featureControlPolicy)
            ->setCtiid($ctiid)
            ->setUuid($uuid);
    }
    /**
     * Get product value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType|null
     */
    public function getProduct()
    {
        return $this->product;
    }
    /**
     * Set product value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $product
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setProduct(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $product = null)
    {
        $this->product = $product;
        return $this;
    }
    /**
     * Get class value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType|null
     */
    public function getClass()
    {
        return $this->class;
    }
    /**
     * Set class value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $class
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setClass(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $class = null)
    {
        $this->class = $class;
        return $this;
    }
    /**
     * Get protocol value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType|null
     */
    public function getProtocol()
    {
        return $this->protocol;
    }
    /**
     * Set protocol value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $protocol
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setProtocol(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $protocol = null)
    {
        $this->protocol = $protocol;
        return $this;
    }
    /**
     * Get protocolSide value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType|null
     */
    public function getProtocolSide()
    {
        return $this->protocolSide;
    }
    /**
     * Set protocolSide value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $protocolSide
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setProtocolSide(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $protocolSide = null)
    {
        $this->protocolSide = $protocolSide;
        return $this;
    }
    /**
     * Get userHoldMohAudioSourceId value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType|null
     */
    public function getUserHoldMohAudioSourceId()
    {
        return $this->userHoldMohAudioSourceId;
    }
    /**
     * Set userHoldMohAudioSourceId value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $userHoldMohAudioSourceId
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setUserHoldMohAudioSourceId(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $userHoldMohAudioSourceId = null)
    {
        $this->userHoldMohAudioSourceId = $userHoldMohAudioSourceId;
        return $this;
    }
    /**
     * Get mlppIndicationStatus value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType|null
     */
    public function getMlppIndicationStatus()
    {
        return $this->mlppIndicationStatus;
    }
    /**
     * Set mlppIndicationStatus value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $mlppIndicationStatus
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setMlppIndicationStatus(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $mlppIndicationStatus = null)
    {
        $this->mlppIndicationStatus = $mlppIndicationStatus;
        return $this;
    }
    /**
     * Get preemption value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType|null
     */
    public function getPreemption()
    {
        return $this->preemption;
    }
    /**
     * Set preemption value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $preemption
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setPreemption(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $preemption = null)
    {
        $this->preemption = $preemption;
        return $this;
    }
    /**
     * Get lines value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\Lines|null
     */
    public function getLines()
    {
        return $this->lines;
    }
    /**
     * Set lines value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\Lines $lines
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setLines(\Losc\CucmBundle\Model\Webservice\StructType\Lines $lines = null)
    {
        $this->lines = $lines;
        return $this;
    }
    /**
     * Get phoneTemplateName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType|null
     */
    public function getPhoneTemplateName()
    {
        return $this->phoneTemplateName;
    }
    /**
     * Set phoneTemplateName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $phoneTemplateName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setPhoneTemplateName(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $phoneTemplateName = null)
    {
        $this->phoneTemplateName = $phoneTemplateName;
        return $this;
    }
    /**
     * Get blfDirectedCallParks value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\BlfDirectedCallParks|null
     */
    public function getBlfDirectedCallParks()
    {
        return $this->blfDirectedCallParks;
    }
    /**
     * Set blfDirectedCallParks value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\BlfDirectedCallParks $blfDirectedCallParks
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setBlfDirectedCallParks(\Losc\CucmBundle\Model\Webservice\StructType\BlfDirectedCallParks $blfDirectedCallParks = null)
    {
        $this->blfDirectedCallParks = $blfDirectedCallParks;
        return $this;
    }
    /**
     * Get addOnModules value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\AddOnModules|null
     */
    public function getAddOnModules()
    {
        return $this->addOnModules;
    }
    /**
     * Set addOnModules value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\AddOnModules $addOnModules
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setAddOnModules(\Losc\CucmBundle\Model\Webservice\StructType\AddOnModules $addOnModules = null)
    {
        $this->addOnModules = $addOnModules;
        return $this;
    }
    /**
     * Get userLocale value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType|null
     */
    public function getUserLocale()
    {
        return $this->userLocale;
    }
    /**
     * Set userLocale value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $userLocale
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setUserLocale(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $userLocale = null)
    {
        $this->userLocale = $userLocale;
        return $this;
    }
    /**
     * Get singleButtonBarge value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType|null
     */
    public function getSingleButtonBarge()
    {
        return $this->singleButtonBarge;
    }
    /**
     * Set singleButtonBarge value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $singleButtonBarge
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setSingleButtonBarge(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $singleButtonBarge = null)
    {
        $this->singleButtonBarge = $singleButtonBarge;
        return $this;
    }
    /**
     * Get joinAcrossLines value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType|null
     */
    public function getJoinAcrossLines()
    {
        return $this->joinAcrossLines;
    }
    /**
     * Set joinAcrossLines value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $joinAcrossLines
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setJoinAcrossLines(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $joinAcrossLines = null)
    {
        $this->joinAcrossLines = $joinAcrossLines;
        return $this;
    }
    /**
     * Get loginUserId value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType|null
     */
    public function getLoginUserId()
    {
        return $this->loginUserId;
    }
    /**
     * Set loginUserId value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $loginUserId
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setLoginUserId(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $loginUserId = null)
    {
        $this->loginUserId = $loginUserId;
        return $this;
    }
    /**
     * Get dndOption value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType|null
     */
    public function getDndOption()
    {
        return $this->dndOption;
    }
    /**
     * Set dndOption value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $dndOption
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setDndOption(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $dndOption = null)
    {
        $this->dndOption = $dndOption;
        return $this;
    }
    /**
     * Get dndRingSetting value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType|null
     */
    public function getDndRingSetting()
    {
        return $this->dndRingSetting;
    }
    /**
     * Set dndRingSetting value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $dndRingSetting
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setDndRingSetting(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $dndRingSetting = null)
    {
        $this->dndRingSetting = $dndRingSetting;
        return $this;
    }
    /**
     * Get emccCallingSearchSpace value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType|null
     */
    public function getEmccCallingSearchSpace()
    {
        return $this->emccCallingSearchSpace;
    }
    /**
     * Set emccCallingSearchSpace value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $emccCallingSearchSpace
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setEmccCallingSearchSpace(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $emccCallingSearchSpace = null)
    {
        $this->emccCallingSearchSpace = $emccCallingSearchSpace;
        return $this;
    }
    /**
     * Get alwaysUsePrimeLine value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType|null
     */
    public function getAlwaysUsePrimeLine()
    {
        return $this->alwaysUsePrimeLine;
    }
    /**
     * Set alwaysUsePrimeLine value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $alwaysUsePrimeLine
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setAlwaysUsePrimeLine(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $alwaysUsePrimeLine = null)
    {
        $this->alwaysUsePrimeLine = $alwaysUsePrimeLine;
        return $this;
    }
    /**
     * Get alwaysUsePrimeLineForVoiceMessage value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType|null
     */
    public function getAlwaysUsePrimeLineForVoiceMessage()
    {
        return $this->alwaysUsePrimeLineForVoiceMessage;
    }
    /**
     * Set alwaysUsePrimeLineForVoiceMessage value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $alwaysUsePrimeLineForVoiceMessage
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setAlwaysUsePrimeLineForVoiceMessage(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $alwaysUsePrimeLineForVoiceMessage = null)
    {
        $this->alwaysUsePrimeLineForVoiceMessage = $alwaysUsePrimeLineForVoiceMessage;
        return $this;
    }
    /**
     * Get softkeyTemplateName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType|null
     */
    public function getSoftkeyTemplateName()
    {
        return $this->softkeyTemplateName;
    }
    /**
     * Set softkeyTemplateName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $softkeyTemplateName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setSoftkeyTemplateName(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $softkeyTemplateName = null)
    {
        $this->softkeyTemplateName = $softkeyTemplateName;
        return $this;
    }
    /**
     * Get callInfoPrivacyStatus value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType|null
     */
    public function getCallInfoPrivacyStatus()
    {
        return $this->callInfoPrivacyStatus;
    }
    /**
     * Set callInfoPrivacyStatus value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $callInfoPrivacyStatus
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setCallInfoPrivacyStatus(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $callInfoPrivacyStatus = null)
    {
        $this->callInfoPrivacyStatus = $callInfoPrivacyStatus;
        return $this;
    }
    /**
     * Get services value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\Services|null
     */
    public function getServices()
    {
        return $this->services;
    }
    /**
     * Set services value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\Services $services
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setServices(\Losc\CucmBundle\Model\Webservice\StructType\Services $services = null)
    {
        $this->services = $services;
        return $this;
    }
    /**
     * Get featureControlPolicy value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType|null
     */
    public function getFeatureControlPolicy()
    {
        return $this->featureControlPolicy;
    }
    /**
     * Set featureControlPolicy value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\ORFkType $featureControlPolicy
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setFeatureControlPolicy(\Losc\CucmBundle\Model\Webservice\StructType\ORFkType $featureControlPolicy = null)
    {
        $this->featureControlPolicy = $featureControlPolicy;
        return $this;
    }
    /**
     * Get ctiid value
     * @return int|null
     */
    public function getCtiid()
    {
        return $this->ctiid;
    }
    /**
     * Set ctiid value
     * @param int $ctiid
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setCtiid($ctiid = null)
    {
        // validation for constraint: int
        if (!is_null($ctiid) && !(is_int($ctiid) || ctype_digit($ctiid))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($ctiid, true), gettype($ctiid)), __LINE__);
        }
        $this->ctiid = $ctiid;
        return $this;
    }
    /**
     * Get uuid value
     * @return string|null
     */
    public function getUuid()
    {
        return $this->uuid;
    }
    /**
     * Set uuid value
     * @param string $uuid
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORDeviceProfile
     */
    public function setUuid($uuid = null)
    {
        // validation for constraint: string
        if (!is_null($uuid) && !is_string($uuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uuid, true), gettype($uuid)), __LINE__);
        }
        // validation for constraint: pattern(\{........-....-....-....-............\})
        if (!is_null($uuid) && !preg_match('/\\{........-....-....-....-............\\}/', $uuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression \{........-....-....-....-............\}', var_export($uuid, true)), __LINE__);
        }
        $this->uuid = $uuid;
        return $this;
    }
}
