<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ORFkType StructType
 * @subpackage Structs
 */
class ORFkType extends AbstractStructBase
{
    /**
     * The choice
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\GetOptionType[]
     */
    public $choice;
    /**
     * Constructor method for ORFkType
     * @uses ORFkType::setChoice()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\GetOptionType[] $choice
     */
    public function __construct(array $choice = array())
    {
        $this
            ->setChoice($choice);
    }
    /**
     * Get choice value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\GetOptionType[]|null
     */
    public function getChoice()
    {
        return $this->choice;
    }
    /**
     * This method is responsible for validating the values passed to the setChoice method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChoice method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateChoiceForArrayConstraintsFromSetChoice(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $oRFkTypeChoiceItem) {
            // validation for constraint: itemType
            if (!$oRFkTypeChoiceItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\GetOptionType) {
                $invalidValues[] = is_object($oRFkTypeChoiceItem) ? get_class($oRFkTypeChoiceItem) : sprintf('%s(%s)', gettype($oRFkTypeChoiceItem), var_export($oRFkTypeChoiceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The choice property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\GetOptionType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set choice value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\GetOptionType[] $choice
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public function setChoice(array $choice = array())
    {
        // validation for constraint: array
        if ('' !== ($choiceArrayErrorMessage = self::validateChoiceForArrayConstraintsFromSetChoice($choice))) {
            throw new \InvalidArgumentException($choiceArrayErrorMessage, __LINE__);
        }
        $this->choice = $choice;
        return $this;
    }
    /**
     * Add item to choice value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\GetOptionType $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ORFkType
     */
    public function addToChoice(\Losc\CucmBundle\Model\Webservice\StructType\GetOptionType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\GetOptionType) {
            throw new \InvalidArgumentException(sprintf('The choice property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\GetOptionType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->choice[] = $item;
        return $this;
    }
}
