<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for pageSection StructType
 * @subpackage Structs
 */
class PageSection extends AbstractStructBase
{
    /**
     * The name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $name;
    /**
     * The state
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $state;
    /**
     * The order
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $order;
    /**
     * Constructor method for pageSection
     * @uses PageSection::setName()
     * @uses PageSection::setState()
     * @uses PageSection::setOrder()
     * @param string $name
     * @param string $state
     * @param string $order
     */
    public function __construct($name = null, $state = null, $order = null)
    {
        $this
            ->setName($name)
            ->setState($state)
            ->setOrder($order);
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XWebPageSection::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XWebPageSection::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $name
     * @return \Losc\CucmBundle\Model\Webservice\StructType\PageSection
     */
    public function setName($name = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XWebPageSection::valueIsValid($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XWebPageSection', is_array($name) ? implode(', ', $name) : var_export($name, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XWebPageSection::getValidValues())), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get state value
     * @return string|null
     */
    public function getState()
    {
        return $this->state;
    }
    /**
     * Set state value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XWebPageDisplay::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XWebPageDisplay::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $state
     * @return \Losc\CucmBundle\Model\Webservice\StructType\PageSection
     */
    public function setState($state = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XWebPageDisplay::valueIsValid($state)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XWebPageDisplay', is_array($state) ? implode(', ', $state) : var_export($state, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XWebPageDisplay::getValidValues())), __LINE__);
        }
        $this->state = $state;
        return $this;
    }
    /**
     * Get order value
     * @return string|null
     */
    public function getOrder()
    {
        return $this->order;
    }
    /**
     * Set order value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $order
     * @return \Losc\CucmBundle\Model\Webservice\StructType\PageSection
     */
    public function setOrder($order = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($order)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($order) ? implode(', ', $order) : var_export($order, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->order = $order;
        return $this;
    }
}
