<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for pageSections StructType
 * @subpackage Structs
 */
class PageSections extends AbstractStructBase
{
    /**
     * The pageSection
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\PageSection[]
     */
    public $pageSection;
    /**
     * Constructor method for pageSections
     * @uses PageSections::setPageSection()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\PageSection[] $pageSection
     */
    public function __construct(array $pageSection = array())
    {
        $this
            ->setPageSection($pageSection);
    }
    /**
     * Get pageSection value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\PageSection[]|null
     */
    public function getPageSection()
    {
        return $this->pageSection;
    }
    /**
     * This method is responsible for validating the values passed to the setPageSection method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPageSection method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePageSectionForArrayConstraintsFromSetPageSection(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pageSectionsPageSectionItem) {
            // validation for constraint: itemType
            if (!$pageSectionsPageSectionItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\PageSection) {
                $invalidValues[] = is_object($pageSectionsPageSectionItem) ? get_class($pageSectionsPageSectionItem) : sprintf('%s(%s)', gettype($pageSectionsPageSectionItem), var_export($pageSectionsPageSectionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The pageSection property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\PageSection, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set pageSection value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\PageSection[] $pageSection
     * @return \Losc\CucmBundle\Model\Webservice\StructType\PageSections
     */
    public function setPageSection(array $pageSection = array())
    {
        // validation for constraint: array
        if ('' !== ($pageSectionArrayErrorMessage = self::validatePageSectionForArrayConstraintsFromSetPageSection($pageSection))) {
            throw new \InvalidArgumentException($pageSectionArrayErrorMessage, __LINE__);
        }
        $this->pageSection = $pageSection;
        return $this;
    }
    /**
     * Add item to pageSection value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\PageSection $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\PageSections
     */
    public function addToPageSection(\Losc\CucmBundle\Model\Webservice\StructType\PageSection $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\PageSection) {
            throw new \InvalidArgumentException(sprintf('The pageSection property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\PageSection, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->pageSection[] = $item;
        return $this;
    }
}
