<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for phoneProfiles StructType
 * @subpackage Structs
 */
class PhoneProfiles extends AbstractStructBase
{
    /**
     * The profileName
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType[]
     */
    public $profileName;
    /**
     * Constructor method for phoneProfiles
     * @uses PhoneProfiles::setProfileName()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType[] $profileName
     */
    public function __construct(array $profileName = array())
    {
        $this
            ->setProfileName($profileName);
    }
    /**
     * Get profileName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType[]|null
     */
    public function getProfileName()
    {
        return $this->profileName;
    }
    /**
     * This method is responsible for validating the values passed to the setProfileName method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProfileName method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProfileNameForArrayConstraintsFromSetProfileName(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $phoneProfilesProfileNameItem) {
            // validation for constraint: itemType
            if (!$phoneProfilesProfileNameItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\XFkType) {
                $invalidValues[] = is_object($phoneProfilesProfileNameItem) ? get_class($phoneProfilesProfileNameItem) : sprintf('%s(%s)', gettype($phoneProfilesProfileNameItem), var_export($phoneProfilesProfileNameItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The profileName property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XFkType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set profileName value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType[] $profileName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\PhoneProfiles
     */
    public function setProfileName(array $profileName = array())
    {
        // validation for constraint: array
        if ('' !== ($profileNameArrayErrorMessage = self::validateProfileNameForArrayConstraintsFromSetProfileName($profileName))) {
            throw new \InvalidArgumentException($profileNameArrayErrorMessage, __LINE__);
        }
        $this->profileName = $profileName;
        return $this;
    }
    /**
     * Add item to profileName value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\PhoneProfiles
     */
    public function addToProfileName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\XFkType) {
            throw new \InvalidArgumentException(sprintf('The profileName property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XFkType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->profileName[] = $item;
        return $this;
    }
}
