<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for presenceGroups StructType
 * @subpackage Structs
 */
class PresenceGroups extends AbstractStructBase
{
    /**
     * The presenceGroup
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XPresenceGroupMember[]
     */
    public $presenceGroup;
    /**
     * Constructor method for presenceGroups
     * @uses PresenceGroups::setPresenceGroup()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XPresenceGroupMember[] $presenceGroup
     */
    public function __construct(array $presenceGroup = array())
    {
        $this
            ->setPresenceGroup($presenceGroup);
    }
    /**
     * Get presenceGroup value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XPresenceGroupMember[]|null
     */
    public function getPresenceGroup()
    {
        return $this->presenceGroup;
    }
    /**
     * This method is responsible for validating the values passed to the setPresenceGroup method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPresenceGroup method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePresenceGroupForArrayConstraintsFromSetPresenceGroup(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $presenceGroupsPresenceGroupItem) {
            // validation for constraint: itemType
            if (!$presenceGroupsPresenceGroupItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\XPresenceGroupMember) {
                $invalidValues[] = is_object($presenceGroupsPresenceGroupItem) ? get_class($presenceGroupsPresenceGroupItem) : sprintf('%s(%s)', gettype($presenceGroupsPresenceGroupItem), var_export($presenceGroupsPresenceGroupItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The presenceGroup property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XPresenceGroupMember, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set presenceGroup value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XPresenceGroupMember[] $presenceGroup
     * @return \Losc\CucmBundle\Model\Webservice\StructType\PresenceGroups
     */
    public function setPresenceGroup(array $presenceGroup = array())
    {
        // validation for constraint: array
        if ('' !== ($presenceGroupArrayErrorMessage = self::validatePresenceGroupForArrayConstraintsFromSetPresenceGroup($presenceGroup))) {
            throw new \InvalidArgumentException($presenceGroupArrayErrorMessage, __LINE__);
        }
        $this->presenceGroup = $presenceGroup;
        return $this;
    }
    /**
     * Add item to presenceGroup value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XPresenceGroupMember $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\PresenceGroups
     */
    public function addToPresenceGroup(\Losc\CucmBundle\Model\Webservice\StructType\XPresenceGroupMember $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\XPresenceGroupMember) {
            throw new \InvalidArgumentException(sprintf('The presenceGroup property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XPresenceGroupMember, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->presenceGroup[] = $item;
        return $this;
    }
}
