<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RImeFeatureConfig StructType
 * @subpackage Structs
 */
class RImeFeatureConfig extends AbstractStructBase
{
    /**
     * The preventImeCallsFromAnalogGateways
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $preventImeCallsFromAnalogGateways;
    /**
     * The enableIntraDomain
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $enableIntraDomain;
    /**
     * The allowMwiNotification
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $allowMwiNotification;
    /**
     * The trunkConnectionTimer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $trunkConnectionTimer;
    /**
     * The firewallConnectionTimer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $firewallConnectionTimer;
    /**
     * The firewallTranscationTimer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $firewallTranscationTimer;
    /**
     * The firewallIdleTimer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $firewallIdleTimer;
    /**
     * The failedCallAttemptThreshold
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $failedCallAttemptThreshold;
    /**
     * The callFallbackAttemptThreshold
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $callFallbackAttemptThreshold;
    /**
     * The qualityTimer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $qualityTimer;
    /**
     * The useImeForOutboundCalls
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $useImeForOutboundCalls;
    /**
     * Constructor method for RImeFeatureConfig
     * @uses RImeFeatureConfig::setPreventImeCallsFromAnalogGateways()
     * @uses RImeFeatureConfig::setEnableIntraDomain()
     * @uses RImeFeatureConfig::setAllowMwiNotification()
     * @uses RImeFeatureConfig::setTrunkConnectionTimer()
     * @uses RImeFeatureConfig::setFirewallConnectionTimer()
     * @uses RImeFeatureConfig::setFirewallTranscationTimer()
     * @uses RImeFeatureConfig::setFirewallIdleTimer()
     * @uses RImeFeatureConfig::setFailedCallAttemptThreshold()
     * @uses RImeFeatureConfig::setCallFallbackAttemptThreshold()
     * @uses RImeFeatureConfig::setQualityTimer()
     * @uses RImeFeatureConfig::setUseImeForOutboundCalls()
     * @param string $preventImeCallsFromAnalogGateways
     * @param string $enableIntraDomain
     * @param string $allowMwiNotification
     * @param string $trunkConnectionTimer
     * @param string $firewallConnectionTimer
     * @param string $firewallTranscationTimer
     * @param string $firewallIdleTimer
     * @param string $failedCallAttemptThreshold
     * @param string $callFallbackAttemptThreshold
     * @param string $qualityTimer
     * @param string $useImeForOutboundCalls
     */
    public function __construct($preventImeCallsFromAnalogGateways = null, $enableIntraDomain = null, $allowMwiNotification = null, $trunkConnectionTimer = null, $firewallConnectionTimer = null, $firewallTranscationTimer = null, $firewallIdleTimer = null, $failedCallAttemptThreshold = null, $callFallbackAttemptThreshold = null, $qualityTimer = null, $useImeForOutboundCalls = null)
    {
        $this
            ->setPreventImeCallsFromAnalogGateways($preventImeCallsFromAnalogGateways)
            ->setEnableIntraDomain($enableIntraDomain)
            ->setAllowMwiNotification($allowMwiNotification)
            ->setTrunkConnectionTimer($trunkConnectionTimer)
            ->setFirewallConnectionTimer($firewallConnectionTimer)
            ->setFirewallTranscationTimer($firewallTranscationTimer)
            ->setFirewallIdleTimer($firewallIdleTimer)
            ->setFailedCallAttemptThreshold($failedCallAttemptThreshold)
            ->setCallFallbackAttemptThreshold($callFallbackAttemptThreshold)
            ->setQualityTimer($qualityTimer)
            ->setUseImeForOutboundCalls($useImeForOutboundCalls);
    }
    /**
     * Get preventImeCallsFromAnalogGateways value
     * @return string|null
     */
    public function getPreventImeCallsFromAnalogGateways()
    {
        return $this->preventImeCallsFromAnalogGateways;
    }
    /**
     * Set preventImeCallsFromAnalogGateways value
     * @param string $preventImeCallsFromAnalogGateways
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RImeFeatureConfig
     */
    public function setPreventImeCallsFromAnalogGateways($preventImeCallsFromAnalogGateways = null)
    {
        // validation for constraint: string
        if (!is_null($preventImeCallsFromAnalogGateways) && !is_string($preventImeCallsFromAnalogGateways)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($preventImeCallsFromAnalogGateways, true), gettype($preventImeCallsFromAnalogGateways)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($preventImeCallsFromAnalogGateways) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $preventImeCallsFromAnalogGateways)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($preventImeCallsFromAnalogGateways, true)), __LINE__);
        }
        $this->preventImeCallsFromAnalogGateways = $preventImeCallsFromAnalogGateways;
        return $this;
    }
    /**
     * Get enableIntraDomain value
     * @return string|null
     */
    public function getEnableIntraDomain()
    {
        return $this->enableIntraDomain;
    }
    /**
     * Set enableIntraDomain value
     * @param string $enableIntraDomain
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RImeFeatureConfig
     */
    public function setEnableIntraDomain($enableIntraDomain = null)
    {
        // validation for constraint: string
        if (!is_null($enableIntraDomain) && !is_string($enableIntraDomain)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($enableIntraDomain, true), gettype($enableIntraDomain)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($enableIntraDomain) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $enableIntraDomain)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($enableIntraDomain, true)), __LINE__);
        }
        $this->enableIntraDomain = $enableIntraDomain;
        return $this;
    }
    /**
     * Get allowMwiNotification value
     * @return string|null
     */
    public function getAllowMwiNotification()
    {
        return $this->allowMwiNotification;
    }
    /**
     * Set allowMwiNotification value
     * @param string $allowMwiNotification
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RImeFeatureConfig
     */
    public function setAllowMwiNotification($allowMwiNotification = null)
    {
        // validation for constraint: string
        if (!is_null($allowMwiNotification) && !is_string($allowMwiNotification)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($allowMwiNotification, true), gettype($allowMwiNotification)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($allowMwiNotification) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $allowMwiNotification)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($allowMwiNotification, true)), __LINE__);
        }
        $this->allowMwiNotification = $allowMwiNotification;
        return $this;
    }
    /**
     * Get trunkConnectionTimer value
     * @return string|null
     */
    public function getTrunkConnectionTimer()
    {
        return $this->trunkConnectionTimer;
    }
    /**
     * Set trunkConnectionTimer value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $trunkConnectionTimer
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RImeFeatureConfig
     */
    public function setTrunkConnectionTimer($trunkConnectionTimer = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($trunkConnectionTimer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($trunkConnectionTimer) ? implode(', ', $trunkConnectionTimer) : var_export($trunkConnectionTimer, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->trunkConnectionTimer = $trunkConnectionTimer;
        return $this;
    }
    /**
     * Get firewallConnectionTimer value
     * @return string|null
     */
    public function getFirewallConnectionTimer()
    {
        return $this->firewallConnectionTimer;
    }
    /**
     * Set firewallConnectionTimer value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $firewallConnectionTimer
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RImeFeatureConfig
     */
    public function setFirewallConnectionTimer($firewallConnectionTimer = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($firewallConnectionTimer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($firewallConnectionTimer) ? implode(', ', $firewallConnectionTimer) : var_export($firewallConnectionTimer, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->firewallConnectionTimer = $firewallConnectionTimer;
        return $this;
    }
    /**
     * Get firewallTranscationTimer value
     * @return string|null
     */
    public function getFirewallTranscationTimer()
    {
        return $this->firewallTranscationTimer;
    }
    /**
     * Set firewallTranscationTimer value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $firewallTranscationTimer
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RImeFeatureConfig
     */
    public function setFirewallTranscationTimer($firewallTranscationTimer = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($firewallTranscationTimer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($firewallTranscationTimer) ? implode(', ', $firewallTranscationTimer) : var_export($firewallTranscationTimer, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->firewallTranscationTimer = $firewallTranscationTimer;
        return $this;
    }
    /**
     * Get firewallIdleTimer value
     * @return string|null
     */
    public function getFirewallIdleTimer()
    {
        return $this->firewallIdleTimer;
    }
    /**
     * Set firewallIdleTimer value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $firewallIdleTimer
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RImeFeatureConfig
     */
    public function setFirewallIdleTimer($firewallIdleTimer = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($firewallIdleTimer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($firewallIdleTimer) ? implode(', ', $firewallIdleTimer) : var_export($firewallIdleTimer, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->firewallIdleTimer = $firewallIdleTimer;
        return $this;
    }
    /**
     * Get failedCallAttemptThreshold value
     * @return string|null
     */
    public function getFailedCallAttemptThreshold()
    {
        return $this->failedCallAttemptThreshold;
    }
    /**
     * Set failedCallAttemptThreshold value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $failedCallAttemptThreshold
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RImeFeatureConfig
     */
    public function setFailedCallAttemptThreshold($failedCallAttemptThreshold = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($failedCallAttemptThreshold)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($failedCallAttemptThreshold) ? implode(', ', $failedCallAttemptThreshold) : var_export($failedCallAttemptThreshold, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->failedCallAttemptThreshold = $failedCallAttemptThreshold;
        return $this;
    }
    /**
     * Get callFallbackAttemptThreshold value
     * @return string|null
     */
    public function getCallFallbackAttemptThreshold()
    {
        return $this->callFallbackAttemptThreshold;
    }
    /**
     * Set callFallbackAttemptThreshold value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $callFallbackAttemptThreshold
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RImeFeatureConfig
     */
    public function setCallFallbackAttemptThreshold($callFallbackAttemptThreshold = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($callFallbackAttemptThreshold)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($callFallbackAttemptThreshold) ? implode(', ', $callFallbackAttemptThreshold) : var_export($callFallbackAttemptThreshold, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->callFallbackAttemptThreshold = $callFallbackAttemptThreshold;
        return $this;
    }
    /**
     * Get qualityTimer value
     * @return string|null
     */
    public function getQualityTimer()
    {
        return $this->qualityTimer;
    }
    /**
     * Set qualityTimer value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $qualityTimer
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RImeFeatureConfig
     */
    public function setQualityTimer($qualityTimer = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($qualityTimer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($qualityTimer) ? implode(', ', $qualityTimer) : var_export($qualityTimer, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->qualityTimer = $qualityTimer;
        return $this;
    }
    /**
     * Get useImeForOutboundCalls value
     * @return string|null
     */
    public function getUseImeForOutboundCalls()
    {
        return $this->useImeForOutboundCalls;
    }
    /**
     * Set useImeForOutboundCalls value
     * @param string $useImeForOutboundCalls
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RImeFeatureConfig
     */
    public function setUseImeForOutboundCalls($useImeForOutboundCalls = null)
    {
        // validation for constraint: string
        if (!is_null($useImeForOutboundCalls) && !is_string($useImeForOutboundCalls)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($useImeForOutboundCalls, true), gettype($useImeForOutboundCalls)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($useImeForOutboundCalls) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $useImeForOutboundCalls)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($useImeForOutboundCalls, true)), __LINE__);
        }
        $this->useImeForOutboundCalls = $useImeForOutboundCalls;
        return $this;
    }
}
