<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RPolicyRelationship StructType
 * @subpackage Structs
 */
class RPolicyRelationship extends AbstractStructBase
{
    /**
     * The geoLocationPolicyAName
     * Meta information extracted from the WSDL
     * - documentation: This is a read only tag. The value will be the currently added GeoLocationPolicy pkid.
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $geoLocationPolicyAName;
    /**
     * The geoLocationDeviceA
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $geoLocationDeviceA;
    /**
     * The geoLocationPolicyBName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $geoLocationPolicyBName;
    /**
     * The geoLocationDeviceB
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $geoLocationDeviceB;
    /**
     * The logicalPartitionPolicy
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $logicalPartitionPolicy;
    /**
     * The uuid
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - pattern: \{........-....-....-....-............\}
     * @var string
     */
    public $uuid;
    /**
     * Constructor method for RPolicyRelationship
     * @uses RPolicyRelationship::setGeoLocationPolicyAName()
     * @uses RPolicyRelationship::setGeoLocationDeviceA()
     * @uses RPolicyRelationship::setGeoLocationPolicyBName()
     * @uses RPolicyRelationship::setGeoLocationDeviceB()
     * @uses RPolicyRelationship::setLogicalPartitionPolicy()
     * @uses RPolicyRelationship::setUuid()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $geoLocationPolicyAName
     * @param string $geoLocationDeviceA
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $geoLocationPolicyBName
     * @param string $geoLocationDeviceB
     * @param string $logicalPartitionPolicy
     * @param string $uuid
     */
    public function __construct(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $geoLocationPolicyAName = null, $geoLocationDeviceA = null, \Losc\CucmBundle\Model\Webservice\StructType\XFkType $geoLocationPolicyBName = null, $geoLocationDeviceB = null, $logicalPartitionPolicy = null, $uuid = null)
    {
        $this
            ->setGeoLocationPolicyAName($geoLocationPolicyAName)
            ->setGeoLocationDeviceA($geoLocationDeviceA)
            ->setGeoLocationPolicyBName($geoLocationPolicyBName)
            ->setGeoLocationDeviceB($geoLocationDeviceB)
            ->setLogicalPartitionPolicy($logicalPartitionPolicy)
            ->setUuid($uuid);
    }
    /**
     * Get geoLocationPolicyAName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getGeoLocationPolicyAName()
    {
        return $this->geoLocationPolicyAName;
    }
    /**
     * Set geoLocationPolicyAName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $geoLocationPolicyAName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RPolicyRelationship
     */
    public function setGeoLocationPolicyAName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $geoLocationPolicyAName = null)
    {
        $this->geoLocationPolicyAName = $geoLocationPolicyAName;
        return $this;
    }
    /**
     * Get geoLocationDeviceA value
     * @return string|null
     */
    public function getGeoLocationDeviceA()
    {
        return $this->geoLocationDeviceA;
    }
    /**
     * Set geoLocationDeviceA value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XGeoLocationDevice::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XGeoLocationDevice::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $geoLocationDeviceA
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RPolicyRelationship
     */
    public function setGeoLocationDeviceA($geoLocationDeviceA = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XGeoLocationDevice::valueIsValid($geoLocationDeviceA)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XGeoLocationDevice', is_array($geoLocationDeviceA) ? implode(', ', $geoLocationDeviceA) : var_export($geoLocationDeviceA, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XGeoLocationDevice::getValidValues())), __LINE__);
        }
        $this->geoLocationDeviceA = $geoLocationDeviceA;
        return $this;
    }
    /**
     * Get geoLocationPolicyBName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getGeoLocationPolicyBName()
    {
        return $this->geoLocationPolicyBName;
    }
    /**
     * Set geoLocationPolicyBName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $geoLocationPolicyBName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RPolicyRelationship
     */
    public function setGeoLocationPolicyBName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $geoLocationPolicyBName = null)
    {
        $this->geoLocationPolicyBName = $geoLocationPolicyBName;
        return $this;
    }
    /**
     * Get geoLocationDeviceB value
     * @return string|null
     */
    public function getGeoLocationDeviceB()
    {
        return $this->geoLocationDeviceB;
    }
    /**
     * Set geoLocationDeviceB value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XGeoLocationDevice::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XGeoLocationDevice::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $geoLocationDeviceB
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RPolicyRelationship
     */
    public function setGeoLocationDeviceB($geoLocationDeviceB = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XGeoLocationDevice::valueIsValid($geoLocationDeviceB)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XGeoLocationDevice', is_array($geoLocationDeviceB) ? implode(', ', $geoLocationDeviceB) : var_export($geoLocationDeviceB, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XGeoLocationDevice::getValidValues())), __LINE__);
        }
        $this->geoLocationDeviceB = $geoLocationDeviceB;
        return $this;
    }
    /**
     * Get logicalPartitionPolicy value
     * @return string|null
     */
    public function getLogicalPartitionPolicy()
    {
        return $this->logicalPartitionPolicy;
    }
    /**
     * Set logicalPartitionPolicy value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XLogicalPartitionPolicy::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XLogicalPartitionPolicy::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $logicalPartitionPolicy
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RPolicyRelationship
     */
    public function setLogicalPartitionPolicy($logicalPartitionPolicy = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XLogicalPartitionPolicy::valueIsValid($logicalPartitionPolicy)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XLogicalPartitionPolicy', is_array($logicalPartitionPolicy) ? implode(', ', $logicalPartitionPolicy) : var_export($logicalPartitionPolicy, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XLogicalPartitionPolicy::getValidValues())), __LINE__);
        }
        $this->logicalPartitionPolicy = $logicalPartitionPolicy;
        return $this;
    }
    /**
     * Get uuid value
     * @return string|null
     */
    public function getUuid()
    {
        return $this->uuid;
    }
    /**
     * Set uuid value
     * @param string $uuid
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RPolicyRelationship
     */
    public function setUuid($uuid = null)
    {
        // validation for constraint: string
        if (!is_null($uuid) && !is_string($uuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uuid, true), gettype($uuid)), __LINE__);
        }
        // validation for constraint: pattern(\{........-....-....-....-............\})
        if (!is_null($uuid) && !preg_match('/\\{........-....-....-....-............\\}/', $uuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression \{........-....-....-....-............\}', var_export($uuid, true)), __LINE__);
        }
        $this->uuid = $uuid;
        return $this;
    }
}
