<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RRemoteCluster StructType
 * @subpackage Structs
 */
class RRemoteCluster extends AbstractStructBase
{
    /**
     * The clusterId
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 255
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $clusterId;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The fullyQualifiedName
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $fullyQualifiedName;
    /**
     * The emcc
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember
     */
    public $emcc;
    /**
     * The pstnAccess
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember
     */
    public $pstnAccess;
    /**
     * The rsvpAgent
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember
     */
    public $rsvpAgent;
    /**
     * The tftp
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember
     */
    public $tftp;
    /**
     * The lbm
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember
     */
    public $lbm;
    /**
     * The uds
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember
     */
    public $uds;
    /**
     * The uuid
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - pattern: \{........-....-....-....-............\}
     * @var string
     */
    public $uuid;
    /**
     * Constructor method for RRemoteCluster
     * @uses RRemoteCluster::setClusterId()
     * @uses RRemoteCluster::setDescription()
     * @uses RRemoteCluster::setFullyQualifiedName()
     * @uses RRemoteCluster::setEmcc()
     * @uses RRemoteCluster::setPstnAccess()
     * @uses RRemoteCluster::setRsvpAgent()
     * @uses RRemoteCluster::setTftp()
     * @uses RRemoteCluster::setLbm()
     * @uses RRemoteCluster::setUds()
     * @uses RRemoteCluster::setUuid()
     * @param string $clusterId
     * @param string $description
     * @param string $fullyQualifiedName
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $emcc
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $pstnAccess
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $rsvpAgent
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $tftp
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $lbm
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $uds
     * @param string $uuid
     */
    public function __construct($clusterId = null, $description = null, $fullyQualifiedName = null, \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $emcc = null, \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $pstnAccess = null, \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $rsvpAgent = null, \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $tftp = null, \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $lbm = null, \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $uds = null, $uuid = null)
    {
        $this
            ->setClusterId($clusterId)
            ->setDescription($description)
            ->setFullyQualifiedName($fullyQualifiedName)
            ->setEmcc($emcc)
            ->setPstnAccess($pstnAccess)
            ->setRsvpAgent($rsvpAgent)
            ->setTftp($tftp)
            ->setLbm($lbm)
            ->setUds($uds)
            ->setUuid($uuid);
    }
    /**
     * Get clusterId value
     * @return string|null
     */
    public function getClusterId()
    {
        return $this->clusterId;
    }
    /**
     * Set clusterId value
     * @param string $clusterId
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RRemoteCluster
     */
    public function setClusterId($clusterId = null)
    {
        // validation for constraint: string
        if (!is_null($clusterId) && !is_string($clusterId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($clusterId, true), gettype($clusterId)), __LINE__);
        }
        // validation for constraint: maxLength(255)
        if (!is_null($clusterId) && mb_strlen($clusterId) > 255) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 255', mb_strlen($clusterId)), __LINE__);
        }
        $this->clusterId = $clusterId;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RRemoteCluster
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get fullyQualifiedName value
     * @return string|null
     */
    public function getFullyQualifiedName()
    {
        return $this->fullyQualifiedName;
    }
    /**
     * Set fullyQualifiedName value
     * @param string $fullyQualifiedName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RRemoteCluster
     */
    public function setFullyQualifiedName($fullyQualifiedName = null)
    {
        // validation for constraint: string
        if (!is_null($fullyQualifiedName) && !is_string($fullyQualifiedName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fullyQualifiedName, true), gettype($fullyQualifiedName)), __LINE__);
        }
        // validation for constraint: maxLength(50)
        if (!is_null($fullyQualifiedName) && mb_strlen($fullyQualifiedName) > 50) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 50', mb_strlen($fullyQualifiedName)), __LINE__);
        }
        $this->fullyQualifiedName = $fullyQualifiedName;
        return $this;
    }
    /**
     * Get emcc value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember|null
     */
    public function getEmcc()
    {
        return $this->emcc;
    }
    /**
     * Set emcc value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $emcc
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RRemoteCluster
     */
    public function setEmcc(\Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $emcc = null)
    {
        $this->emcc = $emcc;
        return $this;
    }
    /**
     * Get pstnAccess value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember|null
     */
    public function getPstnAccess()
    {
        return $this->pstnAccess;
    }
    /**
     * Set pstnAccess value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $pstnAccess
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RRemoteCluster
     */
    public function setPstnAccess(\Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $pstnAccess = null)
    {
        $this->pstnAccess = $pstnAccess;
        return $this;
    }
    /**
     * Get rsvpAgent value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember|null
     */
    public function getRsvpAgent()
    {
        return $this->rsvpAgent;
    }
    /**
     * Set rsvpAgent value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $rsvpAgent
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RRemoteCluster
     */
    public function setRsvpAgent(\Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $rsvpAgent = null)
    {
        $this->rsvpAgent = $rsvpAgent;
        return $this;
    }
    /**
     * Get tftp value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember|null
     */
    public function getTftp()
    {
        return $this->tftp;
    }
    /**
     * Set tftp value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $tftp
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RRemoteCluster
     */
    public function setTftp(\Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $tftp = null)
    {
        $this->tftp = $tftp;
        return $this;
    }
    /**
     * Get lbm value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember|null
     */
    public function getLbm()
    {
        return $this->lbm;
    }
    /**
     * Set lbm value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $lbm
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RRemoteCluster
     */
    public function setLbm(\Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $lbm = null)
    {
        $this->lbm = $lbm;
        return $this;
    }
    /**
     * Get uds value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember|null
     */
    public function getUds()
    {
        return $this->uds;
    }
    /**
     * Set uds value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $uds
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RRemoteCluster
     */
    public function setUds(\Losc\CucmBundle\Model\Webservice\StructType\RRemoteClusterMember $uds = null)
    {
        $this->uds = $uds;
        return $this;
    }
    /**
     * Get uuid value
     * @return string|null
     */
    public function getUuid()
    {
        return $this->uuid;
    }
    /**
     * Set uuid value
     * @param string $uuid
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RRemoteCluster
     */
    public function setUuid($uuid = null)
    {
        // validation for constraint: string
        if (!is_null($uuid) && !is_string($uuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uuid, true), gettype($uuid)), __LINE__);
        }
        // validation for constraint: pattern(\{........-....-....-....-............\})
        if (!is_null($uuid) && !preg_match('/\\{........-....-....-....-............\\}/', $uuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression \{........-....-....-....-............\}', var_export($uuid, true)), __LINE__);
        }
        $this->uuid = $uuid;
        return $this;
    }
}
