<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RSNMPUser StructType
 * @subpackage Structs
 */
class RSNMPUser extends AbstractStructBase
{
    /**
     * The userName
     * @var string
     */
    public $userName;
    /**
     * The authRequired
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $authRequired;
    /**
     * The authPassword
     * @var string
     */
    public $authPassword;
    /**
     * The authProtocol
     * @var string
     */
    public $authProtocol;
    /**
     * The privacyRequired
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $privacyRequired;
    /**
     * The privacyPassword
     * @var string
     */
    public $privacyPassword;
    /**
     * The privacyProtocol
     * @var string
     */
    public $privacyProtocol;
    /**
     * The accessPrivilege
     * @var string
     */
    public $accessPrivilege;
    /**
     * The ArrayOfHosts
     * @var \Losc\CucmBundle\Model\Webservice\ArrayType\RArrayOfHosts
     */
    public $ArrayOfHosts;
    /**
     * Constructor method for RSNMPUser
     * @uses RSNMPUser::setUserName()
     * @uses RSNMPUser::setAuthRequired()
     * @uses RSNMPUser::setAuthPassword()
     * @uses RSNMPUser::setAuthProtocol()
     * @uses RSNMPUser::setPrivacyRequired()
     * @uses RSNMPUser::setPrivacyPassword()
     * @uses RSNMPUser::setPrivacyProtocol()
     * @uses RSNMPUser::setAccessPrivilege()
     * @uses RSNMPUser::setArrayOfHosts()
     * @param string $userName
     * @param string $authRequired
     * @param string $authPassword
     * @param string $authProtocol
     * @param string $privacyRequired
     * @param string $privacyPassword
     * @param string $privacyProtocol
     * @param string $accessPrivilege
     * @param \Losc\CucmBundle\Model\Webservice\ArrayType\RArrayOfHosts $arrayOfHosts
     */
    public function __construct($userName = null, $authRequired = null, $authPassword = null, $authProtocol = null, $privacyRequired = null, $privacyPassword = null, $privacyProtocol = null, $accessPrivilege = null, \Losc\CucmBundle\Model\Webservice\ArrayType\RArrayOfHosts $arrayOfHosts = null)
    {
        $this
            ->setUserName($userName)
            ->setAuthRequired($authRequired)
            ->setAuthPassword($authPassword)
            ->setAuthProtocol($authProtocol)
            ->setPrivacyRequired($privacyRequired)
            ->setPrivacyPassword($privacyPassword)
            ->setPrivacyProtocol($privacyProtocol)
            ->setAccessPrivilege($accessPrivilege)
            ->setArrayOfHosts($arrayOfHosts);
    }
    /**
     * Get userName value
     * @return string|null
     */
    public function getUserName()
    {
        return $this->userName;
    }
    /**
     * Set userName value
     * @param string $userName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSNMPUser
     */
    public function setUserName($userName = null)
    {
        // validation for constraint: string
        if (!is_null($userName) && !is_string($userName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userName, true), gettype($userName)), __LINE__);
        }
        $this->userName = $userName;
        return $this;
    }
    /**
     * Get authRequired value
     * @return string|null
     */
    public function getAuthRequired()
    {
        return $this->authRequired;
    }
    /**
     * Set authRequired value
     * @param string $authRequired
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSNMPUser
     */
    public function setAuthRequired($authRequired = null)
    {
        // validation for constraint: string
        if (!is_null($authRequired) && !is_string($authRequired)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($authRequired, true), gettype($authRequired)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($authRequired) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $authRequired)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($authRequired, true)), __LINE__);
        }
        $this->authRequired = $authRequired;
        return $this;
    }
    /**
     * Get authPassword value
     * @return string|null
     */
    public function getAuthPassword()
    {
        return $this->authPassword;
    }
    /**
     * Set authPassword value
     * @param string $authPassword
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSNMPUser
     */
    public function setAuthPassword($authPassword = null)
    {
        // validation for constraint: string
        if (!is_null($authPassword) && !is_string($authPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($authPassword, true), gettype($authPassword)), __LINE__);
        }
        $this->authPassword = $authPassword;
        return $this;
    }
    /**
     * Get authProtocol value
     * @return string|null
     */
    public function getAuthProtocol()
    {
        return $this->authProtocol;
    }
    /**
     * Set authProtocol value
     * @param string $authProtocol
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSNMPUser
     */
    public function setAuthProtocol($authProtocol = null)
    {
        // validation for constraint: string
        if (!is_null($authProtocol) && !is_string($authProtocol)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($authProtocol, true), gettype($authProtocol)), __LINE__);
        }
        $this->authProtocol = $authProtocol;
        return $this;
    }
    /**
     * Get privacyRequired value
     * @return string|null
     */
    public function getPrivacyRequired()
    {
        return $this->privacyRequired;
    }
    /**
     * Set privacyRequired value
     * @param string $privacyRequired
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSNMPUser
     */
    public function setPrivacyRequired($privacyRequired = null)
    {
        // validation for constraint: string
        if (!is_null($privacyRequired) && !is_string($privacyRequired)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($privacyRequired, true), gettype($privacyRequired)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($privacyRequired) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $privacyRequired)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($privacyRequired, true)), __LINE__);
        }
        $this->privacyRequired = $privacyRequired;
        return $this;
    }
    /**
     * Get privacyPassword value
     * @return string|null
     */
    public function getPrivacyPassword()
    {
        return $this->privacyPassword;
    }
    /**
     * Set privacyPassword value
     * @param string $privacyPassword
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSNMPUser
     */
    public function setPrivacyPassword($privacyPassword = null)
    {
        // validation for constraint: string
        if (!is_null($privacyPassword) && !is_string($privacyPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($privacyPassword, true), gettype($privacyPassword)), __LINE__);
        }
        $this->privacyPassword = $privacyPassword;
        return $this;
    }
    /**
     * Get privacyProtocol value
     * @return string|null
     */
    public function getPrivacyProtocol()
    {
        return $this->privacyProtocol;
    }
    /**
     * Set privacyProtocol value
     * @param string $privacyProtocol
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSNMPUser
     */
    public function setPrivacyProtocol($privacyProtocol = null)
    {
        // validation for constraint: string
        if (!is_null($privacyProtocol) && !is_string($privacyProtocol)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($privacyProtocol, true), gettype($privacyProtocol)), __LINE__);
        }
        $this->privacyProtocol = $privacyProtocol;
        return $this;
    }
    /**
     * Get accessPrivilege value
     * @return string|null
     */
    public function getAccessPrivilege()
    {
        return $this->accessPrivilege;
    }
    /**
     * Set accessPrivilege value
     * @param string $accessPrivilege
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSNMPUser
     */
    public function setAccessPrivilege($accessPrivilege = null)
    {
        // validation for constraint: string
        if (!is_null($accessPrivilege) && !is_string($accessPrivilege)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($accessPrivilege, true), gettype($accessPrivilege)), __LINE__);
        }
        $this->accessPrivilege = $accessPrivilege;
        return $this;
    }
    /**
     * Get ArrayOfHosts value
     * @return \Losc\CucmBundle\Model\Webservice\ArrayType\RArrayOfHosts|null
     */
    public function getArrayOfHosts()
    {
        return $this->ArrayOfHosts;
    }
    /**
     * Set ArrayOfHosts value
     * @param \Losc\CucmBundle\Model\Webservice\ArrayType\RArrayOfHosts $arrayOfHosts
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSNMPUser
     */
    public function setArrayOfHosts(\Losc\CucmBundle\Model\Webservice\ArrayType\RArrayOfHosts $arrayOfHosts = null)
    {
        $this->ArrayOfHosts = $arrayOfHosts;
        return $this;
    }
}
