<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RSyslogConfig StructType
 * @subpackage Structs
 */
class RSyslogConfig extends AbstractStructBase
{
    /**
     * The AlarmLevelEvent
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $AlarmLevelEvent;
    /**
     * The RemoteServerName1
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $RemoteServerName1;
    /**
     * The RemoteServerName2
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $RemoteServerName2;
    /**
     * The RemoteServerName3
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $RemoteServerName3;
    /**
     * The RemoteServerName4
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $RemoteServerName4;
    /**
     * The RemoteServerName5
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $RemoteServerName5;
    /**
     * The monitor
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $monitor;
    /**
     * The Enable
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $Enable;
    /**
     * Constructor method for RSyslogConfig
     * @uses RSyslogConfig::setAlarmLevelEvent()
     * @uses RSyslogConfig::setRemoteServerName1()
     * @uses RSyslogConfig::setRemoteServerName2()
     * @uses RSyslogConfig::setRemoteServerName3()
     * @uses RSyslogConfig::setRemoteServerName4()
     * @uses RSyslogConfig::setRemoteServerName5()
     * @uses RSyslogConfig::setMonitor()
     * @uses RSyslogConfig::setEnable()
     * @param string $alarmLevelEvent
     * @param string $remoteServerName1
     * @param string $remoteServerName2
     * @param string $remoteServerName3
     * @param string $remoteServerName4
     * @param string $remoteServerName5
     * @param string $monitor
     * @param string $enable
     */
    public function __construct($alarmLevelEvent = null, $remoteServerName1 = null, $remoteServerName2 = null, $remoteServerName3 = null, $remoteServerName4 = null, $remoteServerName5 = null, $monitor = null, $enable = null)
    {
        $this
            ->setAlarmLevelEvent($alarmLevelEvent)
            ->setRemoteServerName1($remoteServerName1)
            ->setRemoteServerName2($remoteServerName2)
            ->setRemoteServerName3($remoteServerName3)
            ->setRemoteServerName4($remoteServerName4)
            ->setRemoteServerName5($remoteServerName5)
            ->setMonitor($monitor)
            ->setEnable($enable);
    }
    /**
     * Get AlarmLevelEvent value
     * @return string|null
     */
    public function getAlarmLevelEvent()
    {
        return $this->AlarmLevelEvent;
    }
    /**
     * Set AlarmLevelEvent value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XAlarmSeverity::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XAlarmSeverity::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $alarmLevelEvent
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSyslogConfig
     */
    public function setAlarmLevelEvent($alarmLevelEvent = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XAlarmSeverity::valueIsValid($alarmLevelEvent)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XAlarmSeverity', is_array($alarmLevelEvent) ? implode(', ', $alarmLevelEvent) : var_export($alarmLevelEvent, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XAlarmSeverity::getValidValues())), __LINE__);
        }
        $this->AlarmLevelEvent = $alarmLevelEvent;
        return $this;
    }
    /**
     * Get RemoteServerName1 value
     * @return string|null
     */
    public function getRemoteServerName1()
    {
        return $this->RemoteServerName1;
    }
    /**
     * Set RemoteServerName1 value
     * @param string $remoteServerName1
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSyslogConfig
     */
    public function setRemoteServerName1($remoteServerName1 = null)
    {
        // validation for constraint: string
        if (!is_null($remoteServerName1) && !is_string($remoteServerName1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($remoteServerName1, true), gettype($remoteServerName1)), __LINE__);
        }
        $this->RemoteServerName1 = $remoteServerName1;
        return $this;
    }
    /**
     * Get RemoteServerName2 value
     * @return string|null
     */
    public function getRemoteServerName2()
    {
        return $this->RemoteServerName2;
    }
    /**
     * Set RemoteServerName2 value
     * @param string $remoteServerName2
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSyslogConfig
     */
    public function setRemoteServerName2($remoteServerName2 = null)
    {
        // validation for constraint: string
        if (!is_null($remoteServerName2) && !is_string($remoteServerName2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($remoteServerName2, true), gettype($remoteServerName2)), __LINE__);
        }
        $this->RemoteServerName2 = $remoteServerName2;
        return $this;
    }
    /**
     * Get RemoteServerName3 value
     * @return string|null
     */
    public function getRemoteServerName3()
    {
        return $this->RemoteServerName3;
    }
    /**
     * Set RemoteServerName3 value
     * @param string $remoteServerName3
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSyslogConfig
     */
    public function setRemoteServerName3($remoteServerName3 = null)
    {
        // validation for constraint: string
        if (!is_null($remoteServerName3) && !is_string($remoteServerName3)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($remoteServerName3, true), gettype($remoteServerName3)), __LINE__);
        }
        $this->RemoteServerName3 = $remoteServerName3;
        return $this;
    }
    /**
     * Get RemoteServerName4 value
     * @return string|null
     */
    public function getRemoteServerName4()
    {
        return $this->RemoteServerName4;
    }
    /**
     * Set RemoteServerName4 value
     * @param string $remoteServerName4
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSyslogConfig
     */
    public function setRemoteServerName4($remoteServerName4 = null)
    {
        // validation for constraint: string
        if (!is_null($remoteServerName4) && !is_string($remoteServerName4)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($remoteServerName4, true), gettype($remoteServerName4)), __LINE__);
        }
        $this->RemoteServerName4 = $remoteServerName4;
        return $this;
    }
    /**
     * Get RemoteServerName5 value
     * @return string|null
     */
    public function getRemoteServerName5()
    {
        return $this->RemoteServerName5;
    }
    /**
     * Set RemoteServerName5 value
     * @param string $remoteServerName5
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSyslogConfig
     */
    public function setRemoteServerName5($remoteServerName5 = null)
    {
        // validation for constraint: string
        if (!is_null($remoteServerName5) && !is_string($remoteServerName5)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($remoteServerName5, true), gettype($remoteServerName5)), __LINE__);
        }
        $this->RemoteServerName5 = $remoteServerName5;
        return $this;
    }
    /**
     * Get monitor value
     * @return string|null
     */
    public function getMonitor()
    {
        return $this->monitor;
    }
    /**
     * Set monitor value
     * @param string $monitor
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSyslogConfig
     */
    public function setMonitor($monitor = null)
    {
        // validation for constraint: string
        if (!is_null($monitor) && !is_string($monitor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($monitor, true), gettype($monitor)), __LINE__);
        }
        $this->monitor = $monitor;
        return $this;
    }
    /**
     * Get Enable value
     * @return string|null
     */
    public function getEnable()
    {
        return $this->Enable;
    }
    /**
     * Set Enable value
     * @param string $enable
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSyslogConfig
     */
    public function setEnable($enable = null)
    {
        // validation for constraint: string
        if (!is_null($enable) && !is_string($enable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($enable, true), gettype($enable)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($enable) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $enable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($enable, true)), __LINE__);
        }
        $this->Enable = $enable;
        return $this;
    }
}
