<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RSyslogConfiguration StructType
 * @subpackage Structs
 */
class RSyslogConfiguration extends AbstractStructBase
{
    /**
     * The serverName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $serverName;
    /**
     * The serviceGroup
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $serviceGroup;
    /**
     * The service
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $service;
    /**
     * The alarmConfigs
     * @var \Losc\CucmBundle\Model\Webservice\StructType\AlarmConfigs
     */
    public $alarmConfigs;
    /**
     * The EndPointAlarm
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $EndPointAlarm;
    /**
     * Constructor method for RSyslogConfiguration
     * @uses RSyslogConfiguration::setServerName()
     * @uses RSyslogConfiguration::setServiceGroup()
     * @uses RSyslogConfiguration::setService()
     * @uses RSyslogConfiguration::setAlarmConfigs()
     * @uses RSyslogConfiguration::setEndPointAlarm()
     * @param string $serverName
     * @param string $serviceGroup
     * @param string $service
     * @param \Losc\CucmBundle\Model\Webservice\StructType\AlarmConfigs $alarmConfigs
     * @param string $endPointAlarm
     */
    public function __construct($serverName = null, $serviceGroup = null, $service = null, \Losc\CucmBundle\Model\Webservice\StructType\AlarmConfigs $alarmConfigs = null, $endPointAlarm = null)
    {
        $this
            ->setServerName($serverName)
            ->setServiceGroup($serviceGroup)
            ->setService($service)
            ->setAlarmConfigs($alarmConfigs)
            ->setEndPointAlarm($endPointAlarm);
    }
    /**
     * Get serverName value
     * @return string|null
     */
    public function getServerName()
    {
        return $this->serverName;
    }
    /**
     * Set serverName value
     * @param string $serverName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSyslogConfiguration
     */
    public function setServerName($serverName = null)
    {
        // validation for constraint: string
        if (!is_null($serverName) && !is_string($serverName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serverName, true), gettype($serverName)), __LINE__);
        }
        $this->serverName = $serverName;
        return $this;
    }
    /**
     * Get serviceGroup value
     * @return string|null
     */
    public function getServiceGroup()
    {
        return $this->serviceGroup;
    }
    /**
     * Set serviceGroup value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XServiceGrouping::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XServiceGrouping::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $serviceGroup
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSyslogConfiguration
     */
    public function setServiceGroup($serviceGroup = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XServiceGrouping::valueIsValid($serviceGroup)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XServiceGrouping', is_array($serviceGroup) ? implode(', ', $serviceGroup) : var_export($serviceGroup, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XServiceGrouping::getValidValues())), __LINE__);
        }
        $this->serviceGroup = $serviceGroup;
        return $this;
    }
    /**
     * Get service value
     * @return string|null
     */
    public function getService()
    {
        return $this->service;
    }
    /**
     * Set service value
     * @param string $service
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSyslogConfiguration
     */
    public function setService($service = null)
    {
        // validation for constraint: string
        if (!is_null($service) && !is_string($service)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($service, true), gettype($service)), __LINE__);
        }
        $this->service = $service;
        return $this;
    }
    /**
     * Get alarmConfigs value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\AlarmConfigs|null
     */
    public function getAlarmConfigs()
    {
        return $this->alarmConfigs;
    }
    /**
     * Set alarmConfigs value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\AlarmConfigs $alarmConfigs
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSyslogConfiguration
     */
    public function setAlarmConfigs(\Losc\CucmBundle\Model\Webservice\StructType\AlarmConfigs $alarmConfigs = null)
    {
        $this->alarmConfigs = $alarmConfigs;
        return $this;
    }
    /**
     * Get EndPointAlarm value
     * @return string|null
     */
    public function getEndPointAlarm()
    {
        return $this->EndPointAlarm;
    }
    /**
     * Set EndPointAlarm value
     * @param string $endPointAlarm
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RSyslogConfiguration
     */
    public function setEndPointAlarm($endPointAlarm = null)
    {
        // validation for constraint: string
        if (!is_null($endPointAlarm) && !is_string($endPointAlarm)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endPointAlarm, true), gettype($endPointAlarm)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($endPointAlarm) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $endPointAlarm)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($endPointAlarm, true)), __LINE__);
        }
        $this->EndPointAlarm = $endPointAlarm;
        return $this;
    }
}
