<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for relatedRegions StructType
 * @subpackage Structs
 */
class RelatedRegions extends AbstractStructBase
{
    /**
     * The relatedRegion
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XRegionRelationship[]
     */
    public $relatedRegion;
    /**
     * Constructor method for relatedRegions
     * @uses RelatedRegions::setRelatedRegion()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XRegionRelationship[] $relatedRegion
     */
    public function __construct(array $relatedRegion = array())
    {
        $this
            ->setRelatedRegion($relatedRegion);
    }
    /**
     * Get relatedRegion value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XRegionRelationship[]|null
     */
    public function getRelatedRegion()
    {
        return $this->relatedRegion;
    }
    /**
     * This method is responsible for validating the values passed to the setRelatedRegion method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRelatedRegion method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRelatedRegionForArrayConstraintsFromSetRelatedRegion(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $relatedRegionsRelatedRegionItem) {
            // validation for constraint: itemType
            if (!$relatedRegionsRelatedRegionItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\XRegionRelationship) {
                $invalidValues[] = is_object($relatedRegionsRelatedRegionItem) ? get_class($relatedRegionsRelatedRegionItem) : sprintf('%s(%s)', gettype($relatedRegionsRelatedRegionItem), var_export($relatedRegionsRelatedRegionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The relatedRegion property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XRegionRelationship, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set relatedRegion value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XRegionRelationship[] $relatedRegion
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RelatedRegions
     */
    public function setRelatedRegion(array $relatedRegion = array())
    {
        // validation for constraint: array
        if ('' !== ($relatedRegionArrayErrorMessage = self::validateRelatedRegionForArrayConstraintsFromSetRelatedRegion($relatedRegion))) {
            throw new \InvalidArgumentException($relatedRegionArrayErrorMessage, __LINE__);
        }
        $this->relatedRegion = $relatedRegion;
        return $this;
    }
    /**
     * Add item to relatedRegion value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XRegionRelationship $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RelatedRegions
     */
    public function addToRelatedRegion(\Losc\CucmBundle\Model\Webservice\StructType\XRegionRelationship $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\XRegionRelationship) {
            throw new \InvalidArgumentException(sprintf('The relatedRegion property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XRegionRelationship, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->relatedRegion[] = $item;
        return $this;
    }
}
