<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for removeApplicationToSoftkeyTemplateReq StructType
 * @subpackage Structs
 */
class RemoveApplicationToSoftkeyTemplateReq extends AbstractStructBase
{
    /**
     * The softKeyTemplateName
     * Meta information extracted from the WSDL
     * - documentation: This template should not be a standard template
     * - minOccurs: 1
     * - nillable: false
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $softKeyTemplateName;
    /**
     * The applicationName
     * Meta information extracted from the WSDL
     * - documentation: This application should not be Cisco CallManager.
     * - base: xsd:string
     * - maxLength: 100
     * - nillable: false
     * @var string
     */
    public $applicationName;
    /**
     * The sequence
     * Meta information extracted from the WSDL
     * - use: optional
     * @var int
     */
    public $sequence;
    /**
     * Constructor method for removeApplicationToSoftkeyTemplateReq
     * @uses RemoveApplicationToSoftkeyTemplateReq::setSoftKeyTemplateName()
     * @uses RemoveApplicationToSoftkeyTemplateReq::setApplicationName()
     * @uses RemoveApplicationToSoftkeyTemplateReq::setSequence()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $softKeyTemplateName
     * @param string $applicationName
     * @param int $sequence
     */
    public function __construct(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $softKeyTemplateName = null, $applicationName = null, $sequence = null)
    {
        $this
            ->setSoftKeyTemplateName($softKeyTemplateName)
            ->setApplicationName($applicationName)
            ->setSequence($sequence);
    }
    /**
     * Get softKeyTemplateName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public function getSoftKeyTemplateName()
    {
        return $this->softKeyTemplateName;
    }
    /**
     * Set softKeyTemplateName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $softKeyTemplateName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RemoveApplicationToSoftkeyTemplateReq
     */
    public function setSoftKeyTemplateName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $softKeyTemplateName = null)
    {
        $this->softKeyTemplateName = $softKeyTemplateName;
        return $this;
    }
    /**
     * Get applicationName value
     * @return string|null
     */
    public function getApplicationName()
    {
        return $this->applicationName;
    }
    /**
     * Set applicationName value
     * @param string $applicationName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RemoveApplicationToSoftkeyTemplateReq
     */
    public function setApplicationName($applicationName = null)
    {
        // validation for constraint: string
        if (!is_null($applicationName) && !is_string($applicationName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($applicationName, true), gettype($applicationName)), __LINE__);
        }
        // validation for constraint: maxLength(100)
        if (!is_null($applicationName) && mb_strlen($applicationName) > 100) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 100', mb_strlen($applicationName)), __LINE__);
        }
        $this->applicationName = $applicationName;
        return $this;
    }
    /**
     * Get sequence value
     * @return int|null
     */
    public function getSequence()
    {
        return $this->sequence;
    }
    /**
     * Set sequence value
     * @param int $sequence
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RemoveApplicationToSoftkeyTemplateReq
     */
    public function setSequence($sequence = null)
    {
        // validation for constraint: int
        if (!is_null($sequence) && !(is_int($sequence) || ctype_digit($sequence))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sequence, true), gettype($sequence)), __LINE__);
        }
        $this->sequence = $sequence;
        return $this;
    }
}
