<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for removeAssociatedCucms StructType
 * @subpackage Structs
 */
class RemoveAssociatedCucms extends XCommonMembersExtension
{
    /**
     * The associatedCucm
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XSafForwarderMember[]
     */
    public $associatedCucm;
    /**
     * Constructor method for removeAssociatedCucms
     * @uses RemoveAssociatedCucms::setAssociatedCucm()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XSafForwarderMember[] $associatedCucm
     */
    public function __construct(array $associatedCucm = array())
    {
        $this
            ->setAssociatedCucm($associatedCucm);
    }
    /**
     * Get associatedCucm value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSafForwarderMember[]
     */
    public function getAssociatedCucm()
    {
        return $this->associatedCucm;
    }
    /**
     * This method is responsible for validating the values passed to the setAssociatedCucm method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAssociatedCucm method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAssociatedCucmForArrayConstraintsFromSetAssociatedCucm(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $removeAssociatedCucmsAssociatedCucmItem) {
            // validation for constraint: itemType
            if (!$removeAssociatedCucmsAssociatedCucmItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\XSafForwarderMember) {
                $invalidValues[] = is_object($removeAssociatedCucmsAssociatedCucmItem) ? get_class($removeAssociatedCucmsAssociatedCucmItem) : sprintf('%s(%s)', gettype($removeAssociatedCucmsAssociatedCucmItem), var_export($removeAssociatedCucmsAssociatedCucmItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The associatedCucm property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XSafForwarderMember, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set associatedCucm value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XSafForwarderMember[] $associatedCucm
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RemoveAssociatedCucms
     */
    public function setAssociatedCucm(array $associatedCucm = array())
    {
        // validation for constraint: array
        if ('' !== ($associatedCucmArrayErrorMessage = self::validateAssociatedCucmForArrayConstraintsFromSetAssociatedCucm($associatedCucm))) {
            throw new \InvalidArgumentException($associatedCucmArrayErrorMessage, __LINE__);
        }
        $this->associatedCucm = $associatedCucm;
        return $this;
    }
    /**
     * Add item to associatedCucm value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XSafForwarderMember $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RemoveAssociatedCucms
     */
    public function addToAssociatedCucm(\Losc\CucmBundle\Model\Webservice\StructType\XSafForwarderMember $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\XSafForwarderMember) {
            throw new \InvalidArgumentException(sprintf('The associatedCucm property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XSafForwarderMember, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->associatedCucm[] = $item;
        return $this;
    }
}
