<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for removeAssociatedTrunks StructType
 * @subpackage Structs
 */
class RemoveAssociatedTrunks extends XCommonMembersExtension
{
    /**
     * The associatedTrunk
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XCcdRequestingServiceMember[]
     */
    public $associatedTrunk;
    /**
     * Constructor method for removeAssociatedTrunks
     * @uses RemoveAssociatedTrunks::setAssociatedTrunk()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XCcdRequestingServiceMember[] $associatedTrunk
     */
    public function __construct(array $associatedTrunk = array())
    {
        $this
            ->setAssociatedTrunk($associatedTrunk);
    }
    /**
     * Get associatedTrunk value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XCcdRequestingServiceMember[]
     */
    public function getAssociatedTrunk()
    {
        return $this->associatedTrunk;
    }
    /**
     * This method is responsible for validating the values passed to the setAssociatedTrunk method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAssociatedTrunk method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAssociatedTrunkForArrayConstraintsFromSetAssociatedTrunk(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $removeAssociatedTrunksAssociatedTrunkItem) {
            // validation for constraint: itemType
            if (!$removeAssociatedTrunksAssociatedTrunkItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\XCcdRequestingServiceMember) {
                $invalidValues[] = is_object($removeAssociatedTrunksAssociatedTrunkItem) ? get_class($removeAssociatedTrunksAssociatedTrunkItem) : sprintf('%s(%s)', gettype($removeAssociatedTrunksAssociatedTrunkItem), var_export($removeAssociatedTrunksAssociatedTrunkItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The associatedTrunk property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XCcdRequestingServiceMember, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set associatedTrunk value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XCcdRequestingServiceMember[] $associatedTrunk
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RemoveAssociatedTrunks
     */
    public function setAssociatedTrunk(array $associatedTrunk = array())
    {
        // validation for constraint: array
        if ('' !== ($associatedTrunkArrayErrorMessage = self::validateAssociatedTrunkForArrayConstraintsFromSetAssociatedTrunk($associatedTrunk))) {
            throw new \InvalidArgumentException($associatedTrunkArrayErrorMessage, __LINE__);
        }
        $this->associatedTrunk = $associatedTrunk;
        return $this;
    }
    /**
     * Add item to associatedTrunk value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XCcdRequestingServiceMember $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RemoveAssociatedTrunks
     */
    public function addToAssociatedTrunk(\Losc\CucmBundle\Model\Webservice\StructType\XCcdRequestingServiceMember $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\XCcdRequestingServiceMember) {
            throw new \InvalidArgumentException(sprintf('The associatedTrunk property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XCcdRequestingServiceMember, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->associatedTrunk[] = $item;
        return $this;
    }
}
