<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for removeCallStates StructType
 * @subpackage Structs
 */
class RemoveCallStates extends AbstractStructBase
{
    /**
     * The callState
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XCallStateMember[]
     */
    public $callState;
    /**
     * Constructor method for removeCallStates
     * @uses RemoveCallStates::setCallState()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XCallStateMember[] $callState
     */
    public function __construct(array $callState = array())
    {
        $this
            ->setCallState($callState);
    }
    /**
     * Get callState value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XCallStateMember[]|null
     */
    public function getCallState()
    {
        return $this->callState;
    }
    /**
     * This method is responsible for validating the values passed to the setCallState method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCallState method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCallStateForArrayConstraintsFromSetCallState(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $removeCallStatesCallStateItem) {
            // validation for constraint: itemType
            if (!$removeCallStatesCallStateItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\XCallStateMember) {
                $invalidValues[] = is_object($removeCallStatesCallStateItem) ? get_class($removeCallStatesCallStateItem) : sprintf('%s(%s)', gettype($removeCallStatesCallStateItem), var_export($removeCallStatesCallStateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The callState property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XCallStateMember, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set callState value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XCallStateMember[] $callState
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RemoveCallStates
     */
    public function setCallState(array $callState = array())
    {
        // validation for constraint: array
        if ('' !== ($callStateArrayErrorMessage = self::validateCallStateForArrayConstraintsFromSetCallState($callState))) {
            throw new \InvalidArgumentException($callStateArrayErrorMessage, __LINE__);
        }
        $this->callState = $callState;
        return $this;
    }
    /**
     * Add item to callState value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XCallStateMember $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RemoveCallStates
     */
    public function addToCallState(\Losc\CucmBundle\Model\Webservice\StructType\XCallStateMember $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\XCallStateMember) {
            throw new \InvalidArgumentException(sprintf('The callState property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XCallStateMember, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->callState[] = $item;
        return $this;
    }
}
