<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for removeEndUsers StructType
 * @subpackage Structs
 */
class RemoveEndUsers extends XCommonMembersExtension
{
    /**
     * The selectedEndUser
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \Losc\CucmBundle\Model\Webservice\StructType\SelectedEndUser[]
     */
    public $selectedEndUser;
    /**
     * Constructor method for removeEndUsers
     * @uses RemoveEndUsers::setSelectedEndUser()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\SelectedEndUser[] $selectedEndUser
     */
    public function __construct(array $selectedEndUser = array())
    {
        $this
            ->setSelectedEndUser($selectedEndUser);
    }
    /**
     * Get selectedEndUser value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SelectedEndUser[]
     */
    public function getSelectedEndUser()
    {
        return $this->selectedEndUser;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectedEndUser method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectedEndUser method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectedEndUserForArrayConstraintsFromSetSelectedEndUser(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $removeEndUsersSelectedEndUserItem) {
            // validation for constraint: itemType
            if (!$removeEndUsersSelectedEndUserItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\SelectedEndUser) {
                $invalidValues[] = is_object($removeEndUsersSelectedEndUserItem) ? get_class($removeEndUsersSelectedEndUserItem) : sprintf('%s(%s)', gettype($removeEndUsersSelectedEndUserItem), var_export($removeEndUsersSelectedEndUserItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The selectedEndUser property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\SelectedEndUser, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set selectedEndUser value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\SelectedEndUser[] $selectedEndUser
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RemoveEndUsers
     */
    public function setSelectedEndUser(array $selectedEndUser = array())
    {
        // validation for constraint: array
        if ('' !== ($selectedEndUserArrayErrorMessage = self::validateSelectedEndUserForArrayConstraintsFromSetSelectedEndUser($selectedEndUser))) {
            throw new \InvalidArgumentException($selectedEndUserArrayErrorMessage, __LINE__);
        }
        $this->selectedEndUser = $selectedEndUser;
        return $this;
    }
    /**
     * Add item to selectedEndUser value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\SelectedEndUser $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RemoveEndUsers
     */
    public function addToSelectedEndUser(\Losc\CucmBundle\Model\Webservice\StructType\SelectedEndUser $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\SelectedEndUser) {
            throw new \InvalidArgumentException(sprintf('The selectedEndUser property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\SelectedEndUser, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->selectedEndUser[] = $item;
        return $this;
    }
}
