<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for removeUserRoles StructType
 * @subpackage Structs
 */
class RemoveUserRoles extends XCommonMembersExtension
{
    /**
     * The userRole
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XUserGroupRoles[]
     */
    public $userRole;
    /**
     * Constructor method for removeUserRoles
     * @uses RemoveUserRoles::setUserRole()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XUserGroupRoles[] $userRole
     */
    public function __construct(array $userRole = array())
    {
        $this
            ->setUserRole($userRole);
    }
    /**
     * Get userRole value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XUserGroupRoles[]|null
     */
    public function getUserRole()
    {
        return $this->userRole;
    }
    /**
     * This method is responsible for validating the values passed to the setUserRole method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUserRole method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUserRoleForArrayConstraintsFromSetUserRole(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $removeUserRolesUserRoleItem) {
            // validation for constraint: itemType
            if (!$removeUserRolesUserRoleItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\XUserGroupRoles) {
                $invalidValues[] = is_object($removeUserRolesUserRoleItem) ? get_class($removeUserRolesUserRoleItem) : sprintf('%s(%s)', gettype($removeUserRolesUserRoleItem), var_export($removeUserRolesUserRoleItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The userRole property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XUserGroupRoles, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set userRole value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XUserGroupRoles[] $userRole
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RemoveUserRoles
     */
    public function setUserRole(array $userRole = array())
    {
        // validation for constraint: array
        if ('' !== ($userRoleArrayErrorMessage = self::validateUserRoleForArrayConstraintsFromSetUserRole($userRole))) {
            throw new \InvalidArgumentException($userRoleArrayErrorMessage, __LINE__);
        }
        $this->userRole = $userRole;
        return $this;
    }
    /**
     * Add item to userRole value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XUserGroupRoles $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RemoveUserRoles
     */
    public function addToUserRole(\Losc\CucmBundle\Model\Webservice\StructType\XUserGroupRoles $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\XUserGroupRoles) {
            throw new \InvalidArgumentException(sprintf('The userRole property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XUserGroupRoles, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->userRole[] = $item;
        return $this;
    }
}
