<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for searchCriteria StructType
 * Meta information extracted from the WSDL
 * - documentation: Specify Search Criterion | At least one element under searchCriteria has to be mentioned
 * @subpackage Structs
 */
class SearchCriteria extends AbstractStructBase
{
    /**
     * The name
     * Meta information extracted from the WSDL
     * - documentation: The device name,using only URL-friendly characters | The template's name | From Device Table | Actually called "tag" in database. | From Device table. | Should not be modified for Cisco Media Termination Point (WS-SVC-CMM). | Not
     * nullable. | The primary hostname of the process node.
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - documentation: Optional description of the device | From Device Table | From Device table.
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The ownerIdName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ownerIdName;
    /**
     * The dirn
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dirn;
    /**
     * The cssName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $cssName;
    /**
     * The processNodeRole
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $processNodeRole;
    /**
     * The callManagerGroupName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $callManagerGroupName;
    /**
     * The regionName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $regionName;
    /**
     * The namespace
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $namespace;
    /**
     * The subNet
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $subNet;
    /**
     * The subNetMaskSz
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $subNetMaskSz;
    /**
     * The code
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $code;
    /**
     * The authorizationLevel
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $authorizationLevel;
    /**
     * The userLocale
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $userLocale;
    /**
     * The recordingCssName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $recordingCssName;
    /**
     * The recorderDestination
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $recorderDestination;
    /**
     * The processNodeName
     * Meta information extracted from the WSDL
     * - documentation: The process Node that this the service parameter belongs to. Not nullable.
     * - minOccurs: 0
     * @var string
     */
    public $processNodeName;
    /**
     * The sourceId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $sourceId;
    /**
     * The primaryDnsIpAddress
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $primaryDnsIpAddress;
    /**
     * The secondaryDnsIpAddress
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $secondaryDnsIpAddress;
    /**
     * The domainName
     * Meta information extracted from the WSDL
     * - documentation: For SCCP mention MAC Address
     * - minOccurs: 0
     * @var string
     */
    public $domainName;
    /**
     * The dhcpServerName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dhcpServerName;
    /**
     * The subnetIpAddress
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $subnetIpAddress;
    /**
     * The primaryStartIpAddress
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $primaryStartIpAddress;
    /**
     * The primaryEndIpAddress
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $primaryEndIpAddress;
    /**
     * The secondaryStartIpAddress
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $secondaryStartIpAddress;
    /**
     * The secondaryEndIpAddress
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $secondaryEndIpAddress;
    /**
     * The pattern
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $pattern;
    /**
     * The routePartitionName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $routePartitionName;
    /**
     * The callManagerName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $callManagerName;
    /**
     * The reversionPattern
     * Meta information extracted from the WSDL
     * - documentation: The pattern used to revert the call when the parked call is not retrieved within retrieval timer.
     * - minOccurs: 0
     * @var string
     */
    public $reversionPattern;
    /**
     * The firstName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $firstName;
    /**
     * The lastName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $lastName;
    /**
     * The userid
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $userid;
    /**
     * The department
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $department;
    /**
     * The realm
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $realm;
    /**
     * The ipAddress
     * Meta information extracted from the WSDL
     * - documentation: Applicable for Cisco Unity Voice Mail 4.x or later, Cisco Unity Connection and Cisco Web Dialer
     * - minOccurs: 0
     * @var string
     */
    public $ipAddress;
    /**
     * The timeZone
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $timeZone;
    /**
     * The applicationUser
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $applicationUser;
    /**
     * The instanceId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $instanceId;
    /**
     * The endUserId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $endUserId;
    /**
     * The service
     * Meta information extracted from the WSDL
     * - documentation: The service that this service parameter belongs to.
     * - minOccurs: 0
     * @var string
     */
    public $service;
    /**
     * The callingSearchSpaceName
     * Meta information extracted from the WSDL
     * - documentation: UUID changed each time device is updated
     * - minOccurs: 0
     * @var string
     */
    public $callingSearchSpaceName;
    /**
     * The devicePoolName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $devicePoolName;
    /**
     * The securityProfileName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $securityProfileName;
    /**
     * The dnPattern
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dnPattern;
    /**
     * The serviceName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $serviceName;
    /**
     * The serviceDescription
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $serviceDescription;
    /**
     * The dialPlanName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dialPlanName;
    /**
     * The routeFilterName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $routeFilterName;
    /**
     * The dnOrPatternIpv6
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dnOrPatternIpv6;
    /**
     * The numberBeginWith
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $numberBeginWith;
    /**
     * The dialPattern
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dialPattern;
    /**
     * The usage
     * Meta information extracted from the WSDL
     * - documentation: For Intercom DN and Intercom Translation patterns the usage tag value needs to be specified explicitly as Device Intercom and Translation Intercom respectively. For all other patterns it is a Read-only tag.
     * - minOccurs: 0
     * @var string
     */
    public $usage;
    /**
     * The protocol
     * Meta information extracted from the WSDL
     * - documentation: Protocol option is read-only,except when creating a device.
     * - minOccurs: 0
     * @var string
     */
    public $protocol;
    /**
     * The remoteDestinationProfileName
     * Meta information extracted from the WSDL
     * - documentation: If you are giving value to dualModeDeviceName then you can't give value to remoteDestinationProfileName,viceversa
     * - minOccurs: 0
     * @var string
     */
    public $remoteDestinationProfileName;
    /**
     * The ctiRemoteDeviceName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ctiRemoteDeviceName;
    /**
     * The dualModeDeviceName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dualModeDeviceName;
    /**
     * The dnOrPattern
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dnOrPattern;
    /**
     * The partition
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $partition;
    /**
     * The type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $type;
    /**
     * The hostedPattern
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $hostedPattern;
    /**
     * The clusterId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $clusterId;
    /**
     * The ldapDn
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ldapDn;
    /**
     * The userSearchBase
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $userSearchBase;
    /**
     * The learnedPattern
     * Meta information extracted from the WSDL
     * - documentation: Either learnedPattern or learnedPatternPrefix has to be set
     * - minOccurs: 0
     * @var string
     */
    public $learnedPattern;
    /**
     * The learnedPatternPrefix
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $learnedPatternPrefix;
    /**
     * The callControlIdentity
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $callControlIdentity;
    /**
     * The domain
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $domain;
    /**
     * The imeEnrolledPatternGroupName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $imeEnrolledPatternGroupName;
    /**
     * The imeExclusionNumberGroupName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $imeExclusionNumberGroupName;
    /**
     * The filter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $filter;
    /**
     * The subjectName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $subjectName;
    /**
     * The issuerName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $issuerName;
    /**
     * The serialNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $serialNumber;
    /**
     * The timeToLive
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $timeToLive;
    /**
     * The directorynumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $directorynumber;
    /**
     * The field
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $field;
    /**
     * The hostName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $hostName;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Description;
    /**
     * The routeString
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $routeString;
    /**
     * The defaultVideoStreamId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $defaultVideoStreamId;
    /**
     * The ldapConfigName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ldapConfigName;
    /**
     * The ldapManagerDisgName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ldapManagerDisgName;
    /**
     * The ldapUserSearch
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ldapUserSearch;
    /**
     * The ccaId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ccaId;
    /**
     * The primarySoftSwitchId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $primarySoftSwitchId;
    /**
     * The deviceDescription
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $deviceDescription;
    /**
     * The server
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $server;
    /**
     * The presenceRedundancyGroup
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $presenceRedundancyGroup;
    /**
     * The ssidPrefix
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ssidPrefix;
    /**
     * The authenticationMethod
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $authenticationMethod;
    /**
     * The ssid
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ssid;
    /**
     * The networkAccessProfile
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $networkAccessProfile;
    /**
     * The lineDescription
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $lineDescription;
    /**
     * The ldapConfigurationName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ldapConfigurationName;
    /**
     * Constructor method for searchCriteria
     * @uses SearchCriteria::setName()
     * @uses SearchCriteria::setDescription()
     * @uses SearchCriteria::setOwnerIdName()
     * @uses SearchCriteria::setDirn()
     * @uses SearchCriteria::setCssName()
     * @uses SearchCriteria::setProcessNodeRole()
     * @uses SearchCriteria::setCallManagerGroupName()
     * @uses SearchCriteria::setRegionName()
     * @uses SearchCriteria::setNamespace()
     * @uses SearchCriteria::setSubNet()
     * @uses SearchCriteria::setSubNetMaskSz()
     * @uses SearchCriteria::setCode()
     * @uses SearchCriteria::setAuthorizationLevel()
     * @uses SearchCriteria::setUserLocale()
     * @uses SearchCriteria::setRecordingCssName()
     * @uses SearchCriteria::setRecorderDestination()
     * @uses SearchCriteria::setProcessNodeName()
     * @uses SearchCriteria::setSourceId()
     * @uses SearchCriteria::setPrimaryDnsIpAddress()
     * @uses SearchCriteria::setSecondaryDnsIpAddress()
     * @uses SearchCriteria::setDomainName()
     * @uses SearchCriteria::setDhcpServerName()
     * @uses SearchCriteria::setSubnetIpAddress()
     * @uses SearchCriteria::setPrimaryStartIpAddress()
     * @uses SearchCriteria::setPrimaryEndIpAddress()
     * @uses SearchCriteria::setSecondaryStartIpAddress()
     * @uses SearchCriteria::setSecondaryEndIpAddress()
     * @uses SearchCriteria::setPattern()
     * @uses SearchCriteria::setRoutePartitionName()
     * @uses SearchCriteria::setCallManagerName()
     * @uses SearchCriteria::setReversionPattern()
     * @uses SearchCriteria::setFirstName()
     * @uses SearchCriteria::setLastName()
     * @uses SearchCriteria::setUserid()
     * @uses SearchCriteria::setDepartment()
     * @uses SearchCriteria::setRealm()
     * @uses SearchCriteria::setIpAddress()
     * @uses SearchCriteria::setTimeZone()
     * @uses SearchCriteria::setApplicationUser()
     * @uses SearchCriteria::setInstanceId()
     * @uses SearchCriteria::setEndUserId()
     * @uses SearchCriteria::setService()
     * @uses SearchCriteria::setCallingSearchSpaceName()
     * @uses SearchCriteria::setDevicePoolName()
     * @uses SearchCriteria::setSecurityProfileName()
     * @uses SearchCriteria::setDnPattern()
     * @uses SearchCriteria::setServiceName()
     * @uses SearchCriteria::setServiceDescription()
     * @uses SearchCriteria::setDialPlanName()
     * @uses SearchCriteria::setRouteFilterName()
     * @uses SearchCriteria::setDnOrPatternIpv6()
     * @uses SearchCriteria::setNumberBeginWith()
     * @uses SearchCriteria::setDialPattern()
     * @uses SearchCriteria::setUsage()
     * @uses SearchCriteria::setProtocol()
     * @uses SearchCriteria::setRemoteDestinationProfileName()
     * @uses SearchCriteria::setCtiRemoteDeviceName()
     * @uses SearchCriteria::setDualModeDeviceName()
     * @uses SearchCriteria::setDnOrPattern()
     * @uses SearchCriteria::setPartition()
     * @uses SearchCriteria::setType()
     * @uses SearchCriteria::setHostedPattern()
     * @uses SearchCriteria::setClusterId()
     * @uses SearchCriteria::setLdapDn()
     * @uses SearchCriteria::setUserSearchBase()
     * @uses SearchCriteria::setLearnedPattern()
     * @uses SearchCriteria::setLearnedPatternPrefix()
     * @uses SearchCriteria::setCallControlIdentity()
     * @uses SearchCriteria::setDomain()
     * @uses SearchCriteria::setImeEnrolledPatternGroupName()
     * @uses SearchCriteria::setImeExclusionNumberGroupName()
     * @uses SearchCriteria::setFilter()
     * @uses SearchCriteria::setSubjectName()
     * @uses SearchCriteria::setIssuerName()
     * @uses SearchCriteria::setSerialNumber()
     * @uses SearchCriteria::setTimeToLive()
     * @uses SearchCriteria::setDirectorynumber()
     * @uses SearchCriteria::setField()
     * @uses SearchCriteria::setHostName()
     * @uses SearchCriteria::setDescription_1()
     * @uses SearchCriteria::setRouteString()
     * @uses SearchCriteria::setDefaultVideoStreamId()
     * @uses SearchCriteria::setLdapConfigName()
     * @uses SearchCriteria::setLdapManagerDisgName()
     * @uses SearchCriteria::setLdapUserSearch()
     * @uses SearchCriteria::setCcaId()
     * @uses SearchCriteria::setPrimarySoftSwitchId()
     * @uses SearchCriteria::setDeviceDescription()
     * @uses SearchCriteria::setServer()
     * @uses SearchCriteria::setPresenceRedundancyGroup()
     * @uses SearchCriteria::setSsidPrefix()
     * @uses SearchCriteria::setAuthenticationMethod()
     * @uses SearchCriteria::setSsid()
     * @uses SearchCriteria::setNetworkAccessProfile()
     * @uses SearchCriteria::setLineDescription()
     * @uses SearchCriteria::setLdapConfigurationName()
     * @param string $name
     * @param string $description
     * @param string $ownerIdName
     * @param string $dirn
     * @param string $cssName
     * @param string $processNodeRole
     * @param string $callManagerGroupName
     * @param string $regionName
     * @param string $namespace
     * @param string $subNet
     * @param string $subNetMaskSz
     * @param string $code
     * @param string $authorizationLevel
     * @param string $userLocale
     * @param string $recordingCssName
     * @param string $recorderDestination
     * @param string $processNodeName
     * @param string $sourceId
     * @param string $primaryDnsIpAddress
     * @param string $secondaryDnsIpAddress
     * @param string $domainName
     * @param string $dhcpServerName
     * @param string $subnetIpAddress
     * @param string $primaryStartIpAddress
     * @param string $primaryEndIpAddress
     * @param string $secondaryStartIpAddress
     * @param string $secondaryEndIpAddress
     * @param string $pattern
     * @param string $routePartitionName
     * @param string $callManagerName
     * @param string $reversionPattern
     * @param string $firstName
     * @param string $lastName
     * @param string $userid
     * @param string $department
     * @param string $realm
     * @param string $ipAddress
     * @param string $timeZone
     * @param string $applicationUser
     * @param string $instanceId
     * @param string $endUserId
     * @param string $service
     * @param string $callingSearchSpaceName
     * @param string $devicePoolName
     * @param string $securityProfileName
     * @param string $dnPattern
     * @param string $serviceName
     * @param string $serviceDescription
     * @param string $dialPlanName
     * @param string $routeFilterName
     * @param string $dnOrPatternIpv6
     * @param string $numberBeginWith
     * @param string $dialPattern
     * @param string $usage
     * @param string $protocol
     * @param string $remoteDestinationProfileName
     * @param string $ctiRemoteDeviceName
     * @param string $dualModeDeviceName
     * @param string $dnOrPattern
     * @param string $partition
     * @param string $type
     * @param string $hostedPattern
     * @param string $clusterId
     * @param string $ldapDn
     * @param string $userSearchBase
     * @param string $learnedPattern
     * @param string $learnedPatternPrefix
     * @param string $callControlIdentity
     * @param string $domain
     * @param string $imeEnrolledPatternGroupName
     * @param string $imeExclusionNumberGroupName
     * @param string $filter
     * @param string $subjectName
     * @param string $issuerName
     * @param string $serialNumber
     * @param string $timeToLive
     * @param string $directorynumber
     * @param string $field
     * @param string $hostName
     * @param string $description
     * @param string $routeString
     * @param string $defaultVideoStreamId
     * @param string $ldapConfigName
     * @param string $ldapManagerDisgName
     * @param string $ldapUserSearch
     * @param string $ccaId
     * @param string $primarySoftSwitchId
     * @param string $deviceDescription
     * @param string $server
     * @param string $presenceRedundancyGroup
     * @param string $ssidPrefix
     * @param string $authenticationMethod
     * @param string $ssid
     * @param string $networkAccessProfile
     * @param string $lineDescription
     * @param string $ldapConfigurationName
     */
    public function __construct($name = null, $description = null, $ownerIdName = null, $dirn = null, $cssName = null, $processNodeRole = null, $callManagerGroupName = null, $regionName = null, $namespace = null, $subNet = null, $subNetMaskSz = null, $code = null, $authorizationLevel = null, $userLocale = null, $recordingCssName = null, $recorderDestination = null, $processNodeName = null, $sourceId = null, $primaryDnsIpAddress = null, $secondaryDnsIpAddress = null, $domainName = null, $dhcpServerName = null, $subnetIpAddress = null, $primaryStartIpAddress = null, $primaryEndIpAddress = null, $secondaryStartIpAddress = null, $secondaryEndIpAddress = null, $pattern = null, $routePartitionName = null, $callManagerName = null, $reversionPattern = null, $firstName = null, $lastName = null, $userid = null, $department = null, $realm = null, $ipAddress = null, $timeZone = null, $applicationUser = null, $instanceId = null, $endUserId = null, $service = null, $callingSearchSpaceName = null, $devicePoolName = null, $securityProfileName = null, $dnPattern = null, $serviceName = null, $serviceDescription = null, $dialPlanName = null, $routeFilterName = null, $dnOrPatternIpv6 = null, $numberBeginWith = null, $dialPattern = null, $usage = null, $protocol = null, $remoteDestinationProfileName = null, $ctiRemoteDeviceName = null, $dualModeDeviceName = null, $dnOrPattern = null, $partition = null, $type = null, $hostedPattern = null, $clusterId = null, $ldapDn = null, $userSearchBase = null, $learnedPattern = null, $learnedPatternPrefix = null, $callControlIdentity = null, $domain = null, $imeEnrolledPatternGroupName = null, $imeExclusionNumberGroupName = null, $filter = null, $subjectName = null, $issuerName = null, $serialNumber = null, $timeToLive = null, $directorynumber = null, $field = null, $hostName = null, $description_1 = null, $routeString = null, $defaultVideoStreamId = null, $ldapConfigName = null, $ldapManagerDisgName = null, $ldapUserSearch = null, $ccaId = null, $primarySoftSwitchId = null, $deviceDescription = null, $server = null, $presenceRedundancyGroup = null, $ssidPrefix = null, $authenticationMethod = null, $ssid = null, $networkAccessProfile = null, $lineDescription = null, $ldapConfigurationName = null)
    {
        $this
            ->setName($name)
            ->setDescription($description)
            ->setOwnerIdName($ownerIdName)
            ->setDirn($dirn)
            ->setCssName($cssName)
            ->setProcessNodeRole($processNodeRole)
            ->setCallManagerGroupName($callManagerGroupName)
            ->setRegionName($regionName)
            ->setNamespace($namespace)
            ->setSubNet($subNet)
            ->setSubNetMaskSz($subNetMaskSz)
            ->setCode($code)
            ->setAuthorizationLevel($authorizationLevel)
            ->setUserLocale($userLocale)
            ->setRecordingCssName($recordingCssName)
            ->setRecorderDestination($recorderDestination)
            ->setProcessNodeName($processNodeName)
            ->setSourceId($sourceId)
            ->setPrimaryDnsIpAddress($primaryDnsIpAddress)
            ->setSecondaryDnsIpAddress($secondaryDnsIpAddress)
            ->setDomainName($domainName)
            ->setDhcpServerName($dhcpServerName)
            ->setSubnetIpAddress($subnetIpAddress)
            ->setPrimaryStartIpAddress($primaryStartIpAddress)
            ->setPrimaryEndIpAddress($primaryEndIpAddress)
            ->setSecondaryStartIpAddress($secondaryStartIpAddress)
            ->setSecondaryEndIpAddress($secondaryEndIpAddress)
            ->setPattern($pattern)
            ->setRoutePartitionName($routePartitionName)
            ->setCallManagerName($callManagerName)
            ->setReversionPattern($reversionPattern)
            ->setFirstName($firstName)
            ->setLastName($lastName)
            ->setUserid($userid)
            ->setDepartment($department)
            ->setRealm($realm)
            ->setIpAddress($ipAddress)
            ->setTimeZone($timeZone)
            ->setApplicationUser($applicationUser)
            ->setInstanceId($instanceId)
            ->setEndUserId($endUserId)
            ->setService($service)
            ->setCallingSearchSpaceName($callingSearchSpaceName)
            ->setDevicePoolName($devicePoolName)
            ->setSecurityProfileName($securityProfileName)
            ->setDnPattern($dnPattern)
            ->setServiceName($serviceName)
            ->setServiceDescription($serviceDescription)
            ->setDialPlanName($dialPlanName)
            ->setRouteFilterName($routeFilterName)
            ->setDnOrPatternIpv6($dnOrPatternIpv6)
            ->setNumberBeginWith($numberBeginWith)
            ->setDialPattern($dialPattern)
            ->setUsage($usage)
            ->setProtocol($protocol)
            ->setRemoteDestinationProfileName($remoteDestinationProfileName)
            ->setCtiRemoteDeviceName($ctiRemoteDeviceName)
            ->setDualModeDeviceName($dualModeDeviceName)
            ->setDnOrPattern($dnOrPattern)
            ->setPartition($partition)
            ->setType($type)
            ->setHostedPattern($hostedPattern)
            ->setClusterId($clusterId)
            ->setLdapDn($ldapDn)
            ->setUserSearchBase($userSearchBase)
            ->setLearnedPattern($learnedPattern)
            ->setLearnedPatternPrefix($learnedPatternPrefix)
            ->setCallControlIdentity($callControlIdentity)
            ->setDomain($domain)
            ->setImeEnrolledPatternGroupName($imeEnrolledPatternGroupName)
            ->setImeExclusionNumberGroupName($imeExclusionNumberGroupName)
            ->setFilter($filter)
            ->setSubjectName($subjectName)
            ->setIssuerName($issuerName)
            ->setSerialNumber($serialNumber)
            ->setTimeToLive($timeToLive)
            ->setDirectorynumber($directorynumber)
            ->setField($field)
            ->setHostName($hostName)
            ->setDescription_1($description_1)
            ->setRouteString($routeString)
            ->setDefaultVideoStreamId($defaultVideoStreamId)
            ->setLdapConfigName($ldapConfigName)
            ->setLdapManagerDisgName($ldapManagerDisgName)
            ->setLdapUserSearch($ldapUserSearch)
            ->setCcaId($ccaId)
            ->setPrimarySoftSwitchId($primarySoftSwitchId)
            ->setDeviceDescription($deviceDescription)
            ->setServer($server)
            ->setPresenceRedundancyGroup($presenceRedundancyGroup)
            ->setSsidPrefix($ssidPrefix)
            ->setAuthenticationMethod($authenticationMethod)
            ->setSsid($ssid)
            ->setNetworkAccessProfile($networkAccessProfile)
            ->setLineDescription($lineDescription)
            ->setLdapConfigurationName($ldapConfigurationName);
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get ownerIdName value
     * @return string|null
     */
    public function getOwnerIdName()
    {
        return $this->ownerIdName;
    }
    /**
     * Set ownerIdName value
     * @param string $ownerIdName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setOwnerIdName($ownerIdName = null)
    {
        // validation for constraint: string
        if (!is_null($ownerIdName) && !is_string($ownerIdName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ownerIdName, true), gettype($ownerIdName)), __LINE__);
        }
        $this->ownerIdName = $ownerIdName;
        return $this;
    }
    /**
     * Get dirn value
     * @return string|null
     */
    public function getDirn()
    {
        return $this->dirn;
    }
    /**
     * Set dirn value
     * @param string $dirn
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setDirn($dirn = null)
    {
        // validation for constraint: string
        if (!is_null($dirn) && !is_string($dirn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dirn, true), gettype($dirn)), __LINE__);
        }
        $this->dirn = $dirn;
        return $this;
    }
    /**
     * Get cssName value
     * @return string|null
     */
    public function getCssName()
    {
        return $this->cssName;
    }
    /**
     * Set cssName value
     * @param string $cssName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setCssName($cssName = null)
    {
        // validation for constraint: string
        if (!is_null($cssName) && !is_string($cssName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cssName, true), gettype($cssName)), __LINE__);
        }
        $this->cssName = $cssName;
        return $this;
    }
    /**
     * Get processNodeRole value
     * @return string|null
     */
    public function getProcessNodeRole()
    {
        return $this->processNodeRole;
    }
    /**
     * Set processNodeRole value
     * @param string $processNodeRole
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setProcessNodeRole($processNodeRole = null)
    {
        // validation for constraint: string
        if (!is_null($processNodeRole) && !is_string($processNodeRole)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($processNodeRole, true), gettype($processNodeRole)), __LINE__);
        }
        $this->processNodeRole = $processNodeRole;
        return $this;
    }
    /**
     * Get callManagerGroupName value
     * @return string|null
     */
    public function getCallManagerGroupName()
    {
        return $this->callManagerGroupName;
    }
    /**
     * Set callManagerGroupName value
     * @param string $callManagerGroupName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setCallManagerGroupName($callManagerGroupName = null)
    {
        // validation for constraint: string
        if (!is_null($callManagerGroupName) && !is_string($callManagerGroupName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callManagerGroupName, true), gettype($callManagerGroupName)), __LINE__);
        }
        $this->callManagerGroupName = $callManagerGroupName;
        return $this;
    }
    /**
     * Get regionName value
     * @return string|null
     */
    public function getRegionName()
    {
        return $this->regionName;
    }
    /**
     * Set regionName value
     * @param string $regionName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setRegionName($regionName = null)
    {
        // validation for constraint: string
        if (!is_null($regionName) && !is_string($regionName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($regionName, true), gettype($regionName)), __LINE__);
        }
        $this->regionName = $regionName;
        return $this;
    }
    /**
     * Get namespace value
     * @return string|null
     */
    public function getNamespace()
    {
        return $this->namespace;
    }
    /**
     * Set namespace value
     * @param string $namespace
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setNamespace($namespace = null)
    {
        // validation for constraint: string
        if (!is_null($namespace) && !is_string($namespace)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($namespace, true), gettype($namespace)), __LINE__);
        }
        $this->namespace = $namespace;
        return $this;
    }
    /**
     * Get subNet value
     * @return string|null
     */
    public function getSubNet()
    {
        return $this->subNet;
    }
    /**
     * Set subNet value
     * @param string $subNet
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setSubNet($subNet = null)
    {
        // validation for constraint: string
        if (!is_null($subNet) && !is_string($subNet)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($subNet, true), gettype($subNet)), __LINE__);
        }
        $this->subNet = $subNet;
        return $this;
    }
    /**
     * Get subNetMaskSz value
     * @return string|null
     */
    public function getSubNetMaskSz()
    {
        return $this->subNetMaskSz;
    }
    /**
     * Set subNetMaskSz value
     * @param string $subNetMaskSz
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setSubNetMaskSz($subNetMaskSz = null)
    {
        // validation for constraint: string
        if (!is_null($subNetMaskSz) && !is_string($subNetMaskSz)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($subNetMaskSz, true), gettype($subNetMaskSz)), __LINE__);
        }
        $this->subNetMaskSz = $subNetMaskSz;
        return $this;
    }
    /**
     * Get code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->code;
    }
    /**
     * Set code value
     * @param string $code
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->code = $code;
        return $this;
    }
    /**
     * Get authorizationLevel value
     * @return string|null
     */
    public function getAuthorizationLevel()
    {
        return $this->authorizationLevel;
    }
    /**
     * Set authorizationLevel value
     * @param string $authorizationLevel
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setAuthorizationLevel($authorizationLevel = null)
    {
        // validation for constraint: string
        if (!is_null($authorizationLevel) && !is_string($authorizationLevel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($authorizationLevel, true), gettype($authorizationLevel)), __LINE__);
        }
        $this->authorizationLevel = $authorizationLevel;
        return $this;
    }
    /**
     * Get userLocale value
     * @return string|null
     */
    public function getUserLocale()
    {
        return $this->userLocale;
    }
    /**
     * Set userLocale value
     * @param string $userLocale
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setUserLocale($userLocale = null)
    {
        // validation for constraint: string
        if (!is_null($userLocale) && !is_string($userLocale)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userLocale, true), gettype($userLocale)), __LINE__);
        }
        $this->userLocale = $userLocale;
        return $this;
    }
    /**
     * Get recordingCssName value
     * @return string|null
     */
    public function getRecordingCssName()
    {
        return $this->recordingCssName;
    }
    /**
     * Set recordingCssName value
     * @param string $recordingCssName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setRecordingCssName($recordingCssName = null)
    {
        // validation for constraint: string
        if (!is_null($recordingCssName) && !is_string($recordingCssName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($recordingCssName, true), gettype($recordingCssName)), __LINE__);
        }
        $this->recordingCssName = $recordingCssName;
        return $this;
    }
    /**
     * Get recorderDestination value
     * @return string|null
     */
    public function getRecorderDestination()
    {
        return $this->recorderDestination;
    }
    /**
     * Set recorderDestination value
     * @param string $recorderDestination
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setRecorderDestination($recorderDestination = null)
    {
        // validation for constraint: string
        if (!is_null($recorderDestination) && !is_string($recorderDestination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($recorderDestination, true), gettype($recorderDestination)), __LINE__);
        }
        $this->recorderDestination = $recorderDestination;
        return $this;
    }
    /**
     * Get processNodeName value
     * @return string|null
     */
    public function getProcessNodeName()
    {
        return $this->processNodeName;
    }
    /**
     * Set processNodeName value
     * @param string $processNodeName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setProcessNodeName($processNodeName = null)
    {
        // validation for constraint: string
        if (!is_null($processNodeName) && !is_string($processNodeName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($processNodeName, true), gettype($processNodeName)), __LINE__);
        }
        $this->processNodeName = $processNodeName;
        return $this;
    }
    /**
     * Get sourceId value
     * @return string|null
     */
    public function getSourceId()
    {
        return $this->sourceId;
    }
    /**
     * Set sourceId value
     * @param string $sourceId
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setSourceId($sourceId = null)
    {
        // validation for constraint: string
        if (!is_null($sourceId) && !is_string($sourceId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sourceId, true), gettype($sourceId)), __LINE__);
        }
        $this->sourceId = $sourceId;
        return $this;
    }
    /**
     * Get primaryDnsIpAddress value
     * @return string|null
     */
    public function getPrimaryDnsIpAddress()
    {
        return $this->primaryDnsIpAddress;
    }
    /**
     * Set primaryDnsIpAddress value
     * @param string $primaryDnsIpAddress
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setPrimaryDnsIpAddress($primaryDnsIpAddress = null)
    {
        // validation for constraint: string
        if (!is_null($primaryDnsIpAddress) && !is_string($primaryDnsIpAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($primaryDnsIpAddress, true), gettype($primaryDnsIpAddress)), __LINE__);
        }
        $this->primaryDnsIpAddress = $primaryDnsIpAddress;
        return $this;
    }
    /**
     * Get secondaryDnsIpAddress value
     * @return string|null
     */
    public function getSecondaryDnsIpAddress()
    {
        return $this->secondaryDnsIpAddress;
    }
    /**
     * Set secondaryDnsIpAddress value
     * @param string $secondaryDnsIpAddress
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setSecondaryDnsIpAddress($secondaryDnsIpAddress = null)
    {
        // validation for constraint: string
        if (!is_null($secondaryDnsIpAddress) && !is_string($secondaryDnsIpAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($secondaryDnsIpAddress, true), gettype($secondaryDnsIpAddress)), __LINE__);
        }
        $this->secondaryDnsIpAddress = $secondaryDnsIpAddress;
        return $this;
    }
    /**
     * Get domainName value
     * @return string|null
     */
    public function getDomainName()
    {
        return $this->domainName;
    }
    /**
     * Set domainName value
     * @param string $domainName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setDomainName($domainName = null)
    {
        // validation for constraint: string
        if (!is_null($domainName) && !is_string($domainName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($domainName, true), gettype($domainName)), __LINE__);
        }
        $this->domainName = $domainName;
        return $this;
    }
    /**
     * Get dhcpServerName value
     * @return string|null
     */
    public function getDhcpServerName()
    {
        return $this->dhcpServerName;
    }
    /**
     * Set dhcpServerName value
     * @param string $dhcpServerName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setDhcpServerName($dhcpServerName = null)
    {
        // validation for constraint: string
        if (!is_null($dhcpServerName) && !is_string($dhcpServerName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dhcpServerName, true), gettype($dhcpServerName)), __LINE__);
        }
        $this->dhcpServerName = $dhcpServerName;
        return $this;
    }
    /**
     * Get subnetIpAddress value
     * @return string|null
     */
    public function getSubnetIpAddress()
    {
        return $this->subnetIpAddress;
    }
    /**
     * Set subnetIpAddress value
     * @param string $subnetIpAddress
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setSubnetIpAddress($subnetIpAddress = null)
    {
        // validation for constraint: string
        if (!is_null($subnetIpAddress) && !is_string($subnetIpAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($subnetIpAddress, true), gettype($subnetIpAddress)), __LINE__);
        }
        $this->subnetIpAddress = $subnetIpAddress;
        return $this;
    }
    /**
     * Get primaryStartIpAddress value
     * @return string|null
     */
    public function getPrimaryStartIpAddress()
    {
        return $this->primaryStartIpAddress;
    }
    /**
     * Set primaryStartIpAddress value
     * @param string $primaryStartIpAddress
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setPrimaryStartIpAddress($primaryStartIpAddress = null)
    {
        // validation for constraint: string
        if (!is_null($primaryStartIpAddress) && !is_string($primaryStartIpAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($primaryStartIpAddress, true), gettype($primaryStartIpAddress)), __LINE__);
        }
        $this->primaryStartIpAddress = $primaryStartIpAddress;
        return $this;
    }
    /**
     * Get primaryEndIpAddress value
     * @return string|null
     */
    public function getPrimaryEndIpAddress()
    {
        return $this->primaryEndIpAddress;
    }
    /**
     * Set primaryEndIpAddress value
     * @param string $primaryEndIpAddress
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setPrimaryEndIpAddress($primaryEndIpAddress = null)
    {
        // validation for constraint: string
        if (!is_null($primaryEndIpAddress) && !is_string($primaryEndIpAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($primaryEndIpAddress, true), gettype($primaryEndIpAddress)), __LINE__);
        }
        $this->primaryEndIpAddress = $primaryEndIpAddress;
        return $this;
    }
    /**
     * Get secondaryStartIpAddress value
     * @return string|null
     */
    public function getSecondaryStartIpAddress()
    {
        return $this->secondaryStartIpAddress;
    }
    /**
     * Set secondaryStartIpAddress value
     * @param string $secondaryStartIpAddress
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setSecondaryStartIpAddress($secondaryStartIpAddress = null)
    {
        // validation for constraint: string
        if (!is_null($secondaryStartIpAddress) && !is_string($secondaryStartIpAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($secondaryStartIpAddress, true), gettype($secondaryStartIpAddress)), __LINE__);
        }
        $this->secondaryStartIpAddress = $secondaryStartIpAddress;
        return $this;
    }
    /**
     * Get secondaryEndIpAddress value
     * @return string|null
     */
    public function getSecondaryEndIpAddress()
    {
        return $this->secondaryEndIpAddress;
    }
    /**
     * Set secondaryEndIpAddress value
     * @param string $secondaryEndIpAddress
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setSecondaryEndIpAddress($secondaryEndIpAddress = null)
    {
        // validation for constraint: string
        if (!is_null($secondaryEndIpAddress) && !is_string($secondaryEndIpAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($secondaryEndIpAddress, true), gettype($secondaryEndIpAddress)), __LINE__);
        }
        $this->secondaryEndIpAddress = $secondaryEndIpAddress;
        return $this;
    }
    /**
     * Get pattern value
     * @return string|null
     */
    public function getPattern()
    {
        return $this->pattern;
    }
    /**
     * Set pattern value
     * @param string $pattern
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setPattern($pattern = null)
    {
        // validation for constraint: string
        if (!is_null($pattern) && !is_string($pattern)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pattern, true), gettype($pattern)), __LINE__);
        }
        $this->pattern = $pattern;
        return $this;
    }
    /**
     * Get routePartitionName value
     * @return string|null
     */
    public function getRoutePartitionName()
    {
        return $this->routePartitionName;
    }
    /**
     * Set routePartitionName value
     * @param string $routePartitionName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setRoutePartitionName($routePartitionName = null)
    {
        // validation for constraint: string
        if (!is_null($routePartitionName) && !is_string($routePartitionName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($routePartitionName, true), gettype($routePartitionName)), __LINE__);
        }
        $this->routePartitionName = $routePartitionName;
        return $this;
    }
    /**
     * Get callManagerName value
     * @return string|null
     */
    public function getCallManagerName()
    {
        return $this->callManagerName;
    }
    /**
     * Set callManagerName value
     * @param string $callManagerName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setCallManagerName($callManagerName = null)
    {
        // validation for constraint: string
        if (!is_null($callManagerName) && !is_string($callManagerName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callManagerName, true), gettype($callManagerName)), __LINE__);
        }
        $this->callManagerName = $callManagerName;
        return $this;
    }
    /**
     * Get reversionPattern value
     * @return string|null
     */
    public function getReversionPattern()
    {
        return $this->reversionPattern;
    }
    /**
     * Set reversionPattern value
     * @param string $reversionPattern
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setReversionPattern($reversionPattern = null)
    {
        // validation for constraint: string
        if (!is_null($reversionPattern) && !is_string($reversionPattern)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reversionPattern, true), gettype($reversionPattern)), __LINE__);
        }
        $this->reversionPattern = $reversionPattern;
        return $this;
    }
    /**
     * Get firstName value
     * @return string|null
     */
    public function getFirstName()
    {
        return $this->firstName;
    }
    /**
     * Set firstName value
     * @param string $firstName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setFirstName($firstName = null)
    {
        // validation for constraint: string
        if (!is_null($firstName) && !is_string($firstName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firstName, true), gettype($firstName)), __LINE__);
        }
        $this->firstName = $firstName;
        return $this;
    }
    /**
     * Get lastName value
     * @return string|null
     */
    public function getLastName()
    {
        return $this->lastName;
    }
    /**
     * Set lastName value
     * @param string $lastName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setLastName($lastName = null)
    {
        // validation for constraint: string
        if (!is_null($lastName) && !is_string($lastName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastName, true), gettype($lastName)), __LINE__);
        }
        $this->lastName = $lastName;
        return $this;
    }
    /**
     * Get userid value
     * @return string|null
     */
    public function getUserid()
    {
        return $this->userid;
    }
    /**
     * Set userid value
     * @param string $userid
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setUserid($userid = null)
    {
        // validation for constraint: string
        if (!is_null($userid) && !is_string($userid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userid, true), gettype($userid)), __LINE__);
        }
        $this->userid = $userid;
        return $this;
    }
    /**
     * Get department value
     * @return string|null
     */
    public function getDepartment()
    {
        return $this->department;
    }
    /**
     * Set department value
     * @param string $department
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setDepartment($department = null)
    {
        // validation for constraint: string
        if (!is_null($department) && !is_string($department)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($department, true), gettype($department)), __LINE__);
        }
        $this->department = $department;
        return $this;
    }
    /**
     * Get realm value
     * @return string|null
     */
    public function getRealm()
    {
        return $this->realm;
    }
    /**
     * Set realm value
     * @param string $realm
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setRealm($realm = null)
    {
        // validation for constraint: string
        if (!is_null($realm) && !is_string($realm)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($realm, true), gettype($realm)), __LINE__);
        }
        $this->realm = $realm;
        return $this;
    }
    /**
     * Get ipAddress value
     * @return string|null
     */
    public function getIpAddress()
    {
        return $this->ipAddress;
    }
    /**
     * Set ipAddress value
     * @param string $ipAddress
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setIpAddress($ipAddress = null)
    {
        // validation for constraint: string
        if (!is_null($ipAddress) && !is_string($ipAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ipAddress, true), gettype($ipAddress)), __LINE__);
        }
        $this->ipAddress = $ipAddress;
        return $this;
    }
    /**
     * Get timeZone value
     * @return string|null
     */
    public function getTimeZone()
    {
        return $this->timeZone;
    }
    /**
     * Set timeZone value
     * @param string $timeZone
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setTimeZone($timeZone = null)
    {
        // validation for constraint: string
        if (!is_null($timeZone) && !is_string($timeZone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($timeZone, true), gettype($timeZone)), __LINE__);
        }
        $this->timeZone = $timeZone;
        return $this;
    }
    /**
     * Get applicationUser value
     * @return string|null
     */
    public function getApplicationUser()
    {
        return $this->applicationUser;
    }
    /**
     * Set applicationUser value
     * @param string $applicationUser
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setApplicationUser($applicationUser = null)
    {
        // validation for constraint: string
        if (!is_null($applicationUser) && !is_string($applicationUser)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($applicationUser, true), gettype($applicationUser)), __LINE__);
        }
        $this->applicationUser = $applicationUser;
        return $this;
    }
    /**
     * Get instanceId value
     * @return string|null
     */
    public function getInstanceId()
    {
        return $this->instanceId;
    }
    /**
     * Set instanceId value
     * @param string $instanceId
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setInstanceId($instanceId = null)
    {
        // validation for constraint: string
        if (!is_null($instanceId) && !is_string($instanceId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($instanceId, true), gettype($instanceId)), __LINE__);
        }
        $this->instanceId = $instanceId;
        return $this;
    }
    /**
     * Get endUserId value
     * @return string|null
     */
    public function getEndUserId()
    {
        return $this->endUserId;
    }
    /**
     * Set endUserId value
     * @param string $endUserId
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setEndUserId($endUserId = null)
    {
        // validation for constraint: string
        if (!is_null($endUserId) && !is_string($endUserId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endUserId, true), gettype($endUserId)), __LINE__);
        }
        $this->endUserId = $endUserId;
        return $this;
    }
    /**
     * Get service value
     * @return string|null
     */
    public function getService()
    {
        return $this->service;
    }
    /**
     * Set service value
     * @param string $service
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setService($service = null)
    {
        // validation for constraint: string
        if (!is_null($service) && !is_string($service)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($service, true), gettype($service)), __LINE__);
        }
        $this->service = $service;
        return $this;
    }
    /**
     * Get callingSearchSpaceName value
     * @return string|null
     */
    public function getCallingSearchSpaceName()
    {
        return $this->callingSearchSpaceName;
    }
    /**
     * Set callingSearchSpaceName value
     * @param string $callingSearchSpaceName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setCallingSearchSpaceName($callingSearchSpaceName = null)
    {
        // validation for constraint: string
        if (!is_null($callingSearchSpaceName) && !is_string($callingSearchSpaceName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callingSearchSpaceName, true), gettype($callingSearchSpaceName)), __LINE__);
        }
        $this->callingSearchSpaceName = $callingSearchSpaceName;
        return $this;
    }
    /**
     * Get devicePoolName value
     * @return string|null
     */
    public function getDevicePoolName()
    {
        return $this->devicePoolName;
    }
    /**
     * Set devicePoolName value
     * @param string $devicePoolName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setDevicePoolName($devicePoolName = null)
    {
        // validation for constraint: string
        if (!is_null($devicePoolName) && !is_string($devicePoolName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($devicePoolName, true), gettype($devicePoolName)), __LINE__);
        }
        $this->devicePoolName = $devicePoolName;
        return $this;
    }
    /**
     * Get securityProfileName value
     * @return string|null
     */
    public function getSecurityProfileName()
    {
        return $this->securityProfileName;
    }
    /**
     * Set securityProfileName value
     * @param string $securityProfileName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setSecurityProfileName($securityProfileName = null)
    {
        // validation for constraint: string
        if (!is_null($securityProfileName) && !is_string($securityProfileName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($securityProfileName, true), gettype($securityProfileName)), __LINE__);
        }
        $this->securityProfileName = $securityProfileName;
        return $this;
    }
    /**
     * Get dnPattern value
     * @return string|null
     */
    public function getDnPattern()
    {
        return $this->dnPattern;
    }
    /**
     * Set dnPattern value
     * @param string $dnPattern
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setDnPattern($dnPattern = null)
    {
        // validation for constraint: string
        if (!is_null($dnPattern) && !is_string($dnPattern)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dnPattern, true), gettype($dnPattern)), __LINE__);
        }
        $this->dnPattern = $dnPattern;
        return $this;
    }
    /**
     * Get serviceName value
     * @return string|null
     */
    public function getServiceName()
    {
        return $this->serviceName;
    }
    /**
     * Set serviceName value
     * @param string $serviceName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setServiceName($serviceName = null)
    {
        // validation for constraint: string
        if (!is_null($serviceName) && !is_string($serviceName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serviceName, true), gettype($serviceName)), __LINE__);
        }
        $this->serviceName = $serviceName;
        return $this;
    }
    /**
     * Get serviceDescription value
     * @return string|null
     */
    public function getServiceDescription()
    {
        return $this->serviceDescription;
    }
    /**
     * Set serviceDescription value
     * @param string $serviceDescription
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setServiceDescription($serviceDescription = null)
    {
        // validation for constraint: string
        if (!is_null($serviceDescription) && !is_string($serviceDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serviceDescription, true), gettype($serviceDescription)), __LINE__);
        }
        $this->serviceDescription = $serviceDescription;
        return $this;
    }
    /**
     * Get dialPlanName value
     * @return string|null
     */
    public function getDialPlanName()
    {
        return $this->dialPlanName;
    }
    /**
     * Set dialPlanName value
     * @param string $dialPlanName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setDialPlanName($dialPlanName = null)
    {
        // validation for constraint: string
        if (!is_null($dialPlanName) && !is_string($dialPlanName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dialPlanName, true), gettype($dialPlanName)), __LINE__);
        }
        $this->dialPlanName = $dialPlanName;
        return $this;
    }
    /**
     * Get routeFilterName value
     * @return string|null
     */
    public function getRouteFilterName()
    {
        return $this->routeFilterName;
    }
    /**
     * Set routeFilterName value
     * @param string $routeFilterName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setRouteFilterName($routeFilterName = null)
    {
        // validation for constraint: string
        if (!is_null($routeFilterName) && !is_string($routeFilterName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($routeFilterName, true), gettype($routeFilterName)), __LINE__);
        }
        $this->routeFilterName = $routeFilterName;
        return $this;
    }
    /**
     * Get dnOrPatternIpv6 value
     * @return string|null
     */
    public function getDnOrPatternIpv6()
    {
        return $this->dnOrPatternIpv6;
    }
    /**
     * Set dnOrPatternIpv6 value
     * @param string $dnOrPatternIpv6
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setDnOrPatternIpv6($dnOrPatternIpv6 = null)
    {
        // validation for constraint: string
        if (!is_null($dnOrPatternIpv6) && !is_string($dnOrPatternIpv6)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dnOrPatternIpv6, true), gettype($dnOrPatternIpv6)), __LINE__);
        }
        $this->dnOrPatternIpv6 = $dnOrPatternIpv6;
        return $this;
    }
    /**
     * Get numberBeginWith value
     * @return string|null
     */
    public function getNumberBeginWith()
    {
        return $this->numberBeginWith;
    }
    /**
     * Set numberBeginWith value
     * @param string $numberBeginWith
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setNumberBeginWith($numberBeginWith = null)
    {
        // validation for constraint: string
        if (!is_null($numberBeginWith) && !is_string($numberBeginWith)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($numberBeginWith, true), gettype($numberBeginWith)), __LINE__);
        }
        $this->numberBeginWith = $numberBeginWith;
        return $this;
    }
    /**
     * Get dialPattern value
     * @return string|null
     */
    public function getDialPattern()
    {
        return $this->dialPattern;
    }
    /**
     * Set dialPattern value
     * @param string $dialPattern
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setDialPattern($dialPattern = null)
    {
        // validation for constraint: string
        if (!is_null($dialPattern) && !is_string($dialPattern)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dialPattern, true), gettype($dialPattern)), __LINE__);
        }
        $this->dialPattern = $dialPattern;
        return $this;
    }
    /**
     * Get usage value
     * @return string|null
     */
    public function getUsage()
    {
        return $this->usage;
    }
    /**
     * Set usage value
     * @param string $usage
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setUsage($usage = null)
    {
        // validation for constraint: string
        if (!is_null($usage) && !is_string($usage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($usage, true), gettype($usage)), __LINE__);
        }
        $this->usage = $usage;
        return $this;
    }
    /**
     * Get protocol value
     * @return string|null
     */
    public function getProtocol()
    {
        return $this->protocol;
    }
    /**
     * Set protocol value
     * @param string $protocol
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setProtocol($protocol = null)
    {
        // validation for constraint: string
        if (!is_null($protocol) && !is_string($protocol)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($protocol, true), gettype($protocol)), __LINE__);
        }
        $this->protocol = $protocol;
        return $this;
    }
    /**
     * Get remoteDestinationProfileName value
     * @return string|null
     */
    public function getRemoteDestinationProfileName()
    {
        return $this->remoteDestinationProfileName;
    }
    /**
     * Set remoteDestinationProfileName value
     * @param string $remoteDestinationProfileName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setRemoteDestinationProfileName($remoteDestinationProfileName = null)
    {
        // validation for constraint: string
        if (!is_null($remoteDestinationProfileName) && !is_string($remoteDestinationProfileName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($remoteDestinationProfileName, true), gettype($remoteDestinationProfileName)), __LINE__);
        }
        $this->remoteDestinationProfileName = $remoteDestinationProfileName;
        return $this;
    }
    /**
     * Get ctiRemoteDeviceName value
     * @return string|null
     */
    public function getCtiRemoteDeviceName()
    {
        return $this->ctiRemoteDeviceName;
    }
    /**
     * Set ctiRemoteDeviceName value
     * @param string $ctiRemoteDeviceName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setCtiRemoteDeviceName($ctiRemoteDeviceName = null)
    {
        // validation for constraint: string
        if (!is_null($ctiRemoteDeviceName) && !is_string($ctiRemoteDeviceName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ctiRemoteDeviceName, true), gettype($ctiRemoteDeviceName)), __LINE__);
        }
        $this->ctiRemoteDeviceName = $ctiRemoteDeviceName;
        return $this;
    }
    /**
     * Get dualModeDeviceName value
     * @return string|null
     */
    public function getDualModeDeviceName()
    {
        return $this->dualModeDeviceName;
    }
    /**
     * Set dualModeDeviceName value
     * @param string $dualModeDeviceName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setDualModeDeviceName($dualModeDeviceName = null)
    {
        // validation for constraint: string
        if (!is_null($dualModeDeviceName) && !is_string($dualModeDeviceName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dualModeDeviceName, true), gettype($dualModeDeviceName)), __LINE__);
        }
        $this->dualModeDeviceName = $dualModeDeviceName;
        return $this;
    }
    /**
     * Get dnOrPattern value
     * @return string|null
     */
    public function getDnOrPattern()
    {
        return $this->dnOrPattern;
    }
    /**
     * Set dnOrPattern value
     * @param string $dnOrPattern
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setDnOrPattern($dnOrPattern = null)
    {
        // validation for constraint: string
        if (!is_null($dnOrPattern) && !is_string($dnOrPattern)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dnOrPattern, true), gettype($dnOrPattern)), __LINE__);
        }
        $this->dnOrPattern = $dnOrPattern;
        return $this;
    }
    /**
     * Get partition value
     * @return string|null
     */
    public function getPartition()
    {
        return $this->partition;
    }
    /**
     * Set partition value
     * @param string $partition
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setPartition($partition = null)
    {
        // validation for constraint: string
        if (!is_null($partition) && !is_string($partition)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($partition, true), gettype($partition)), __LINE__);
        }
        $this->partition = $partition;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get hostedPattern value
     * @return string|null
     */
    public function getHostedPattern()
    {
        return $this->hostedPattern;
    }
    /**
     * Set hostedPattern value
     * @param string $hostedPattern
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setHostedPattern($hostedPattern = null)
    {
        // validation for constraint: string
        if (!is_null($hostedPattern) && !is_string($hostedPattern)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($hostedPattern, true), gettype($hostedPattern)), __LINE__);
        }
        $this->hostedPattern = $hostedPattern;
        return $this;
    }
    /**
     * Get clusterId value
     * @return string|null
     */
    public function getClusterId()
    {
        return $this->clusterId;
    }
    /**
     * Set clusterId value
     * @param string $clusterId
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setClusterId($clusterId = null)
    {
        // validation for constraint: string
        if (!is_null($clusterId) && !is_string($clusterId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($clusterId, true), gettype($clusterId)), __LINE__);
        }
        $this->clusterId = $clusterId;
        return $this;
    }
    /**
     * Get ldapDn value
     * @return string|null
     */
    public function getLdapDn()
    {
        return $this->ldapDn;
    }
    /**
     * Set ldapDn value
     * @param string $ldapDn
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setLdapDn($ldapDn = null)
    {
        // validation for constraint: string
        if (!is_null($ldapDn) && !is_string($ldapDn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ldapDn, true), gettype($ldapDn)), __LINE__);
        }
        $this->ldapDn = $ldapDn;
        return $this;
    }
    /**
     * Get userSearchBase value
     * @return string|null
     */
    public function getUserSearchBase()
    {
        return $this->userSearchBase;
    }
    /**
     * Set userSearchBase value
     * @param string $userSearchBase
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setUserSearchBase($userSearchBase = null)
    {
        // validation for constraint: string
        if (!is_null($userSearchBase) && !is_string($userSearchBase)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userSearchBase, true), gettype($userSearchBase)), __LINE__);
        }
        $this->userSearchBase = $userSearchBase;
        return $this;
    }
    /**
     * Get learnedPattern value
     * @return string|null
     */
    public function getLearnedPattern()
    {
        return $this->learnedPattern;
    }
    /**
     * Set learnedPattern value
     * @param string $learnedPattern
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setLearnedPattern($learnedPattern = null)
    {
        // validation for constraint: string
        if (!is_null($learnedPattern) && !is_string($learnedPattern)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($learnedPattern, true), gettype($learnedPattern)), __LINE__);
        }
        $this->learnedPattern = $learnedPattern;
        return $this;
    }
    /**
     * Get learnedPatternPrefix value
     * @return string|null
     */
    public function getLearnedPatternPrefix()
    {
        return $this->learnedPatternPrefix;
    }
    /**
     * Set learnedPatternPrefix value
     * @param string $learnedPatternPrefix
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setLearnedPatternPrefix($learnedPatternPrefix = null)
    {
        // validation for constraint: string
        if (!is_null($learnedPatternPrefix) && !is_string($learnedPatternPrefix)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($learnedPatternPrefix, true), gettype($learnedPatternPrefix)), __LINE__);
        }
        $this->learnedPatternPrefix = $learnedPatternPrefix;
        return $this;
    }
    /**
     * Get callControlIdentity value
     * @return string|null
     */
    public function getCallControlIdentity()
    {
        return $this->callControlIdentity;
    }
    /**
     * Set callControlIdentity value
     * @param string $callControlIdentity
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setCallControlIdentity($callControlIdentity = null)
    {
        // validation for constraint: string
        if (!is_null($callControlIdentity) && !is_string($callControlIdentity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callControlIdentity, true), gettype($callControlIdentity)), __LINE__);
        }
        $this->callControlIdentity = $callControlIdentity;
        return $this;
    }
    /**
     * Get domain value
     * @return string|null
     */
    public function getDomain()
    {
        return $this->domain;
    }
    /**
     * Set domain value
     * @param string $domain
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setDomain($domain = null)
    {
        // validation for constraint: string
        if (!is_null($domain) && !is_string($domain)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($domain, true), gettype($domain)), __LINE__);
        }
        $this->domain = $domain;
        return $this;
    }
    /**
     * Get imeEnrolledPatternGroupName value
     * @return string|null
     */
    public function getImeEnrolledPatternGroupName()
    {
        return $this->imeEnrolledPatternGroupName;
    }
    /**
     * Set imeEnrolledPatternGroupName value
     * @param string $imeEnrolledPatternGroupName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setImeEnrolledPatternGroupName($imeEnrolledPatternGroupName = null)
    {
        // validation for constraint: string
        if (!is_null($imeEnrolledPatternGroupName) && !is_string($imeEnrolledPatternGroupName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($imeEnrolledPatternGroupName, true), gettype($imeEnrolledPatternGroupName)), __LINE__);
        }
        $this->imeEnrolledPatternGroupName = $imeEnrolledPatternGroupName;
        return $this;
    }
    /**
     * Get imeExclusionNumberGroupName value
     * @return string|null
     */
    public function getImeExclusionNumberGroupName()
    {
        return $this->imeExclusionNumberGroupName;
    }
    /**
     * Set imeExclusionNumberGroupName value
     * @param string $imeExclusionNumberGroupName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setImeExclusionNumberGroupName($imeExclusionNumberGroupName = null)
    {
        // validation for constraint: string
        if (!is_null($imeExclusionNumberGroupName) && !is_string($imeExclusionNumberGroupName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($imeExclusionNumberGroupName, true), gettype($imeExclusionNumberGroupName)), __LINE__);
        }
        $this->imeExclusionNumberGroupName = $imeExclusionNumberGroupName;
        return $this;
    }
    /**
     * Get filter value
     * @return string|null
     */
    public function getFilter()
    {
        return $this->filter;
    }
    /**
     * Set filter value
     * @param string $filter
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setFilter($filter = null)
    {
        // validation for constraint: string
        if (!is_null($filter) && !is_string($filter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($filter, true), gettype($filter)), __LINE__);
        }
        $this->filter = $filter;
        return $this;
    }
    /**
     * Get subjectName value
     * @return string|null
     */
    public function getSubjectName()
    {
        return $this->subjectName;
    }
    /**
     * Set subjectName value
     * @param string $subjectName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setSubjectName($subjectName = null)
    {
        // validation for constraint: string
        if (!is_null($subjectName) && !is_string($subjectName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($subjectName, true), gettype($subjectName)), __LINE__);
        }
        $this->subjectName = $subjectName;
        return $this;
    }
    /**
     * Get issuerName value
     * @return string|null
     */
    public function getIssuerName()
    {
        return $this->issuerName;
    }
    /**
     * Set issuerName value
     * @param string $issuerName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setIssuerName($issuerName = null)
    {
        // validation for constraint: string
        if (!is_null($issuerName) && !is_string($issuerName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($issuerName, true), gettype($issuerName)), __LINE__);
        }
        $this->issuerName = $issuerName;
        return $this;
    }
    /**
     * Get serialNumber value
     * @return string|null
     */
    public function getSerialNumber()
    {
        return $this->serialNumber;
    }
    /**
     * Set serialNumber value
     * @param string $serialNumber
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setSerialNumber($serialNumber = null)
    {
        // validation for constraint: string
        if (!is_null($serialNumber) && !is_string($serialNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serialNumber, true), gettype($serialNumber)), __LINE__);
        }
        $this->serialNumber = $serialNumber;
        return $this;
    }
    /**
     * Get timeToLive value
     * @return string|null
     */
    public function getTimeToLive()
    {
        return $this->timeToLive;
    }
    /**
     * Set timeToLive value
     * @param string $timeToLive
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setTimeToLive($timeToLive = null)
    {
        // validation for constraint: string
        if (!is_null($timeToLive) && !is_string($timeToLive)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($timeToLive, true), gettype($timeToLive)), __LINE__);
        }
        $this->timeToLive = $timeToLive;
        return $this;
    }
    /**
     * Get directorynumber value
     * @return string|null
     */
    public function getDirectorynumber()
    {
        return $this->directorynumber;
    }
    /**
     * Set directorynumber value
     * @param string $directorynumber
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setDirectorynumber($directorynumber = null)
    {
        // validation for constraint: string
        if (!is_null($directorynumber) && !is_string($directorynumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($directorynumber, true), gettype($directorynumber)), __LINE__);
        }
        $this->directorynumber = $directorynumber;
        return $this;
    }
    /**
     * Get field value
     * @return string|null
     */
    public function getField()
    {
        return $this->field;
    }
    /**
     * Set field value
     * @param string $field
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setField($field = null)
    {
        // validation for constraint: string
        if (!is_null($field) && !is_string($field)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($field, true), gettype($field)), __LINE__);
        }
        $this->field = $field;
        return $this;
    }
    /**
     * Get hostName value
     * @return string|null
     */
    public function getHostName()
    {
        return $this->hostName;
    }
    /**
     * Set hostName value
     * @param string $hostName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setHostName($hostName = null)
    {
        // validation for constraint: string
        if (!is_null($hostName) && !is_string($hostName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($hostName, true), gettype($hostName)), __LINE__);
        }
        $this->hostName = $hostName;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription_1()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setDescription_1($description_1 = null)
    {
        // validation for constraint: string
        if (!is_null($description_1) && !is_string($description_1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description_1, true), gettype($description_1)), __LINE__);
        }
        $this->Description = $description_1;
        return $this;
    }
    /**
     * Get routeString value
     * @return string|null
     */
    public function getRouteString()
    {
        return $this->routeString;
    }
    /**
     * Set routeString value
     * @param string $routeString
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setRouteString($routeString = null)
    {
        // validation for constraint: string
        if (!is_null($routeString) && !is_string($routeString)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($routeString, true), gettype($routeString)), __LINE__);
        }
        $this->routeString = $routeString;
        return $this;
    }
    /**
     * Get defaultVideoStreamId value
     * @return string|null
     */
    public function getDefaultVideoStreamId()
    {
        return $this->defaultVideoStreamId;
    }
    /**
     * Set defaultVideoStreamId value
     * @param string $defaultVideoStreamId
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setDefaultVideoStreamId($defaultVideoStreamId = null)
    {
        // validation for constraint: string
        if (!is_null($defaultVideoStreamId) && !is_string($defaultVideoStreamId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($defaultVideoStreamId, true), gettype($defaultVideoStreamId)), __LINE__);
        }
        $this->defaultVideoStreamId = $defaultVideoStreamId;
        return $this;
    }
    /**
     * Get ldapConfigName value
     * @return string|null
     */
    public function getLdapConfigName()
    {
        return $this->ldapConfigName;
    }
    /**
     * Set ldapConfigName value
     * @param string $ldapConfigName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setLdapConfigName($ldapConfigName = null)
    {
        // validation for constraint: string
        if (!is_null($ldapConfigName) && !is_string($ldapConfigName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ldapConfigName, true), gettype($ldapConfigName)), __LINE__);
        }
        $this->ldapConfigName = $ldapConfigName;
        return $this;
    }
    /**
     * Get ldapManagerDisgName value
     * @return string|null
     */
    public function getLdapManagerDisgName()
    {
        return $this->ldapManagerDisgName;
    }
    /**
     * Set ldapManagerDisgName value
     * @param string $ldapManagerDisgName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setLdapManagerDisgName($ldapManagerDisgName = null)
    {
        // validation for constraint: string
        if (!is_null($ldapManagerDisgName) && !is_string($ldapManagerDisgName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ldapManagerDisgName, true), gettype($ldapManagerDisgName)), __LINE__);
        }
        $this->ldapManagerDisgName = $ldapManagerDisgName;
        return $this;
    }
    /**
     * Get ldapUserSearch value
     * @return string|null
     */
    public function getLdapUserSearch()
    {
        return $this->ldapUserSearch;
    }
    /**
     * Set ldapUserSearch value
     * @param string $ldapUserSearch
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setLdapUserSearch($ldapUserSearch = null)
    {
        // validation for constraint: string
        if (!is_null($ldapUserSearch) && !is_string($ldapUserSearch)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ldapUserSearch, true), gettype($ldapUserSearch)), __LINE__);
        }
        $this->ldapUserSearch = $ldapUserSearch;
        return $this;
    }
    /**
     * Get ccaId value
     * @return string|null
     */
    public function getCcaId()
    {
        return $this->ccaId;
    }
    /**
     * Set ccaId value
     * @param string $ccaId
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setCcaId($ccaId = null)
    {
        // validation for constraint: string
        if (!is_null($ccaId) && !is_string($ccaId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ccaId, true), gettype($ccaId)), __LINE__);
        }
        $this->ccaId = $ccaId;
        return $this;
    }
    /**
     * Get primarySoftSwitchId value
     * @return string|null
     */
    public function getPrimarySoftSwitchId()
    {
        return $this->primarySoftSwitchId;
    }
    /**
     * Set primarySoftSwitchId value
     * @param string $primarySoftSwitchId
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setPrimarySoftSwitchId($primarySoftSwitchId = null)
    {
        // validation for constraint: string
        if (!is_null($primarySoftSwitchId) && !is_string($primarySoftSwitchId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($primarySoftSwitchId, true), gettype($primarySoftSwitchId)), __LINE__);
        }
        $this->primarySoftSwitchId = $primarySoftSwitchId;
        return $this;
    }
    /**
     * Get deviceDescription value
     * @return string|null
     */
    public function getDeviceDescription()
    {
        return $this->deviceDescription;
    }
    /**
     * Set deviceDescription value
     * @param string $deviceDescription
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setDeviceDescription($deviceDescription = null)
    {
        // validation for constraint: string
        if (!is_null($deviceDescription) && !is_string($deviceDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deviceDescription, true), gettype($deviceDescription)), __LINE__);
        }
        $this->deviceDescription = $deviceDescription;
        return $this;
    }
    /**
     * Get server value
     * @return string|null
     */
    public function getServer()
    {
        return $this->server;
    }
    /**
     * Set server value
     * @param string $server
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setServer($server = null)
    {
        // validation for constraint: string
        if (!is_null($server) && !is_string($server)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($server, true), gettype($server)), __LINE__);
        }
        $this->server = $server;
        return $this;
    }
    /**
     * Get presenceRedundancyGroup value
     * @return string|null
     */
    public function getPresenceRedundancyGroup()
    {
        return $this->presenceRedundancyGroup;
    }
    /**
     * Set presenceRedundancyGroup value
     * @param string $presenceRedundancyGroup
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setPresenceRedundancyGroup($presenceRedundancyGroup = null)
    {
        // validation for constraint: string
        if (!is_null($presenceRedundancyGroup) && !is_string($presenceRedundancyGroup)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($presenceRedundancyGroup, true), gettype($presenceRedundancyGroup)), __LINE__);
        }
        $this->presenceRedundancyGroup = $presenceRedundancyGroup;
        return $this;
    }
    /**
     * Get ssidPrefix value
     * @return string|null
     */
    public function getSsidPrefix()
    {
        return $this->ssidPrefix;
    }
    /**
     * Set ssidPrefix value
     * @param string $ssidPrefix
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setSsidPrefix($ssidPrefix = null)
    {
        // validation for constraint: string
        if (!is_null($ssidPrefix) && !is_string($ssidPrefix)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ssidPrefix, true), gettype($ssidPrefix)), __LINE__);
        }
        $this->ssidPrefix = $ssidPrefix;
        return $this;
    }
    /**
     * Get authenticationMethod value
     * @return string|null
     */
    public function getAuthenticationMethod()
    {
        return $this->authenticationMethod;
    }
    /**
     * Set authenticationMethod value
     * @param string $authenticationMethod
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setAuthenticationMethod($authenticationMethod = null)
    {
        // validation for constraint: string
        if (!is_null($authenticationMethod) && !is_string($authenticationMethod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($authenticationMethod, true), gettype($authenticationMethod)), __LINE__);
        }
        $this->authenticationMethod = $authenticationMethod;
        return $this;
    }
    /**
     * Get ssid value
     * @return string|null
     */
    public function getSsid()
    {
        return $this->ssid;
    }
    /**
     * Set ssid value
     * @param string $ssid
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setSsid($ssid = null)
    {
        // validation for constraint: string
        if (!is_null($ssid) && !is_string($ssid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ssid, true), gettype($ssid)), __LINE__);
        }
        $this->ssid = $ssid;
        return $this;
    }
    /**
     * Get networkAccessProfile value
     * @return string|null
     */
    public function getNetworkAccessProfile()
    {
        return $this->networkAccessProfile;
    }
    /**
     * Set networkAccessProfile value
     * @param string $networkAccessProfile
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setNetworkAccessProfile($networkAccessProfile = null)
    {
        // validation for constraint: string
        if (!is_null($networkAccessProfile) && !is_string($networkAccessProfile)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($networkAccessProfile, true), gettype($networkAccessProfile)), __LINE__);
        }
        $this->networkAccessProfile = $networkAccessProfile;
        return $this;
    }
    /**
     * Get lineDescription value
     * @return string|null
     */
    public function getLineDescription()
    {
        return $this->lineDescription;
    }
    /**
     * Set lineDescription value
     * @param string $lineDescription
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setLineDescription($lineDescription = null)
    {
        // validation for constraint: string
        if (!is_null($lineDescription) && !is_string($lineDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lineDescription, true), gettype($lineDescription)), __LINE__);
        }
        $this->lineDescription = $lineDescription;
        return $this;
    }
    /**
     * Get ldapConfigurationName value
     * @return string|null
     */
    public function getLdapConfigurationName()
    {
        return $this->ldapConfigurationName;
    }
    /**
     * Set ldapConfigurationName value
     * @param string $ldapConfigurationName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SearchCriteria
     */
    public function setLdapConfigurationName($ldapConfigurationName = null)
    {
        // validation for constraint: string
        if (!is_null($ldapConfigurationName) && !is_string($ldapConfigurationName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ldapConfigurationName, true), gettype($ldapConfigurationName)), __LINE__);
        }
        $this->ldapConfigurationName = $ldapConfigurationName;
        return $this;
    }
}
