<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for serviceProfileInfos StructType
 * @subpackage Structs
 */
class ServiceProfileInfos extends AbstractStructBase
{
    /**
     * The serviceProfileInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: 7
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XServiceProfileList[]
     */
    public $serviceProfileInfo;
    /**
     * Constructor method for serviceProfileInfos
     * @uses ServiceProfileInfos::setServiceProfileInfo()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XServiceProfileList[] $serviceProfileInfo
     */
    public function __construct(array $serviceProfileInfo = array())
    {
        $this
            ->setServiceProfileInfo($serviceProfileInfo);
    }
    /**
     * Get serviceProfileInfo value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XServiceProfileList[]|null
     */
    public function getServiceProfileInfo()
    {
        return $this->serviceProfileInfo;
    }
    /**
     * This method is responsible for validating the values passed to the setServiceProfileInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setServiceProfileInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateServiceProfileInfoForArrayConstraintsFromSetServiceProfileInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $serviceProfileInfosServiceProfileInfoItem) {
            // validation for constraint: itemType
            if (!$serviceProfileInfosServiceProfileInfoItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\XServiceProfileList) {
                $invalidValues[] = is_object($serviceProfileInfosServiceProfileInfoItem) ? get_class($serviceProfileInfosServiceProfileInfoItem) : sprintf('%s(%s)', gettype($serviceProfileInfosServiceProfileInfoItem), var_export($serviceProfileInfosServiceProfileInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The serviceProfileInfo property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XServiceProfileList, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set serviceProfileInfo value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XServiceProfileList[] $serviceProfileInfo
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ServiceProfileInfos
     */
    public function setServiceProfileInfo(array $serviceProfileInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($serviceProfileInfoArrayErrorMessage = self::validateServiceProfileInfoForArrayConstraintsFromSetServiceProfileInfo($serviceProfileInfo))) {
            throw new \InvalidArgumentException($serviceProfileInfoArrayErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(7)
        if (is_array($serviceProfileInfo) && count($serviceProfileInfo) > 7) {
            throw new \InvalidArgumentException(sprintf('Invalid count of %s, the number of elements contained by the property must be less than or equal to 7', count($serviceProfileInfo)), __LINE__);
        }
        $this->serviceProfileInfo = $serviceProfileInfo;
        return $this;
    }
    /**
     * Add item to serviceProfileInfo value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XServiceProfileList $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\ServiceProfileInfos
     */
    public function addToServiceProfileInfo(\Losc\CucmBundle\Model\Webservice\StructType\XServiceProfileList $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\XServiceProfileList) {
            throw new \InvalidArgumentException(sprintf('The serviceProfileInfo property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XServiceProfileList, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: maxOccurs(7)
        if (is_array($this->serviceProfileInfo) && count($this->serviceProfileInfo) >= 7) {
            throw new \InvalidArgumentException(sprintf('You can\'t add anymore element to this property that already contains %s elements, the number of elements contained by the property must be less than or equal to 7', count($this->serviceProfileInfo)), __LINE__);
        }
        $this->serviceProfileInfo[] = $item;
        return $this;
    }
}
