<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for softKeys StructType
 * Meta information extracted from the WSDL
 * - documentation: List of mandatory keys for each callstate :: On Hook - NewCall Connected - End Call On Hold - Resume Off Hook - End Call Connected Transfer - Transfer Digits After First - Backward Connected Conference - Conference Ring Out - End
 * Call Off Hook With Feature - End Call
 * @subpackage Structs
 */
class SoftKeys extends AbstractStructBase
{
    /**
     * The softKey
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XSoftKeyMember[]
     */
    public $softKey;
    /**
     * Constructor method for softKeys
     * @uses SoftKeys::setSoftKey()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XSoftKeyMember[] $softKey
     */
    public function __construct(array $softKey = array())
    {
        $this
            ->setSoftKey($softKey);
    }
    /**
     * Get softKey value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSoftKeyMember[]|null
     */
    public function getSoftKey()
    {
        return $this->softKey;
    }
    /**
     * This method is responsible for validating the values passed to the setSoftKey method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSoftKey method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSoftKeyForArrayConstraintsFromSetSoftKey(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $softKeysSoftKeyItem) {
            // validation for constraint: itemType
            if (!$softKeysSoftKeyItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\XSoftKeyMember) {
                $invalidValues[] = is_object($softKeysSoftKeyItem) ? get_class($softKeysSoftKeyItem) : sprintf('%s(%s)', gettype($softKeysSoftKeyItem), var_export($softKeysSoftKeyItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The softKey property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XSoftKeyMember, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set softKey value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XSoftKeyMember[] $softKey
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SoftKeys
     */
    public function setSoftKey(array $softKey = array())
    {
        // validation for constraint: array
        if ('' !== ($softKeyArrayErrorMessage = self::validateSoftKeyForArrayConstraintsFromSetSoftKey($softKey))) {
            throw new \InvalidArgumentException($softKeyArrayErrorMessage, __LINE__);
        }
        $this->softKey = $softKey;
        return $this;
    }
    /**
     * Add item to softKey value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XSoftKeyMember $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\SoftKeys
     */
    public function addToSoftKey(\Losc\CucmBundle\Model\Webservice\StructType\XSoftKeyMember $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\XSoftKeyMember) {
            throw new \InvalidArgumentException(sprintf('The softKey property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XSoftKeyMember, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->softKey[] = $item;
        return $this;
    }
}
