<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for subunits StructType
 * @subpackage Structs
 */
class Subunits extends AbstractStructBase
{
    /**
     * The subunit
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \Losc\CucmBundle\Model\Webservice\StructType\Subunit[]
     */
    public $subunit;
    /**
     * Constructor method for subunits
     * @uses Subunits::setSubunit()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\Subunit[] $subunit
     */
    public function __construct(array $subunit = array())
    {
        $this
            ->setSubunit($subunit);
    }
    /**
     * Get subunit value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\Subunit[]|null
     */
    public function getSubunit()
    {
        return $this->subunit;
    }
    /**
     * This method is responsible for validating the values passed to the setSubunit method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSubunit method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSubunitForArrayConstraintsFromSetSubunit(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $subunitsSubunitItem) {
            // validation for constraint: itemType
            if (!$subunitsSubunitItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\Subunit) {
                $invalidValues[] = is_object($subunitsSubunitItem) ? get_class($subunitsSubunitItem) : sprintf('%s(%s)', gettype($subunitsSubunitItem), var_export($subunitsSubunitItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The subunit property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\Subunit, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set subunit value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\Subunit[] $subunit
     * @return \Losc\CucmBundle\Model\Webservice\StructType\Subunits
     */
    public function setSubunit(array $subunit = array())
    {
        // validation for constraint: array
        if ('' !== ($subunitArrayErrorMessage = self::validateSubunitForArrayConstraintsFromSetSubunit($subunit))) {
            throw new \InvalidArgumentException($subunitArrayErrorMessage, __LINE__);
        }
        $this->subunit = $subunit;
        return $this;
    }
    /**
     * Add item to subunit value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\Subunit $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\Subunits
     */
    public function addToSubunit(\Losc\CucmBundle\Model\Webservice\StructType\Subunit $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\Subunit) {
            throw new \InvalidArgumentException(sprintf('The subunit property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\Subunit, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->subunit[] = $item;
        return $this;
    }
}
