<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateCcdFeatureConfigReq StructType
 * @subpackage Structs
 */
class UpdateCcdFeatureConfigReq extends APIRequest
{
    /**
     * The ccdParam
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \Losc\CucmBundle\Model\Webservice\StructType\RCcdParam[]
     */
    public $ccdParam;
    /**
     * Constructor method for UpdateCcdFeatureConfigReq
     * @uses UpdateCcdFeatureConfigReq::setCcdParam()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RCcdParam[] $ccdParam
     */
    public function __construct(array $ccdParam = array())
    {
        $this
            ->setCcdParam($ccdParam);
    }
    /**
     * Get ccdParam value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RCcdParam[]
     */
    public function getCcdParam()
    {
        return $this->ccdParam;
    }
    /**
     * This method is responsible for validating the values passed to the setCcdParam method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCcdParam method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCcdParamForArrayConstraintsFromSetCcdParam(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $updateCcdFeatureConfigReqCcdParamItem) {
            // validation for constraint: itemType
            if (!$updateCcdFeatureConfigReqCcdParamItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\RCcdParam) {
                $invalidValues[] = is_object($updateCcdFeatureConfigReqCcdParamItem) ? get_class($updateCcdFeatureConfigReqCcdParamItem) : sprintf('%s(%s)', gettype($updateCcdFeatureConfigReqCcdParamItem), var_export($updateCcdFeatureConfigReqCcdParamItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ccdParam property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\RCcdParam, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ccdParam value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RCcdParam[] $ccdParam
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateCcdFeatureConfigReq
     */
    public function setCcdParam(array $ccdParam = array())
    {
        // validation for constraint: array
        if ('' !== ($ccdParamArrayErrorMessage = self::validateCcdParamForArrayConstraintsFromSetCcdParam($ccdParam))) {
            throw new \InvalidArgumentException($ccdParamArrayErrorMessage, __LINE__);
        }
        $this->ccdParam = $ccdParam;
        return $this;
    }
    /**
     * Add item to ccdParam value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RCcdParam $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateCcdFeatureConfigReq
     */
    public function addToCcdParam(\Losc\CucmBundle\Model\Webservice\StructType\RCcdParam $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\RCcdParam) {
            throw new \InvalidArgumentException(sprintf('The ccdParam property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\RCcdParam, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ccdParam[] = $item;
        return $this;
    }
}
