<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateMobilityProfileReq StructType
 * @subpackage Structs
 */
class UpdateMobilityProfileReq extends NameAndGUIDRequest
{
    /**
     * The newName
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $newName;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $description;
    /**
     * The mobileClientCallingOption
     * Meta information extracted from the WSDL
     * - default: Dial via Office Reverse
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $mobileClientCallingOption;
    /**
     * The dvofServiceAccessNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $dvofServiceAccessNumber;
    /**
     * The dirn
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XDirn
     */
    public $dirn;
    /**
     * The dvorCallerId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dvorCallerId;
    /**
     * Constructor method for UpdateMobilityProfileReq
     * @uses UpdateMobilityProfileReq::setNewName()
     * @uses UpdateMobilityProfileReq::setDescription()
     * @uses UpdateMobilityProfileReq::setMobileClientCallingOption()
     * @uses UpdateMobilityProfileReq::setDvofServiceAccessNumber()
     * @uses UpdateMobilityProfileReq::setDirn()
     * @uses UpdateMobilityProfileReq::setDvorCallerId()
     * @param string $newName
     * @param string $description
     * @param string $mobileClientCallingOption
     * @param string $dvofServiceAccessNumber
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XDirn $dirn
     * @param string $dvorCallerId
     */
    public function __construct($newName = null, $description = null, $mobileClientCallingOption = 'Dial via Office Reverse', $dvofServiceAccessNumber = null, \Losc\CucmBundle\Model\Webservice\StructType\XDirn $dirn = null, $dvorCallerId = null)
    {
        $this
            ->setNewName($newName)
            ->setDescription($description)
            ->setMobileClientCallingOption($mobileClientCallingOption)
            ->setDvofServiceAccessNumber($dvofServiceAccessNumber)
            ->setDirn($dirn)
            ->setDvorCallerId($dvorCallerId);
    }
    /**
     * Get newName value
     * @return string|null
     */
    public function getNewName()
    {
        return $this->newName;
    }
    /**
     * Set newName value
     * @param string $newName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateMobilityProfileReq
     */
    public function setNewName($newName = null)
    {
        // validation for constraint: string
        if (!is_null($newName) && !is_string($newName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($newName, true), gettype($newName)), __LINE__);
        }
        // validation for constraint: maxLength(50)
        if (!is_null($newName) && mb_strlen($newName) > 50) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 50', mb_strlen($newName)), __LINE__);
        }
        $this->newName = $newName;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateMobilityProfileReq
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get mobileClientCallingOption value
     * @return string|null
     */
    public function getMobileClientCallingOption()
    {
        return $this->mobileClientCallingOption;
    }
    /**
     * Set mobileClientCallingOption value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XDialViaOffice::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XDialViaOffice::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $mobileClientCallingOption
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateMobilityProfileReq
     */
    public function setMobileClientCallingOption($mobileClientCallingOption = 'Dial via Office Reverse')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XDialViaOffice::valueIsValid($mobileClientCallingOption)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XDialViaOffice', is_array($mobileClientCallingOption) ? implode(', ', $mobileClientCallingOption) : var_export($mobileClientCallingOption, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XDialViaOffice::getValidValues())), __LINE__);
        }
        $this->mobileClientCallingOption = $mobileClientCallingOption;
        return $this;
    }
    /**
     * Get dvofServiceAccessNumber value
     * @return string|null
     */
    public function getDvofServiceAccessNumber()
    {
        return $this->dvofServiceAccessNumber;
    }
    /**
     * Set dvofServiceAccessNumber value
     * @param string $dvofServiceAccessNumber
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateMobilityProfileReq
     */
    public function setDvofServiceAccessNumber($dvofServiceAccessNumber = null)
    {
        // validation for constraint: string
        if (!is_null($dvofServiceAccessNumber) && !is_string($dvofServiceAccessNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dvofServiceAccessNumber, true), gettype($dvofServiceAccessNumber)), __LINE__);
        }
        $this->dvofServiceAccessNumber = $dvofServiceAccessNumber;
        return $this;
    }
    /**
     * Get dirn value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XDirn|null
     */
    public function getDirn()
    {
        return $this->dirn;
    }
    /**
     * Set dirn value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XDirn $dirn
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateMobilityProfileReq
     */
    public function setDirn(\Losc\CucmBundle\Model\Webservice\StructType\XDirn $dirn = null)
    {
        $this->dirn = $dirn;
        return $this;
    }
    /**
     * Get dvorCallerId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDvorCallerId()
    {
        return isset($this->dvorCallerId) ? $this->dvorCallerId : null;
    }
    /**
     * Set dvorCallerId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dvorCallerId
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateMobilityProfileReq
     */
    public function setDvorCallerId($dvorCallerId = null)
    {
        // validation for constraint: string
        if (!is_null($dvorCallerId) && !is_string($dvorCallerId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dvorCallerId, true), gettype($dvorCallerId)), __LINE__);
        }
        if (is_null($dvorCallerId) || (is_array($dvorCallerId) && empty($dvorCallerId))) {
            unset($this->dvorCallerId);
        } else {
            $this->dvorCallerId = $dvorCallerId;
        }
        return $this;
    }
}
