<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateMobilityReq StructType
 * Meta information extracted from the WSDL
 * - documentation: It is mandatory to give either handoffNumber or DTMFNumber tag in the request. Both can't be null.
 * @subpackage Structs
 */
class UpdateMobilityReq extends AbstractStructBase
{
    /**
     * The handoffNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $handoffNumber;
    /**
     * The DTMFNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $DTMFNumber;
    /**
     * The newHandoffNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $newHandoffNumber;
    /**
     * The newHandoffPartitionName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $newHandoffPartitionName;
    /**
     * The newDTMFNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $newDTMFNumber;
    /**
     * The newDTMFPartitionName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $newDTMFPartitionName;
    /**
     * Constructor method for UpdateMobilityReq
     * @uses UpdateMobilityReq::setHandoffNumber()
     * @uses UpdateMobilityReq::setDTMFNumber()
     * @uses UpdateMobilityReq::setNewHandoffNumber()
     * @uses UpdateMobilityReq::setNewHandoffPartitionName()
     * @uses UpdateMobilityReq::setNewDTMFNumber()
     * @uses UpdateMobilityReq::setNewDTMFPartitionName()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $handoffNumber
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $dTMFNumber
     * @param string $newHandoffNumber
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $newHandoffPartitionName
     * @param string $newDTMFNumber
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $newDTMFPartitionName
     */
    public function __construct(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $handoffNumber = null, \Losc\CucmBundle\Model\Webservice\StructType\XFkType $dTMFNumber = null, $newHandoffNumber = null, \Losc\CucmBundle\Model\Webservice\StructType\XFkType $newHandoffPartitionName = null, $newDTMFNumber = null, \Losc\CucmBundle\Model\Webservice\StructType\XFkType $newDTMFPartitionName = null)
    {
        $this
            ->setHandoffNumber($handoffNumber)
            ->setDTMFNumber($dTMFNumber)
            ->setNewHandoffNumber($newHandoffNumber)
            ->setNewHandoffPartitionName($newHandoffPartitionName)
            ->setNewDTMFNumber($newDTMFNumber)
            ->setNewDTMFPartitionName($newDTMFPartitionName);
    }
    /**
     * Get handoffNumber value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getHandoffNumber()
    {
        return $this->handoffNumber;
    }
    /**
     * Set handoffNumber value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $handoffNumber
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateMobilityReq
     */
    public function setHandoffNumber(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $handoffNumber = null)
    {
        $this->handoffNumber = $handoffNumber;
        return $this;
    }
    /**
     * Get DTMFNumber value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getDTMFNumber()
    {
        return $this->DTMFNumber;
    }
    /**
     * Set DTMFNumber value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $dTMFNumber
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateMobilityReq
     */
    public function setDTMFNumber(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $dTMFNumber = null)
    {
        $this->DTMFNumber = $dTMFNumber;
        return $this;
    }
    /**
     * Get newHandoffNumber value
     * @return string|null
     */
    public function getNewHandoffNumber()
    {
        return $this->newHandoffNumber;
    }
    /**
     * Set newHandoffNumber value
     * @param string $newHandoffNumber
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateMobilityReq
     */
    public function setNewHandoffNumber($newHandoffNumber = null)
    {
        // validation for constraint: string
        if (!is_null($newHandoffNumber) && !is_string($newHandoffNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($newHandoffNumber, true), gettype($newHandoffNumber)), __LINE__);
        }
        $this->newHandoffNumber = $newHandoffNumber;
        return $this;
    }
    /**
     * Get newHandoffPartitionName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getNewHandoffPartitionName()
    {
        return $this->newHandoffPartitionName;
    }
    /**
     * Set newHandoffPartitionName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $newHandoffPartitionName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateMobilityReq
     */
    public function setNewHandoffPartitionName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $newHandoffPartitionName = null)
    {
        $this->newHandoffPartitionName = $newHandoffPartitionName;
        return $this;
    }
    /**
     * Get newDTMFNumber value
     * @return string|null
     */
    public function getNewDTMFNumber()
    {
        return $this->newDTMFNumber;
    }
    /**
     * Set newDTMFNumber value
     * @param string $newDTMFNumber
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateMobilityReq
     */
    public function setNewDTMFNumber($newDTMFNumber = null)
    {
        // validation for constraint: string
        if (!is_null($newDTMFNumber) && !is_string($newDTMFNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($newDTMFNumber, true), gettype($newDTMFNumber)), __LINE__);
        }
        $this->newDTMFNumber = $newDTMFNumber;
        return $this;
    }
    /**
     * Get newDTMFPartitionName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getNewDTMFPartitionName()
    {
        return $this->newDTMFPartitionName;
    }
    /**
     * Set newDTMFPartitionName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $newDTMFPartitionName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateMobilityReq
     */
    public function setNewDTMFPartitionName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $newDTMFPartitionName = null)
    {
        $this->newDTMFPartitionName = $newDTMFPartitionName;
        return $this;
    }
}
