<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdatePhoneButtonTemplateReq StructType
 * @subpackage Structs
 */
class UpdatePhoneButtonTemplateReq extends NameAndGUIDRequest
{
    /**
     * The newName
     * Meta information extracted from the WSDL
     * - documentation: The template's name
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $newName;
    /**
     * The buttons
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\Buttons
     */
    public $buttons;
    /**
     * Constructor method for UpdatePhoneButtonTemplateReq
     * @uses UpdatePhoneButtonTemplateReq::setNewName()
     * @uses UpdatePhoneButtonTemplateReq::setButtons()
     * @param string $newName
     * @param \Losc\CucmBundle\Model\Webservice\StructType\Buttons $buttons
     */
    public function __construct($newName = null, \Losc\CucmBundle\Model\Webservice\StructType\Buttons $buttons = null)
    {
        $this
            ->setNewName($newName)
            ->setButtons($buttons);
    }
    /**
     * Get newName value
     * @return string|null
     */
    public function getNewName()
    {
        return $this->newName;
    }
    /**
     * Set newName value
     * @param string $newName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdatePhoneButtonTemplateReq
     */
    public function setNewName($newName = null)
    {
        // validation for constraint: string
        if (!is_null($newName) && !is_string($newName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($newName, true), gettype($newName)), __LINE__);
        }
        $this->newName = $newName;
        return $this;
    }
    /**
     * Get buttons value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\Buttons|null
     */
    public function getButtons()
    {
        return $this->buttons;
    }
    /**
     * Set buttons value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\Buttons $buttons
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdatePhoneButtonTemplateReq
     */
    public function setButtons(\Losc\CucmBundle\Model\Webservice\StructType\Buttons $buttons = null)
    {
        $this->buttons = $buttons;
        return $this;
    }
}
