<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateResourcePriorityNamespaceReq StructType
 * @subpackage Structs
 */
class UpdateResourcePriorityNamespaceReq extends APIRequest
{
    /**
     * The namespace
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - choice: uuid | namespace
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxLength: 10
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $namespace;
    /**
     * The uuid
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - choice: uuid | namespace
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - pattern: \{........-....-....-....-............\}
     * @var string
     */
    public $uuid;
    /**
     * The newNamespace
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 10
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $newNamespace;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $description;
    /**
     * The isDefault
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxOccurs: 1
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $isDefault;
    /**
     * Constructor method for UpdateResourcePriorityNamespaceReq
     * @uses UpdateResourcePriorityNamespaceReq::setNamespace()
     * @uses UpdateResourcePriorityNamespaceReq::setUuid()
     * @uses UpdateResourcePriorityNamespaceReq::setNewNamespace()
     * @uses UpdateResourcePriorityNamespaceReq::setDescription()
     * @uses UpdateResourcePriorityNamespaceReq::setIsDefault()
     * @param string $namespace
     * @param string $uuid
     * @param string $newNamespace
     * @param string $description
     * @param string $isDefault
     */
    public function __construct($namespace = null, $uuid = null, $newNamespace = null, $description = null, $isDefault = null)
    {
        $this
            ->setNamespace($namespace)
            ->setUuid($uuid)
            ->setNewNamespace($newNamespace)
            ->setDescription($description)
            ->setIsDefault($isDefault);
    }
    /**
     * Get namespace value
     * @return string
     */
    public function getNamespace()
    {
        return isset($this->namespace) ? $this->namespace : null;
    }
    /**
     * This method is responsible for validating the value passed to the setNamespace method
     * This method is willingly generated in order to preserve the one-line inline validation within the setNamespace method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateNamespaceForChoiceConstraintsFromSetNamespace($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'uuid',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property namespace can\'t be set as the property %s is already set. Only one property must be set among these properties: namespace, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set namespace value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param string $namespace
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateResourcePriorityNamespaceReq
     */
    public function setNamespace($namespace = null)
    {
        // validation for constraint: string
        if (!is_null($namespace) && !is_string($namespace)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($namespace, true), gettype($namespace)), __LINE__);
        }
        // validation for constraint: choice(uuid, namespace)
        if ('' !== ($namespaceChoiceErrorMessage = self::validateNamespaceForChoiceConstraintsFromSetNamespace($namespace))) {
            throw new \InvalidArgumentException($namespaceChoiceErrorMessage, __LINE__);
        }
        // validation for constraint: maxLength(10)
        if (!is_null($namespace) && mb_strlen($namespace) > 10) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 10', mb_strlen($namespace)), __LINE__);
        }
        if (is_null($namespace) || (is_array($namespace) && empty($namespace))) {
            unset($this->namespace);
        } else {
            $this->namespace = $namespace;
        }
        return $this;
    }
    /**
     * Get uuid value
     * @return string|null
     */
    public function getUuid()
    {
        return isset($this->uuid) ? $this->uuid : null;
    }
    /**
     * This method is responsible for validating the value passed to the setUuid method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUuid method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateUuidForChoiceConstraintsFromSetUuid($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'namespace',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property uuid can\'t be set as the property %s is already set. Only one property must be set among these properties: uuid, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set uuid value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param string $uuid
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateResourcePriorityNamespaceReq
     */
    public function setUuid($uuid = null)
    {
        // validation for constraint: string
        if (!is_null($uuid) && !is_string($uuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uuid, true), gettype($uuid)), __LINE__);
        }
        // validation for constraint: choice(uuid, namespace)
        if ('' !== ($uuidChoiceErrorMessage = self::validateUuidForChoiceConstraintsFromSetUuid($uuid))) {
            throw new \InvalidArgumentException($uuidChoiceErrorMessage, __LINE__);
        }
        // validation for constraint: pattern(\{........-....-....-....-............\})
        if (!is_null($uuid) && !preg_match('/\\{........-....-....-....-............\\}/', $uuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression \{........-....-....-....-............\}', var_export($uuid, true)), __LINE__);
        }
        if (is_null($uuid) || (is_array($uuid) && empty($uuid))) {
            unset($this->uuid);
        } else {
            $this->uuid = $uuid;
        }
        return $this;
    }
    /**
     * Get newNamespace value
     * @return string|null
     */
    public function getNewNamespace()
    {
        return $this->newNamespace;
    }
    /**
     * Set newNamespace value
     * @param string $newNamespace
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateResourcePriorityNamespaceReq
     */
    public function setNewNamespace($newNamespace = null)
    {
        // validation for constraint: string
        if (!is_null($newNamespace) && !is_string($newNamespace)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($newNamespace, true), gettype($newNamespace)), __LINE__);
        }
        // validation for constraint: maxLength(10)
        if (!is_null($newNamespace) && mb_strlen($newNamespace) > 10) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 10', mb_strlen($newNamespace)), __LINE__);
        }
        $this->newNamespace = $newNamespace;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateResourcePriorityNamespaceReq
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get isDefault value
     * @return string|null
     */
    public function getIsDefault()
    {
        return $this->isDefault;
    }
    /**
     * Set isDefault value
     * @param string $isDefault
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateResourcePriorityNamespaceReq
     */
    public function setIsDefault($isDefault = null)
    {
        // validation for constraint: string
        if (!is_null($isDefault) && !is_string($isDefault)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($isDefault, true), gettype($isDefault)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($isDefault) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $isDefault)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($isDefault, true)), __LINE__);
        }
        $this->isDefault = $isDefault;
        return $this;
    }
}
