<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateSoftKeySetReq StructType
 * @subpackage Structs
 */
class UpdateSoftKeySetReq extends NameAndGUIDRequest
{
    /**
     * The removeCallStates
     * Meta information extracted from the WSDL
     * - choice: removeCallStates | addCallStates | callStates
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 0
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\RemoveCallStates
     */
    public $removeCallStates;
    /**
     * The addCallStates
     * Meta information extracted from the WSDL
     * - choice: removeCallStates | addCallStates | callStates
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 0
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\AddCallStates
     */
    public $addCallStates;
    /**
     * The callStates
     * Meta information extracted from the WSDL
     * - choice: removeCallStates | addCallStates | callStates
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 0
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\CallStates
     */
    public $callStates;
    /**
     * Constructor method for UpdateSoftKeySetReq
     * @uses UpdateSoftKeySetReq::setRemoveCallStates()
     * @uses UpdateSoftKeySetReq::setAddCallStates()
     * @uses UpdateSoftKeySetReq::setCallStates()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RemoveCallStates $removeCallStates
     * @param \Losc\CucmBundle\Model\Webservice\StructType\AddCallStates $addCallStates
     * @param \Losc\CucmBundle\Model\Webservice\StructType\CallStates $callStates
     */
    public function __construct(\Losc\CucmBundle\Model\Webservice\StructType\RemoveCallStates $removeCallStates = null, \Losc\CucmBundle\Model\Webservice\StructType\AddCallStates $addCallStates = null, \Losc\CucmBundle\Model\Webservice\StructType\CallStates $callStates = null)
    {
        $this
            ->setRemoveCallStates($removeCallStates)
            ->setAddCallStates($addCallStates)
            ->setCallStates($callStates);
    }
    /**
     * Get removeCallStates value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\RemoveCallStates|null
     */
    public function getRemoveCallStates()
    {
        return isset($this->removeCallStates) ? $this->removeCallStates : null;
    }
    /**
     * This method is responsible for validating the value passed to the setRemoveCallStates method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRemoveCallStates method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateRemoveCallStatesForChoiceConstraintsFromSetRemoveCallStates($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'addCallStates',
            'callStates',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property removeCallStates can\'t be set as the property %s is already set. Only one property must be set among these properties: removeCallStates, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set removeCallStates value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\RemoveCallStates $removeCallStates
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateSoftKeySetReq
     */
    public function setRemoveCallStates(\Losc\CucmBundle\Model\Webservice\StructType\RemoveCallStates $removeCallStates = null)
    {
        // validation for constraint: choice(removeCallStates, addCallStates, callStates)
        if ('' !== ($removeCallStatesChoiceErrorMessage = self::validateRemoveCallStatesForChoiceConstraintsFromSetRemoveCallStates($removeCallStates))) {
            throw new \InvalidArgumentException($removeCallStatesChoiceErrorMessage, __LINE__);
        }
        if (is_null($removeCallStates) || (is_array($removeCallStates) && empty($removeCallStates))) {
            unset($this->removeCallStates);
        } else {
            $this->removeCallStates = $removeCallStates;
        }
        return $this;
    }
    /**
     * Get addCallStates value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\AddCallStates|null
     */
    public function getAddCallStates()
    {
        return isset($this->addCallStates) ? $this->addCallStates : null;
    }
    /**
     * This method is responsible for validating the value passed to the setAddCallStates method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAddCallStates method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateAddCallStatesForChoiceConstraintsFromSetAddCallStates($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'removeCallStates',
            'callStates',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property addCallStates can\'t be set as the property %s is already set. Only one property must be set among these properties: addCallStates, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set addCallStates value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\AddCallStates $addCallStates
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateSoftKeySetReq
     */
    public function setAddCallStates(\Losc\CucmBundle\Model\Webservice\StructType\AddCallStates $addCallStates = null)
    {
        // validation for constraint: choice(removeCallStates, addCallStates, callStates)
        if ('' !== ($addCallStatesChoiceErrorMessage = self::validateAddCallStatesForChoiceConstraintsFromSetAddCallStates($addCallStates))) {
            throw new \InvalidArgumentException($addCallStatesChoiceErrorMessage, __LINE__);
        }
        if (is_null($addCallStates) || (is_array($addCallStates) && empty($addCallStates))) {
            unset($this->addCallStates);
        } else {
            $this->addCallStates = $addCallStates;
        }
        return $this;
    }
    /**
     * Get callStates value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\CallStates|null
     */
    public function getCallStates()
    {
        return isset($this->callStates) ? $this->callStates : null;
    }
    /**
     * This method is responsible for validating the value passed to the setCallStates method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCallStates method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateCallStatesForChoiceConstraintsFromSetCallStates($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'removeCallStates',
            'addCallStates',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property callStates can\'t be set as the property %s is already set. Only one property must be set among these properties: callStates, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set callStates value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\CallStates $callStates
     * @return \Losc\CucmBundle\Model\Webservice\StructType\UpdateSoftKeySetReq
     */
    public function setCallStates(\Losc\CucmBundle\Model\Webservice\StructType\CallStates $callStates = null)
    {
        // validation for constraint: choice(removeCallStates, addCallStates, callStates)
        if ('' !== ($callStatesChoiceErrorMessage = self::validateCallStatesForChoiceConstraintsFromSetCallStates($callStates))) {
            throw new \InvalidArgumentException($callStatesChoiceErrorMessage, __LINE__);
        }
        if (is_null($callStates) || (is_array($callStates) && empty($callStates))) {
            unset($this->callStates);
        } else {
            $this->callStates = $callStates;
        }
        return $this;
    }
}
