<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for vpnGateways StructType
 * @subpackage Structs
 */
class VpnGateways extends AbstractStructBase
{
    /**
     * The vpnGateway
     * Meta information extracted from the WSDL
     * - maxOccurs: 3
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XVpnGroupMember[]
     */
    public $vpnGateway;
    /**
     * Constructor method for vpnGateways
     * @uses VpnGateways::setVpnGateway()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XVpnGroupMember[] $vpnGateway
     */
    public function __construct(array $vpnGateway = array())
    {
        $this
            ->setVpnGateway($vpnGateway);
    }
    /**
     * Get vpnGateway value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XVpnGroupMember[]|null
     */
    public function getVpnGateway()
    {
        return $this->vpnGateway;
    }
    /**
     * This method is responsible for validating the values passed to the setVpnGateway method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVpnGateway method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVpnGatewayForArrayConstraintsFromSetVpnGateway(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $vpnGatewaysVpnGatewayItem) {
            // validation for constraint: itemType
            if (!$vpnGatewaysVpnGatewayItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\XVpnGroupMember) {
                $invalidValues[] = is_object($vpnGatewaysVpnGatewayItem) ? get_class($vpnGatewaysVpnGatewayItem) : sprintf('%s(%s)', gettype($vpnGatewaysVpnGatewayItem), var_export($vpnGatewaysVpnGatewayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The vpnGateway property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XVpnGroupMember, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set vpnGateway value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XVpnGroupMember[] $vpnGateway
     * @return \Losc\CucmBundle\Model\Webservice\StructType\VpnGateways
     */
    public function setVpnGateway(array $vpnGateway = array())
    {
        // validation for constraint: array
        if ('' !== ($vpnGatewayArrayErrorMessage = self::validateVpnGatewayForArrayConstraintsFromSetVpnGateway($vpnGateway))) {
            throw new \InvalidArgumentException($vpnGatewayArrayErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(3)
        if (is_array($vpnGateway) && count($vpnGateway) > 3) {
            throw new \InvalidArgumentException(sprintf('Invalid count of %s, the number of elements contained by the property must be less than or equal to 3', count($vpnGateway)), __LINE__);
        }
        $this->vpnGateway = $vpnGateway;
        return $this;
    }
    /**
     * Add item to vpnGateway value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XVpnGroupMember $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\VpnGateways
     */
    public function addToVpnGateway(\Losc\CucmBundle\Model\Webservice\StructType\XVpnGroupMember $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\XVpnGroupMember) {
            throw new \InvalidArgumentException(sprintf('The vpnGateway property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\XVpnGroupMember, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: maxOccurs(3)
        if (is_array($this->vpnGateway) && count($this->vpnGateway) >= 3) {
            throw new \InvalidArgumentException(sprintf('You can\'t add anymore element to this property that already contains %s elements, the number of elements contained by the property must be less than or equal to 3', count($this->vpnGateway)), __LINE__);
        }
        $this->vpnGateway[] = $item;
        return $this;
    }
}
