<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XAarGroupRelationship StructType
 * @subpackage Structs
 */
class XAarGroupRelationship extends AbstractStructBase
{
    /**
     * The aarGroupFromName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $aarGroupFromName;
    /**
     * The aarGroupToName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $aarGroupToName;
    /**
     * The prefixDigit
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 32
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $prefixDigit;
    /**
     * Constructor method for XAarGroupRelationship
     * @uses XAarGroupRelationship::setAarGroupFromName()
     * @uses XAarGroupRelationship::setAarGroupToName()
     * @uses XAarGroupRelationship::setPrefixDigit()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $aarGroupFromName
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $aarGroupToName
     * @param string $prefixDigit
     */
    public function __construct(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $aarGroupFromName = null, \Losc\CucmBundle\Model\Webservice\StructType\XFkType $aarGroupToName = null, $prefixDigit = null)
    {
        $this
            ->setAarGroupFromName($aarGroupFromName)
            ->setAarGroupToName($aarGroupToName)
            ->setPrefixDigit($prefixDigit);
    }
    /**
     * Get aarGroupFromName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public function getAarGroupFromName()
    {
        return $this->aarGroupFromName;
    }
    /**
     * Set aarGroupFromName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $aarGroupFromName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XAarGroupRelationship
     */
    public function setAarGroupFromName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $aarGroupFromName = null)
    {
        $this->aarGroupFromName = $aarGroupFromName;
        return $this;
    }
    /**
     * Get aarGroupToName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public function getAarGroupToName()
    {
        return $this->aarGroupToName;
    }
    /**
     * Set aarGroupToName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $aarGroupToName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XAarGroupRelationship
     */
    public function setAarGroupToName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $aarGroupToName = null)
    {
        $this->aarGroupToName = $aarGroupToName;
        return $this;
    }
    /**
     * Get prefixDigit value
     * @return string
     */
    public function getPrefixDigit()
    {
        return $this->prefixDigit;
    }
    /**
     * Set prefixDigit value
     * @param string $prefixDigit
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XAarGroupRelationship
     */
    public function setPrefixDigit($prefixDigit = null)
    {
        // validation for constraint: string
        if (!is_null($prefixDigit) && !is_string($prefixDigit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($prefixDigit, true), gettype($prefixDigit)), __LINE__);
        }
        // validation for constraint: maxLength(32)
        if (!is_null($prefixDigit) && mb_strlen($prefixDigit) > 32) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 32', mb_strlen($prefixDigit)), __LINE__);
        }
        $this->prefixDigit = $prefixDigit;
        return $this;
    }
}
