<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XAppServerInfo StructType
 * @subpackage Structs
 */
class XAppServerInfo extends AbstractStructBase
{
    /**
     * The appServerName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $appServerName;
    /**
     * The appServerContent
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $appServerContent;
    /**
     * The content
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XContent
     */
    public $content;
    /**
     * Constructor method for XAppServerInfo
     * @uses XAppServerInfo::setAppServerName()
     * @uses XAppServerInfo::setAppServerContent()
     * @uses XAppServerInfo::setContent()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $appServerName
     * @param string $appServerContent
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XContent $content
     */
    public function __construct(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $appServerName = null, $appServerContent = null, \Losc\CucmBundle\Model\Webservice\StructType\XContent $content = null)
    {
        $this
            ->setAppServerName($appServerName)
            ->setAppServerContent($appServerContent)
            ->setContent($content);
    }
    /**
     * Get appServerName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public function getAppServerName()
    {
        return $this->appServerName;
    }
    /**
     * Set appServerName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $appServerName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XAppServerInfo
     */
    public function setAppServerName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $appServerName = null)
    {
        $this->appServerName = $appServerName;
        return $this;
    }
    /**
     * Get appServerContent value
     * @return string
     */
    public function getAppServerContent()
    {
        return $this->appServerContent;
    }
    /**
     * Set appServerContent value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XAppServerContent::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XAppServerContent::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $appServerContent
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XAppServerInfo
     */
    public function setAppServerContent($appServerContent = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XAppServerContent::valueIsValid($appServerContent)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XAppServerContent', is_array($appServerContent) ? implode(', ', $appServerContent) : var_export($appServerContent, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XAppServerContent::getValidValues())), __LINE__);
        }
        $this->appServerContent = $appServerContent;
        return $this;
    }
    /**
     * Get content value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XContent|null
     */
    public function getContent()
    {
        return isset($this->content) ? $this->content : null;
    }
    /**
     * Set content value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XContent $content
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XAppServerInfo
     */
    public function setContent(\Losc\CucmBundle\Model\Webservice\StructType\XContent $content = null)
    {
        if (is_null($content) || (is_array($content) && empty($content))) {
            unset($this->content);
        } else {
            $this->content = $content;
        }
        return $this;
    }
}
