<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XApplicationToSoftKeyTemplate StructType
 * @subpackage Structs
 */
class XApplicationToSoftKeyTemplate extends AbstractStructBase
{
    /**
     * The softKeyTemplateName
     * Meta information extracted from the WSDL
     * - documentation: This template should not be a standard template
     * - minOccurs: 1
     * - nillable: false
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $softKeyTemplateName;
    /**
     * The standardSoftKeyTemplateName
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * - nillable: false
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $standardSoftKeyTemplateName;
    /**
     * The uuid
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - pattern: \{........-....-....-....-............\}
     * - use: optional
     * @var string
     */
    public $uuid;
    /**
     * Constructor method for XApplicationToSoftKeyTemplate
     * @uses XApplicationToSoftKeyTemplate::setSoftKeyTemplateName()
     * @uses XApplicationToSoftKeyTemplate::setStandardSoftKeyTemplateName()
     * @uses XApplicationToSoftKeyTemplate::setUuid()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $softKeyTemplateName
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $standardSoftKeyTemplateName
     * @param string $uuid
     */
    public function __construct(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $softKeyTemplateName = null, \Losc\CucmBundle\Model\Webservice\StructType\XFkType $standardSoftKeyTemplateName = null, $uuid = null)
    {
        $this
            ->setSoftKeyTemplateName($softKeyTemplateName)
            ->setStandardSoftKeyTemplateName($standardSoftKeyTemplateName)
            ->setUuid($uuid);
    }
    /**
     * Get softKeyTemplateName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public function getSoftKeyTemplateName()
    {
        return $this->softKeyTemplateName;
    }
    /**
     * Set softKeyTemplateName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $softKeyTemplateName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XApplicationToSoftKeyTemplate
     */
    public function setSoftKeyTemplateName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $softKeyTemplateName = null)
    {
        $this->softKeyTemplateName = $softKeyTemplateName;
        return $this;
    }
    /**
     * Get standardSoftKeyTemplateName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public function getStandardSoftKeyTemplateName()
    {
        return $this->standardSoftKeyTemplateName;
    }
    /**
     * Set standardSoftKeyTemplateName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $standardSoftKeyTemplateName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XApplicationToSoftKeyTemplate
     */
    public function setStandardSoftKeyTemplateName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $standardSoftKeyTemplateName = null)
    {
        $this->standardSoftKeyTemplateName = $standardSoftKeyTemplateName;
        return $this;
    }
    /**
     * Get uuid value
     * @return string|null
     */
    public function getUuid()
    {
        return $this->uuid;
    }
    /**
     * Set uuid value
     * @param string $uuid
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XApplicationToSoftKeyTemplate
     */
    public function setUuid($uuid = null)
    {
        // validation for constraint: string
        if (!is_null($uuid) && !is_string($uuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uuid, true), gettype($uuid)), __LINE__);
        }
        // validation for constraint: pattern(\{........-....-....-....-............\})
        if (!is_null($uuid) && !preg_match('/\\{........-....-....-....-............\\}/', $uuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression \{........-....-....-....-............\}', var_export($uuid, true)), __LINE__);
        }
        $this->uuid = $uuid;
        return $this;
    }
}
