<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XDialPlanTag StructType
 * @subpackage Structs
 */
class XDialPlanTag extends AbstractStructBase
{
    /**
     * The name
     * Meta information extracted from the WSDL
     * - documentation: Actually called "tag" in database.
     * - base: xsd:string
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $name;
    /**
     * The dialPlanName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $dialPlanName;
    /**
     * The operator
     * Meta information extracted from the WSDL
     * - default: ==
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $operator;
    /**
     * The suppressFromRouteFilter
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: false
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $suppressFromRouteFilter;
    /**
     * Constructor method for XDialPlanTag
     * @uses XDialPlanTag::setName()
     * @uses XDialPlanTag::setDialPlanName()
     * @uses XDialPlanTag::setOperator()
     * @uses XDialPlanTag::setSuppressFromRouteFilter()
     * @param string $name
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $dialPlanName
     * @param string $operator
     * @param string $suppressFromRouteFilter
     */
    public function __construct($name = null, \Losc\CucmBundle\Model\Webservice\StructType\XFkType $dialPlanName = null, $operator = '==', $suppressFromRouteFilter = 'false')
    {
        $this
            ->setName($name)
            ->setDialPlanName($dialPlanName)
            ->setOperator($operator)
            ->setSuppressFromRouteFilter($suppressFromRouteFilter);
    }
    /**
     * Get name value
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XDialPlanTag
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        // validation for constraint: maxLength(50)
        if (!is_null($name) && mb_strlen($name) > 50) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 50', mb_strlen($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get dialPlanName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public function getDialPlanName()
    {
        return $this->dialPlanName;
    }
    /**
     * Set dialPlanName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $dialPlanName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XDialPlanTag
     */
    public function setDialPlanName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $dialPlanName = null)
    {
        $this->dialPlanName = $dialPlanName;
        return $this;
    }
    /**
     * Get operator value
     * @return string
     */
    public function getOperator()
    {
        return $this->operator;
    }
    /**
     * Set operator value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XOperator::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XOperator::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $operator
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XDialPlanTag
     */
    public function setOperator($operator = '==')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XOperator::valueIsValid($operator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XOperator', is_array($operator) ? implode(', ', $operator) : var_export($operator, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XOperator::getValidValues())), __LINE__);
        }
        $this->operator = $operator;
        return $this;
    }
    /**
     * Get suppressFromRouteFilter value
     * @return string|null
     */
    public function getSuppressFromRouteFilter()
    {
        return $this->suppressFromRouteFilter;
    }
    /**
     * Set suppressFromRouteFilter value
     * @param string $suppressFromRouteFilter
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XDialPlanTag
     */
    public function setSuppressFromRouteFilter($suppressFromRouteFilter = 'false')
    {
        // validation for constraint: string
        if (!is_null($suppressFromRouteFilter) && !is_string($suppressFromRouteFilter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($suppressFromRouteFilter, true), gettype($suppressFromRouteFilter)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($suppressFromRouteFilter) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $suppressFromRouteFilter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($suppressFromRouteFilter, true)), __LINE__);
        }
        $this->suppressFromRouteFilter = $suppressFromRouteFilter;
        return $this;
    }
}
