<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XGatewayEndpointDigitalAccessBri StructType
 * @subpackage Structs
 */
class XGatewayEndpointDigitalAccessBri extends AbstractStructBase
{
    /**
     * The domainName
     * Meta information extracted from the WSDL
     * - choice: domainName | gatewayUuid
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $domainName;
    /**
     * The gatewayUuid
     * Meta information extracted from the WSDL
     * - documentation: pkid of the Gateway whose endpoint is to be added
     * - base: xsd:string
     * - choice: domainName | gatewayUuid
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxOccurs: 1
     * - minOccurs: 1
     * - pattern: \{........-....-....-....-............\}
     * @var string
     */
    public $gatewayUuid;
    /**
     * The unit
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $unit;
    /**
     * The subunit
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $subunit;
    /**
     * The endpoint
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XGatewayEndpointDigitalBri
     */
    public $endpoint;
    /**
     * Constructor method for XGatewayEndpointDigitalAccessBri
     * @uses XGatewayEndpointDigitalAccessBri::setDomainName()
     * @uses XGatewayEndpointDigitalAccessBri::setGatewayUuid()
     * @uses XGatewayEndpointDigitalAccessBri::setUnit()
     * @uses XGatewayEndpointDigitalAccessBri::setSubunit()
     * @uses XGatewayEndpointDigitalAccessBri::setEndpoint()
     * @param string $domainName
     * @param string $gatewayUuid
     * @param string $unit
     * @param string $subunit
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XGatewayEndpointDigitalBri $endpoint
     */
    public function __construct($domainName = null, $gatewayUuid = null, $unit = null, $subunit = null, \Losc\CucmBundle\Model\Webservice\StructType\XGatewayEndpointDigitalBri $endpoint = null)
    {
        $this
            ->setDomainName($domainName)
            ->setGatewayUuid($gatewayUuid)
            ->setUnit($unit)
            ->setSubunit($subunit)
            ->setEndpoint($endpoint);
    }
    /**
     * Get domainName value
     * @return string
     */
    public function getDomainName()
    {
        return isset($this->domainName) ? $this->domainName : null;
    }
    /**
     * This method is responsible for validating the value passed to the setDomainName method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDomainName method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateDomainNameForChoiceConstraintsFromSetDomainName($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'gatewayUuid',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property domainName can\'t be set as the property %s is already set. Only one property must be set among these properties: domainName, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set domainName value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param string $domainName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XGatewayEndpointDigitalAccessBri
     */
    public function setDomainName($domainName = null)
    {
        // validation for constraint: string
        if (!is_null($domainName) && !is_string($domainName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($domainName, true), gettype($domainName)), __LINE__);
        }
        // validation for constraint: choice(domainName, gatewayUuid)
        if ('' !== ($domainNameChoiceErrorMessage = self::validateDomainNameForChoiceConstraintsFromSetDomainName($domainName))) {
            throw new \InvalidArgumentException($domainNameChoiceErrorMessage, __LINE__);
        }
        if (is_null($domainName) || (is_array($domainName) && empty($domainName))) {
            unset($this->domainName);
        } else {
            $this->domainName = $domainName;
        }
        return $this;
    }
    /**
     * Get gatewayUuid value
     * @return string
     */
    public function getGatewayUuid()
    {
        return isset($this->gatewayUuid) ? $this->gatewayUuid : null;
    }
    /**
     * This method is responsible for validating the value passed to the setGatewayUuid method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGatewayUuid method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateGatewayUuidForChoiceConstraintsFromSetGatewayUuid($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'domainName',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property gatewayUuid can\'t be set as the property %s is already set. Only one property must be set among these properties: gatewayUuid, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set gatewayUuid value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param string $gatewayUuid
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XGatewayEndpointDigitalAccessBri
     */
    public function setGatewayUuid($gatewayUuid = null)
    {
        // validation for constraint: string
        if (!is_null($gatewayUuid) && !is_string($gatewayUuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($gatewayUuid, true), gettype($gatewayUuid)), __LINE__);
        }
        // validation for constraint: choice(domainName, gatewayUuid)
        if ('' !== ($gatewayUuidChoiceErrorMessage = self::validateGatewayUuidForChoiceConstraintsFromSetGatewayUuid($gatewayUuid))) {
            throw new \InvalidArgumentException($gatewayUuidChoiceErrorMessage, __LINE__);
        }
        // validation for constraint: pattern(\{........-....-....-....-............\})
        if (!is_null($gatewayUuid) && !preg_match('/\\{........-....-....-....-............\\}/', $gatewayUuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression \{........-....-....-....-............\}', var_export($gatewayUuid, true)), __LINE__);
        }
        if (is_null($gatewayUuid) || (is_array($gatewayUuid) && empty($gatewayUuid))) {
            unset($this->gatewayUuid);
        } else {
            $this->gatewayUuid = $gatewayUuid;
        }
        return $this;
    }
    /**
     * Get unit value
     * @return string
     */
    public function getUnit()
    {
        return $this->unit;
    }
    /**
     * Set unit value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $unit
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XGatewayEndpointDigitalAccessBri
     */
    public function setUnit($unit = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($unit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($unit) ? implode(', ', $unit) : var_export($unit, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->unit = $unit;
        return $this;
    }
    /**
     * Get subunit value
     * @return string
     */
    public function getSubunit()
    {
        return $this->subunit;
    }
    /**
     * Set subunit value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $subunit
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XGatewayEndpointDigitalAccessBri
     */
    public function setSubunit($subunit = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($subunit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($subunit) ? implode(', ', $subunit) : var_export($subunit, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->subunit = $subunit;
        return $this;
    }
    /**
     * Get endpoint value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XGatewayEndpointDigitalBri
     */
    public function getEndpoint()
    {
        return $this->endpoint;
    }
    /**
     * Set endpoint value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XGatewayEndpointDigitalBri $endpoint
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XGatewayEndpointDigitalAccessBri
     */
    public function setEndpoint(\Losc\CucmBundle\Model\Webservice\StructType\XGatewayEndpointDigitalBri $endpoint = null)
    {
        $this->endpoint = $endpoint;
        return $this;
    }
}
