<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XLbmHubGroup StructType
 * @subpackage Structs
 */
class XLbmHubGroup extends AbstractStructBase
{
    /**
     * The name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $name;
    /**
     * The member1
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $member1;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $description;
    /**
     * The member2
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $member2;
    /**
     * The member3
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $member3;
    /**
     * The members
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\Members
     */
    public $members;
    /**
     * Constructor method for XLbmHubGroup
     * @uses XLbmHubGroup::setName()
     * @uses XLbmHubGroup::setMember1()
     * @uses XLbmHubGroup::setDescription()
     * @uses XLbmHubGroup::setMember2()
     * @uses XLbmHubGroup::setMember3()
     * @uses XLbmHubGroup::setMembers()
     * @param string $name
     * @param string $member1
     * @param string $description
     * @param string $member2
     * @param string $member3
     * @param \Losc\CucmBundle\Model\Webservice\StructType\Members $members
     */
    public function __construct($name = null, $member1 = null, $description = null, $member2 = null, $member3 = null, \Losc\CucmBundle\Model\Webservice\StructType\Members $members = null)
    {
        $this
            ->setName($name)
            ->setMember1($member1)
            ->setDescription($description)
            ->setMember2($member2)
            ->setMember3($member3)
            ->setMembers($members);
    }
    /**
     * Get name value
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XLbmHubGroup
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get member1 value
     * @return string
     */
    public function getMember1()
    {
        return $this->member1;
    }
    /**
     * Set member1 value
     * @param string $member1
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XLbmHubGroup
     */
    public function setMember1($member1 = null)
    {
        // validation for constraint: string
        if (!is_null($member1) && !is_string($member1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($member1, true), gettype($member1)), __LINE__);
        }
        $this->member1 = $member1;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XLbmHubGroup
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get member2 value
     * @return string|null
     */
    public function getMember2()
    {
        return $this->member2;
    }
    /**
     * Set member2 value
     * @param string $member2
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XLbmHubGroup
     */
    public function setMember2($member2 = null)
    {
        // validation for constraint: string
        if (!is_null($member2) && !is_string($member2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($member2, true), gettype($member2)), __LINE__);
        }
        $this->member2 = $member2;
        return $this;
    }
    /**
     * Get member3 value
     * @return string|null
     */
    public function getMember3()
    {
        return $this->member3;
    }
    /**
     * Set member3 value
     * @param string $member3
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XLbmHubGroup
     */
    public function setMember3($member3 = null)
    {
        // validation for constraint: string
        if (!is_null($member3) && !is_string($member3)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($member3, true), gettype($member3)), __LINE__);
        }
        $this->member3 = $member3;
        return $this;
    }
    /**
     * Get members value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\Members|null
     */
    public function getMembers()
    {
        return $this->members;
    }
    /**
     * Set members value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\Members $members
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XLbmHubGroup
     */
    public function setMembers(\Losc\CucmBundle\Model\Webservice\StructType\Members $members = null)
    {
        $this->members = $members;
        return $this;
    }
}
