<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XLineGroupMember StructType
 * @subpackage Structs
 */
class XLineGroupMember extends AbstractStructBase
{
    /**
     * The lineSelectionOrder
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $lineSelectionOrder;
    /**
     * The directoryNumber
     * Meta information extracted from the WSDL
     * - documentation: The uuid attribute is read here
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XDirn
     */
    public $directoryNumber;
    /**
     * Constructor method for XLineGroupMember
     * @uses XLineGroupMember::setLineSelectionOrder()
     * @uses XLineGroupMember::setDirectoryNumber()
     * @param string $lineSelectionOrder
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XDirn $directoryNumber
     */
    public function __construct($lineSelectionOrder = null, \Losc\CucmBundle\Model\Webservice\StructType\XDirn $directoryNumber = null)
    {
        $this
            ->setLineSelectionOrder($lineSelectionOrder)
            ->setDirectoryNumber($directoryNumber);
    }
    /**
     * Get lineSelectionOrder value
     * @return string
     */
    public function getLineSelectionOrder()
    {
        return $this->lineSelectionOrder;
    }
    /**
     * Set lineSelectionOrder value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $lineSelectionOrder
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XLineGroupMember
     */
    public function setLineSelectionOrder($lineSelectionOrder = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($lineSelectionOrder)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($lineSelectionOrder) ? implode(', ', $lineSelectionOrder) : var_export($lineSelectionOrder, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->lineSelectionOrder = $lineSelectionOrder;
        return $this;
    }
    /**
     * Get directoryNumber value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XDirn
     */
    public function getDirectoryNumber()
    {
        return $this->directoryNumber;
    }
    /**
     * Set directoryNumber value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XDirn $directoryNumber
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XLineGroupMember
     */
    public function setDirectoryNumber(\Losc\CucmBundle\Model\Webservice\StructType\XDirn $directoryNumber = null)
    {
        $this->directoryNumber = $directoryNumber;
        return $this;
    }
}
