<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XMobileSmartClientProfile StructType
 * @subpackage Structs
 */
class XMobileSmartClientProfile extends AbstractStructBase
{
    /**
     * The name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $name;
    /**
     * The mobileSmartClient
     * Meta information extracted from the WSDL
     * - default: CUMC
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $mobileSmartClient;
    /**
     * The enableSnrUri
     * Meta information extracted from the WSDL
     * - default: x-cisco-serviceuri-mobileconnect
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $enableSnrUri;
    /**
     * The enableCFAUri
     * Meta information extracted from the WSDL
     * - default: x-cisco-serviceuri-cfwdall
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $enableCFAUri;
    /**
     * The handOffUri
     * Meta information extracted from the WSDL
     * - default: x-cisco-serviceuri-handoff
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $handOffUri;
    /**
     * Constructor method for XMobileSmartClientProfile
     * @uses XMobileSmartClientProfile::setName()
     * @uses XMobileSmartClientProfile::setMobileSmartClient()
     * @uses XMobileSmartClientProfile::setEnableSnrUri()
     * @uses XMobileSmartClientProfile::setEnableCFAUri()
     * @uses XMobileSmartClientProfile::setHandOffUri()
     * @param string $name
     * @param string $mobileSmartClient
     * @param string $enableSnrUri
     * @param string $enableCFAUri
     * @param string $handOffUri
     */
    public function __construct($name = null, $mobileSmartClient = 'CUMC', $enableSnrUri = 'x-cisco-serviceuri-mobileconnect', $enableCFAUri = 'x-cisco-serviceuri-cfwdall', $handOffUri = 'x-cisco-serviceuri-handoff')
    {
        $this
            ->setName($name)
            ->setMobileSmartClient($mobileSmartClient)
            ->setEnableSnrUri($enableSnrUri)
            ->setEnableCFAUri($enableCFAUri)
            ->setHandOffUri($handOffUri);
    }
    /**
     * Get name value
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XMobileSmartClientProfile
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get mobileSmartClient value
     * @return string
     */
    public function getMobileSmartClient()
    {
        return $this->mobileSmartClient;
    }
    /**
     * Set mobileSmartClient value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XMobileSmartClient::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XMobileSmartClient::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $mobileSmartClient
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XMobileSmartClientProfile
     */
    public function setMobileSmartClient($mobileSmartClient = 'CUMC')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XMobileSmartClient::valueIsValid($mobileSmartClient)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XMobileSmartClient', is_array($mobileSmartClient) ? implode(', ', $mobileSmartClient) : var_export($mobileSmartClient, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XMobileSmartClient::getValidValues())), __LINE__);
        }
        $this->mobileSmartClient = $mobileSmartClient;
        return $this;
    }
    /**
     * Get enableSnrUri value
     * @return string
     */
    public function getEnableSnrUri()
    {
        return $this->enableSnrUri;
    }
    /**
     * Set enableSnrUri value
     * @param string $enableSnrUri
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XMobileSmartClientProfile
     */
    public function setEnableSnrUri($enableSnrUri = 'x-cisco-serviceuri-mobileconnect')
    {
        // validation for constraint: string
        if (!is_null($enableSnrUri) && !is_string($enableSnrUri)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($enableSnrUri, true), gettype($enableSnrUri)), __LINE__);
        }
        $this->enableSnrUri = $enableSnrUri;
        return $this;
    }
    /**
     * Get enableCFAUri value
     * @return string
     */
    public function getEnableCFAUri()
    {
        return $this->enableCFAUri;
    }
    /**
     * Set enableCFAUri value
     * @param string $enableCFAUri
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XMobileSmartClientProfile
     */
    public function setEnableCFAUri($enableCFAUri = 'x-cisco-serviceuri-cfwdall')
    {
        // validation for constraint: string
        if (!is_null($enableCFAUri) && !is_string($enableCFAUri)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($enableCFAUri, true), gettype($enableCFAUri)), __LINE__);
        }
        $this->enableCFAUri = $enableCFAUri;
        return $this;
    }
    /**
     * Get handOffUri value
     * @return string
     */
    public function getHandOffUri()
    {
        return $this->handOffUri;
    }
    /**
     * Set handOffUri value
     * @param string $handOffUri
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XMobileSmartClientProfile
     */
    public function setHandOffUri($handOffUri = 'x-cisco-serviceuri-handoff')
    {
        // validation for constraint: string
        if (!is_null($handOffUri) && !is_string($handOffUri)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($handOffUri, true), gettype($handOffUri)), __LINE__);
        }
        $this->handOffUri = $handOffUri;
        return $this;
    }
}
