<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XPhoneButtonTemplate StructType
 * @subpackage Structs
 */
class XPhoneButtonTemplate extends AbstractStructBase
{
    /**
     * The name
     * Meta information extracted from the WSDL
     * - documentation: The template's name
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $name;
    /**
     * The basePhoneTemplateName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $basePhoneTemplateName;
    /**
     * The buttons
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Losc\CucmBundle\Model\Webservice\StructType\Buttons
     */
    public $buttons;
    /**
     * Constructor method for XPhoneButtonTemplate
     * @uses XPhoneButtonTemplate::setName()
     * @uses XPhoneButtonTemplate::setBasePhoneTemplateName()
     * @uses XPhoneButtonTemplate::setButtons()
     * @param string $name
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $basePhoneTemplateName
     * @param \Losc\CucmBundle\Model\Webservice\StructType\Buttons $buttons
     */
    public function __construct($name = null, \Losc\CucmBundle\Model\Webservice\StructType\XFkType $basePhoneTemplateName = null, \Losc\CucmBundle\Model\Webservice\StructType\Buttons $buttons = null)
    {
        $this
            ->setName($name)
            ->setBasePhoneTemplateName($basePhoneTemplateName)
            ->setButtons($buttons);
    }
    /**
     * Get name value
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XPhoneButtonTemplate
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get basePhoneTemplateName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public function getBasePhoneTemplateName()
    {
        return $this->basePhoneTemplateName;
    }
    /**
     * Set basePhoneTemplateName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $basePhoneTemplateName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XPhoneButtonTemplate
     */
    public function setBasePhoneTemplateName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $basePhoneTemplateName = null)
    {
        $this->basePhoneTemplateName = $basePhoneTemplateName;
        return $this;
    }
    /**
     * Get buttons value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\Buttons|null
     */
    public function getButtons()
    {
        return $this->buttons;
    }
    /**
     * Set buttons value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\Buttons $buttons
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XPhoneButtonTemplate
     */
    public function setButtons(\Losc\CucmBundle\Model\Webservice\StructType\Buttons $buttons = null)
    {
        $this->buttons = $buttons;
        return $this;
    }
}
