<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XPhoneNtp StructType
 * @subpackage Structs
 */
class XPhoneNtp extends AbstractStructBase
{
    /**
     * The ipAddress
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $ipAddress;
    /**
     * The mode
     * Meta information extracted from the WSDL
     * - default: Directed Broadcast
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $mode;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $description;
    /**
     * Constructor method for XPhoneNtp
     * @uses XPhoneNtp::setIpAddress()
     * @uses XPhoneNtp::setMode()
     * @uses XPhoneNtp::setDescription()
     * @param string $ipAddress
     * @param string $mode
     * @param string $description
     */
    public function __construct($ipAddress = null, $mode = 'Directed Broadcast', $description = null)
    {
        $this
            ->setIpAddress($ipAddress)
            ->setMode($mode)
            ->setDescription($description);
    }
    /**
     * Get ipAddress value
     * @return string
     */
    public function getIpAddress()
    {
        return $this->ipAddress;
    }
    /**
     * Set ipAddress value
     * @param string $ipAddress
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XPhoneNtp
     */
    public function setIpAddress($ipAddress = null)
    {
        // validation for constraint: string
        if (!is_null($ipAddress) && !is_string($ipAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ipAddress, true), gettype($ipAddress)), __LINE__);
        }
        $this->ipAddress = $ipAddress;
        return $this;
    }
    /**
     * Get mode value
     * @return string
     */
    public function getMode()
    {
        return $this->mode;
    }
    /**
     * Set mode value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XZzntpmode::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XZzntpmode::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $mode
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XPhoneNtp
     */
    public function setMode($mode = 'Directed Broadcast')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XZzntpmode::valueIsValid($mode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XZzntpmode', is_array($mode) ? implode(', ', $mode) : var_export($mode, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XZzntpmode::getValidValues())), __LINE__);
        }
        $this->mode = $mode;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XPhoneNtp
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
}
