<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XPolicyRelationship StructType
 * @subpackage Structs
 */
class XPolicyRelationship extends AbstractStructBase
{
    /**
     * The geoLocationPolicyAName
     * Meta information extracted from the WSDL
     * - documentation: This is a read only tag. The value will be the currently added GeoLocationPolicy pkid.
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $geoLocationPolicyAName;
    /**
     * The geoLocationDeviceA
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $geoLocationDeviceA;
    /**
     * The geoLocationPolicyBName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $geoLocationPolicyBName;
    /**
     * The geoLocationDeviceB
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $geoLocationDeviceB;
    /**
     * The logicalPartitionPolicy
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $logicalPartitionPolicy;
    /**
     * Constructor method for XPolicyRelationship
     * @uses XPolicyRelationship::setGeoLocationPolicyAName()
     * @uses XPolicyRelationship::setGeoLocationDeviceA()
     * @uses XPolicyRelationship::setGeoLocationPolicyBName()
     * @uses XPolicyRelationship::setGeoLocationDeviceB()
     * @uses XPolicyRelationship::setLogicalPartitionPolicy()
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $geoLocationPolicyAName
     * @param string $geoLocationDeviceA
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $geoLocationPolicyBName
     * @param string $geoLocationDeviceB
     * @param string $logicalPartitionPolicy
     */
    public function __construct(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $geoLocationPolicyAName = null, $geoLocationDeviceA = null, \Losc\CucmBundle\Model\Webservice\StructType\XFkType $geoLocationPolicyBName = null, $geoLocationDeviceB = null, $logicalPartitionPolicy = null)
    {
        $this
            ->setGeoLocationPolicyAName($geoLocationPolicyAName)
            ->setGeoLocationDeviceA($geoLocationDeviceA)
            ->setGeoLocationPolicyBName($geoLocationPolicyBName)
            ->setGeoLocationDeviceB($geoLocationDeviceB)
            ->setLogicalPartitionPolicy($logicalPartitionPolicy);
    }
    /**
     * Get geoLocationPolicyAName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public function getGeoLocationPolicyAName()
    {
        return $this->geoLocationPolicyAName;
    }
    /**
     * Set geoLocationPolicyAName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $geoLocationPolicyAName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XPolicyRelationship
     */
    public function setGeoLocationPolicyAName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $geoLocationPolicyAName = null)
    {
        $this->geoLocationPolicyAName = $geoLocationPolicyAName;
        return $this;
    }
    /**
     * Get geoLocationDeviceA value
     * @return string
     */
    public function getGeoLocationDeviceA()
    {
        return $this->geoLocationDeviceA;
    }
    /**
     * Set geoLocationDeviceA value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XGeoLocationDevice::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XGeoLocationDevice::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $geoLocationDeviceA
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XPolicyRelationship
     */
    public function setGeoLocationDeviceA($geoLocationDeviceA = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XGeoLocationDevice::valueIsValid($geoLocationDeviceA)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XGeoLocationDevice', is_array($geoLocationDeviceA) ? implode(', ', $geoLocationDeviceA) : var_export($geoLocationDeviceA, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XGeoLocationDevice::getValidValues())), __LINE__);
        }
        $this->geoLocationDeviceA = $geoLocationDeviceA;
        return $this;
    }
    /**
     * Get geoLocationPolicyBName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public function getGeoLocationPolicyBName()
    {
        return $this->geoLocationPolicyBName;
    }
    /**
     * Set geoLocationPolicyBName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $geoLocationPolicyBName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XPolicyRelationship
     */
    public function setGeoLocationPolicyBName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $geoLocationPolicyBName = null)
    {
        $this->geoLocationPolicyBName = $geoLocationPolicyBName;
        return $this;
    }
    /**
     * Get geoLocationDeviceB value
     * @return string
     */
    public function getGeoLocationDeviceB()
    {
        return $this->geoLocationDeviceB;
    }
    /**
     * Set geoLocationDeviceB value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XGeoLocationDevice::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XGeoLocationDevice::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $geoLocationDeviceB
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XPolicyRelationship
     */
    public function setGeoLocationDeviceB($geoLocationDeviceB = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XGeoLocationDevice::valueIsValid($geoLocationDeviceB)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XGeoLocationDevice', is_array($geoLocationDeviceB) ? implode(', ', $geoLocationDeviceB) : var_export($geoLocationDeviceB, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XGeoLocationDevice::getValidValues())), __LINE__);
        }
        $this->geoLocationDeviceB = $geoLocationDeviceB;
        return $this;
    }
    /**
     * Get logicalPartitionPolicy value
     * @return string
     */
    public function getLogicalPartitionPolicy()
    {
        return $this->logicalPartitionPolicy;
    }
    /**
     * Set logicalPartitionPolicy value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XLogicalPartitionPolicy::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XLogicalPartitionPolicy::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $logicalPartitionPolicy
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XPolicyRelationship
     */
    public function setLogicalPartitionPolicy($logicalPartitionPolicy = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XLogicalPartitionPolicy::valueIsValid($logicalPartitionPolicy)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XLogicalPartitionPolicy', is_array($logicalPartitionPolicy) ? implode(', ', $logicalPartitionPolicy) : var_export($logicalPartitionPolicy, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XLogicalPartitionPolicy::getValidValues())), __LINE__);
        }
        $this->logicalPartitionPolicy = $logicalPartitionPolicy;
        return $this;
    }
}
