<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XRemoteClusterMember StructType
 * @subpackage Structs
 */
class XRemoteClusterMember extends AbstractStructBase
{
    /**
     * The enabled
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: true
     * - maxOccurs: 1
     * - minOccurs: 1
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $enabled;
    /**
     * Constructor method for XRemoteClusterMember
     * @uses XRemoteClusterMember::setEnabled()
     * @param string $enabled
     */
    public function __construct($enabled = 'true')
    {
        $this
            ->setEnabled($enabled);
    }
    /**
     * Get enabled value
     * @return string
     */
    public function getEnabled()
    {
        return $this->enabled;
    }
    /**
     * Set enabled value
     * @param string $enabled
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XRemoteClusterMember
     */
    public function setEnabled($enabled = 'true')
    {
        // validation for constraint: string
        if (!is_null($enabled) && !is_string($enabled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($enabled, true), gettype($enabled)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($enabled) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $enabled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($enabled, true)), __LINE__);
        }
        $this->enabled = $enabled;
        return $this;
    }
}
