<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XRouteGroupMember StructType
 * @subpackage Structs
 */
class XRouteGroupMember extends AbstractStructBase
{
    /**
     * The deviceSelectionOrder
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $deviceSelectionOrder;
    /**
     * The deviceName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $deviceName;
    /**
     * The port
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $port;
    /**
     * Constructor method for XRouteGroupMember
     * @uses XRouteGroupMember::setDeviceSelectionOrder()
     * @uses XRouteGroupMember::setDeviceName()
     * @uses XRouteGroupMember::setPort()
     * @param string $deviceSelectionOrder
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $deviceName
     * @param string $port
     */
    public function __construct($deviceSelectionOrder = null, \Losc\CucmBundle\Model\Webservice\StructType\XFkType $deviceName = null, $port = null)
    {
        $this
            ->setDeviceSelectionOrder($deviceSelectionOrder)
            ->setDeviceName($deviceName)
            ->setPort($port);
    }
    /**
     * Get deviceSelectionOrder value
     * @return string
     */
    public function getDeviceSelectionOrder()
    {
        return $this->deviceSelectionOrder;
    }
    /**
     * Set deviceSelectionOrder value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $deviceSelectionOrder
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XRouteGroupMember
     */
    public function setDeviceSelectionOrder($deviceSelectionOrder = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($deviceSelectionOrder)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($deviceSelectionOrder) ? implode(', ', $deviceSelectionOrder) : var_export($deviceSelectionOrder, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->deviceSelectionOrder = $deviceSelectionOrder;
        return $this;
    }
    /**
     * Get deviceName value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public function getDeviceName()
    {
        return $this->deviceName;
    }
    /**
     * Set deviceName value
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $deviceName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XRouteGroupMember
     */
    public function setDeviceName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $deviceName = null)
    {
        $this->deviceName = $deviceName;
        return $this;
    }
    /**
     * Get port value
     * @return string
     */
    public function getPort()
    {
        return $this->port;
    }
    /**
     * Set port value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $port
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XRouteGroupMember
     */
    public function setPort($port = null)
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($port)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($port) ? implode(', ', $port) : var_export($port, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->port = $port;
        return $this;
    }
}
