<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XSdpTransparencyProfile StructType
 * @subpackage Structs
 */
class XSdpTransparencyProfile extends AbstractStructBase
{
    /**
     * The name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $name;
    /**
     * The attributeSet
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \Losc\CucmBundle\Model\Webservice\StructType\AttributeSet[]
     */
    public $attributeSet;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $description;
    /**
     * Constructor method for XSdpTransparencyProfile
     * @uses XSdpTransparencyProfile::setName()
     * @uses XSdpTransparencyProfile::setAttributeSet()
     * @uses XSdpTransparencyProfile::setDescription()
     * @param string $name
     * @param \Losc\CucmBundle\Model\Webservice\StructType\AttributeSet[] $attributeSet
     * @param string $description
     */
    public function __construct($name = null, array $attributeSet = array(), $description = null)
    {
        $this
            ->setName($name)
            ->setAttributeSet($attributeSet)
            ->setDescription($description);
    }
    /**
     * Get name value
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSdpTransparencyProfile
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get attributeSet value
     * @return \Losc\CucmBundle\Model\Webservice\StructType\AttributeSet[]
     */
    public function getAttributeSet()
    {
        return $this->attributeSet;
    }
    /**
     * This method is responsible for validating the values passed to the setAttributeSet method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAttributeSet method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAttributeSetForArrayConstraintsFromSetAttributeSet(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $xSdpTransparencyProfileAttributeSetItem) {
            // validation for constraint: itemType
            if (!$xSdpTransparencyProfileAttributeSetItem instanceof \Losc\CucmBundle\Model\Webservice\StructType\AttributeSet) {
                $invalidValues[] = is_object($xSdpTransparencyProfileAttributeSetItem) ? get_class($xSdpTransparencyProfileAttributeSetItem) : sprintf('%s(%s)', gettype($xSdpTransparencyProfileAttributeSetItem), var_export($xSdpTransparencyProfileAttributeSetItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The attributeSet property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\AttributeSet, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set attributeSet value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\AttributeSet[] $attributeSet
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSdpTransparencyProfile
     */
    public function setAttributeSet(array $attributeSet = array())
    {
        // validation for constraint: array
        if ('' !== ($attributeSetArrayErrorMessage = self::validateAttributeSetForArrayConstraintsFromSetAttributeSet($attributeSet))) {
            throw new \InvalidArgumentException($attributeSetArrayErrorMessage, __LINE__);
        }
        $this->attributeSet = $attributeSet;
        return $this;
    }
    /**
     * Add item to attributeSet value
     * @throws \InvalidArgumentException
     * @param \Losc\CucmBundle\Model\Webservice\StructType\AttributeSet $item
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSdpTransparencyProfile
     */
    public function addToAttributeSet(\Losc\CucmBundle\Model\Webservice\StructType\AttributeSet $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Losc\CucmBundle\Model\Webservice\StructType\AttributeSet) {
            throw new \InvalidArgumentException(sprintf('The attributeSet property can only contain items of type \Losc\CucmBundle\Model\Webservice\StructType\AttributeSet, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->attributeSet[] = $item;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSdpTransparencyProfile
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
}
