<?php

namespace Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XSipProfile StructType
 * @subpackage Structs
 */
class XSipProfile extends AbstractStructBase
{
    /**
     * The name
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $name;
    /**
     * The sipBandwidthModifier
     * Meta information extracted from the WSDL
     * - default: TIAS and AS
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $sipBandwidthModifier;
    /**
     * The userAgentServerHeaderInfo
     * Meta information extracted from the WSDL
     * - default: Send Unified CM Version Information as User-Agent Header
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $userAgentServerHeaderInfo;
    /**
     * The dialStringInterpretation
     * Meta information extracted from the WSDL
     * - default: Phone number consists of characters 0-9, *, #, and + (others treated as URI addresses)
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $dialStringInterpretation;
    /**
     * The callingLineIdentification
     * Meta information extracted from the WSDL
     * - default: Default
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $callingLineIdentification;
    /**
     * The sipSessionRefreshMethod
     * Meta information extracted from the WSDL
     * - default: Invite
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $sipSessionRefreshMethod;
    /**
     * The earlyOfferSuppVoiceCall
     * Meta information extracted from the WSDL
     * - default: Disabled (Default value)
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $earlyOfferSuppVoiceCall;
    /**
     * The cucmVersionInSipHeader
     * Meta information extracted from the WSDL
     * - default: Major And Minor
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $cucmVersionInSipHeader;
    /**
     * The confidentialAccessLevelHeaders
     * Meta information extracted from the WSDL
     * - default: Disabled
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $confidentialAccessLevelHeaders;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 100
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $description;
    /**
     * The defaultTelephonyEventPayloadType
     * Meta information extracted from the WSDL
     * - default: 101
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $defaultTelephonyEventPayloadType;
    /**
     * The redirectByApplication
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: false
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $redirectByApplication;
    /**
     * The ringing180
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: false
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $ringing180;
    /**
     * The timerInvite
     * Meta information extracted from the WSDL
     * - default: 180
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $timerInvite;
    /**
     * The timerRegisterDelta
     * Meta information extracted from the WSDL
     * - default: 5
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $timerRegisterDelta;
    /**
     * The timerRegister
     * Meta information extracted from the WSDL
     * - default: 3600
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $timerRegister;
    /**
     * The timerT1
     * Meta information extracted from the WSDL
     * - default: 500
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $timerT1;
    /**
     * The timerT2
     * Meta information extracted from the WSDL
     * - default: 4000
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $timerT2;
    /**
     * The retryInvite
     * Meta information extracted from the WSDL
     * - default: 6
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $retryInvite;
    /**
     * The retryNotInvite
     * Meta information extracted from the WSDL
     * - default: 10
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $retryNotInvite;
    /**
     * The startMediaPort
     * Meta information extracted from the WSDL
     * - default: 16384
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $startMediaPort;
    /**
     * The stopMediaPort
     * Meta information extracted from the WSDL
     * - default: 32766
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $stopMediaPort;
    /**
     * The callpickupListUri
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: x-cisco-serviceuri-opickup
     * - maxLength: 128
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $callpickupListUri;
    /**
     * The callpickupGroupUri
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: x-cisco-serviceuri-gpickup
     * - maxLength: 128
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $callpickupGroupUri;
    /**
     * The meetmeServiceUrl
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: x-cisco-serviceuri-meetme
     * - maxLength: 128
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $meetmeServiceUrl;
    /**
     * The userInfo
     * Meta information extracted from the WSDL
     * - default: None
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $userInfo;
    /**
     * The dtmfDbLevel
     * Meta information extracted from the WSDL
     * - default: Nominal
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $dtmfDbLevel;
    /**
     * The callHoldRingback
     * Meta information extracted from the WSDL
     * - default: Off
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $callHoldRingback;
    /**
     * The anonymousCallBlock
     * Meta information extracted from the WSDL
     * - default: Off
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $anonymousCallBlock;
    /**
     * The callerIdBlock
     * Meta information extracted from the WSDL
     * - default: Off
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $callerIdBlock;
    /**
     * The dndControl
     * Meta information extracted from the WSDL
     * - default: User
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $dndControl;
    /**
     * The telnetLevel
     * Meta information extracted from the WSDL
     * - default: Disabled
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $telnetLevel;
    /**
     * The timerKeepAlive
     * Meta information extracted from the WSDL
     * - default: 120
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $timerKeepAlive;
    /**
     * The timerSubscribe
     * Meta information extracted from the WSDL
     * - default: 120
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $timerSubscribe;
    /**
     * The timerSubscribeDelta
     * Meta information extracted from the WSDL
     * - default: 5
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $timerSubscribeDelta;
    /**
     * The maxRedirects
     * Meta information extracted from the WSDL
     * - default: 70
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $maxRedirects;
    /**
     * The timerOffHookToFirstDigit
     * Meta information extracted from the WSDL
     * - default: 15000
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $timerOffHookToFirstDigit;
    /**
     * The callForwardUri
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: x-cisco-serviceuri-cfwdall
     * - maxLength: 128
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $callForwardUri;
    /**
     * The abbreviatedDialUri
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: x-cisco-serviceuri-abbrdial
     * - maxLength: 128
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $abbreviatedDialUri;
    /**
     * The confJointEnable
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: true
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $confJointEnable;
    /**
     * The rfc2543Hold
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: false
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $rfc2543Hold;
    /**
     * The semiAttendedTransfer
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: true
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $semiAttendedTransfer;
    /**
     * The enableVad
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: false
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $enableVad;
    /**
     * The stutterMsgWaiting
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: false
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $stutterMsgWaiting;
    /**
     * The callStats
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: false
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $callStats;
    /**
     * The t38Invite
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: false
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $t38Invite;
    /**
     * The rerouteIncomingRequest
     * Meta information extracted from the WSDL
     * - default: Never
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $rerouteIncomingRequest;
    /**
     * The resourcePriorityNamespaceListName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $resourcePriorityNamespaceListName;
    /**
     * The enableAnatForEarlyOfferCalls
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: false
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $enableAnatForEarlyOfferCalls;
    /**
     * The rsvpOverSip
     * Meta information extracted from the WSDL
     * - default: Local RSVP
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $rsvpOverSip;
    /**
     * The fallbackToLocalRsvp
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: true
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $fallbackToLocalRsvp;
    /**
     * The sipRe11XxEnabled
     * Meta information extracted from the WSDL
     * - default: Disabled
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $sipRe11XxEnabled;
    /**
     * The gClear
     * Meta information extracted from the WSDL
     * - default: Disabled
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $gClear;
    /**
     * The sendRecvSDPInMidCallInvite
     * Meta information extracted from the WSDL
     * - documentation: This field is editable only if earlyOfferSupportForVoiceCall is set to true.
     * - base: xsd:string
     * - default: false
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $sendRecvSDPInMidCallInvite;
    /**
     * The enableOutboundOptionsPing
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: false
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $enableOutboundOptionsPing;
    /**
     * The optionsPingIntervalWhenStatusOK
     * Meta information extracted from the WSDL
     * - default: 60
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $optionsPingIntervalWhenStatusOK;
    /**
     * The optionsPingIntervalWhenStatusNotOK
     * Meta information extracted from the WSDL
     * - default: 120
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $optionsPingIntervalWhenStatusNotOK;
    /**
     * The deliverConferenceBridgeIdentifier
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $deliverConferenceBridgeIdentifier;
    /**
     * The sipOptionsRetryCount
     * Meta information extracted from the WSDL
     * - default: 6
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $sipOptionsRetryCount;
    /**
     * The sipOptionsRetryTimer
     * Meta information extracted from the WSDL
     * - default: 500
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $sipOptionsRetryTimer;
    /**
     * The enableUriOutdialSupport
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $enableUriOutdialSupport;
    /**
     * The allowPresentationSharingUsingBfcp
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $allowPresentationSharingUsingBfcp;
    /**
     * The scriptParameters
     * Meta information extracted from the WSDL
     * - documentation: This field will be enabled only when SIP Normalization Script is present.
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $scriptParameters;
    /**
     * The isScriptTraceEnabled
     * Meta information extracted from the WSDL
     * - documentation: This field will be enabled only when SIP Normalization Script is present.
     * - base: xsd:string
     * - default: false
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $isScriptTraceEnabled;
    /**
     * The sipNormalizationScript
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $sipNormalizationScript;
    /**
     * The allowiXApplicationMedia
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $allowiXApplicationMedia;
    /**
     * The acceptAudioCodecPreferences
     * Meta information extracted from the WSDL
     * - default: Default
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $acceptAudioCodecPreferences;
    /**
     * The mlppUserAuthorization
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: false
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $mlppUserAuthorization;
    /**
     * The isAssuredSipServiceEnabled
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: false
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $isAssuredSipServiceEnabled;
    /**
     * The resourcePriorityNamespace
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $resourcePriorityNamespace;
    /**
     * The useCallerIdCallerNameinUriOutgoingRequest
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $useCallerIdCallerNameinUriOutgoingRequest;
    /**
     * The callerIdDn
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $callerIdDn;
    /**
     * The callerName
     * Meta information extracted from the WSDL
     * - documentation: Characters which are not valid for caller name are ampersand, braces, less than or greater than, percentage sign, double quotes, square brackets and pipe.
     * - base: xsd:string
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $callerName;
    /**
     * The rejectAnonymousIncomingCall
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $rejectAnonymousIncomingCall;
    /**
     * The callpickupUri
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: x-cisco-serviceuri-pickup
     * - maxLength: 128
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $callpickupUri;
    /**
     * The rejectAnonymousOutgoingCall
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $rejectAnonymousOutgoingCall;
    /**
     * The videoCallTrafficClass
     * Meta information extracted from the WSDL
     * - default: Mixed
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $videoCallTrafficClass;
    /**
     * The sdpTransparency
     * Meta information extracted from the WSDL
     * - documentation: SDP Transparency Profile for SIP Profile
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $sdpTransparency;
    /**
     * The allowMultipleCodecs
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: false
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $allowMultipleCodecs;
    /**
     * The destRouteString
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $destRouteString;
    /**
     * The inactiveSDPRequired
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: false
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $inactiveSDPRequired;
    /**
     * Constructor method for XSipProfile
     * @uses XSipProfile::setName()
     * @uses XSipProfile::setSipBandwidthModifier()
     * @uses XSipProfile::setUserAgentServerHeaderInfo()
     * @uses XSipProfile::setDialStringInterpretation()
     * @uses XSipProfile::setCallingLineIdentification()
     * @uses XSipProfile::setSipSessionRefreshMethod()
     * @uses XSipProfile::setEarlyOfferSuppVoiceCall()
     * @uses XSipProfile::setCucmVersionInSipHeader()
     * @uses XSipProfile::setConfidentialAccessLevelHeaders()
     * @uses XSipProfile::setDescription()
     * @uses XSipProfile::setDefaultTelephonyEventPayloadType()
     * @uses XSipProfile::setRedirectByApplication()
     * @uses XSipProfile::setRinging180()
     * @uses XSipProfile::setTimerInvite()
     * @uses XSipProfile::setTimerRegisterDelta()
     * @uses XSipProfile::setTimerRegister()
     * @uses XSipProfile::setTimerT1()
     * @uses XSipProfile::setTimerT2()
     * @uses XSipProfile::setRetryInvite()
     * @uses XSipProfile::setRetryNotInvite()
     * @uses XSipProfile::setStartMediaPort()
     * @uses XSipProfile::setStopMediaPort()
     * @uses XSipProfile::setCallpickupListUri()
     * @uses XSipProfile::setCallpickupGroupUri()
     * @uses XSipProfile::setMeetmeServiceUrl()
     * @uses XSipProfile::setUserInfo()
     * @uses XSipProfile::setDtmfDbLevel()
     * @uses XSipProfile::setCallHoldRingback()
     * @uses XSipProfile::setAnonymousCallBlock()
     * @uses XSipProfile::setCallerIdBlock()
     * @uses XSipProfile::setDndControl()
     * @uses XSipProfile::setTelnetLevel()
     * @uses XSipProfile::setTimerKeepAlive()
     * @uses XSipProfile::setTimerSubscribe()
     * @uses XSipProfile::setTimerSubscribeDelta()
     * @uses XSipProfile::setMaxRedirects()
     * @uses XSipProfile::setTimerOffHookToFirstDigit()
     * @uses XSipProfile::setCallForwardUri()
     * @uses XSipProfile::setAbbreviatedDialUri()
     * @uses XSipProfile::setConfJointEnable()
     * @uses XSipProfile::setRfc2543Hold()
     * @uses XSipProfile::setSemiAttendedTransfer()
     * @uses XSipProfile::setEnableVad()
     * @uses XSipProfile::setStutterMsgWaiting()
     * @uses XSipProfile::setCallStats()
     * @uses XSipProfile::setT38Invite()
     * @uses XSipProfile::setRerouteIncomingRequest()
     * @uses XSipProfile::setResourcePriorityNamespaceListName()
     * @uses XSipProfile::setEnableAnatForEarlyOfferCalls()
     * @uses XSipProfile::setRsvpOverSip()
     * @uses XSipProfile::setFallbackToLocalRsvp()
     * @uses XSipProfile::setSipRe11XxEnabled()
     * @uses XSipProfile::setGClear()
     * @uses XSipProfile::setSendRecvSDPInMidCallInvite()
     * @uses XSipProfile::setEnableOutboundOptionsPing()
     * @uses XSipProfile::setOptionsPingIntervalWhenStatusOK()
     * @uses XSipProfile::setOptionsPingIntervalWhenStatusNotOK()
     * @uses XSipProfile::setDeliverConferenceBridgeIdentifier()
     * @uses XSipProfile::setSipOptionsRetryCount()
     * @uses XSipProfile::setSipOptionsRetryTimer()
     * @uses XSipProfile::setEnableUriOutdialSupport()
     * @uses XSipProfile::setAllowPresentationSharingUsingBfcp()
     * @uses XSipProfile::setScriptParameters()
     * @uses XSipProfile::setIsScriptTraceEnabled()
     * @uses XSipProfile::setSipNormalizationScript()
     * @uses XSipProfile::setAllowiXApplicationMedia()
     * @uses XSipProfile::setAcceptAudioCodecPreferences()
     * @uses XSipProfile::setMlppUserAuthorization()
     * @uses XSipProfile::setIsAssuredSipServiceEnabled()
     * @uses XSipProfile::setResourcePriorityNamespace()
     * @uses XSipProfile::setUseCallerIdCallerNameinUriOutgoingRequest()
     * @uses XSipProfile::setCallerIdDn()
     * @uses XSipProfile::setCallerName()
     * @uses XSipProfile::setRejectAnonymousIncomingCall()
     * @uses XSipProfile::setCallpickupUri()
     * @uses XSipProfile::setRejectAnonymousOutgoingCall()
     * @uses XSipProfile::setVideoCallTrafficClass()
     * @uses XSipProfile::setSdpTransparency()
     * @uses XSipProfile::setAllowMultipleCodecs()
     * @uses XSipProfile::setDestRouteString()
     * @uses XSipProfile::setInactiveSDPRequired()
     * @param string $name
     * @param string $sipBandwidthModifier
     * @param string $userAgentServerHeaderInfo
     * @param string $dialStringInterpretation
     * @param string $callingLineIdentification
     * @param string $sipSessionRefreshMethod
     * @param string $earlyOfferSuppVoiceCall
     * @param string $cucmVersionInSipHeader
     * @param string $confidentialAccessLevelHeaders
     * @param string $description
     * @param string $defaultTelephonyEventPayloadType
     * @param string $redirectByApplication
     * @param string $ringing180
     * @param string $timerInvite
     * @param string $timerRegisterDelta
     * @param string $timerRegister
     * @param string $timerT1
     * @param string $timerT2
     * @param string $retryInvite
     * @param string $retryNotInvite
     * @param string $startMediaPort
     * @param string $stopMediaPort
     * @param string $callpickupListUri
     * @param string $callpickupGroupUri
     * @param string $meetmeServiceUrl
     * @param string $userInfo
     * @param string $dtmfDbLevel
     * @param string $callHoldRingback
     * @param string $anonymousCallBlock
     * @param string $callerIdBlock
     * @param string $dndControl
     * @param string $telnetLevel
     * @param string $timerKeepAlive
     * @param string $timerSubscribe
     * @param string $timerSubscribeDelta
     * @param string $maxRedirects
     * @param string $timerOffHookToFirstDigit
     * @param string $callForwardUri
     * @param string $abbreviatedDialUri
     * @param string $confJointEnable
     * @param string $rfc2543Hold
     * @param string $semiAttendedTransfer
     * @param string $enableVad
     * @param string $stutterMsgWaiting
     * @param string $callStats
     * @param string $t38Invite
     * @param string $rerouteIncomingRequest
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $resourcePriorityNamespaceListName
     * @param string $enableAnatForEarlyOfferCalls
     * @param string $rsvpOverSip
     * @param string $fallbackToLocalRsvp
     * @param string $sipRe11XxEnabled
     * @param string $gClear
     * @param string $sendRecvSDPInMidCallInvite
     * @param string $enableOutboundOptionsPing
     * @param string $optionsPingIntervalWhenStatusOK
     * @param string $optionsPingIntervalWhenStatusNotOK
     * @param string $deliverConferenceBridgeIdentifier
     * @param string $sipOptionsRetryCount
     * @param string $sipOptionsRetryTimer
     * @param string $enableUriOutdialSupport
     * @param string $allowPresentationSharingUsingBfcp
     * @param string $scriptParameters
     * @param string $isScriptTraceEnabled
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $sipNormalizationScript
     * @param string $allowiXApplicationMedia
     * @param string $acceptAudioCodecPreferences
     * @param string $mlppUserAuthorization
     * @param string $isAssuredSipServiceEnabled
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $resourcePriorityNamespace
     * @param string $useCallerIdCallerNameinUriOutgoingRequest
     * @param string $callerIdDn
     * @param string $callerName
     * @param string $rejectAnonymousIncomingCall
     * @param string $callpickupUri
     * @param string $rejectAnonymousOutgoingCall
     * @param string $videoCallTrafficClass
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $sdpTransparency
     * @param string $allowMultipleCodecs
     * @param string $destRouteString
     * @param string $inactiveSDPRequired
     */
    public function __construct($name = null, $sipBandwidthModifier = 'TIAS and AS', $userAgentServerHeaderInfo = 'Send Unified CM Version Information as User-Agent Header', $dialStringInterpretation = Phone number consists of characters 0-9, *, #, and + (others treated as URI addresses), $callingLineIdentification = 'Default', $sipSessionRefreshMethod = 'Invite', $earlyOfferSuppVoiceCall = Disabled (Default value), $cucmVersionInSipHeader = 'Major And Minor', $confidentialAccessLevelHeaders = 'Disabled', $description = null, $defaultTelephonyEventPayloadType = '101', $redirectByApplication = 'false', $ringing180 = 'false', $timerInvite = '180', $timerRegisterDelta = '5', $timerRegister = '3600', $timerT1 = '500', $timerT2 = '4000', $retryInvite = '6', $retryNotInvite = '10', $startMediaPort = '16384', $stopMediaPort = '32766', $callpickupListUri = 'x-cisco-serviceuri-opickup', $callpickupGroupUri = 'x-cisco-serviceuri-gpickup', $meetmeServiceUrl = 'x-cisco-serviceuri-meetme', $userInfo = 'None', $dtmfDbLevel = 'Nominal', $callHoldRingback = 'Off', $anonymousCallBlock = 'Off', $callerIdBlock = 'Off', $dndControl = 'User', $telnetLevel = 'Disabled', $timerKeepAlive = '120', $timerSubscribe = '120', $timerSubscribeDelta = '5', $maxRedirects = '70', $timerOffHookToFirstDigit = '15000', $callForwardUri = 'x-cisco-serviceuri-cfwdall', $abbreviatedDialUri = 'x-cisco-serviceuri-abbrdial', $confJointEnable = 'true', $rfc2543Hold = 'false', $semiAttendedTransfer = 'true', $enableVad = 'false', $stutterMsgWaiting = 'false', $callStats = 'false', $t38Invite = 'false', $rerouteIncomingRequest = 'Never', \Losc\CucmBundle\Model\Webservice\StructType\XFkType $resourcePriorityNamespaceListName = null, $enableAnatForEarlyOfferCalls = 'false', $rsvpOverSip = 'Local RSVP', $fallbackToLocalRsvp = 'true', $sipRe11XxEnabled = 'Disabled', $gClear = 'Disabled', $sendRecvSDPInMidCallInvite = 'false', $enableOutboundOptionsPing = 'false', $optionsPingIntervalWhenStatusOK = '60', $optionsPingIntervalWhenStatusNotOK = '120', $deliverConferenceBridgeIdentifier = null, $sipOptionsRetryCount = '6', $sipOptionsRetryTimer = '500', $enableUriOutdialSupport = null, $allowPresentationSharingUsingBfcp = null, $scriptParameters = null, $isScriptTraceEnabled = 'false', \Losc\CucmBundle\Model\Webservice\StructType\XFkType $sipNormalizationScript = null, $allowiXApplicationMedia = null, $acceptAudioCodecPreferences = 'Default', $mlppUserAuthorization = 'false', $isAssuredSipServiceEnabled = 'false', \Losc\CucmBundle\Model\Webservice\StructType\XFkType $resourcePriorityNamespace = null, $useCallerIdCallerNameinUriOutgoingRequest = null, $callerIdDn = null, $callerName = null, $rejectAnonymousIncomingCall = null, $callpickupUri = 'x-cisco-serviceuri-pickup', $rejectAnonymousOutgoingCall = null, $videoCallTrafficClass = 'Mixed', \Losc\CucmBundle\Model\Webservice\StructType\XFkType $sdpTransparency = null, $allowMultipleCodecs = 'false', $destRouteString = null, $inactiveSDPRequired = 'false')
    {
        $this
            ->setName($name)
            ->setSipBandwidthModifier($sipBandwidthModifier)
            ->setUserAgentServerHeaderInfo($userAgentServerHeaderInfo)
            ->setDialStringInterpretation($dialStringInterpretation)
            ->setCallingLineIdentification($callingLineIdentification)
            ->setSipSessionRefreshMethod($sipSessionRefreshMethod)
            ->setEarlyOfferSuppVoiceCall($earlyOfferSuppVoiceCall)
            ->setCucmVersionInSipHeader($cucmVersionInSipHeader)
            ->setConfidentialAccessLevelHeaders($confidentialAccessLevelHeaders)
            ->setDescription($description)
            ->setDefaultTelephonyEventPayloadType($defaultTelephonyEventPayloadType)
            ->setRedirectByApplication($redirectByApplication)
            ->setRinging180($ringing180)
            ->setTimerInvite($timerInvite)
            ->setTimerRegisterDelta($timerRegisterDelta)
            ->setTimerRegister($timerRegister)
            ->setTimerT1($timerT1)
            ->setTimerT2($timerT2)
            ->setRetryInvite($retryInvite)
            ->setRetryNotInvite($retryNotInvite)
            ->setStartMediaPort($startMediaPort)
            ->setStopMediaPort($stopMediaPort)
            ->setCallpickupListUri($callpickupListUri)
            ->setCallpickupGroupUri($callpickupGroupUri)
            ->setMeetmeServiceUrl($meetmeServiceUrl)
            ->setUserInfo($userInfo)
            ->setDtmfDbLevel($dtmfDbLevel)
            ->setCallHoldRingback($callHoldRingback)
            ->setAnonymousCallBlock($anonymousCallBlock)
            ->setCallerIdBlock($callerIdBlock)
            ->setDndControl($dndControl)
            ->setTelnetLevel($telnetLevel)
            ->setTimerKeepAlive($timerKeepAlive)
            ->setTimerSubscribe($timerSubscribe)
            ->setTimerSubscribeDelta($timerSubscribeDelta)
            ->setMaxRedirects($maxRedirects)
            ->setTimerOffHookToFirstDigit($timerOffHookToFirstDigit)
            ->setCallForwardUri($callForwardUri)
            ->setAbbreviatedDialUri($abbreviatedDialUri)
            ->setConfJointEnable($confJointEnable)
            ->setRfc2543Hold($rfc2543Hold)
            ->setSemiAttendedTransfer($semiAttendedTransfer)
            ->setEnableVad($enableVad)
            ->setStutterMsgWaiting($stutterMsgWaiting)
            ->setCallStats($callStats)
            ->setT38Invite($t38Invite)
            ->setRerouteIncomingRequest($rerouteIncomingRequest)
            ->setResourcePriorityNamespaceListName($resourcePriorityNamespaceListName)
            ->setEnableAnatForEarlyOfferCalls($enableAnatForEarlyOfferCalls)
            ->setRsvpOverSip($rsvpOverSip)
            ->setFallbackToLocalRsvp($fallbackToLocalRsvp)
            ->setSipRe11XxEnabled($sipRe11XxEnabled)
            ->setGClear($gClear)
            ->setSendRecvSDPInMidCallInvite($sendRecvSDPInMidCallInvite)
            ->setEnableOutboundOptionsPing($enableOutboundOptionsPing)
            ->setOptionsPingIntervalWhenStatusOK($optionsPingIntervalWhenStatusOK)
            ->setOptionsPingIntervalWhenStatusNotOK($optionsPingIntervalWhenStatusNotOK)
            ->setDeliverConferenceBridgeIdentifier($deliverConferenceBridgeIdentifier)
            ->setSipOptionsRetryCount($sipOptionsRetryCount)
            ->setSipOptionsRetryTimer($sipOptionsRetryTimer)
            ->setEnableUriOutdialSupport($enableUriOutdialSupport)
            ->setAllowPresentationSharingUsingBfcp($allowPresentationSharingUsingBfcp)
            ->setScriptParameters($scriptParameters)
            ->setIsScriptTraceEnabled($isScriptTraceEnabled)
            ->setSipNormalizationScript($sipNormalizationScript)
            ->setAllowiXApplicationMedia($allowiXApplicationMedia)
            ->setAcceptAudioCodecPreferences($acceptAudioCodecPreferences)
            ->setMlppUserAuthorization($mlppUserAuthorization)
            ->setIsAssuredSipServiceEnabled($isAssuredSipServiceEnabled)
            ->setResourcePriorityNamespace($resourcePriorityNamespace)
            ->setUseCallerIdCallerNameinUriOutgoingRequest($useCallerIdCallerNameinUriOutgoingRequest)
            ->setCallerIdDn($callerIdDn)
            ->setCallerName($callerName)
            ->setRejectAnonymousIncomingCall($rejectAnonymousIncomingCall)
            ->setCallpickupUri($callpickupUri)
            ->setRejectAnonymousOutgoingCall($rejectAnonymousOutgoingCall)
            ->setVideoCallTrafficClass($videoCallTrafficClass)
            ->setSdpTransparency($sdpTransparency)
            ->setAllowMultipleCodecs($allowMultipleCodecs)
            ->setDestRouteString($destRouteString)
            ->setInactiveSDPRequired($inactiveSDPRequired);
    }
    /**
     * Get name value
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        // validation for constraint: maxLength(50)
        if (!is_null($name) && mb_strlen($name) > 50) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 50', mb_strlen($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get sipBandwidthModifier value
     * @return string
     */
    public function getSipBandwidthModifier()
    {
        return $this->sipBandwidthModifier;
    }
    /**
     * Set sipBandwidthModifier value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XSIPBandwidthModifier::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XSIPBandwidthModifier::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $sipBandwidthModifier
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setSipBandwidthModifier($sipBandwidthModifier = 'TIAS and AS')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XSIPBandwidthModifier::valueIsValid($sipBandwidthModifier)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XSIPBandwidthModifier', is_array($sipBandwidthModifier) ? implode(', ', $sipBandwidthModifier) : var_export($sipBandwidthModifier, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XSIPBandwidthModifier::getValidValues())), __LINE__);
        }
        $this->sipBandwidthModifier = $sipBandwidthModifier;
        return $this;
    }
    /**
     * Get userAgentServerHeaderInfo value
     * @return string
     */
    public function getUserAgentServerHeaderInfo()
    {
        return $this->userAgentServerHeaderInfo;
    }
    /**
     * Set userAgentServerHeaderInfo value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XUserAgentServerHeaderInfo::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XUserAgentServerHeaderInfo::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $userAgentServerHeaderInfo
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setUserAgentServerHeaderInfo($userAgentServerHeaderInfo = 'Send Unified CM Version Information as User-Agent Header')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XUserAgentServerHeaderInfo::valueIsValid($userAgentServerHeaderInfo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XUserAgentServerHeaderInfo', is_array($userAgentServerHeaderInfo) ? implode(', ', $userAgentServerHeaderInfo) : var_export($userAgentServerHeaderInfo, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XUserAgentServerHeaderInfo::getValidValues())), __LINE__);
        }
        $this->userAgentServerHeaderInfo = $userAgentServerHeaderInfo;
        return $this;
    }
    /**
     * Get dialStringInterpretation value
     * @return string
     */
    public function getDialStringInterpretation()
    {
        return $this->dialStringInterpretation;
    }
    /**
     * Set dialStringInterpretation value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XURIDisambiguationPolicy::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XURIDisambiguationPolicy::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $dialStringInterpretation
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setDialStringInterpretation($dialStringInterpretation = Phone number consists of characters 0-9, *, #, and + (others treated as URI addresses))
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XURIDisambiguationPolicy::valueIsValid($dialStringInterpretation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XURIDisambiguationPolicy', is_array($dialStringInterpretation) ? implode(', ', $dialStringInterpretation) : var_export($dialStringInterpretation, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XURIDisambiguationPolicy::getValidValues())), __LINE__);
        }
        $this->dialStringInterpretation = $dialStringInterpretation;
        return $this;
    }
    /**
     * Get callingLineIdentification value
     * @return string
     */
    public function getCallingLineIdentification()
    {
        return $this->callingLineIdentification;
    }
    /**
     * Set callingLineIdentification value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XCallingLineIdentification::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XCallingLineIdentification::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $callingLineIdentification
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setCallingLineIdentification($callingLineIdentification = 'Default')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XCallingLineIdentification::valueIsValid($callingLineIdentification)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XCallingLineIdentification', is_array($callingLineIdentification) ? implode(', ', $callingLineIdentification) : var_export($callingLineIdentification, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XCallingLineIdentification::getValidValues())), __LINE__);
        }
        $this->callingLineIdentification = $callingLineIdentification;
        return $this;
    }
    /**
     * Get sipSessionRefreshMethod value
     * @return string
     */
    public function getSipSessionRefreshMethod()
    {
        return $this->sipSessionRefreshMethod;
    }
    /**
     * Set sipSessionRefreshMethod value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XSipSessionRefreshMethod::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XSipSessionRefreshMethod::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $sipSessionRefreshMethod
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setSipSessionRefreshMethod($sipSessionRefreshMethod = 'Invite')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XSipSessionRefreshMethod::valueIsValid($sipSessionRefreshMethod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XSipSessionRefreshMethod', is_array($sipSessionRefreshMethod) ? implode(', ', $sipSessionRefreshMethod) : var_export($sipSessionRefreshMethod, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XSipSessionRefreshMethod::getValidValues())), __LINE__);
        }
        $this->sipSessionRefreshMethod = $sipSessionRefreshMethod;
        return $this;
    }
    /**
     * Get earlyOfferSuppVoiceCall value
     * @return string
     */
    public function getEarlyOfferSuppVoiceCall()
    {
        return $this->earlyOfferSuppVoiceCall;
    }
    /**
     * Set earlyOfferSuppVoiceCall value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XEOSuppVoiceCall::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XEOSuppVoiceCall::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $earlyOfferSuppVoiceCall
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setEarlyOfferSuppVoiceCall($earlyOfferSuppVoiceCall = Disabled (Default value))
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XEOSuppVoiceCall::valueIsValid($earlyOfferSuppVoiceCall)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XEOSuppVoiceCall', is_array($earlyOfferSuppVoiceCall) ? implode(', ', $earlyOfferSuppVoiceCall) : var_export($earlyOfferSuppVoiceCall, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XEOSuppVoiceCall::getValidValues())), __LINE__);
        }
        $this->earlyOfferSuppVoiceCall = $earlyOfferSuppVoiceCall;
        return $this;
    }
    /**
     * Get cucmVersionInSipHeader value
     * @return string
     */
    public function getCucmVersionInSipHeader()
    {
        return $this->cucmVersionInSipHeader;
    }
    /**
     * Set cucmVersionInSipHeader value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XCUCMVersionInSipHeader::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XCUCMVersionInSipHeader::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $cucmVersionInSipHeader
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setCucmVersionInSipHeader($cucmVersionInSipHeader = 'Major And Minor')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XCUCMVersionInSipHeader::valueIsValid($cucmVersionInSipHeader)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XCUCMVersionInSipHeader', is_array($cucmVersionInSipHeader) ? implode(', ', $cucmVersionInSipHeader) : var_export($cucmVersionInSipHeader, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XCUCMVersionInSipHeader::getValidValues())), __LINE__);
        }
        $this->cucmVersionInSipHeader = $cucmVersionInSipHeader;
        return $this;
    }
    /**
     * Get confidentialAccessLevelHeaders value
     * @return string
     */
    public function getConfidentialAccessLevelHeaders()
    {
        return $this->confidentialAccessLevelHeaders;
    }
    /**
     * Set confidentialAccessLevelHeaders value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XCALHeaders::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XCALHeaders::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $confidentialAccessLevelHeaders
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setConfidentialAccessLevelHeaders($confidentialAccessLevelHeaders = 'Disabled')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XCALHeaders::valueIsValid($confidentialAccessLevelHeaders)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XCALHeaders', is_array($confidentialAccessLevelHeaders) ? implode(', ', $confidentialAccessLevelHeaders) : var_export($confidentialAccessLevelHeaders, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XCALHeaders::getValidValues())), __LINE__);
        }
        $this->confidentialAccessLevelHeaders = $confidentialAccessLevelHeaders;
        return $this;
    }
    /**
     * Get description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDescription()
    {
        return isset($this->description) ? $this->description : null;
    }
    /**
     * Set description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $description
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        // validation for constraint: maxLength(100)
        if (!is_null($description) && mb_strlen($description) > 100) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 100', mb_strlen($description)), __LINE__);
        }
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->description);
        } else {
            $this->description = $description;
        }
        return $this;
    }
    /**
     * Get defaultTelephonyEventPayloadType value
     * @return string|null
     */
    public function getDefaultTelephonyEventPayloadType()
    {
        return $this->defaultTelephonyEventPayloadType;
    }
    /**
     * Set defaultTelephonyEventPayloadType value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $defaultTelephonyEventPayloadType
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setDefaultTelephonyEventPayloadType($defaultTelephonyEventPayloadType = '101')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($defaultTelephonyEventPayloadType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($defaultTelephonyEventPayloadType) ? implode(', ', $defaultTelephonyEventPayloadType) : var_export($defaultTelephonyEventPayloadType, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->defaultTelephonyEventPayloadType = $defaultTelephonyEventPayloadType;
        return $this;
    }
    /**
     * Get redirectByApplication value
     * @return string|null
     */
    public function getRedirectByApplication()
    {
        return $this->redirectByApplication;
    }
    /**
     * Set redirectByApplication value
     * @param string $redirectByApplication
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setRedirectByApplication($redirectByApplication = 'false')
    {
        // validation for constraint: string
        if (!is_null($redirectByApplication) && !is_string($redirectByApplication)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($redirectByApplication, true), gettype($redirectByApplication)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($redirectByApplication) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $redirectByApplication)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($redirectByApplication, true)), __LINE__);
        }
        $this->redirectByApplication = $redirectByApplication;
        return $this;
    }
    /**
     * Get ringing180 value
     * @return string|null
     */
    public function getRinging180()
    {
        return $this->ringing180;
    }
    /**
     * Set ringing180 value
     * @param string $ringing180
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setRinging180($ringing180 = 'false')
    {
        // validation for constraint: string
        if (!is_null($ringing180) && !is_string($ringing180)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ringing180, true), gettype($ringing180)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($ringing180) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $ringing180)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($ringing180, true)), __LINE__);
        }
        $this->ringing180 = $ringing180;
        return $this;
    }
    /**
     * Get timerInvite value
     * @return string|null
     */
    public function getTimerInvite()
    {
        return $this->timerInvite;
    }
    /**
     * Set timerInvite value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $timerInvite
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setTimerInvite($timerInvite = '180')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($timerInvite)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($timerInvite) ? implode(', ', $timerInvite) : var_export($timerInvite, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->timerInvite = $timerInvite;
        return $this;
    }
    /**
     * Get timerRegisterDelta value
     * @return string|null
     */
    public function getTimerRegisterDelta()
    {
        return $this->timerRegisterDelta;
    }
    /**
     * Set timerRegisterDelta value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $timerRegisterDelta
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setTimerRegisterDelta($timerRegisterDelta = '5')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($timerRegisterDelta)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($timerRegisterDelta) ? implode(', ', $timerRegisterDelta) : var_export($timerRegisterDelta, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->timerRegisterDelta = $timerRegisterDelta;
        return $this;
    }
    /**
     * Get timerRegister value
     * @return string|null
     */
    public function getTimerRegister()
    {
        return $this->timerRegister;
    }
    /**
     * Set timerRegister value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $timerRegister
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setTimerRegister($timerRegister = '3600')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($timerRegister)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($timerRegister) ? implode(', ', $timerRegister) : var_export($timerRegister, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->timerRegister = $timerRegister;
        return $this;
    }
    /**
     * Get timerT1 value
     * @return string|null
     */
    public function getTimerT1()
    {
        return $this->timerT1;
    }
    /**
     * Set timerT1 value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $timerT1
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setTimerT1($timerT1 = '500')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($timerT1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($timerT1) ? implode(', ', $timerT1) : var_export($timerT1, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->timerT1 = $timerT1;
        return $this;
    }
    /**
     * Get timerT2 value
     * @return string|null
     */
    public function getTimerT2()
    {
        return $this->timerT2;
    }
    /**
     * Set timerT2 value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $timerT2
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setTimerT2($timerT2 = '4000')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($timerT2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($timerT2) ? implode(', ', $timerT2) : var_export($timerT2, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->timerT2 = $timerT2;
        return $this;
    }
    /**
     * Get retryInvite value
     * @return string|null
     */
    public function getRetryInvite()
    {
        return $this->retryInvite;
    }
    /**
     * Set retryInvite value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $retryInvite
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setRetryInvite($retryInvite = '6')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($retryInvite)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($retryInvite) ? implode(', ', $retryInvite) : var_export($retryInvite, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->retryInvite = $retryInvite;
        return $this;
    }
    /**
     * Get retryNotInvite value
     * @return string|null
     */
    public function getRetryNotInvite()
    {
        return $this->retryNotInvite;
    }
    /**
     * Set retryNotInvite value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $retryNotInvite
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setRetryNotInvite($retryNotInvite = '10')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($retryNotInvite)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($retryNotInvite) ? implode(', ', $retryNotInvite) : var_export($retryNotInvite, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->retryNotInvite = $retryNotInvite;
        return $this;
    }
    /**
     * Get startMediaPort value
     * @return string|null
     */
    public function getStartMediaPort()
    {
        return $this->startMediaPort;
    }
    /**
     * Set startMediaPort value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $startMediaPort
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setStartMediaPort($startMediaPort = '16384')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($startMediaPort)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($startMediaPort) ? implode(', ', $startMediaPort) : var_export($startMediaPort, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->startMediaPort = $startMediaPort;
        return $this;
    }
    /**
     * Get stopMediaPort value
     * @return string|null
     */
    public function getStopMediaPort()
    {
        return $this->stopMediaPort;
    }
    /**
     * Set stopMediaPort value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $stopMediaPort
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setStopMediaPort($stopMediaPort = '32766')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($stopMediaPort)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($stopMediaPort) ? implode(', ', $stopMediaPort) : var_export($stopMediaPort, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->stopMediaPort = $stopMediaPort;
        return $this;
    }
    /**
     * Get callpickupListUri value
     * @return string|null
     */
    public function getCallpickupListUri()
    {
        return $this->callpickupListUri;
    }
    /**
     * Set callpickupListUri value
     * @param string $callpickupListUri
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setCallpickupListUri($callpickupListUri = 'x-cisco-serviceuri-opickup')
    {
        // validation for constraint: string
        if (!is_null($callpickupListUri) && !is_string($callpickupListUri)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callpickupListUri, true), gettype($callpickupListUri)), __LINE__);
        }
        // validation for constraint: maxLength(128)
        if (!is_null($callpickupListUri) && mb_strlen($callpickupListUri) > 128) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 128', mb_strlen($callpickupListUri)), __LINE__);
        }
        $this->callpickupListUri = $callpickupListUri;
        return $this;
    }
    /**
     * Get callpickupGroupUri value
     * @return string|null
     */
    public function getCallpickupGroupUri()
    {
        return $this->callpickupGroupUri;
    }
    /**
     * Set callpickupGroupUri value
     * @param string $callpickupGroupUri
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setCallpickupGroupUri($callpickupGroupUri = 'x-cisco-serviceuri-gpickup')
    {
        // validation for constraint: string
        if (!is_null($callpickupGroupUri) && !is_string($callpickupGroupUri)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callpickupGroupUri, true), gettype($callpickupGroupUri)), __LINE__);
        }
        // validation for constraint: maxLength(128)
        if (!is_null($callpickupGroupUri) && mb_strlen($callpickupGroupUri) > 128) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 128', mb_strlen($callpickupGroupUri)), __LINE__);
        }
        $this->callpickupGroupUri = $callpickupGroupUri;
        return $this;
    }
    /**
     * Get meetmeServiceUrl value
     * @return string|null
     */
    public function getMeetmeServiceUrl()
    {
        return $this->meetmeServiceUrl;
    }
    /**
     * Set meetmeServiceUrl value
     * @param string $meetmeServiceUrl
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setMeetmeServiceUrl($meetmeServiceUrl = 'x-cisco-serviceuri-meetme')
    {
        // validation for constraint: string
        if (!is_null($meetmeServiceUrl) && !is_string($meetmeServiceUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($meetmeServiceUrl, true), gettype($meetmeServiceUrl)), __LINE__);
        }
        // validation for constraint: maxLength(128)
        if (!is_null($meetmeServiceUrl) && mb_strlen($meetmeServiceUrl) > 128) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 128', mb_strlen($meetmeServiceUrl)), __LINE__);
        }
        $this->meetmeServiceUrl = $meetmeServiceUrl;
        return $this;
    }
    /**
     * Get userInfo value
     * @return string|null
     */
    public function getUserInfo()
    {
        return $this->userInfo;
    }
    /**
     * Set userInfo value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XZzuserInfo::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XZzuserInfo::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $userInfo
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setUserInfo($userInfo = 'None')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XZzuserInfo::valueIsValid($userInfo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XZzuserInfo', is_array($userInfo) ? implode(', ', $userInfo) : var_export($userInfo, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XZzuserInfo::getValidValues())), __LINE__);
        }
        $this->userInfo = $userInfo;
        return $this;
    }
    /**
     * Get dtmfDbLevel value
     * @return string|null
     */
    public function getDtmfDbLevel()
    {
        return $this->dtmfDbLevel;
    }
    /**
     * Set dtmfDbLevel value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XZzdtmfDbLevel::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XZzdtmfDbLevel::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $dtmfDbLevel
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setDtmfDbLevel($dtmfDbLevel = 'Nominal')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XZzdtmfDbLevel::valueIsValid($dtmfDbLevel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XZzdtmfDbLevel', is_array($dtmfDbLevel) ? implode(', ', $dtmfDbLevel) : var_export($dtmfDbLevel, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XZzdtmfDbLevel::getValidValues())), __LINE__);
        }
        $this->dtmfDbLevel = $dtmfDbLevel;
        return $this;
    }
    /**
     * Get callHoldRingback value
     * @return string|null
     */
    public function getCallHoldRingback()
    {
        return $this->callHoldRingback;
    }
    /**
     * Set callHoldRingback value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XZzpreff::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XZzpreff::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $callHoldRingback
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setCallHoldRingback($callHoldRingback = 'Off')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XZzpreff::valueIsValid($callHoldRingback)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XZzpreff', is_array($callHoldRingback) ? implode(', ', $callHoldRingback) : var_export($callHoldRingback, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XZzpreff::getValidValues())), __LINE__);
        }
        $this->callHoldRingback = $callHoldRingback;
        return $this;
    }
    /**
     * Get anonymousCallBlock value
     * @return string|null
     */
    public function getAnonymousCallBlock()
    {
        return $this->anonymousCallBlock;
    }
    /**
     * Set anonymousCallBlock value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XZzpreff::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XZzpreff::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $anonymousCallBlock
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setAnonymousCallBlock($anonymousCallBlock = 'Off')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XZzpreff::valueIsValid($anonymousCallBlock)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XZzpreff', is_array($anonymousCallBlock) ? implode(', ', $anonymousCallBlock) : var_export($anonymousCallBlock, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XZzpreff::getValidValues())), __LINE__);
        }
        $this->anonymousCallBlock = $anonymousCallBlock;
        return $this;
    }
    /**
     * Get callerIdBlock value
     * @return string|null
     */
    public function getCallerIdBlock()
    {
        return $this->callerIdBlock;
    }
    /**
     * Set callerIdBlock value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XZzpreff::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XZzpreff::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $callerIdBlock
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setCallerIdBlock($callerIdBlock = 'Off')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XZzpreff::valueIsValid($callerIdBlock)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XZzpreff', is_array($callerIdBlock) ? implode(', ', $callerIdBlock) : var_export($callerIdBlock, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XZzpreff::getValidValues())), __LINE__);
        }
        $this->callerIdBlock = $callerIdBlock;
        return $this;
    }
    /**
     * Get dndControl value
     * @return string|null
     */
    public function getDndControl()
    {
        return $this->dndControl;
    }
    /**
     * Set dndControl value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XZzdndcontrol::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XZzdndcontrol::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $dndControl
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setDndControl($dndControl = 'User')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XZzdndcontrol::valueIsValid($dndControl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XZzdndcontrol', is_array($dndControl) ? implode(', ', $dndControl) : var_export($dndControl, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XZzdndcontrol::getValidValues())), __LINE__);
        }
        $this->dndControl = $dndControl;
        return $this;
    }
    /**
     * Get telnetLevel value
     * @return string|null
     */
    public function getTelnetLevel()
    {
        return $this->telnetLevel;
    }
    /**
     * Set telnetLevel value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XTelnetLevel::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XTelnetLevel::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $telnetLevel
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setTelnetLevel($telnetLevel = 'Disabled')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XTelnetLevel::valueIsValid($telnetLevel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XTelnetLevel', is_array($telnetLevel) ? implode(', ', $telnetLevel) : var_export($telnetLevel, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XTelnetLevel::getValidValues())), __LINE__);
        }
        $this->telnetLevel = $telnetLevel;
        return $this;
    }
    /**
     * Get timerKeepAlive value
     * @return string|null
     */
    public function getTimerKeepAlive()
    {
        return $this->timerKeepAlive;
    }
    /**
     * Set timerKeepAlive value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $timerKeepAlive
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setTimerKeepAlive($timerKeepAlive = '120')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($timerKeepAlive)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($timerKeepAlive) ? implode(', ', $timerKeepAlive) : var_export($timerKeepAlive, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->timerKeepAlive = $timerKeepAlive;
        return $this;
    }
    /**
     * Get timerSubscribe value
     * @return string|null
     */
    public function getTimerSubscribe()
    {
        return $this->timerSubscribe;
    }
    /**
     * Set timerSubscribe value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $timerSubscribe
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setTimerSubscribe($timerSubscribe = '120')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($timerSubscribe)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($timerSubscribe) ? implode(', ', $timerSubscribe) : var_export($timerSubscribe, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->timerSubscribe = $timerSubscribe;
        return $this;
    }
    /**
     * Get timerSubscribeDelta value
     * @return string|null
     */
    public function getTimerSubscribeDelta()
    {
        return $this->timerSubscribeDelta;
    }
    /**
     * Set timerSubscribeDelta value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $timerSubscribeDelta
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setTimerSubscribeDelta($timerSubscribeDelta = '5')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($timerSubscribeDelta)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($timerSubscribeDelta) ? implode(', ', $timerSubscribeDelta) : var_export($timerSubscribeDelta, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->timerSubscribeDelta = $timerSubscribeDelta;
        return $this;
    }
    /**
     * Get maxRedirects value
     * @return string|null
     */
    public function getMaxRedirects()
    {
        return $this->maxRedirects;
    }
    /**
     * Set maxRedirects value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $maxRedirects
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setMaxRedirects($maxRedirects = '70')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($maxRedirects)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($maxRedirects) ? implode(', ', $maxRedirects) : var_export($maxRedirects, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->maxRedirects = $maxRedirects;
        return $this;
    }
    /**
     * Get timerOffHookToFirstDigit value
     * @return string|null
     */
    public function getTimerOffHookToFirstDigit()
    {
        return $this->timerOffHookToFirstDigit;
    }
    /**
     * Set timerOffHookToFirstDigit value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $timerOffHookToFirstDigit
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setTimerOffHookToFirstDigit($timerOffHookToFirstDigit = '15000')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($timerOffHookToFirstDigit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($timerOffHookToFirstDigit) ? implode(', ', $timerOffHookToFirstDigit) : var_export($timerOffHookToFirstDigit, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->timerOffHookToFirstDigit = $timerOffHookToFirstDigit;
        return $this;
    }
    /**
     * Get callForwardUri value
     * @return string|null
     */
    public function getCallForwardUri()
    {
        return $this->callForwardUri;
    }
    /**
     * Set callForwardUri value
     * @param string $callForwardUri
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setCallForwardUri($callForwardUri = 'x-cisco-serviceuri-cfwdall')
    {
        // validation for constraint: string
        if (!is_null($callForwardUri) && !is_string($callForwardUri)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callForwardUri, true), gettype($callForwardUri)), __LINE__);
        }
        // validation for constraint: maxLength(128)
        if (!is_null($callForwardUri) && mb_strlen($callForwardUri) > 128) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 128', mb_strlen($callForwardUri)), __LINE__);
        }
        $this->callForwardUri = $callForwardUri;
        return $this;
    }
    /**
     * Get abbreviatedDialUri value
     * @return string|null
     */
    public function getAbbreviatedDialUri()
    {
        return $this->abbreviatedDialUri;
    }
    /**
     * Set abbreviatedDialUri value
     * @param string $abbreviatedDialUri
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setAbbreviatedDialUri($abbreviatedDialUri = 'x-cisco-serviceuri-abbrdial')
    {
        // validation for constraint: string
        if (!is_null($abbreviatedDialUri) && !is_string($abbreviatedDialUri)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($abbreviatedDialUri, true), gettype($abbreviatedDialUri)), __LINE__);
        }
        // validation for constraint: maxLength(128)
        if (!is_null($abbreviatedDialUri) && mb_strlen($abbreviatedDialUri) > 128) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 128', mb_strlen($abbreviatedDialUri)), __LINE__);
        }
        $this->abbreviatedDialUri = $abbreviatedDialUri;
        return $this;
    }
    /**
     * Get confJointEnable value
     * @return string|null
     */
    public function getConfJointEnable()
    {
        return $this->confJointEnable;
    }
    /**
     * Set confJointEnable value
     * @param string $confJointEnable
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setConfJointEnable($confJointEnable = 'true')
    {
        // validation for constraint: string
        if (!is_null($confJointEnable) && !is_string($confJointEnable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($confJointEnable, true), gettype($confJointEnable)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($confJointEnable) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $confJointEnable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($confJointEnable, true)), __LINE__);
        }
        $this->confJointEnable = $confJointEnable;
        return $this;
    }
    /**
     * Get rfc2543Hold value
     * @return string|null
     */
    public function getRfc2543Hold()
    {
        return $this->rfc2543Hold;
    }
    /**
     * Set rfc2543Hold value
     * @param string $rfc2543Hold
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setRfc2543Hold($rfc2543Hold = 'false')
    {
        // validation for constraint: string
        if (!is_null($rfc2543Hold) && !is_string($rfc2543Hold)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rfc2543Hold, true), gettype($rfc2543Hold)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($rfc2543Hold) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $rfc2543Hold)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($rfc2543Hold, true)), __LINE__);
        }
        $this->rfc2543Hold = $rfc2543Hold;
        return $this;
    }
    /**
     * Get semiAttendedTransfer value
     * @return string|null
     */
    public function getSemiAttendedTransfer()
    {
        return $this->semiAttendedTransfer;
    }
    /**
     * Set semiAttendedTransfer value
     * @param string $semiAttendedTransfer
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setSemiAttendedTransfer($semiAttendedTransfer = 'true')
    {
        // validation for constraint: string
        if (!is_null($semiAttendedTransfer) && !is_string($semiAttendedTransfer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($semiAttendedTransfer, true), gettype($semiAttendedTransfer)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($semiAttendedTransfer) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $semiAttendedTransfer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($semiAttendedTransfer, true)), __LINE__);
        }
        $this->semiAttendedTransfer = $semiAttendedTransfer;
        return $this;
    }
    /**
     * Get enableVad value
     * @return string|null
     */
    public function getEnableVad()
    {
        return $this->enableVad;
    }
    /**
     * Set enableVad value
     * @param string $enableVad
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setEnableVad($enableVad = 'false')
    {
        // validation for constraint: string
        if (!is_null($enableVad) && !is_string($enableVad)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($enableVad, true), gettype($enableVad)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($enableVad) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $enableVad)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($enableVad, true)), __LINE__);
        }
        $this->enableVad = $enableVad;
        return $this;
    }
    /**
     * Get stutterMsgWaiting value
     * @return string|null
     */
    public function getStutterMsgWaiting()
    {
        return $this->stutterMsgWaiting;
    }
    /**
     * Set stutterMsgWaiting value
     * @param string $stutterMsgWaiting
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setStutterMsgWaiting($stutterMsgWaiting = 'false')
    {
        // validation for constraint: string
        if (!is_null($stutterMsgWaiting) && !is_string($stutterMsgWaiting)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($stutterMsgWaiting, true), gettype($stutterMsgWaiting)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($stutterMsgWaiting) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $stutterMsgWaiting)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($stutterMsgWaiting, true)), __LINE__);
        }
        $this->stutterMsgWaiting = $stutterMsgWaiting;
        return $this;
    }
    /**
     * Get callStats value
     * @return string|null
     */
    public function getCallStats()
    {
        return $this->callStats;
    }
    /**
     * Set callStats value
     * @param string $callStats
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setCallStats($callStats = 'false')
    {
        // validation for constraint: string
        if (!is_null($callStats) && !is_string($callStats)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callStats, true), gettype($callStats)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($callStats) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $callStats)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($callStats, true)), __LINE__);
        }
        $this->callStats = $callStats;
        return $this;
    }
    /**
     * Get t38Invite value
     * @return string|null
     */
    public function getT38Invite()
    {
        return $this->t38Invite;
    }
    /**
     * Set t38Invite value
     * @param string $t38Invite
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setT38Invite($t38Invite = 'false')
    {
        // validation for constraint: string
        if (!is_null($t38Invite) && !is_string($t38Invite)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($t38Invite, true), gettype($t38Invite)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($t38Invite) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $t38Invite)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($t38Invite, true)), __LINE__);
        }
        $this->t38Invite = $t38Invite;
        return $this;
    }
    /**
     * Get rerouteIncomingRequest value
     * @return string|null
     */
    public function getRerouteIncomingRequest()
    {
        return $this->rerouteIncomingRequest;
    }
    /**
     * Set rerouteIncomingRequest value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XSIPReroute::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XSIPReroute::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $rerouteIncomingRequest
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setRerouteIncomingRequest($rerouteIncomingRequest = 'Never')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XSIPReroute::valueIsValid($rerouteIncomingRequest)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XSIPReroute', is_array($rerouteIncomingRequest) ? implode(', ', $rerouteIncomingRequest) : var_export($rerouteIncomingRequest, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XSIPReroute::getValidValues())), __LINE__);
        }
        $this->rerouteIncomingRequest = $rerouteIncomingRequest;
        return $this;
    }
    /**
     * Get resourcePriorityNamespaceListName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getResourcePriorityNamespaceListName()
    {
        return isset($this->resourcePriorityNamespaceListName) ? $this->resourcePriorityNamespaceListName : null;
    }
    /**
     * Set resourcePriorityNamespaceListName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $resourcePriorityNamespaceListName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setResourcePriorityNamespaceListName(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $resourcePriorityNamespaceListName = null)
    {
        if (is_null($resourcePriorityNamespaceListName) || (is_array($resourcePriorityNamespaceListName) && empty($resourcePriorityNamespaceListName))) {
            unset($this->resourcePriorityNamespaceListName);
        } else {
            $this->resourcePriorityNamespaceListName = $resourcePriorityNamespaceListName;
        }
        return $this;
    }
    /**
     * Get enableAnatForEarlyOfferCalls value
     * @return string|null
     */
    public function getEnableAnatForEarlyOfferCalls()
    {
        return $this->enableAnatForEarlyOfferCalls;
    }
    /**
     * Set enableAnatForEarlyOfferCalls value
     * @param string $enableAnatForEarlyOfferCalls
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setEnableAnatForEarlyOfferCalls($enableAnatForEarlyOfferCalls = 'false')
    {
        // validation for constraint: string
        if (!is_null($enableAnatForEarlyOfferCalls) && !is_string($enableAnatForEarlyOfferCalls)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($enableAnatForEarlyOfferCalls, true), gettype($enableAnatForEarlyOfferCalls)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($enableAnatForEarlyOfferCalls) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $enableAnatForEarlyOfferCalls)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($enableAnatForEarlyOfferCalls, true)), __LINE__);
        }
        $this->enableAnatForEarlyOfferCalls = $enableAnatForEarlyOfferCalls;
        return $this;
    }
    /**
     * Get rsvpOverSip value
     * @return string|null
     */
    public function getRsvpOverSip()
    {
        return $this->rsvpOverSip;
    }
    /**
     * Set rsvpOverSip value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XRSVPOverSIP::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XRSVPOverSIP::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $rsvpOverSip
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setRsvpOverSip($rsvpOverSip = 'Local RSVP')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XRSVPOverSIP::valueIsValid($rsvpOverSip)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XRSVPOverSIP', is_array($rsvpOverSip) ? implode(', ', $rsvpOverSip) : var_export($rsvpOverSip, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XRSVPOverSIP::getValidValues())), __LINE__);
        }
        $this->rsvpOverSip = $rsvpOverSip;
        return $this;
    }
    /**
     * Get fallbackToLocalRsvp value
     * @return string|null
     */
    public function getFallbackToLocalRsvp()
    {
        return $this->fallbackToLocalRsvp;
    }
    /**
     * Set fallbackToLocalRsvp value
     * @param string $fallbackToLocalRsvp
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setFallbackToLocalRsvp($fallbackToLocalRsvp = 'true')
    {
        // validation for constraint: string
        if (!is_null($fallbackToLocalRsvp) && !is_string($fallbackToLocalRsvp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fallbackToLocalRsvp, true), gettype($fallbackToLocalRsvp)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($fallbackToLocalRsvp) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $fallbackToLocalRsvp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($fallbackToLocalRsvp, true)), __LINE__);
        }
        $this->fallbackToLocalRsvp = $fallbackToLocalRsvp;
        return $this;
    }
    /**
     * Get sipRe11XxEnabled value
     * @return string|null
     */
    public function getSipRe11XxEnabled()
    {
        return $this->sipRe11XxEnabled;
    }
    /**
     * Set sipRe11XxEnabled value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XSIPRel1XXOptions::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XSIPRel1XXOptions::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $sipRe11XxEnabled
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setSipRe11XxEnabled($sipRe11XxEnabled = 'Disabled')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XSIPRel1XXOptions::valueIsValid($sipRe11XxEnabled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XSIPRel1XXOptions', is_array($sipRe11XxEnabled) ? implode(', ', $sipRe11XxEnabled) : var_export($sipRe11XxEnabled, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XSIPRel1XXOptions::getValidValues())), __LINE__);
        }
        $this->sipRe11XxEnabled = $sipRe11XxEnabled;
        return $this;
    }
    /**
     * Get gClear value
     * @return string|null
     */
    public function getGClear()
    {
        return $this->gClear;
    }
    /**
     * Set gClear value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XGClear::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XGClear::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $gClear
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setGClear($gClear = 'Disabled')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XGClear::valueIsValid($gClear)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XGClear', is_array($gClear) ? implode(', ', $gClear) : var_export($gClear, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XGClear::getValidValues())), __LINE__);
        }
        $this->gClear = $gClear;
        return $this;
    }
    /**
     * Get sendRecvSDPInMidCallInvite value
     * @return string|null
     */
    public function getSendRecvSDPInMidCallInvite()
    {
        return $this->sendRecvSDPInMidCallInvite;
    }
    /**
     * Set sendRecvSDPInMidCallInvite value
     * @param string $sendRecvSDPInMidCallInvite
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setSendRecvSDPInMidCallInvite($sendRecvSDPInMidCallInvite = 'false')
    {
        // validation for constraint: string
        if (!is_null($sendRecvSDPInMidCallInvite) && !is_string($sendRecvSDPInMidCallInvite)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sendRecvSDPInMidCallInvite, true), gettype($sendRecvSDPInMidCallInvite)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($sendRecvSDPInMidCallInvite) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $sendRecvSDPInMidCallInvite)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($sendRecvSDPInMidCallInvite, true)), __LINE__);
        }
        $this->sendRecvSDPInMidCallInvite = $sendRecvSDPInMidCallInvite;
        return $this;
    }
    /**
     * Get enableOutboundOptionsPing value
     * @return string|null
     */
    public function getEnableOutboundOptionsPing()
    {
        return $this->enableOutboundOptionsPing;
    }
    /**
     * Set enableOutboundOptionsPing value
     * @param string $enableOutboundOptionsPing
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setEnableOutboundOptionsPing($enableOutboundOptionsPing = 'false')
    {
        // validation for constraint: string
        if (!is_null($enableOutboundOptionsPing) && !is_string($enableOutboundOptionsPing)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($enableOutboundOptionsPing, true), gettype($enableOutboundOptionsPing)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($enableOutboundOptionsPing) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $enableOutboundOptionsPing)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($enableOutboundOptionsPing, true)), __LINE__);
        }
        $this->enableOutboundOptionsPing = $enableOutboundOptionsPing;
        return $this;
    }
    /**
     * Get optionsPingIntervalWhenStatusOK value
     * @return string|null
     */
    public function getOptionsPingIntervalWhenStatusOK()
    {
        return $this->optionsPingIntervalWhenStatusOK;
    }
    /**
     * Set optionsPingIntervalWhenStatusOK value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $optionsPingIntervalWhenStatusOK
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setOptionsPingIntervalWhenStatusOK($optionsPingIntervalWhenStatusOK = '60')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($optionsPingIntervalWhenStatusOK)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($optionsPingIntervalWhenStatusOK) ? implode(', ', $optionsPingIntervalWhenStatusOK) : var_export($optionsPingIntervalWhenStatusOK, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->optionsPingIntervalWhenStatusOK = $optionsPingIntervalWhenStatusOK;
        return $this;
    }
    /**
     * Get optionsPingIntervalWhenStatusNotOK value
     * @return string|null
     */
    public function getOptionsPingIntervalWhenStatusNotOK()
    {
        return $this->optionsPingIntervalWhenStatusNotOK;
    }
    /**
     * Set optionsPingIntervalWhenStatusNotOK value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $optionsPingIntervalWhenStatusNotOK
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setOptionsPingIntervalWhenStatusNotOK($optionsPingIntervalWhenStatusNotOK = '120')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($optionsPingIntervalWhenStatusNotOK)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($optionsPingIntervalWhenStatusNotOK) ? implode(', ', $optionsPingIntervalWhenStatusNotOK) : var_export($optionsPingIntervalWhenStatusNotOK, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->optionsPingIntervalWhenStatusNotOK = $optionsPingIntervalWhenStatusNotOK;
        return $this;
    }
    /**
     * Get deliverConferenceBridgeIdentifier value
     * @return string|null
     */
    public function getDeliverConferenceBridgeIdentifier()
    {
        return $this->deliverConferenceBridgeIdentifier;
    }
    /**
     * Set deliverConferenceBridgeIdentifier value
     * @param string $deliverConferenceBridgeIdentifier
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setDeliverConferenceBridgeIdentifier($deliverConferenceBridgeIdentifier = null)
    {
        // validation for constraint: string
        if (!is_null($deliverConferenceBridgeIdentifier) && !is_string($deliverConferenceBridgeIdentifier)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deliverConferenceBridgeIdentifier, true), gettype($deliverConferenceBridgeIdentifier)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($deliverConferenceBridgeIdentifier) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $deliverConferenceBridgeIdentifier)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($deliverConferenceBridgeIdentifier, true)), __LINE__);
        }
        $this->deliverConferenceBridgeIdentifier = $deliverConferenceBridgeIdentifier;
        return $this;
    }
    /**
     * Get sipOptionsRetryCount value
     * @return string|null
     */
    public function getSipOptionsRetryCount()
    {
        return $this->sipOptionsRetryCount;
    }
    /**
     * Set sipOptionsRetryCount value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $sipOptionsRetryCount
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setSipOptionsRetryCount($sipOptionsRetryCount = '6')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($sipOptionsRetryCount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($sipOptionsRetryCount) ? implode(', ', $sipOptionsRetryCount) : var_export($sipOptionsRetryCount, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->sipOptionsRetryCount = $sipOptionsRetryCount;
        return $this;
    }
    /**
     * Get sipOptionsRetryTimer value
     * @return string|null
     */
    public function getSipOptionsRetryTimer()
    {
        return $this->sipOptionsRetryTimer;
    }
    /**
     * Set sipOptionsRetryTimer value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $sipOptionsRetryTimer
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setSipOptionsRetryTimer($sipOptionsRetryTimer = '500')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XInteger::valueIsValid($sipOptionsRetryTimer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XInteger', is_array($sipOptionsRetryTimer) ? implode(', ', $sipOptionsRetryTimer) : var_export($sipOptionsRetryTimer, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XInteger::getValidValues())), __LINE__);
        }
        $this->sipOptionsRetryTimer = $sipOptionsRetryTimer;
        return $this;
    }
    /**
     * Get enableUriOutdialSupport value
     * @return string|null
     */
    public function getEnableUriOutdialSupport()
    {
        return $this->enableUriOutdialSupport;
    }
    /**
     * Set enableUriOutdialSupport value
     * @param string $enableUriOutdialSupport
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setEnableUriOutdialSupport($enableUriOutdialSupport = null)
    {
        // validation for constraint: string
        if (!is_null($enableUriOutdialSupport) && !is_string($enableUriOutdialSupport)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($enableUriOutdialSupport, true), gettype($enableUriOutdialSupport)), __LINE__);
        }
        $this->enableUriOutdialSupport = $enableUriOutdialSupport;
        return $this;
    }
    /**
     * Get allowPresentationSharingUsingBfcp value
     * @return string|null
     */
    public function getAllowPresentationSharingUsingBfcp()
    {
        return $this->allowPresentationSharingUsingBfcp;
    }
    /**
     * Set allowPresentationSharingUsingBfcp value
     * @param string $allowPresentationSharingUsingBfcp
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setAllowPresentationSharingUsingBfcp($allowPresentationSharingUsingBfcp = null)
    {
        // validation for constraint: string
        if (!is_null($allowPresentationSharingUsingBfcp) && !is_string($allowPresentationSharingUsingBfcp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($allowPresentationSharingUsingBfcp, true), gettype($allowPresentationSharingUsingBfcp)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($allowPresentationSharingUsingBfcp) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $allowPresentationSharingUsingBfcp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($allowPresentationSharingUsingBfcp, true)), __LINE__);
        }
        $this->allowPresentationSharingUsingBfcp = $allowPresentationSharingUsingBfcp;
        return $this;
    }
    /**
     * Get scriptParameters value
     * @return string|null
     */
    public function getScriptParameters()
    {
        return $this->scriptParameters;
    }
    /**
     * Set scriptParameters value
     * @param string $scriptParameters
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setScriptParameters($scriptParameters = null)
    {
        // validation for constraint: string
        if (!is_null($scriptParameters) && !is_string($scriptParameters)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($scriptParameters, true), gettype($scriptParameters)), __LINE__);
        }
        $this->scriptParameters = $scriptParameters;
        return $this;
    }
    /**
     * Get isScriptTraceEnabled value
     * @return string|null
     */
    public function getIsScriptTraceEnabled()
    {
        return $this->isScriptTraceEnabled;
    }
    /**
     * Set isScriptTraceEnabled value
     * @param string $isScriptTraceEnabled
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setIsScriptTraceEnabled($isScriptTraceEnabled = 'false')
    {
        // validation for constraint: string
        if (!is_null($isScriptTraceEnabled) && !is_string($isScriptTraceEnabled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($isScriptTraceEnabled, true), gettype($isScriptTraceEnabled)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($isScriptTraceEnabled) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $isScriptTraceEnabled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($isScriptTraceEnabled, true)), __LINE__);
        }
        $this->isScriptTraceEnabled = $isScriptTraceEnabled;
        return $this;
    }
    /**
     * Get sipNormalizationScript value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getSipNormalizationScript()
    {
        return isset($this->sipNormalizationScript) ? $this->sipNormalizationScript : null;
    }
    /**
     * Set sipNormalizationScript value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $sipNormalizationScript
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setSipNormalizationScript(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $sipNormalizationScript = null)
    {
        if (is_null($sipNormalizationScript) || (is_array($sipNormalizationScript) && empty($sipNormalizationScript))) {
            unset($this->sipNormalizationScript);
        } else {
            $this->sipNormalizationScript = $sipNormalizationScript;
        }
        return $this;
    }
    /**
     * Get allowiXApplicationMedia value
     * @return string|null
     */
    public function getAllowiXApplicationMedia()
    {
        return $this->allowiXApplicationMedia;
    }
    /**
     * Set allowiXApplicationMedia value
     * @param string $allowiXApplicationMedia
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setAllowiXApplicationMedia($allowiXApplicationMedia = null)
    {
        // validation for constraint: string
        if (!is_null($allowiXApplicationMedia) && !is_string($allowiXApplicationMedia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($allowiXApplicationMedia, true), gettype($allowiXApplicationMedia)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($allowiXApplicationMedia) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $allowiXApplicationMedia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($allowiXApplicationMedia, true)), __LINE__);
        }
        $this->allowiXApplicationMedia = $allowiXApplicationMedia;
        return $this;
    }
    /**
     * Get acceptAudioCodecPreferences value
     * @return string|null
     */
    public function getAcceptAudioCodecPreferences()
    {
        return $this->acceptAudioCodecPreferences;
    }
    /**
     * Set acceptAudioCodecPreferences value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XStatus::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $acceptAudioCodecPreferences
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setAcceptAudioCodecPreferences($acceptAudioCodecPreferences = 'Default')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XStatus::valueIsValid($acceptAudioCodecPreferences)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XStatus', is_array($acceptAudioCodecPreferences) ? implode(', ', $acceptAudioCodecPreferences) : var_export($acceptAudioCodecPreferences, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XStatus::getValidValues())), __LINE__);
        }
        $this->acceptAudioCodecPreferences = $acceptAudioCodecPreferences;
        return $this;
    }
    /**
     * Get mlppUserAuthorization value
     * @return string|null
     */
    public function getMlppUserAuthorization()
    {
        return $this->mlppUserAuthorization;
    }
    /**
     * Set mlppUserAuthorization value
     * @param string $mlppUserAuthorization
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setMlppUserAuthorization($mlppUserAuthorization = 'false')
    {
        // validation for constraint: string
        if (!is_null($mlppUserAuthorization) && !is_string($mlppUserAuthorization)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mlppUserAuthorization, true), gettype($mlppUserAuthorization)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($mlppUserAuthorization) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $mlppUserAuthorization)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($mlppUserAuthorization, true)), __LINE__);
        }
        $this->mlppUserAuthorization = $mlppUserAuthorization;
        return $this;
    }
    /**
     * Get isAssuredSipServiceEnabled value
     * @return string|null
     */
    public function getIsAssuredSipServiceEnabled()
    {
        return $this->isAssuredSipServiceEnabled;
    }
    /**
     * Set isAssuredSipServiceEnabled value
     * @param string $isAssuredSipServiceEnabled
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setIsAssuredSipServiceEnabled($isAssuredSipServiceEnabled = 'false')
    {
        // validation for constraint: string
        if (!is_null($isAssuredSipServiceEnabled) && !is_string($isAssuredSipServiceEnabled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($isAssuredSipServiceEnabled, true), gettype($isAssuredSipServiceEnabled)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($isAssuredSipServiceEnabled) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $isAssuredSipServiceEnabled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($isAssuredSipServiceEnabled, true)), __LINE__);
        }
        $this->isAssuredSipServiceEnabled = $isAssuredSipServiceEnabled;
        return $this;
    }
    /**
     * Get resourcePriorityNamespace value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getResourcePriorityNamespace()
    {
        return isset($this->resourcePriorityNamespace) ? $this->resourcePriorityNamespace : null;
    }
    /**
     * Set resourcePriorityNamespace value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $resourcePriorityNamespace
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setResourcePriorityNamespace(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $resourcePriorityNamespace = null)
    {
        if (is_null($resourcePriorityNamespace) || (is_array($resourcePriorityNamespace) && empty($resourcePriorityNamespace))) {
            unset($this->resourcePriorityNamespace);
        } else {
            $this->resourcePriorityNamespace = $resourcePriorityNamespace;
        }
        return $this;
    }
    /**
     * Get useCallerIdCallerNameinUriOutgoingRequest value
     * @return string|null
     */
    public function getUseCallerIdCallerNameinUriOutgoingRequest()
    {
        return $this->useCallerIdCallerNameinUriOutgoingRequest;
    }
    /**
     * Set useCallerIdCallerNameinUriOutgoingRequest value
     * @param string $useCallerIdCallerNameinUriOutgoingRequest
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setUseCallerIdCallerNameinUriOutgoingRequest($useCallerIdCallerNameinUriOutgoingRequest = null)
    {
        // validation for constraint: string
        if (!is_null($useCallerIdCallerNameinUriOutgoingRequest) && !is_string($useCallerIdCallerNameinUriOutgoingRequest)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($useCallerIdCallerNameinUriOutgoingRequest, true), gettype($useCallerIdCallerNameinUriOutgoingRequest)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($useCallerIdCallerNameinUriOutgoingRequest) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $useCallerIdCallerNameinUriOutgoingRequest)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($useCallerIdCallerNameinUriOutgoingRequest, true)), __LINE__);
        }
        $this->useCallerIdCallerNameinUriOutgoingRequest = $useCallerIdCallerNameinUriOutgoingRequest;
        return $this;
    }
    /**
     * Get callerIdDn value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCallerIdDn()
    {
        return isset($this->callerIdDn) ? $this->callerIdDn : null;
    }
    /**
     * Set callerIdDn value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $callerIdDn
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setCallerIdDn($callerIdDn = null)
    {
        // validation for constraint: string
        if (!is_null($callerIdDn) && !is_string($callerIdDn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callerIdDn, true), gettype($callerIdDn)), __LINE__);
        }
        // validation for constraint: maxLength(50)
        if (!is_null($callerIdDn) && mb_strlen($callerIdDn) > 50) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 50', mb_strlen($callerIdDn)), __LINE__);
        }
        if (is_null($callerIdDn) || (is_array($callerIdDn) && empty($callerIdDn))) {
            unset($this->callerIdDn);
        } else {
            $this->callerIdDn = $callerIdDn;
        }
        return $this;
    }
    /**
     * Get callerName value
     * @return string|null
     */
    public function getCallerName()
    {
        return $this->callerName;
    }
    /**
     * Set callerName value
     * @param string $callerName
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setCallerName($callerName = null)
    {
        // validation for constraint: string
        if (!is_null($callerName) && !is_string($callerName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callerName, true), gettype($callerName)), __LINE__);
        }
        // validation for constraint: maxLength(50)
        if (!is_null($callerName) && mb_strlen($callerName) > 50) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 50', mb_strlen($callerName)), __LINE__);
        }
        $this->callerName = $callerName;
        return $this;
    }
    /**
     * Get rejectAnonymousIncomingCall value
     * @return string|null
     */
    public function getRejectAnonymousIncomingCall()
    {
        return $this->rejectAnonymousIncomingCall;
    }
    /**
     * Set rejectAnonymousIncomingCall value
     * @param string $rejectAnonymousIncomingCall
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setRejectAnonymousIncomingCall($rejectAnonymousIncomingCall = null)
    {
        // validation for constraint: string
        if (!is_null($rejectAnonymousIncomingCall) && !is_string($rejectAnonymousIncomingCall)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rejectAnonymousIncomingCall, true), gettype($rejectAnonymousIncomingCall)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($rejectAnonymousIncomingCall) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $rejectAnonymousIncomingCall)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($rejectAnonymousIncomingCall, true)), __LINE__);
        }
        $this->rejectAnonymousIncomingCall = $rejectAnonymousIncomingCall;
        return $this;
    }
    /**
     * Get callpickupUri value
     * @return string|null
     */
    public function getCallpickupUri()
    {
        return $this->callpickupUri;
    }
    /**
     * Set callpickupUri value
     * @param string $callpickupUri
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setCallpickupUri($callpickupUri = 'x-cisco-serviceuri-pickup')
    {
        // validation for constraint: string
        if (!is_null($callpickupUri) && !is_string($callpickupUri)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callpickupUri, true), gettype($callpickupUri)), __LINE__);
        }
        // validation for constraint: maxLength(128)
        if (!is_null($callpickupUri) && mb_strlen($callpickupUri) > 128) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 128', mb_strlen($callpickupUri)), __LINE__);
        }
        $this->callpickupUri = $callpickupUri;
        return $this;
    }
    /**
     * Get rejectAnonymousOutgoingCall value
     * @return string|null
     */
    public function getRejectAnonymousOutgoingCall()
    {
        return $this->rejectAnonymousOutgoingCall;
    }
    /**
     * Set rejectAnonymousOutgoingCall value
     * @param string $rejectAnonymousOutgoingCall
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setRejectAnonymousOutgoingCall($rejectAnonymousOutgoingCall = null)
    {
        // validation for constraint: string
        if (!is_null($rejectAnonymousOutgoingCall) && !is_string($rejectAnonymousOutgoingCall)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rejectAnonymousOutgoingCall, true), gettype($rejectAnonymousOutgoingCall)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($rejectAnonymousOutgoingCall) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $rejectAnonymousOutgoingCall)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($rejectAnonymousOutgoingCall, true)), __LINE__);
        }
        $this->rejectAnonymousOutgoingCall = $rejectAnonymousOutgoingCall;
        return $this;
    }
    /**
     * Get videoCallTrafficClass value
     * @return string|null
     */
    public function getVideoCallTrafficClass()
    {
        return $this->videoCallTrafficClass;
    }
    /**
     * Set videoCallTrafficClass value
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XVideoCallTrafficClass::valueIsValid()
     * @uses \Losc\CucmBundle\Model\Webservice\EnumType\XVideoCallTrafficClass::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $videoCallTrafficClass
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setVideoCallTrafficClass($videoCallTrafficClass = 'Mixed')
    {
        // validation for constraint: enumeration
        if (!\Losc\CucmBundle\Model\Webservice\EnumType\XVideoCallTrafficClass::valueIsValid($videoCallTrafficClass)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Losc\CucmBundle\Model\Webservice\EnumType\XVideoCallTrafficClass', is_array($videoCallTrafficClass) ? implode(', ', $videoCallTrafficClass) : var_export($videoCallTrafficClass, true), implode(', ', \Losc\CucmBundle\Model\Webservice\EnumType\XVideoCallTrafficClass::getValidValues())), __LINE__);
        }
        $this->videoCallTrafficClass = $videoCallTrafficClass;
        return $this;
    }
    /**
     * Get sdpTransparency value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getSdpTransparency()
    {
        return isset($this->sdpTransparency) ? $this->sdpTransparency : null;
    }
    /**
     * Set sdpTransparency value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Losc\CucmBundle\Model\Webservice\StructType\XFkType $sdpTransparency
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setSdpTransparency(\Losc\CucmBundle\Model\Webservice\StructType\XFkType $sdpTransparency = null)
    {
        if (is_null($sdpTransparency) || (is_array($sdpTransparency) && empty($sdpTransparency))) {
            unset($this->sdpTransparency);
        } else {
            $this->sdpTransparency = $sdpTransparency;
        }
        return $this;
    }
    /**
     * Get allowMultipleCodecs value
     * @return string|null
     */
    public function getAllowMultipleCodecs()
    {
        return $this->allowMultipleCodecs;
    }
    /**
     * Set allowMultipleCodecs value
     * @param string $allowMultipleCodecs
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setAllowMultipleCodecs($allowMultipleCodecs = 'false')
    {
        // validation for constraint: string
        if (!is_null($allowMultipleCodecs) && !is_string($allowMultipleCodecs)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($allowMultipleCodecs, true), gettype($allowMultipleCodecs)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($allowMultipleCodecs) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $allowMultipleCodecs)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($allowMultipleCodecs, true)), __LINE__);
        }
        $this->allowMultipleCodecs = $allowMultipleCodecs;
        return $this;
    }
    /**
     * Get destRouteString value
     * @return string|null
     */
    public function getDestRouteString()
    {
        return $this->destRouteString;
    }
    /**
     * Set destRouteString value
     * @param string $destRouteString
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setDestRouteString($destRouteString = null)
    {
        // validation for constraint: string
        if (!is_null($destRouteString) && !is_string($destRouteString)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($destRouteString, true), gettype($destRouteString)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($destRouteString) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $destRouteString)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($destRouteString, true)), __LINE__);
        }
        $this->destRouteString = $destRouteString;
        return $this;
    }
    /**
     * Get inactiveSDPRequired value
     * @return string|null
     */
    public function getInactiveSDPRequired()
    {
        return $this->inactiveSDPRequired;
    }
    /**
     * Set inactiveSDPRequired value
     * @param string $inactiveSDPRequired
     * @return \Losc\CucmBundle\Model\Webservice\StructType\XSipProfile
     */
    public function setInactiveSDPRequired($inactiveSDPRequired = 'false')
    {
        // validation for constraint: string
        if (!is_null($inactiveSDPRequired) && !is_string($inactiveSDPRequired)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($inactiveSDPRequired, true), gettype($inactiveSDPRequired)), __LINE__);
        }
        // validation for constraint: pattern((t)|(f)|(true)|(false)|(0)|(1))
        if (!is_null($inactiveSDPRequired) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $inactiveSDPRequired)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression (t)|(f)|(true)|(false)|(0)|(1)', var_export($inactiveSDPRequired, true)), __LINE__);
        }
        $this->inactiveSDPRequired = $inactiveSDPRequired;
        return $this;
    }
}
