<?php

namespace Losc\CucmBundle\Model\Webservice;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'AXLError' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AXLError',
            'XSipProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSipProfile',
            'AddSipProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddSipProfileReq',
            'UpdateSipProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSipProfileReq',
            'GetSipProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSipProfileReq',
            'GetSipProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSipProfileRes',
            'return' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\_return',
            'ListSipProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSipProfileReq',
            'searchCriteria' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\SearchCriteria',
            'ListSipProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSipProfileRes',
            'GetSipProfileOptionsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSipProfileOptionsReq',
            'GetSipProfileOptionsRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSipProfileOptionsRes',
            'XSipTrunkSecurityProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSipTrunkSecurityProfile',
            'AddSipTrunkSecurityProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddSipTrunkSecurityProfileReq',
            'UpdateSipTrunkSecurityProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSipTrunkSecurityProfileReq',
            'GetSipTrunkSecurityProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSipTrunkSecurityProfileReq',
            'GetSipTrunkSecurityProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSipTrunkSecurityProfileRes',
            'ListSipTrunkSecurityProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSipTrunkSecurityProfileReq',
            'ListSipTrunkSecurityProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSipTrunkSecurityProfileRes',
            'XTimePeriod' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XTimePeriod',
            'AddTimePeriodReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddTimePeriodReq',
            'UpdateTimePeriodReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateTimePeriodReq',
            'GetTimePeriodReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetTimePeriodReq',
            'GetTimePeriodRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetTimePeriodRes',
            'ListTimePeriodReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListTimePeriodReq',
            'ListTimePeriodRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListTimePeriodRes',
            'XTimeSchedule' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XTimeSchedule',
            'members' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Members',
            'AddTimeScheduleReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddTimeScheduleReq',
            'UpdateTimeScheduleReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateTimeScheduleReq',
            'removeMembers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveMembers',
            'addMembers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddMembers',
            'GetTimeScheduleReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetTimeScheduleReq',
            'GetTimeScheduleRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetTimeScheduleRes',
            'ListTimeScheduleReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListTimeScheduleReq',
            'ListTimeScheduleRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListTimeScheduleRes',
            'XTodAccess' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XTodAccess',
            'AddTodAccessReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddTodAccessReq',
            'UpdateTodAccessReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateTodAccessReq',
            'GetTodAccessReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetTodAccessReq',
            'GetTodAccessRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetTodAccessRes',
            'ListTodAccessReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListTodAccessReq',
            'ListTodAccessRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListTodAccessRes',
            'XVoiceMailPilot' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XVoiceMailPilot',
            'AddVoiceMailPilotReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddVoiceMailPilotReq',
            'UpdateVoiceMailPilotReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateVoiceMailPilotReq',
            'RemoveVoiceMailPilotReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveVoiceMailPilotReq',
            'GetVoiceMailPilotReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetVoiceMailPilotReq',
            'GetVoiceMailPilotRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetVoiceMailPilotRes',
            'ListVoiceMailPilotReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListVoiceMailPilotReq',
            'ListVoiceMailPilotRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListVoiceMailPilotRes',
            'XProcessNode' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XProcessNode',
            'AddProcessNodeReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddProcessNodeReq',
            'UpdateProcessNodeReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateProcessNodeReq',
            'GetProcessNodeReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetProcessNodeReq',
            'GetProcessNodeRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetProcessNodeRes',
            'ListProcessNodeReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListProcessNodeReq',
            'ListProcessNodeRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListProcessNodeRes',
            'XCallerFilterList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallerFilterList',
            'AddCallerFilterListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCallerFilterListReq',
            'UpdateCallerFilterListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCallerFilterListReq',
            'GetCallerFilterListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCallerFilterListReq',
            'GetCallerFilterListRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCallerFilterListRes',
            'ListCallerFilterListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCallerFilterListReq',
            'ListCallerFilterListRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCallerFilterListRes',
            'XRoutePartition' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XRoutePartition',
            'AddRoutePartitionReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddRoutePartitionReq',
            'UpdateRoutePartitionReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateRoutePartitionReq',
            'GetRoutePartitionReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetRoutePartitionReq',
            'GetRoutePartitionRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetRoutePartitionRes',
            'ListRoutePartitionReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRoutePartitionReq',
            'ListRoutePartitionRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRoutePartitionRes',
            'XCss' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCss',
            'AddCssReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCssReq',
            'UpdateCssReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCssReq',
            'GetCssReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCssReq',
            'GetCssRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCssRes',
            'ListCssReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCssReq',
            'ListCssRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCssRes',
            'XCallManager' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallManager',
            'autoRegistration' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AutoRegistration',
            'ports' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Ports',
            'mgcpPorts' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\MgcpPorts',
            'sipPorts' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\SipPorts',
            'UpdateCallManagerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCallManagerReq',
            'GetCallManagerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCallManagerReq',
            'GetCallManagerRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCallManagerRes',
            'ListCallManagerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCallManagerReq',
            'ListCallManagerRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCallManagerRes',
            'XMediaResourceGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XMediaResourceGroup',
            'AddMediaResourceGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddMediaResourceGroupReq',
            'UpdateMediaResourceGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateMediaResourceGroupReq',
            'GetMediaResourceGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMediaResourceGroupReq',
            'GetMediaResourceGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMediaResourceGroupRes',
            'ListMediaResourceGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListMediaResourceGroupReq',
            'ListMediaResourceGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListMediaResourceGroupRes',
            'XMediaResourceList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XMediaResourceList',
            'AddMediaResourceListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddMediaResourceListReq',
            'UpdateMediaResourceListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateMediaResourceListReq',
            'GetMediaResourceListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMediaResourceListReq',
            'GetMediaResourceListRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMediaResourceListRes',
            'ListMediaResourceListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListMediaResourceListReq',
            'ListMediaResourceListRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListMediaResourceListRes',
            'XRegion' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XRegion',
            'relatedRegions' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RelatedRegions',
            'AddRegionReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddRegionReq',
            'UpdateRegionReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateRegionReq',
            'GetRegionReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetRegionReq',
            'GetRegionRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetRegionRes',
            'ListRegionReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRegionReq',
            'ListRegionRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRegionRes',
            'XAarGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XAarGroup',
            'AddAarGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddAarGroupReq',
            'UpdateAarGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateAarGroupReq',
            'GetAarGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetAarGroupReq',
            'GetAarGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetAarGroupRes',
            'ListAarGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListAarGroupReq',
            'ListAarGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListAarGroupRes',
            'XPhysicalLocation' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XPhysicalLocation',
            'AddPhysicalLocationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddPhysicalLocationReq',
            'UpdatePhysicalLocationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdatePhysicalLocationReq',
            'GetPhysicalLocationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetPhysicalLocationReq',
            'GetPhysicalLocationRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetPhysicalLocationRes',
            'ListPhysicalLocationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListPhysicalLocationReq',
            'ListPhysicalLocationRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListPhysicalLocationRes',
            'XRouteGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XRouteGroup',
            'AddRouteGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddRouteGroupReq',
            'UpdateRouteGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateRouteGroupReq',
            'GetRouteGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetRouteGroupReq',
            'GetRouteGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetRouteGroupRes',
            'ListRouteGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRouteGroupReq',
            'ListRouteGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRouteGroupRes',
            'XDevicePool' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XDevicePool',
            'localRouteGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LocalRouteGroup',
            'AddDevicePoolReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddDevicePoolReq',
            'UpdateDevicePoolReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateDevicePoolReq',
            'GetDevicePoolReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDevicePoolReq',
            'GetDevicePoolRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDevicePoolRes',
            'ListDevicePoolReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDevicePoolReq',
            'ListDevicePoolRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDevicePoolRes',
            'XDeviceMobilityGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XDeviceMobilityGroup',
            'AddDeviceMobilityGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddDeviceMobilityGroupReq',
            'UpdateDeviceMobilityGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateDeviceMobilityGroupReq',
            'GetDeviceMobilityGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDeviceMobilityGroupReq',
            'GetDeviceMobilityGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDeviceMobilityGroupRes',
            'ListDeviceMobilityGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDeviceMobilityGroupReq',
            'ListDeviceMobilityGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDeviceMobilityGroupRes',
            'XLocation' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XLocation',
            'relatedLocations' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RelatedLocations',
            'betweenLocations' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\BetweenLocations',
            'AddLocationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddLocationReq',
            'UpdateLocationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateLocationReq',
            'GetLocationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLocationReq',
            'GetLocationRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLocationRes',
            'ListLocationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListLocationReq',
            'ListLocationRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListLocationRes',
            'XSoftKeyTemplate' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSoftKeyTemplate',
            'AddSoftKeyTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddSoftKeyTemplateReq',
            'UpdateSoftKeyTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSoftKeyTemplateReq',
            'GetSoftKeyTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSoftKeyTemplateReq',
            'GetSoftKeyTemplateRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSoftKeyTemplateRes',
            'ListSoftKeyTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSoftKeyTemplateReq',
            'ListSoftKeyTemplateRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSoftKeyTemplateRes',
            'XTranscoder' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XTranscoder',
            'AddTranscoderReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddTranscoderReq',
            'UpdateTranscoderReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateTranscoderReq',
            'GetTranscoderReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetTranscoderReq',
            'GetTranscoderRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetTranscoderRes',
            'ListTranscoderReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListTranscoderReq',
            'ListTranscoderRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListTranscoderRes',
            'XCommonDeviceConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCommonDeviceConfig',
            'confidentialAccess' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ConfidentialAccess',
            'AddCommonDeviceConfigReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCommonDeviceConfigReq',
            'UpdateCommonDeviceConfigReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCommonDeviceConfigReq',
            'GetCommonDeviceConfigReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCommonDeviceConfigReq',
            'GetCommonDeviceConfigRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCommonDeviceConfigRes',
            'ListCommonDeviceConfigReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCommonDeviceConfigReq',
            'ListCommonDeviceConfigRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCommonDeviceConfigRes',
            'XResourcePriorityNamespace' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XResourcePriorityNamespace',
            'AddResourcePriorityNamespaceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddResourcePriorityNamespaceReq',
            'UpdateResourcePriorityNamespaceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateResourcePriorityNamespaceReq',
            'RemoveResourcePriorityNamespaceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveResourcePriorityNamespaceReq',
            'GetResourcePriorityNamespaceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetResourcePriorityNamespaceReq',
            'GetResourcePriorityNamespaceRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetResourcePriorityNamespaceRes',
            'ListResourcePriorityNamespaceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListResourcePriorityNamespaceReq',
            'ListResourcePriorityNamespaceRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListResourcePriorityNamespaceRes',
            'ResetResourcePriorityNamespaceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ResetResourcePriorityNamespaceReq',
            'RestartResourcePriorityNamespaceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RestartResourcePriorityNamespaceReq',
            'ApplyResourcePriorityNamespaceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ApplyResourcePriorityNamespaceReq',
            'XResourcePriorityNamespaceList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XResourcePriorityNamespaceList',
            'AddResourcePriorityNamespaceListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddResourcePriorityNamespaceListReq',
            'UpdateResourcePriorityNamespaceListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateResourcePriorityNamespaceListReq',
            'GetResourcePriorityNamespaceListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetResourcePriorityNamespaceListReq',
            'GetResourcePriorityNamespaceListRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetResourcePriorityNamespaceListRes',
            'ListResourcePriorityNamespaceListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListResourcePriorityNamespaceListReq',
            'ListResourcePriorityNamespaceListRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListResourcePriorityNamespaceListRes',
            'XDeviceMobility' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XDeviceMobility',
            'AddDeviceMobilityReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddDeviceMobilityReq',
            'UpdateDeviceMobilityReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateDeviceMobilityReq',
            'GetDeviceMobilityReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDeviceMobilityReq',
            'GetDeviceMobilityRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDeviceMobilityRes',
            'ListDeviceMobilityReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDeviceMobilityReq',
            'ListDeviceMobilityRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDeviceMobilityRes',
            'XCmcInfo' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCmcInfo',
            'AddCmcInfoReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCmcInfoReq',
            'UpdateCmcInfoReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCmcInfoReq',
            'RemoveCmcInfoReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveCmcInfoReq',
            'GetCmcInfoReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCmcInfoReq',
            'GetCmcInfoRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCmcInfoRes',
            'ListCmcInfoReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCmcInfoReq',
            'ListCmcInfoRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCmcInfoRes',
            'XCredentialPolicy' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCredentialPolicy',
            'AddCredentialPolicyReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCredentialPolicyReq',
            'UpdateCredentialPolicyReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCredentialPolicyReq',
            'GetCredentialPolicyReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCredentialPolicyReq',
            'GetCredentialPolicyRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCredentialPolicyRes',
            'ListCredentialPolicyReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCredentialPolicyReq',
            'ListCredentialPolicyRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCredentialPolicyRes',
            'XFacInfo' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XFacInfo',
            'AddFacInfoReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddFacInfoReq',
            'UpdateFacInfoReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateFacInfoReq',
            'GetFacInfoReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetFacInfoReq',
            'GetFacInfoRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetFacInfoRes',
            'ListFacInfoReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListFacInfoReq',
            'ListFacInfoRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListFacInfoRes',
            'XHuntList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XHuntList',
            'AddHuntListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddHuntListReq',
            'UpdateHuntListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateHuntListReq',
            'GetHuntListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetHuntListReq',
            'GetHuntListRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetHuntListRes',
            'ListHuntListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListHuntListReq',
            'ListHuntListRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListHuntListRes',
            'XIvrUserLocale' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XIvrUserLocale',
            'AddIvrUserLocaleReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddIvrUserLocaleReq',
            'UpdateIvrUserLocaleReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateIvrUserLocaleReq',
            'RemoveIvrUserLocaleReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveIvrUserLocaleReq',
            'GetIvrUserLocaleReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetIvrUserLocaleReq',
            'GetIvrUserLocaleRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetIvrUserLocaleRes',
            'ListIvrUserLocaleReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListIvrUserLocaleReq',
            'ListIvrUserLocaleRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListIvrUserLocaleRes',
            'XLineGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XLineGroup',
            'AddLineGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddLineGroupReq',
            'UpdateLineGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateLineGroupReq',
            'GetLineGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLineGroupReq',
            'GetLineGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLineGroupRes',
            'ListLineGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListLineGroupReq',
            'ListLineGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListLineGroupRes',
            'XRecordingProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XRecordingProfile',
            'AddRecordingProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddRecordingProfileReq',
            'UpdateRecordingProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateRecordingProfileReq',
            'GetRecordingProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetRecordingProfileReq',
            'GetRecordingProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetRecordingProfileRes',
            'ListRecordingProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRecordingProfileReq',
            'ListRecordingProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRecordingProfileRes',
            'XRouteFilter' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XRouteFilter',
            'AddRouteFilterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddRouteFilterReq',
            'UpdateRouteFilterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateRouteFilterReq',
            'GetRouteFilterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetRouteFilterReq',
            'GetRouteFilterRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetRouteFilterRes',
            'ListRouteFilterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRouteFilterReq',
            'ListRouteFilterRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRouteFilterRes',
            'XCallManagerGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallManagerGroup',
            'AddCallManagerGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCallManagerGroupReq',
            'UpdateCallManagerGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCallManagerGroupReq',
            'GetCallManagerGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCallManagerGroupReq',
            'GetCallManagerGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCallManagerGroupRes',
            'ListCallManagerGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCallManagerGroupReq',
            'ListCallManagerGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCallManagerGroupRes',
            'XUserGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XUserGroup',
            'userRoles' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UserRoles',
            'AddUserGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddUserGroupReq',
            'UpdateUserGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateUserGroupReq',
            'removeUserRoles' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveUserRoles',
            'addUserRoles' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddUserRoles',
            'GetUserGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetUserGroupReq',
            'GetUserGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetUserGroupRes',
            'ListUserGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListUserGroupReq',
            'ListUserGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListUserGroupRes',
            'XDialPlan' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XDialPlan',
            'GetDialPlanReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDialPlanReq',
            'GetDialPlanRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDialPlanRes',
            'ListDialPlanReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDialPlanReq',
            'ListDialPlanRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDialPlanRes',
            'XDialPlanTag' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XDialPlanTag',
            'GetDialPlanTagReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDialPlanTagReq',
            'GetDialPlanTagRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDialPlanTagRes',
            'ListDialPlanTagReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDialPlanTagReq',
            'ListDialPlanTagRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDialPlanTagRes',
            'XDdi' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XDdi',
            'GetDdiReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDdiReq',
            'GetDdiRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDdiRes',
            'ListDdiReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDdiReq',
            'ListDdiRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDdiRes',
            'XMobileSmartClientProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XMobileSmartClientProfile',
            'GetMobileSmartClientProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMobileSmartClientProfileReq',
            'GetMobileSmartClientProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMobileSmartClientProfileRes',
            'ListMobileSmartClientProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListMobileSmartClientProfileReq',
            'ListMobileSmartClientProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListMobileSmartClientProfileRes',
            'XProcessNodeService' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XProcessNodeService',
            'UpdateProcessNodeServiceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateProcessNodeServiceReq',
            'GetProcessNodeServiceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetProcessNodeServiceReq',
            'GetProcessNodeServiceRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetProcessNodeServiceRes',
            'ListProcessNodeServiceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListProcessNodeServiceReq',
            'ListProcessNodeServiceRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListProcessNodeServiceRes',
            'XMohAudioSource' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XMohAudioSource',
            'UpdateMohAudioSourceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateMohAudioSourceReq',
            'RemoveMohAudioSourceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveMohAudioSourceReq',
            'GetMohAudioSourceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMohAudioSourceReq',
            'GetMohAudioSourceRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMohAudioSourceRes',
            'ListMohAudioSourceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListMohAudioSourceReq',
            'ListMohAudioSourceRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListMohAudioSourceRes',
            'XDhcpServer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XDhcpServer',
            'AddDhcpServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddDhcpServerReq',
            'UpdateDhcpServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateDhcpServerReq',
            'RemoveDhcpServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveDhcpServerReq',
            'GetDhcpServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDhcpServerReq',
            'GetDhcpServerRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDhcpServerRes',
            'ListDhcpServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDhcpServerReq',
            'ListDhcpServerRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDhcpServerRes',
            'XDhcpSubnet' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XDhcpSubnet',
            'AddDhcpSubnetReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddDhcpSubnetReq',
            'UpdateDhcpSubnetReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateDhcpSubnetReq',
            'RemoveDhcpSubnetReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveDhcpSubnetReq',
            'GetDhcpSubnetReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDhcpSubnetReq',
            'GetDhcpSubnetRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDhcpSubnetRes',
            'ListDhcpSubnetReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDhcpSubnetReq',
            'ListDhcpSubnetRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDhcpSubnetRes',
            'XCallPark' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallPark',
            'AddCallParkReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCallParkReq',
            'UpdateCallParkReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCallParkReq',
            'RemoveCallParkReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveCallParkReq',
            'GetCallParkReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCallParkReq',
            'GetCallParkRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCallParkRes',
            'ListCallParkReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCallParkReq',
            'ListCallParkRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCallParkRes',
            'XDirectedCallPark' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XDirectedCallPark',
            'AddDirectedCallParkReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddDirectedCallParkReq',
            'UpdateDirectedCallParkReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateDirectedCallParkReq',
            'RemoveDirectedCallParkReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveDirectedCallParkReq',
            'GetDirectedCallParkReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDirectedCallParkReq',
            'GetDirectedCallParkRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDirectedCallParkRes',
            'ListDirectedCallParkReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDirectedCallParkReq',
            'ListDirectedCallParkRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDirectedCallParkRes',
            'ResetDirectedCallParkReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ResetDirectedCallParkReq',
            'ApplyDirectedCallParkReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ApplyDirectedCallParkReq',
            'XMeetMe' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XMeetMe',
            'AddMeetMeReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddMeetMeReq',
            'UpdateMeetMeReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateMeetMeReq',
            'RemoveMeetMeReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveMeetMeReq',
            'GetMeetMeReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMeetMeReq',
            'GetMeetMeRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMeetMeRes',
            'ListMeetMeReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListMeetMeReq',
            'ListMeetMeRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListMeetMeRes',
            'XMobileVoiceAccess' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XMobileVoiceAccess',
            'locales' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Locales',
            'AddMobileVoiceAccessReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddMobileVoiceAccessReq',
            'UpdateMobileVoiceAccessReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateMobileVoiceAccessReq',
            'removeLocales' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveLocales',
            'addLocales' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddLocales',
            'RemoveMobileVoiceAccessReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveMobileVoiceAccessReq',
            'GetMobileVoiceAccessReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMobileVoiceAccessReq',
            'GetMobileVoiceAccessRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMobileVoiceAccessRes',
            'XRouteList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XRouteList',
            'AddRouteListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddRouteListReq',
            'UpdateRouteListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateRouteListReq',
            'GetRouteListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetRouteListReq',
            'GetRouteListRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetRouteListRes',
            'ListRouteListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRouteListReq',
            'ListRouteListRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRouteListRes',
            'XUser' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XUser',
            'associatedDevices' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AssociatedDevices',
            'primaryExtension' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\PrimaryExtension',
            'associatedGroups' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AssociatedGroups',
            'userGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UserGroup',
            'phoneProfiles' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\PhoneProfiles',
            'passwordCredentials' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\PasswordCredentials',
            'pinCredentials' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\PinCredentials',
            'ctiControlledDeviceProfiles' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\CtiControlledDeviceProfiles',
            'customUserFields' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\CustomUserFields',
            'lineAppearanceAssociationForPresences' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LineAppearanceAssociationForPresences',
            'extensionsInfo' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ExtensionsInfo',
            'AddUserReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddUserReq',
            'UpdateUserReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateUserReq',
            'removeExtensionsInfo' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveExtensionsInfo',
            'addExtensionsInfo' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddExtensionsInfo',
            'RemoveUserReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveUserReq',
            'GetUserReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetUserReq',
            'GetUserRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetUserRes',
            'ListUserReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListUserReq',
            'ListUserRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListUserRes',
            'XAppUser' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XAppUser',
            'AddAppUserReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddAppUserReq',
            'UpdateAppUserReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateAppUserReq',
            'RemoveAppUserReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveAppUserReq',
            'GetAppUserReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetAppUserReq',
            'GetAppUserRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetAppUserRes',
            'ListAppUserReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListAppUserReq',
            'ListAppUserRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListAppUserRes',
            'XSipRealm' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSipRealm',
            'AddSipRealmReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddSipRealmReq',
            'UpdateSipRealmReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSipRealmReq',
            'RemoveSipRealmReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveSipRealmReq',
            'GetSipRealmReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSipRealmReq',
            'GetSipRealmRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSipRealmRes',
            'ListSipRealmReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSipRealmReq',
            'ListSipRealmRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSipRealmRes',
            'XPhoneNtp' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XPhoneNtp',
            'AddPhoneNtpReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddPhoneNtpReq',
            'UpdatePhoneNtpReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdatePhoneNtpReq',
            'RemovePhoneNtpReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemovePhoneNtpReq',
            'GetPhoneNtpReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetPhoneNtpReq',
            'GetPhoneNtpRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetPhoneNtpRes',
            'ListPhoneNtpReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListPhoneNtpReq',
            'ListPhoneNtpRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListPhoneNtpRes',
            'XDateTimeGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XDateTimeGroup',
            'phoneNtpReferences' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\PhoneNtpReferences',
            'AddDateTimeGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddDateTimeGroupReq',
            'UpdateDateTimeGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateDateTimeGroupReq',
            'removePhoneNtpReferences' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemovePhoneNtpReferences',
            'addPhoneNtpReferences' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddPhoneNtpReferences',
            'GetDateTimeGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDateTimeGroupReq',
            'GetDateTimeGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDateTimeGroupRes',
            'ListDateTimeGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDateTimeGroupReq',
            'ListDateTimeGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDateTimeGroupRes',
            'XPresenceGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XPresenceGroup',
            'presenceGroups' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\PresenceGroups',
            'AddPresenceGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddPresenceGroupReq',
            'UpdatePresenceGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdatePresenceGroupReq',
            'GetPresenceGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetPresenceGroupReq',
            'GetPresenceGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetPresenceGroupRes',
            'ListPresenceGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListPresenceGroupReq',
            'ListPresenceGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListPresenceGroupRes',
            'XGeoLocation' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XGeoLocation',
            'AddGeoLocationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddGeoLocationReq',
            'UpdateGeoLocationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateGeoLocationReq',
            'GetGeoLocationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetGeoLocationReq',
            'GetGeoLocationRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetGeoLocationRes',
            'ListGeoLocationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListGeoLocationReq',
            'ListGeoLocationRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListGeoLocationRes',
            'XSrst' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSrst',
            'AddSrstReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddSrstReq',
            'UpdateSrstReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSrstReq',
            'GetSrstReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSrstReq',
            'GetSrstRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSrstRes',
            'ListSrstReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSrstReq',
            'ListSrstRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSrstRes',
            'XMlppDomain' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XMlppDomain',
            'AddMlppDomainReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddMlppDomainReq',
            'UpdateMlppDomainReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateMlppDomainReq',
            'RemoveMlppDomainReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveMlppDomainReq',
            'GetMlppDomainReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMlppDomainReq',
            'GetMlppDomainRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMlppDomainRes',
            'ListMlppDomainReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListMlppDomainReq',
            'ListMlppDomainRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListMlppDomainRes',
            'XCumaServerSecurityProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCumaServerSecurityProfile',
            'AddCumaServerSecurityProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCumaServerSecurityProfileReq',
            'UpdateCumaServerSecurityProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCumaServerSecurityProfileReq',
            'GetCumaServerSecurityProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCumaServerSecurityProfileReq',
            'GetCumaServerSecurityProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCumaServerSecurityProfileRes',
            'ListCumaServerSecurityProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCumaServerSecurityProfileReq',
            'ListCumaServerSecurityProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCumaServerSecurityProfileRes',
            'XApplicationServer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XApplicationServer',
            'appUsers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AppUsers',
            'selectedAppUser' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\SelectedAppUser',
            'endUsers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\EndUsers',
            'selectedEndUser' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\SelectedEndUser',
            'AddApplicationServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddApplicationServerReq',
            'UpdateApplicationServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateApplicationServerReq',
            'removeAppUsers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveAppUsers',
            'addAppUsers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddAppUsers',
            'removeEndUsers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveEndUsers',
            'addEndUsers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddEndUsers',
            'RemoveApplicationServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveApplicationServerReq',
            'GetApplicationServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetApplicationServerReq',
            'GetApplicationServerRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetApplicationServerRes',
            'ListApplicationServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListApplicationServerReq',
            'ListApplicationServerRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListApplicationServerRes',
            'XApplicationUserCapfProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XApplicationUserCapfProfile',
            'AddApplicationUserCapfProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddApplicationUserCapfProfileReq',
            'UpdateApplicationUserCapfProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateApplicationUserCapfProfileReq',
            'RemoveApplicationUserCapfProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveApplicationUserCapfProfileReq',
            'GetApplicationUserCapfProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetApplicationUserCapfProfileReq',
            'GetApplicationUserCapfProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetApplicationUserCapfProfileRes',
            'ListApplicationUserCapfProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListApplicationUserCapfProfileReq',
            'ListApplicationUserCapfProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListApplicationUserCapfProfileRes',
            'XEndUserCapfProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XEndUserCapfProfile',
            'AddEndUserCapfProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddEndUserCapfProfileReq',
            'UpdateEndUserCapfProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateEndUserCapfProfileReq',
            'RemoveEndUserCapfProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveEndUserCapfProfileReq',
            'GetEndUserCapfProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetEndUserCapfProfileReq',
            'GetEndUserCapfProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetEndUserCapfProfileRes',
            'ListEndUserCapfProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListEndUserCapfProfileReq',
            'ListEndUserCapfProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListEndUserCapfProfileRes',
            'XServiceParameter' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XServiceParameter',
            'UpdateServiceParameterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateServiceParameterReq',
            'GetServiceParameterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetServiceParameterReq',
            'GetServiceParameterRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetServiceParameterRes',
            'ListServiceParameterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListServiceParameterReq',
            'ListServiceParameterRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListServiceParameterRes',
            'XUserPhoneAssociation' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XUserPhoneAssociation',
            'AddUserPhoneAssociationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddUserPhoneAssociationReq',
            'XGeoLocationFilter' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XGeoLocationFilter',
            'AddGeoLocationFilterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddGeoLocationFilterReq',
            'UpdateGeoLocationFilterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateGeoLocationFilterReq',
            'GetGeoLocationFilterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetGeoLocationFilterReq',
            'GetGeoLocationFilterRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetGeoLocationFilterRes',
            'ListGeoLocationFilterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListGeoLocationFilterReq',
            'ListGeoLocationFilterRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListGeoLocationFilterRes',
            'XVoiceMailProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XVoiceMailProfile',
            'AddVoiceMailProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddVoiceMailProfileReq',
            'UpdateVoiceMailProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateVoiceMailProfileReq',
            'GetVoiceMailProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetVoiceMailProfileReq',
            'GetVoiceMailProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetVoiceMailProfileRes',
            'ListVoiceMailProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListVoiceMailProfileReq',
            'ListVoiceMailProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListVoiceMailProfileRes',
            'XVoiceMailPort' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XVoiceMailPort',
            'AddVoiceMailPortReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddVoiceMailPortReq',
            'UpdateVoiceMailPortReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateVoiceMailPortReq',
            'GetVoiceMailPortReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetVoiceMailPortReq',
            'GetVoiceMailPortRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetVoiceMailPortRes',
            'ListVoiceMailPortReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListVoiceMailPortReq',
            'ListVoiceMailPortRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListVoiceMailPortRes',
            'XGatekeeper' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XGatekeeper',
            'AddGatekeeperReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddGatekeeperReq',
            'UpdateGatekeeperReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateGatekeeperReq',
            'GetGatekeeperReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetGatekeeperReq',
            'GetGatekeeperRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetGatekeeperRes',
            'ListGatekeeperReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListGatekeeperReq',
            'ListGatekeeperRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListGatekeeperRes',
            'XPhoneButtonTemplate' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XPhoneButtonTemplate',
            'buttons' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Buttons',
            'AddPhoneButtonTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddPhoneButtonTemplateReq',
            'UpdatePhoneButtonTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdatePhoneButtonTemplateReq',
            'GetPhoneButtonTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetPhoneButtonTemplateReq',
            'GetPhoneButtonTemplateRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetPhoneButtonTemplateRes',
            'ListPhoneButtonTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListPhoneButtonTemplateReq',
            'ListPhoneButtonTemplateRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListPhoneButtonTemplateRes',
            'XCommonPhoneConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCommonPhoneConfig',
            'AddCommonPhoneConfigReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCommonPhoneConfigReq',
            'UpdateCommonPhoneConfigReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCommonPhoneConfigReq',
            'GetCommonPhoneConfigReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCommonPhoneConfigReq',
            'GetCommonPhoneConfigRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCommonPhoneConfigRes',
            'ListCommonPhoneConfigReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCommonPhoneConfigReq',
            'ListCommonPhoneConfigRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCommonPhoneConfigRes',
            'XMessageWaiting' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XMessageWaiting',
            'AddMessageWaitingReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddMessageWaitingReq',
            'UpdateMessageWaitingReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateMessageWaitingReq',
            'RemoveMessageWaitingReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveMessageWaitingReq',
            'GetMessageWaitingReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMessageWaitingReq',
            'GetMessageWaitingRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMessageWaitingRes',
            'ListMessageWaitingReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListMessageWaitingReq',
            'ListMessageWaitingRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListMessageWaitingRes',
            'XIpPhoneServices' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XIpPhoneServices',
            'parameters' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Parameters',
            'AddIpPhoneServicesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddIpPhoneServicesReq',
            'UpdateIpPhoneServicesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateIpPhoneServicesReq',
            'removeParameters' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveParameters',
            'addParameters' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddParameters',
            'RemoveIpPhoneServicesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveIpPhoneServicesReq',
            'GetIpPhoneServicesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetIpPhoneServicesReq',
            'GetIpPhoneServicesRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetIpPhoneServicesRes',
            'ListIpPhoneServicesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListIpPhoneServicesReq',
            'ListIpPhoneServicesRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListIpPhoneServicesRes',
            'XCtiRoutePoint' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCtiRoutePoint',
            'lines' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Lines',
            'AddCtiRoutePointReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCtiRoutePointReq',
            'UpdateCtiRoutePointReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCtiRoutePointReq',
            'GetCtiRoutePointReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCtiRoutePointReq',
            'GetCtiRoutePointRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCtiRoutePointRes',
            'ListCtiRoutePointReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCtiRoutePointReq',
            'ListCtiRoutePointRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCtiRoutePointRes',
            'XTransPattern' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XTransPattern',
            'AddTransPatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddTransPatternReq',
            'UpdateTransPatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateTransPatternReq',
            'RemoveTransPatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveTransPatternReq',
            'GetTransPatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetTransPatternReq',
            'GetTransPatternRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetTransPatternRes',
            'ListTransPatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListTransPatternReq',
            'ListTransPatternRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListTransPatternRes',
            'GetTransPatternOptionsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetTransPatternOptionsReq',
            'GetTransPatternOptionsRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetTransPatternOptionsRes',
            'XCallingPartyTransformationPattern' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallingPartyTransformationPattern',
            'AddCallingPartyTransformationPatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCallingPartyTransformationPatternReq',
            'UpdateCallingPartyTransformationPatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCallingPartyTransformationPatternReq',
            'RemoveCallingPartyTransformationPatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveCallingPartyTransformationPatternReq',
            'GetCallingPartyTransformationPatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCallingPartyTransformationPatternReq',
            'GetCallingPartyTransformationPatternRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCallingPartyTransformationPatternRes',
            'ListCallingPartyTransformationPatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCallingPartyTransformationPatternReq',
            'ListCallingPartyTransformationPatternRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCallingPartyTransformationPatternRes',
            'XSipRoutePattern' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSipRoutePattern',
            'AddSipRoutePatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddSipRoutePatternReq',
            'UpdateSipRoutePatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSipRoutePatternReq',
            'RemoveSipRoutePatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveSipRoutePatternReq',
            'GetSipRoutePatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSipRoutePatternReq',
            'GetSipRoutePatternRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSipRoutePatternRes',
            'ListSipRoutePatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSipRoutePatternReq',
            'ListSipRoutePatternRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSipRoutePatternRes',
            'XHuntPilot' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XHuntPilot',
            'parkMonForwardNoRetrieve' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ParkMonForwardNoRetrieve',
            'forwardHuntNoAnswer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ForwardHuntNoAnswer',
            'forwardHuntBusy' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ForwardHuntBusy',
            'AddHuntPilotReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddHuntPilotReq',
            'UpdateHuntPilotReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateHuntPilotReq',
            'RemoveHuntPilotReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveHuntPilotReq',
            'GetHuntPilotReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetHuntPilotReq',
            'GetHuntPilotRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetHuntPilotRes',
            'ListHuntPilotReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListHuntPilotReq',
            'ListHuntPilotRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListHuntPilotRes',
            'XRoutePattern' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XRoutePattern',
            'destination' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Destination',
            'isdnNsfInfoElement' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\IsdnNsfInfoElement',
            'AddRoutePatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddRoutePatternReq',
            'UpdateRoutePatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateRoutePatternReq',
            'RemoveRoutePatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveRoutePatternReq',
            'GetRoutePatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetRoutePatternReq',
            'GetRoutePatternRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetRoutePatternRes',
            'ListRoutePatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRoutePatternReq',
            'ListRoutePatternRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRoutePatternRes',
            'XApplicationDialRules' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XApplicationDialRules',
            'AddApplicationDialRulesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddApplicationDialRulesReq',
            'UpdateApplicationDialRulesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateApplicationDialRulesReq',
            'GetApplicationDialRulesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetApplicationDialRulesReq',
            'GetApplicationDialRulesRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetApplicationDialRulesRes',
            'ListApplicationDialRulesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListApplicationDialRulesReq',
            'ListApplicationDialRulesRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListApplicationDialRulesRes',
            'XDirectoryLookupDialRules' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XDirectoryLookupDialRules',
            'AddDirectoryLookupDialRulesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddDirectoryLookupDialRulesReq',
            'UpdateDirectoryLookupDialRulesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateDirectoryLookupDialRulesReq',
            'GetDirectoryLookupDialRulesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDirectoryLookupDialRulesReq',
            'GetDirectoryLookupDialRulesRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDirectoryLookupDialRulesRes',
            'ListDirectoryLookupDialRulesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDirectoryLookupDialRulesReq',
            'ListDirectoryLookupDialRulesRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDirectoryLookupDialRulesRes',
            'XPhoneSecurityProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XPhoneSecurityProfile',
            'AddPhoneSecurityProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddPhoneSecurityProfileReq',
            'UpdatePhoneSecurityProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdatePhoneSecurityProfileReq',
            'GetPhoneSecurityProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetPhoneSecurityProfileReq',
            'GetPhoneSecurityProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetPhoneSecurityProfileRes',
            'ListPhoneSecurityProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListPhoneSecurityProfileReq',
            'ListPhoneSecurityProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListPhoneSecurityProfileRes',
            'XSipDialRules' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSipDialRules',
            'patterns' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Patterns',
            'plars' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Plars',
            'AddSipDialRulesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddSipDialRulesReq',
            'UpdateSipDialRulesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSipDialRulesReq',
            'removePatterns' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemovePatterns',
            'addPatterns' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddPatterns',
            'removePlars' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemovePlars',
            'addPlars' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddPlars',
            'GetSipDialRulesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSipDialRulesReq',
            'GetSipDialRulesRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSipDialRulesRes',
            'ListSipDialRulesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSipDialRulesReq',
            'ListSipDialRulesRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSipDialRulesRes',
            'XConferenceBridge' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XConferenceBridge',
            'normalizationScriptInfos' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\NormalizationScriptInfos',
            'addresses' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Addresses',
            'AddConferenceBridgeReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddConferenceBridgeReq',
            'UpdateConferenceBridgeReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateConferenceBridgeReq',
            'GetConferenceBridgeReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetConferenceBridgeReq',
            'GetConferenceBridgeRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetConferenceBridgeRes',
            'ListConferenceBridgeReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListConferenceBridgeReq',
            'ListConferenceBridgeRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListConferenceBridgeRes',
            'XAnnunciator' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XAnnunciator',
            'UpdateAnnunciatorReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateAnnunciatorReq',
            'GetAnnunciatorReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetAnnunciatorReq',
            'GetAnnunciatorRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetAnnunciatorRes',
            'ListAnnunciatorReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListAnnunciatorReq',
            'ListAnnunciatorRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListAnnunciatorRes',
            'XMtp' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XMtp',
            'AddMtpReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddMtpReq',
            'UpdateMtpReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateMtpReq',
            'GetMtpReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMtpReq',
            'GetMtpRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMtpRes',
            'ListMtpReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListMtpReq',
            'ListMtpRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListMtpRes',
            'XFixedMohAudioSource' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XFixedMohAudioSource',
            'UpdateFixedMohAudioSourceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateFixedMohAudioSourceReq',
            'GetFixedMohAudioSourceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetFixedMohAudioSourceReq',
            'GetFixedMohAudioSourceRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetFixedMohAudioSourceRes',
            'XAarGroupMatrix' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XAarGroupMatrix',
            'UpdateAarGroupMatrixReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateAarGroupMatrixReq',
            'XRemoteDestinationProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XRemoteDestinationProfile',
            'AddRemoteDestinationProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddRemoteDestinationProfileReq',
            'UpdateRemoteDestinationProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateRemoteDestinationProfileReq',
            'GetRemoteDestinationProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetRemoteDestinationProfileReq',
            'GetRemoteDestinationProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetRemoteDestinationProfileRes',
            'ListRemoteDestinationProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRemoteDestinationProfileReq',
            'ListRemoteDestinationProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRemoteDestinationProfileRes',
            'XLine' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XLine',
            'directoryURIs' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\DirectoryURIs',
            'enterpriseAltNum' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\EnterpriseAltNum',
            'e164AltNum' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\E164AltNum',
            'AddLineReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddLineReq',
            'UpdateLineReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateLineReq',
            'RemoveLineReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveLineReq',
            'GetLineReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLineReq',
            'GetLineRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLineRes',
            'ListLineReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListLineReq',
            'ListLineRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListLineRes',
            'ResetLineReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ResetLineReq',
            'RestartLineReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RestartLineReq',
            'ApplyLineReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ApplyLineReq',
            'GetLineOptionsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLineOptionsReq',
            'GetLineOptionsRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLineOptionsRes',
            'XDefaultDeviceProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XDefaultDeviceProfile',
            'AddDefaultDeviceProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddDefaultDeviceProfileReq',
            'UpdateDefaultDeviceProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateDefaultDeviceProfileReq',
            'GetDefaultDeviceProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDefaultDeviceProfileReq',
            'GetDefaultDeviceProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDefaultDeviceProfileRes',
            'ListDefaultDeviceProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDefaultDeviceProfileReq',
            'ListDefaultDeviceProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDefaultDeviceProfileRes',
            'XH323Phone' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XH323Phone',
            'gateKeeperInfo' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GateKeeperInfo',
            'AddH323PhoneReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddH323PhoneReq',
            'UpdateH323PhoneReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateH323PhoneReq',
            'GetH323PhoneReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetH323PhoneReq',
            'GetH323PhoneRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetH323PhoneRes',
            'ListH323PhoneReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListH323PhoneReq',
            'ListH323PhoneRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListH323PhoneRes',
            'XMohServer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XMohServer',
            'audioSources' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AudioSources',
            'audioSource' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AudioSource',
            'UpdateMohServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateMohServerReq',
            'GetMohServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMohServerReq',
            'GetMohServerRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMohServerRes',
            'ListMohServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListMohServerReq',
            'ListMohServerRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListMohServerRes',
            'XH323Trunk' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XH323Trunk',
            'sigDigits' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\SigDigits',
            'destinations' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Destinations',
            'AddH323TrunkReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddH323TrunkReq',
            'UpdateH323TrunkReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateH323TrunkReq',
            'removeDestinations' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveDestinations',
            'addDestinations' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddDestinations',
            'GetH323TrunkReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetH323TrunkReq',
            'GetH323TrunkRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetH323TrunkRes',
            'ListH323TrunkReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListH323TrunkReq',
            'ListH323TrunkRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListH323TrunkRes',
            'XPhone' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XPhone',
            'speeddials' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Speeddials',
            'busyLampFields' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\BusyLampFields',
            'blfDirectedCallParks' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\BlfDirectedCallParks',
            'addOnModules' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddOnModules',
            'services' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Services',
            'AddPhoneReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddPhoneReq',
            'UpdatePhoneReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdatePhoneReq',
            'removeLines' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveLines',
            'addLines' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddLines',
            'GetPhoneReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetPhoneReq',
            'GetPhoneRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetPhoneRes',
            'ListPhoneReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListPhoneReq',
            'ListPhoneRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListPhoneRes',
            'GetPhoneOptionsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetPhoneOptionsReq',
            'GetPhoneOptionsRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetPhoneOptionsRes',
            'XH323Gateway' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XH323Gateway',
            'AddH323GatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddH323GatewayReq',
            'UpdateH323GatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateH323GatewayReq',
            'GetH323GatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetH323GatewayReq',
            'GetH323GatewayRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetH323GatewayRes',
            'ListH323GatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListH323GatewayReq',
            'ListH323GatewayRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListH323GatewayRes',
            'XDeviceProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XDeviceProfile',
            'AddDeviceProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddDeviceProfileReq',
            'UpdateDeviceProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateDeviceProfileReq',
            'GetDeviceProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDeviceProfileReq',
            'GetDeviceProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDeviceProfileRes',
            'ListDeviceProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDeviceProfileReq',
            'ListDeviceProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDeviceProfileRes',
            'GetDeviceProfileOptionsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDeviceProfileOptionsReq',
            'GetDeviceProfileOptionsRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDeviceProfileOptionsRes',
            'XRemoteDestination' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XRemoteDestination',
            'lineAssociations' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LineAssociations',
            'AddRemoteDestinationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddRemoteDestinationReq',
            'UpdateRemoteDestinationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateRemoteDestinationReq',
            'RemoveRemoteDestinationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveRemoteDestinationReq',
            'GetRemoteDestinationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetRemoteDestinationReq',
            'GetRemoteDestinationRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetRemoteDestinationRes',
            'ListRemoteDestinationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRemoteDestinationReq',
            'ListRemoteDestinationRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRemoteDestinationRes',
            'XVg224' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XVg224',
            'units' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Units',
            'unit' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Unit',
            'subunits' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Subunits',
            'subunit' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Subunit',
            'AddVg224Req' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddVg224Req',
            'UpdateVg224Req' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateVg224Req',
            'RemoveVg224Req' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveVg224Req',
            'GetVg224Req' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetVg224Req',
            'GetVg224Res' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetVg224Res',
            'XGateway' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XGateway',
            'AddGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddGatewayReq',
            'UpdateGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateGatewayReq',
            'RemoveGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveGatewayReq',
            'GetGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetGatewayReq',
            'GetGatewayRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetGatewayRes',
            'ListGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListGatewayReq',
            'ListGatewayRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListGatewayRes',
            'ResetGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ResetGatewayReq',
            'ApplyGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ApplyGatewayReq',
            'XGatewayEndpointAnalogAccess' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XGatewayEndpointAnalogAccess',
            'AddGatewayEndpointAnalogAccessReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddGatewayEndpointAnalogAccessReq',
            'UpdateGatewayEndpointAnalogAccessReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateGatewayEndpointAnalogAccessReq',
            'GetGatewayEndpointAnalogAccessReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetGatewayEndpointAnalogAccessReq',
            'GetGatewayEndpointAnalogAccessRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetGatewayEndpointAnalogAccessRes',
            'XGatewayEndpointDigitalAccessPri' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XGatewayEndpointDigitalAccessPri',
            'AddGatewayEndpointDigitalAccessPriReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddGatewayEndpointDigitalAccessPriReq',
            'UpdateGatewayEndpointDigitalAccessPriReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateGatewayEndpointDigitalAccessPriReq',
            'GetGatewayEndpointDigitalAccessPriReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetGatewayEndpointDigitalAccessPriReq',
            'GetGatewayEndpointDigitalAccessPriRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetGatewayEndpointDigitalAccessPriRes',
            'XGatewayEndpointDigitalAccessBri' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XGatewayEndpointDigitalAccessBri',
            'AddGatewayEndpointDigitalAccessBriReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddGatewayEndpointDigitalAccessBriReq',
            'UpdateGatewayEndpointDigitalAccessBriReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateGatewayEndpointDigitalAccessBriReq',
            'GetGatewayEndpointDigitalAccessBriReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetGatewayEndpointDigitalAccessBriReq',
            'GetGatewayEndpointDigitalAccessBriRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetGatewayEndpointDigitalAccessBriRes',
            'XGatewayEndpointDigitalAccessT1' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XGatewayEndpointDigitalAccessT1',
            'AddGatewayEndpointDigitalAccessT1Req' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddGatewayEndpointDigitalAccessT1Req',
            'UpdateGatewayEndpointDigitalAccessT1Req' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateGatewayEndpointDigitalAccessT1Req',
            'GetGatewayEndpointDigitalAccessT1Req' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetGatewayEndpointDigitalAccessT1Req',
            'GetGatewayEndpointDigitalAccessT1Res' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetGatewayEndpointDigitalAccessT1Res',
            'XCiscoCatalyst600024PortFXSGateway' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCiscoCatalyst600024PortFXSGateway',
            'AddCiscoCatalyst600024PortFXSGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCiscoCatalyst600024PortFXSGatewayReq',
            'UpdateCiscoCatalyst600024PortFXSGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCiscoCatalyst600024PortFXSGatewayReq',
            'GetCiscoCatalyst600024PortFXSGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCiscoCatalyst600024PortFXSGatewayReq',
            'GetCiscoCatalyst600024PortFXSGatewayRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCiscoCatalyst600024PortFXSGatewayRes',
            'ListCiscoCatalyst600024PortFXSGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCiscoCatalyst600024PortFXSGatewayReq',
            'ListCiscoCatalyst600024PortFXSGatewayRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCiscoCatalyst600024PortFXSGatewayRes',
            'XCiscoCatalyst6000E1VoIPGateway' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCiscoCatalyst6000E1VoIPGateway',
            'AddCiscoCatalyst6000E1VoIPGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCiscoCatalyst6000E1VoIPGatewayReq',
            'UpdateCiscoCatalyst6000E1VoIPGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCiscoCatalyst6000E1VoIPGatewayReq',
            'GetCiscoCatalyst6000E1VoIPGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCiscoCatalyst6000E1VoIPGatewayReq',
            'GetCiscoCatalyst6000E1VoIPGatewayRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCiscoCatalyst6000E1VoIPGatewayRes',
            'ListCiscoCatalyst6000E1VoIPGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCiscoCatalyst6000E1VoIPGatewayReq',
            'ListCiscoCatalyst6000E1VoIPGatewayRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCiscoCatalyst6000E1VoIPGatewayRes',
            'XCiscoCatalyst6000T1VoIPGatewayPri' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCiscoCatalyst6000T1VoIPGatewayPri',
            'AddCiscoCatalyst6000T1VoIPGatewayPriReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCiscoCatalyst6000T1VoIPGatewayPriReq',
            'UpdateCiscoCatalyst6000T1VoIPGatewayPriReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCiscoCatalyst6000T1VoIPGatewayPriReq',
            'GetCiscoCatalyst6000T1VoIPGatewayPriReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCiscoCatalyst6000T1VoIPGatewayPriReq',
            'GetCiscoCatalyst6000T1VoIPGatewayPriRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCiscoCatalyst6000T1VoIPGatewayPriRes',
            'ListCiscoCatalyst6000T1VoIPGatewayPriReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCiscoCatalyst6000T1VoIPGatewayPriReq',
            'ListCiscoCatalyst6000T1VoIPGatewayPriRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCiscoCatalyst6000T1VoIPGatewayPriRes',
            'XCiscoCatalyst6000T1VoIPGatewayT1' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCiscoCatalyst6000T1VoIPGatewayT1',
            'AddCiscoCatalyst6000T1VoIPGatewayT1Req' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCiscoCatalyst6000T1VoIPGatewayT1Req',
            'UpdateCiscoCatalyst6000T1VoIPGatewayT1Req' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCiscoCatalyst6000T1VoIPGatewayT1Req',
            'GetCiscoCatalyst6000T1VoIPGatewayT1Req' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCiscoCatalyst6000T1VoIPGatewayT1Req',
            'GetCiscoCatalyst6000T1VoIPGatewayT1Res' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCiscoCatalyst6000T1VoIPGatewayT1Res',
            'ListCiscoCatalyst6000T1VoIPGatewayT1Req' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCiscoCatalyst6000T1VoIPGatewayT1Req',
            'ListCiscoCatalyst6000T1VoIPGatewayT1Res' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCiscoCatalyst6000T1VoIPGatewayT1Res',
            'XCallPickupGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallPickupGroup',
            'callInfoForPickupNotification' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\CallInfoForPickupNotification',
            'AddCallPickupGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCallPickupGroupReq',
            'UpdateCallPickupGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCallPickupGroupReq',
            'RemoveCallPickupGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveCallPickupGroupReq',
            'GetCallPickupGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCallPickupGroupReq',
            'GetCallPickupGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCallPickupGroupRes',
            'ListCallPickupGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCallPickupGroupReq',
            'ListCallPickupGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCallPickupGroupRes',
            'XRoutePlan' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XRoutePlan',
            'ListRoutePlanReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRoutePlanReq',
            'ListRoutePlanRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRoutePlanRes',
            'XGeoLocationPolicy' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XGeoLocationPolicy',
            'relatedPolicies' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RelatedPolicies',
            'AddGeoLocationPolicyReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddGeoLocationPolicyReq',
            'UpdateGeoLocationPolicyReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateGeoLocationPolicyReq',
            'removeRelatedPolicies' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveRelatedPolicies',
            'addRelatedPolicies' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddRelatedPolicies',
            'GetGeoLocationPolicyReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetGeoLocationPolicyReq',
            'GetGeoLocationPolicyRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetGeoLocationPolicyRes',
            'ListGeoLocationPolicyReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListGeoLocationPolicyReq',
            'ListGeoLocationPolicyRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListGeoLocationPolicyRes',
            'XSipTrunk' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSipTrunk',
            'AddSipTrunkReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddSipTrunkReq',
            'UpdateSipTrunkReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSipTrunkReq',
            'GetSipTrunkReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSipTrunkReq',
            'GetSipTrunkRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSipTrunkRes',
            'ListSipTrunkReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSipTrunkReq',
            'ListSipTrunkRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSipTrunkRes',
            'XRegionMatrix' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XRegionMatrix',
            'UpdateRegionMatrixReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateRegionMatrixReq',
            'XCalledPartyTransformationPattern' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCalledPartyTransformationPattern',
            'AddCalledPartyTransformationPatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCalledPartyTransformationPatternReq',
            'UpdateCalledPartyTransformationPatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCalledPartyTransformationPatternReq',
            'RemoveCalledPartyTransformationPatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveCalledPartyTransformationPatternReq',
            'GetCalledPartyTransformationPatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCalledPartyTransformationPatternReq',
            'GetCalledPartyTransformationPatternRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCalledPartyTransformationPatternRes',
            'ListCalledPartyTransformationPatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCalledPartyTransformationPatternReq',
            'ListCalledPartyTransformationPatternRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCalledPartyTransformationPatternRes',
            'XExternalCallControlProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XExternalCallControlProfile',
            'AddExternalCallControlProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddExternalCallControlProfileReq',
            'UpdateExternalCallControlProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateExternalCallControlProfileReq',
            'GetExternalCallControlProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetExternalCallControlProfileReq',
            'GetExternalCallControlProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetExternalCallControlProfileRes',
            'ListExternalCallControlProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListExternalCallControlProfileReq',
            'ListExternalCallControlProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListExternalCallControlProfileRes',
            'XSafSecurityProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSafSecurityProfile',
            'AddSafSecurityProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddSafSecurityProfileReq',
            'UpdateSafSecurityProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSafSecurityProfileReq',
            'GetSafSecurityProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSafSecurityProfileReq',
            'GetSafSecurityProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSafSecurityProfileRes',
            'ListSafSecurityProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSafSecurityProfileReq',
            'ListSafSecurityProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSafSecurityProfileRes',
            'XSafForwarder' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSafForwarder',
            'associatedCucms' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AssociatedCucms',
            'AddSafForwarderReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddSafForwarderReq',
            'UpdateSafForwarderReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSafForwarderReq',
            'removeAssociatedCucms' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveAssociatedCucms',
            'addAssociatedCucms' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddAssociatedCucms',
            'GetSafForwarderReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSafForwarderReq',
            'GetSafForwarderRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSafForwarderRes',
            'ListSafForwarderReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSafForwarderReq',
            'ListSafForwarderRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSafForwarderRes',
            'XCcdHostedDN' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCcdHostedDN',
            'AddCcdHostedDNReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCcdHostedDNReq',
            'UpdateCcdHostedDNReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCcdHostedDNReq',
            'RemoveCcdHostedDNReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveCcdHostedDNReq',
            'GetCcdHostedDNReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCcdHostedDNReq',
            'GetCcdHostedDNRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCcdHostedDNRes',
            'ListCcdHostedDNReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCcdHostedDNReq',
            'ListCcdHostedDNRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCcdHostedDNRes',
            'XCcdHostedDNGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCcdHostedDNGroup',
            'AddCcdHostedDNGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCcdHostedDNGroupReq',
            'UpdateCcdHostedDNGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCcdHostedDNGroupReq',
            'GetCcdHostedDNGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCcdHostedDNGroupReq',
            'GetCcdHostedDNGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCcdHostedDNGroupRes',
            'ListCcdHostedDNGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCcdHostedDNGroupReq',
            'ListCcdHostedDNGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCcdHostedDNGroupRes',
            'XCcdRequestingService' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCcdRequestingService',
            'associatedTrunks' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AssociatedTrunks',
            'AddCcdRequestingServiceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCcdRequestingServiceReq',
            'UpdateCcdRequestingServiceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCcdRequestingServiceReq',
            'removeAssociatedTrunks' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveAssociatedTrunks',
            'addAssociatedTrunks' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddAssociatedTrunks',
            'GetCcdRequestingServiceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCcdRequestingServiceReq',
            'GetCcdRequestingServiceRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCcdRequestingServiceRes',
            'XInterClusterServiceProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XInterClusterServiceProfile',
            'UpdateInterClusterServiceProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateInterClusterServiceProfileReq',
            'GetInterClusterServiceProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetInterClusterServiceProfileReq',
            'GetInterClusterServiceProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetInterClusterServiceProfileRes',
            'XRemoteCluster' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XRemoteCluster',
            'AddRemoteClusterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddRemoteClusterReq',
            'UpdateRemoteClusterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateRemoteClusterReq',
            'RemoveRemoteClusterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveRemoteClusterReq',
            'GetRemoteClusterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetRemoteClusterReq',
            'GetRemoteClusterRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetRemoteClusterRes',
            'ListRemoteClusterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRemoteClusterReq',
            'ListRemoteClusterRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListRemoteClusterRes',
            'XCcdAdvertisingService' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCcdAdvertisingService',
            'AddCcdAdvertisingServiceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCcdAdvertisingServiceReq',
            'UpdateCcdAdvertisingServiceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCcdAdvertisingServiceReq',
            'GetCcdAdvertisingServiceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCcdAdvertisingServiceReq',
            'GetCcdAdvertisingServiceRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCcdAdvertisingServiceRes',
            'ListCcdAdvertisingServiceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCcdAdvertisingServiceReq',
            'ListCcdAdvertisingServiceRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCcdAdvertisingServiceRes',
            'XUnitsToGateway' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XUnitsToGateway',
            'AddUnitsToGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddUnitsToGatewayReq',
            'XGatewaySubunits' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XGatewaySubunits',
            'AddGatewaySubunitsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddGatewaySubunitsReq',
            'XLdapDirectory' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XLdapDirectory',
            'servers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Servers',
            'server' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Server',
            'accessControlGroupInfo' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AccessControlGroupInfo',
            'accessControlGroupName' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AccessControlGroupName',
            'addDns' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddDns',
            'addDn' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddDn',
            'AddLdapDirectoryReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddLdapDirectoryReq',
            'UpdateLdapDirectoryReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateLdapDirectoryReq',
            'removeAccessControlGroupInfo' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveAccessControlGroupInfo',
            'addAccessControlGroupInfo' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddAccessControlGroupInfo',
            'GetLdapDirectoryReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLdapDirectoryReq',
            'GetLdapDirectoryRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLdapDirectoryRes',
            'ListLdapDirectoryReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListLdapDirectoryReq',
            'ListLdapDirectoryRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListLdapDirectoryRes',
            'XEmccFeatureConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XEmccFeatureConfig',
            'UpdateEmccFeatureConfigReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateEmccFeatureConfigReq',
            'GetEmccFeatureConfigReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetEmccFeatureConfigReq',
            'GetEmccFeatureConfigRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetEmccFeatureConfigRes',
            'XSafCcdPurgeBlockLearnedRoutes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSafCcdPurgeBlockLearnedRoutes',
            'AddSafCcdPurgeBlockLearnedRoutesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddSafCcdPurgeBlockLearnedRoutesReq',
            'UpdateSafCcdPurgeBlockLearnedRoutesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSafCcdPurgeBlockLearnedRoutesReq',
            'RemoveSafCcdPurgeBlockLearnedRoutesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveSafCcdPurgeBlockLearnedRoutesReq',
            'GetSafCcdPurgeBlockLearnedRoutesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSafCcdPurgeBlockLearnedRoutesReq',
            'GetSafCcdPurgeBlockLearnedRoutesRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSafCcdPurgeBlockLearnedRoutesRes',
            'ListSafCcdPurgeBlockLearnedRoutesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSafCcdPurgeBlockLearnedRoutesReq',
            'ListSafCcdPurgeBlockLearnedRoutesRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSafCcdPurgeBlockLearnedRoutesRes',
            'XVpnGateway' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XVpnGateway',
            'certificates' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Certificates',
            'AddVpnGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddVpnGatewayReq',
            'UpdateVpnGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateVpnGatewayReq',
            'GetVpnGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetVpnGatewayReq',
            'GetVpnGatewayRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetVpnGatewayRes',
            'ListVpnGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListVpnGatewayReq',
            'ListVpnGatewayRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListVpnGatewayRes',
            'XVpnGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XVpnGroup',
            'vpnGateways' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\VpnGateways',
            'AddVpnGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddVpnGroupReq',
            'UpdateVpnGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateVpnGroupReq',
            'GetVpnGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetVpnGroupReq',
            'GetVpnGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetVpnGroupRes',
            'ListVpnGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListVpnGroupReq',
            'ListVpnGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListVpnGroupRes',
            'XVpnProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XVpnProfile',
            'AddVpnProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddVpnProfileReq',
            'UpdateVpnProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateVpnProfileReq',
            'GetVpnProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetVpnProfileReq',
            'GetVpnProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetVpnProfileRes',
            'ListVpnProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListVpnProfileReq',
            'ListVpnProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListVpnProfileRes',
            'XImeServer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XImeServer',
            'AddImeServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddImeServerReq',
            'UpdateImeServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateImeServerReq',
            'GetImeServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeServerReq',
            'GetImeServerRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeServerRes',
            'ListImeServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImeServerReq',
            'ListImeServerRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImeServerRes',
            'XImeRouteFilterGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XImeRouteFilterGroup',
            'AddImeRouteFilterGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddImeRouteFilterGroupReq',
            'UpdateImeRouteFilterGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateImeRouteFilterGroupReq',
            'GetImeRouteFilterGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeRouteFilterGroupReq',
            'GetImeRouteFilterGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeRouteFilterGroupRes',
            'ListImeRouteFilterGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImeRouteFilterGroupReq',
            'ListImeRouteFilterGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImeRouteFilterGroupRes',
            'XImeRouteFilterElement' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XImeRouteFilterElement',
            'AddImeRouteFilterElementReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddImeRouteFilterElementReq',
            'UpdateImeRouteFilterElementReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateImeRouteFilterElementReq',
            'GetImeRouteFilterElementReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeRouteFilterElementReq',
            'GetImeRouteFilterElementRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeRouteFilterElementRes',
            'ListImeRouteFilterElementReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImeRouteFilterElementReq',
            'ListImeRouteFilterElementRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImeRouteFilterElementRes',
            'XImeClient' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XImeClient',
            'ccmExternalIpMaps' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\CcmExternalIpMaps',
            'AddImeClientReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddImeClientReq',
            'UpdateImeClientReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateImeClientReq',
            'removeCcmExternalIpMaps' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveCcmExternalIpMaps',
            'addCcmExternalIpMaps' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCcmExternalIpMaps',
            'GetImeClientReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeClientReq',
            'GetImeClientRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeClientRes',
            'ListImeClientReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImeClientReq',
            'ListImeClientRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImeClientRes',
            'XImeEnrolledPattern' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XImeEnrolledPattern',
            'AddImeEnrolledPatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddImeEnrolledPatternReq',
            'UpdateImeEnrolledPatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateImeEnrolledPatternReq',
            'RemoveImeEnrolledPatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveImeEnrolledPatternReq',
            'GetImeEnrolledPatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeEnrolledPatternReq',
            'GetImeEnrolledPatternRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeEnrolledPatternRes',
            'ListImeEnrolledPatternReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImeEnrolledPatternReq',
            'ListImeEnrolledPatternRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImeEnrolledPatternRes',
            'XImeEnrolledPatternGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XImeEnrolledPatternGroup',
            'AddImeEnrolledPatternGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddImeEnrolledPatternGroupReq',
            'UpdateImeEnrolledPatternGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateImeEnrolledPatternGroupReq',
            'GetImeEnrolledPatternGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeEnrolledPatternGroupReq',
            'GetImeEnrolledPatternGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeEnrolledPatternGroupRes',
            'ListImeEnrolledPatternGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImeEnrolledPatternGroupReq',
            'ListImeEnrolledPatternGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImeEnrolledPatternGroupRes',
            'XImeExclusionNumber' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XImeExclusionNumber',
            'AddImeExclusionNumberReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddImeExclusionNumberReq',
            'UpdateImeExclusionNumberReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateImeExclusionNumberReq',
            'RemoveImeExclusionNumberReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveImeExclusionNumberReq',
            'GetImeExclusionNumberReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeExclusionNumberReq',
            'GetImeExclusionNumberRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeExclusionNumberRes',
            'ListImeExclusionNumberReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImeExclusionNumberReq',
            'ListImeExclusionNumberRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImeExclusionNumberRes',
            'XImeExclusionNumberGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XImeExclusionNumberGroup',
            'AddImeExclusionNumberGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddImeExclusionNumberGroupReq',
            'UpdateImeExclusionNumberGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateImeExclusionNumberGroupReq',
            'GetImeExclusionNumberGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeExclusionNumberGroupReq',
            'GetImeExclusionNumberGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeExclusionNumberGroupRes',
            'ListImeExclusionNumberGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImeExclusionNumberGroupReq',
            'ListImeExclusionNumberGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImeExclusionNumberGroupRes',
            'XImeFirewall' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XImeFirewall',
            'AddImeFirewallReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddImeFirewallReq',
            'UpdateImeFirewallReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateImeFirewallReq',
            'GetImeFirewallReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeFirewallReq',
            'GetImeFirewallRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeFirewallRes',
            'ListImeFirewallReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImeFirewallReq',
            'ListImeFirewallRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImeFirewallRes',
            'XImeE164Transformation' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XImeE164Transformation',
            'AddImeE164TransformationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddImeE164TransformationReq',
            'UpdateImeE164TransformationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateImeE164TransformationReq',
            'GetImeE164TransformationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeE164TransformationReq',
            'GetImeE164TransformationRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeE164TransformationRes',
            'ListImeE164TransformationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImeE164TransformationReq',
            'ListImeE164TransformationRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImeE164TransformationRes',
            'XTransformationProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XTransformationProfile',
            'AddTransformationProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddTransformationProfileReq',
            'UpdateTransformationProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateTransformationProfileReq',
            'GetTransformationProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetTransformationProfileReq',
            'GetTransformationProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetTransformationProfileRes',
            'ListTransformationProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListTransformationProfileReq',
            'ListTransformationProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListTransformationProfileRes',
            'XFallbackProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XFallbackProfile',
            'AddFallbackProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddFallbackProfileReq',
            'UpdateFallbackProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateFallbackProfileReq',
            'GetFallbackProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetFallbackProfileReq',
            'GetFallbackProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetFallbackProfileRes',
            'ListFallbackProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListFallbackProfileReq',
            'ListFallbackProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListFallbackProfileRes',
            'XLdapFilter' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XLdapFilter',
            'AddLdapFilterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddLdapFilterReq',
            'UpdateLdapFilterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateLdapFilterReq',
            'GetLdapFilterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLdapFilterReq',
            'GetLdapFilterRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLdapFilterRes',
            'ListLdapFilterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListLdapFilterReq',
            'ListLdapFilterRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListLdapFilterRes',
            'XAppServerInfo' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XAppServerInfo',
            'AddAppServerInfoReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddAppServerInfoReq',
            'UpdateAppServerInfoReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateAppServerInfoReq',
            'XTvsCertificate' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XTvsCertificate',
            'roles' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Roles',
            'UpdateTvsCertificateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateTvsCertificateReq',
            'GetTvsCertificateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetTvsCertificateReq',
            'GetTvsCertificateRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetTvsCertificateRes',
            'ListTvsCertificateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListTvsCertificateReq',
            'ListTvsCertificateRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListTvsCertificateRes',
            'XFeatureControlPolicy' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XFeatureControlPolicy',
            'features' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Features',
            'AddFeatureControlPolicyReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddFeatureControlPolicyReq',
            'UpdateFeatureControlPolicyReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateFeatureControlPolicyReq',
            'GetFeatureControlPolicyReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetFeatureControlPolicyReq',
            'GetFeatureControlPolicyRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetFeatureControlPolicyRes',
            'ListFeatureControlPolicyReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListFeatureControlPolicyReq',
            'ListFeatureControlPolicyRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListFeatureControlPolicyRes',
            'XMobilityProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XMobilityProfile',
            'AddMobilityProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddMobilityProfileReq',
            'UpdateMobilityProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateMobilityProfileReq',
            'GetMobilityProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMobilityProfileReq',
            'GetMobilityProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMobilityProfileRes',
            'ListMobilityProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListMobilityProfileReq',
            'ListMobilityProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListMobilityProfileRes',
            'XEnterpriseFeatureAccessConfiguration' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XEnterpriseFeatureAccessConfiguration',
            'AddEnterpriseFeatureAccessConfigurationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddEnterpriseFeatureAccessConfigurationReq',
            'UpdateEnterpriseFeatureAccessConfigurationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateEnterpriseFeatureAccessConfigurationReq',
            'RemoveEnterpriseFeatureAccessConfigurationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveEnterpriseFeatureAccessConfigurationReq',
            'GetEnterpriseFeatureAccessConfigurationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetEnterpriseFeatureAccessConfigurationReq',
            'GetEnterpriseFeatureAccessConfigurationRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetEnterpriseFeatureAccessConfigurationRes',
            'ListEnterpriseFeatureAccessConfigurationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListEnterpriseFeatureAccessConfigurationReq',
            'ListEnterpriseFeatureAccessConfigurationRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListEnterpriseFeatureAccessConfigurationRes',
            'XHandoffConfiguration' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XHandoffConfiguration',
            'AddHandoffConfigurationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddHandoffConfigurationReq',
            'UpdateHandoffConfigurationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateHandoffConfigurationReq',
            'RemoveHandoffConfigurationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveHandoffConfigurationReq',
            'GetHandoffConfigurationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetHandoffConfigurationReq',
            'GetHandoffConfigurationRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetHandoffConfigurationRes',
            'XCalledPartyTracing' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCalledPartyTracing',
            'AddCalledPartyTracingReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCalledPartyTracingReq',
            'RemoveCalledPartyTracingReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveCalledPartyTracingReq',
            'ListCalledPartyTracingReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCalledPartyTracingReq',
            'ListCalledPartyTracingRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCalledPartyTracingRes',
            'XSIPNormalizationScript' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSIPNormalizationScript',
            'AddSIPNormalizationScriptReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddSIPNormalizationScriptReq',
            'UpdateSIPNormalizationScriptReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSIPNormalizationScriptReq',
            'GetSIPNormalizationScriptReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSIPNormalizationScriptReq',
            'GetSIPNormalizationScriptRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSIPNormalizationScriptRes',
            'ListSIPNormalizationScriptReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSIPNormalizationScriptReq',
            'ListSIPNormalizationScriptRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSIPNormalizationScriptRes',
            'XCustomUserField' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCustomUserField',
            'AddCustomUserFieldReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCustomUserFieldReq',
            'UpdateCustomUserFieldReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCustomUserFieldReq',
            'RemoveCustomUserFieldReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveCustomUserFieldReq',
            'GetCustomUserFieldReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCustomUserFieldReq',
            'GetCustomUserFieldRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCustomUserFieldRes',
            'ListCustomUserFieldReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCustomUserFieldReq',
            'ListCustomUserFieldRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCustomUserFieldRes',
            'XGatewaySccpEndpoints' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XGatewaySccpEndpoints',
            'AddGatewaySccpEndpointsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddGatewaySccpEndpointsReq',
            'UpdateGatewaySccpEndpointsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateGatewaySccpEndpointsReq',
            'GetGatewaySccpEndpointsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetGatewaySccpEndpointsReq',
            'GetGatewaySccpEndpointsRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetGatewaySccpEndpointsRes',
            'XBillingServer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XBillingServer',
            'AddBillingServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddBillingServerReq',
            'ListBillingServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListBillingServerReq',
            'ListBillingServerRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListBillingServerRes',
            'XLbmGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XLbmGroup',
            'AddLbmGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddLbmGroupReq',
            'UpdateLbmGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateLbmGroupReq',
            'GetLbmGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLbmGroupReq',
            'GetLbmGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLbmGroupRes',
            'ListLbmGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListLbmGroupReq',
            'ListLbmGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListLbmGroupRes',
            'XAnnouncement' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XAnnouncement',
            'AddAnnouncementReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddAnnouncementReq',
            'UpdateAnnouncementReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateAnnouncementReq',
            'GetAnnouncementReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetAnnouncementReq',
            'GetAnnouncementRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetAnnouncementRes',
            'ListAnnouncementReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListAnnouncementReq',
            'ListAnnouncementRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListAnnouncementRes',
            'XServiceProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XServiceProfile',
            'serviceProfileInfos' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ServiceProfileInfos',
            'AddServiceProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddServiceProfileReq',
            'UpdateServiceProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateServiceProfileReq',
            'GetServiceProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetServiceProfileReq',
            'GetServiceProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetServiceProfileRes',
            'ListServiceProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListServiceProfileReq',
            'ListServiceProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListServiceProfileRes',
            'XLdapSyncCustomField' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XLdapSyncCustomField',
            'AddLdapSyncCustomFieldReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddLdapSyncCustomFieldReq',
            'UpdateLdapSyncCustomFieldReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateLdapSyncCustomFieldReq',
            'RemoveLdapSyncCustomFieldReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveLdapSyncCustomFieldReq',
            'GetLdapSyncCustomFieldReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLdapSyncCustomFieldReq',
            'GetLdapSyncCustomFieldRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLdapSyncCustomFieldRes',
            'XAudioCodecPreferenceList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XAudioCodecPreferenceList',
            'codecsInList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\CodecsInList',
            'AddAudioCodecPreferenceListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddAudioCodecPreferenceListReq',
            'UpdateAudioCodecPreferenceListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateAudioCodecPreferenceListReq',
            'GetAudioCodecPreferenceListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetAudioCodecPreferenceListReq',
            'GetAudioCodecPreferenceListRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetAudioCodecPreferenceListRes',
            'ListAudioCodecPreferenceListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListAudioCodecPreferenceListReq',
            'ListAudioCodecPreferenceListRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListAudioCodecPreferenceListRes',
            'XUcService' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XUcService',
            'AddUcServiceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddUcServiceReq',
            'UpdateUcServiceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateUcServiceReq',
            'GetUcServiceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetUcServiceReq',
            'GetUcServiceRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetUcServiceRes',
            'ListUcServiceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListUcServiceReq',
            'ListUcServiceRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListUcServiceRes',
            'XLbmHubGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XLbmHubGroup',
            'AddLbmHubGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddLbmHubGroupReq',
            'UpdateLbmHubGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateLbmHubGroupReq',
            'GetLbmHubGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLbmHubGroupReq',
            'GetLbmHubGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLbmHubGroupRes',
            'ListLbmHubGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListLbmHubGroupReq',
            'ListLbmHubGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListLbmHubGroupRes',
            'XImportedDirectoryUriCatalogs' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XImportedDirectoryUriCatalogs',
            'AddImportedDirectoryUriCatalogsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddImportedDirectoryUriCatalogsReq',
            'UpdateImportedDirectoryUriCatalogsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateImportedDirectoryUriCatalogsReq',
            'GetImportedDirectoryUriCatalogsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImportedDirectoryUriCatalogsReq',
            'GetImportedDirectoryUriCatalogsRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImportedDirectoryUriCatalogsRes',
            'ListImportedDirectoryUriCatalogsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImportedDirectoryUriCatalogsReq',
            'ListImportedDirectoryUriCatalogsRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListImportedDirectoryUriCatalogsRes',
            'XVohServer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XVohServer',
            'AddVohServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddVohServerReq',
            'UpdateVohServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateVohServerReq',
            'GetVohServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetVohServerReq',
            'GetVohServerRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetVohServerRes',
            'ListVohServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListVohServerReq',
            'ListVohServerRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListVohServerRes',
            'XSdpTransparencyProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSdpTransparencyProfile',
            'attributeSet' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AttributeSet',
            'AddSdpTransparencyProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddSdpTransparencyProfileReq',
            'UpdateSdpTransparencyProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSdpTransparencyProfileReq',
            'GetSdpTransparencyProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSdpTransparencyProfileReq',
            'GetSdpTransparencyProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSdpTransparencyProfileRes',
            'ListSdpTransparencyProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSdpTransparencyProfileReq',
            'ListSdpTransparencyProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListSdpTransparencyProfileRes',
            'XFeatureGroupTemplate' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XFeatureGroupTemplate',
            'AddFeatureGroupTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddFeatureGroupTemplateReq',
            'UpdateFeatureGroupTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateFeatureGroupTemplateReq',
            'GetFeatureGroupTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetFeatureGroupTemplateReq',
            'GetFeatureGroupTemplateRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetFeatureGroupTemplateRes',
            'ListFeatureGroupTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListFeatureGroupTemplateReq',
            'ListFeatureGroupTemplateRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListFeatureGroupTemplateRes',
            'XDirNumberAliasLookupandSync' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XDirNumberAliasLookupandSync',
            'AddDirNumberAliasLookupandSyncReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddDirNumberAliasLookupandSyncReq',
            'UpdateDirNumberAliasLookupandSyncReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateDirNumberAliasLookupandSyncReq',
            'GetDirNumberAliasLookupandSyncReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDirNumberAliasLookupandSyncReq',
            'GetDirNumberAliasLookupandSyncRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetDirNumberAliasLookupandSyncRes',
            'ListDirNumberAliasLookupandSyncReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDirNumberAliasLookupandSyncReq',
            'ListDirNumberAliasLookupandSyncRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListDirNumberAliasLookupandSyncRes',
            'XLocalRouteGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XLocalRouteGroup',
            'AddLocalRouteGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddLocalRouteGroupReq',
            'GetLocalRouteGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLocalRouteGroupReq',
            'GetLocalRouteGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLocalRouteGroupRes',
            'ListLocalRouteGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListLocalRouteGroupReq',
            'ListLocalRouteGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListLocalRouteGroupRes',
            'XAdvertisedPatterns' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XAdvertisedPatterns',
            'AddAdvertisedPatternsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddAdvertisedPatternsReq',
            'UpdateAdvertisedPatternsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateAdvertisedPatternsReq',
            'RemoveAdvertisedPatternsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveAdvertisedPatternsReq',
            'GetAdvertisedPatternsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetAdvertisedPatternsReq',
            'GetAdvertisedPatternsRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetAdvertisedPatternsRes',
            'ListAdvertisedPatternsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListAdvertisedPatternsReq',
            'ListAdvertisedPatternsRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListAdvertisedPatternsRes',
            'XBlockedLearnedPatterns' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XBlockedLearnedPatterns',
            'AddBlockedLearnedPatternsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddBlockedLearnedPatternsReq',
            'UpdateBlockedLearnedPatternsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateBlockedLearnedPatternsReq',
            'RemoveBlockedLearnedPatternsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveBlockedLearnedPatternsReq',
            'GetBlockedLearnedPatternsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetBlockedLearnedPatternsReq',
            'GetBlockedLearnedPatternsRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetBlockedLearnedPatternsRes',
            'ListBlockedLearnedPatternsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListBlockedLearnedPatternsReq',
            'ListBlockedLearnedPatternsRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListBlockedLearnedPatternsRes',
            'XCCAProfiles' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCCAProfiles',
            'AddCCAProfilesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCCAProfilesReq',
            'UpdateCCAProfilesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCCAProfilesReq',
            'RemoveCCAProfilesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveCCAProfilesReq',
            'GetCCAProfilesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCCAProfilesReq',
            'GetCCAProfilesRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCCAProfilesRes',
            'ListCCAProfilesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCCAProfilesReq',
            'ListCCAProfilesRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListCCAProfilesRes',
            'XUniversalDeviceTemplate' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XUniversalDeviceTemplate',
            'AddUniversalDeviceTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddUniversalDeviceTemplateReq',
            'UpdateUniversalDeviceTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateUniversalDeviceTemplateReq',
            'GetUniversalDeviceTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetUniversalDeviceTemplateReq',
            'GetUniversalDeviceTemplateRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetUniversalDeviceTemplateRes',
            'ListUniversalDeviceTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListUniversalDeviceTemplateReq',
            'ListUniversalDeviceTemplateRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListUniversalDeviceTemplateRes',
            'XUserProfileProvision' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XUserProfileProvision',
            'AddUserProfileProvisionReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddUserProfileProvisionReq',
            'UpdateUserProfileProvisionReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateUserProfileProvisionReq',
            'GetUserProfileProvisionReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetUserProfileProvisionReq',
            'GetUserProfileProvisionRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetUserProfileProvisionRes',
            'ListUserProfileProvisionReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListUserProfileProvisionReq',
            'ListUserProfileProvisionRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListUserProfileProvisionRes',
            'XCredentialPolicyDefault' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCredentialPolicyDefault',
            'XPresenceRedundancyGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XPresenceRedundancyGroup',
            'AddPresenceRedundancyGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddPresenceRedundancyGroupReq',
            'UpdatePresenceRedundancyGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdatePresenceRedundancyGroupReq',
            'GetPresenceRedundancyGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetPresenceRedundancyGroupReq',
            'GetPresenceRedundancyGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetPresenceRedundancyGroupRes',
            'ListPresenceRedundancyGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListPresenceRedundancyGroupReq',
            'ListPresenceRedundancyGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListPresenceRedundancyGroupRes',
            'XAssignedPresenceServers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XAssignedPresenceServers',
            'ListAssignedPresenceServersReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListAssignedPresenceServersReq',
            'ListAssignedPresenceServersRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListAssignedPresenceServersRes',
            'XUnassignedPresenceServers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XUnassignedPresenceServers',
            'ListUnassignedPresenceServersReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListUnassignedPresenceServersReq',
            'ListUnassignedPresenceServersRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListUnassignedPresenceServersRes',
            'XAssignedPresenceUsers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XAssignedPresenceUsers',
            'ListAssignedPresenceUsersReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListAssignedPresenceUsersReq',
            'ListAssignedPresenceUsersRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListAssignedPresenceUsersRes',
            'XUnassignedPresenceUsers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XUnassignedPresenceUsers',
            'ListUnassignedPresenceUsersReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListUnassignedPresenceUsersReq',
            'ListUnassignedPresenceUsersRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListUnassignedPresenceUsersRes',
            'XWifiHotspot' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XWifiHotspot',
            'AddWifiHotspotReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddWifiHotspotReq',
            'UpdateWifiHotspotReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateWifiHotspotReq',
            'GetWifiHotspotReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetWifiHotspotReq',
            'GetWifiHotspotRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetWifiHotspotRes',
            'ListWifiHotspotReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListWifiHotspotReq',
            'ListWifiHotspotRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListWifiHotspotRes',
            'XWlanProfileGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XWlanProfileGroup',
            'AddWlanProfileGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddWlanProfileGroupReq',
            'UpdateWlanProfileGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateWlanProfileGroupReq',
            'GetWlanProfileGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetWlanProfileGroupReq',
            'GetWlanProfileGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetWlanProfileGroupRes',
            'ListWlanProfileGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListWlanProfileGroupReq',
            'ListWlanProfileGroupRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListWlanProfileGroupRes',
            'XWLANProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XWLANProfile',
            'AddWLANProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddWLANProfileReq',
            'UpdateWLANProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateWLANProfileReq',
            'GetWLANProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetWLANProfileReq',
            'GetWLANProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetWLANProfileRes',
            'ListWLANProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListWLANProfileReq',
            'ListWLANProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListWLANProfileRes',
            'XUniversalLineTemplate' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XUniversalLineTemplate',
            'AddUniversalLineTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddUniversalLineTemplateReq',
            'UpdateUniversalLineTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateUniversalLineTemplateReq',
            'GetUniversalLineTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetUniversalLineTemplateReq',
            'GetUniversalLineTemplateRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetUniversalLineTemplateRes',
            'ListUniversalLineTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListUniversalLineTemplateReq',
            'ListUniversalLineTemplateRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListUniversalLineTemplateRes',
            'XNetworkAccessProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XNetworkAccessProfile',
            'AddNetworkAccessProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddNetworkAccessProfileReq',
            'UpdateNetworkAccessProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateNetworkAccessProfileReq',
            'GetNetworkAccessProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetNetworkAccessProfileReq',
            'GetNetworkAccessProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetNetworkAccessProfileRes',
            'ListNetworkAccessProfileReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListNetworkAccessProfileReq',
            'ListNetworkAccessProfileRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListNetworkAccessProfileRes',
            'XLicensedUser' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XLicensedUser',
            'GetLicensedUserReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLicensedUserReq',
            'GetLicensedUserRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLicensedUserRes',
            'LSipProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LSipProfile',
            'LSipTrunkSecurityProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LSipTrunkSecurityProfile',
            'LTimePeriod' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LTimePeriod',
            'LTimeSchedule' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LTimeSchedule',
            'LTodAccess' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LTodAccess',
            'LVoiceMailPilot' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LVoiceMailPilot',
            'LProcessNode' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LProcessNode',
            'LCallerFilterList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallerFilterList',
            'LRoutePartition' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LRoutePartition',
            'LCss' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCss',
            'LCallManager' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallManager',
            'LMediaResourceGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LMediaResourceGroup',
            'LMediaResourceList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LMediaResourceList',
            'LRegion' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LRegion',
            'LAarGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LAarGroup',
            'LPhysicalLocation' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LPhysicalLocation',
            'LRouteGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LRouteGroup',
            'LDevicePool' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LDevicePool',
            'LDeviceMobilityGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LDeviceMobilityGroup',
            'LLocation' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LLocation',
            'LSoftKeyTemplate' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LSoftKeyTemplate',
            'LTranscoder' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LTranscoder',
            'LCommonDeviceConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCommonDeviceConfig',
            'LResourcePriorityNamespace' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LResourcePriorityNamespace',
            'LResourcePriorityNamespaceList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LResourcePriorityNamespaceList',
            'LDeviceMobility' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LDeviceMobility',
            'LCmcInfo' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCmcInfo',
            'LCredentialPolicy' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCredentialPolicy',
            'LFacInfo' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LFacInfo',
            'LHuntList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LHuntList',
            'LIvrUserLocale' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LIvrUserLocale',
            'LLineGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LLineGroup',
            'LRecordingProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LRecordingProfile',
            'LRouteFilter' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LRouteFilter',
            'LCallManagerGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallManagerGroup',
            'LUserGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LUserGroup',
            'LDialPlan' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LDialPlan',
            'LDialPlanTag' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LDialPlanTag',
            'LDdi' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LDdi',
            'LMobileSmartClientProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LMobileSmartClientProfile',
            'LProcessNodeService' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LProcessNodeService',
            'LMohAudioSource' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LMohAudioSource',
            'LDhcpServer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LDhcpServer',
            'LDhcpSubnet' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LDhcpSubnet',
            'LCallPark' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallPark',
            'LDirectedCallPark' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LDirectedCallPark',
            'LMeetMe' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LMeetMe',
            'LMobileVoiceAccess' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LMobileVoiceAccess',
            'LRouteList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LRouteList',
            'LUser' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LUser',
            'LAppUser' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LAppUser',
            'LSipRealm' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LSipRealm',
            'LPhoneNtp' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LPhoneNtp',
            'LDateTimeGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LDateTimeGroup',
            'LPresenceGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LPresenceGroup',
            'LGeoLocation' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LGeoLocation',
            'LSrst' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LSrst',
            'LMlppDomain' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LMlppDomain',
            'LCumaServerSecurityProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCumaServerSecurityProfile',
            'LApplicationServer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LApplicationServer',
            'LApplicationUserCapfProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LApplicationUserCapfProfile',
            'LEndUserCapfProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LEndUserCapfProfile',
            'LServiceParameter' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LServiceParameter',
            'LUserPhoneAssociation' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LUserPhoneAssociation',
            'LGeoLocationFilter' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LGeoLocationFilter',
            'LVoiceMailProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LVoiceMailProfile',
            'LVoiceMailPort' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LVoiceMailPort',
            'LGatekeeper' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LGatekeeper',
            'LPhoneButtonTemplate' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LPhoneButtonTemplate',
            'LCommonPhoneConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCommonPhoneConfig',
            'LMessageWaiting' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LMessageWaiting',
            'LIpPhoneServices' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LIpPhoneServices',
            'LCtiRoutePoint' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCtiRoutePoint',
            'LTransPattern' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LTransPattern',
            'LCallingPartyTransformationPattern' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallingPartyTransformationPattern',
            'LSipRoutePattern' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LSipRoutePattern',
            'LHuntPilot' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LHuntPilot',
            'LRoutePattern' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LRoutePattern',
            'LApplicationDialRules' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LApplicationDialRules',
            'LDirectoryLookupDialRules' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LDirectoryLookupDialRules',
            'LPhoneSecurityProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LPhoneSecurityProfile',
            'LSipDialRules' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LSipDialRules',
            'LConferenceBridge' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LConferenceBridge',
            'LAnnunciator' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LAnnunciator',
            'LMtp' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LMtp',
            'LFixedMohAudioSource' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LFixedMohAudioSource',
            'LAarGroupMatrix' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LAarGroupMatrix',
            'LRemoteDestinationProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LRemoteDestinationProfile',
            'LLine' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LLine',
            'LDefaultDeviceProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LDefaultDeviceProfile',
            'LH323Phone' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LH323Phone',
            'LMohServer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LMohServer',
            'LH323Trunk' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LH323Trunk',
            'LPhone' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LPhone',
            'currentConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\CurrentConfig',
            'LH323Gateway' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LH323Gateway',
            'LDeviceProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LDeviceProfile',
            'LRemoteDestination' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LRemoteDestination',
            'LVg224' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LVg224',
            'LGateway' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LGateway',
            'LGatewayEndpointAnalogAccess' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LGatewayEndpointAnalogAccess',
            'LGatewayEndpointDigitalAccessPri' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LGatewayEndpointDigitalAccessPri',
            'LGatewayEndpointDigitalAccessBri' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LGatewayEndpointDigitalAccessBri',
            'LGatewayEndpointDigitalAccessT1' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LGatewayEndpointDigitalAccessT1',
            'LCiscoCatalyst600024PortFXSGateway' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCiscoCatalyst600024PortFXSGateway',
            'LCiscoCatalyst6000E1VoIPGateway' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCiscoCatalyst6000E1VoIPGateway',
            'LCiscoCatalyst6000T1VoIPGatewayPri' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCiscoCatalyst6000T1VoIPGatewayPri',
            'LCiscoCatalyst6000T1VoIPGatewayT1' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCiscoCatalyst6000T1VoIPGatewayT1',
            'LCallPickupGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallPickupGroup',
            'LRoutePlan' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LRoutePlan',
            'LGeoLocationPolicy' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LGeoLocationPolicy',
            'LSipTrunk' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LSipTrunk',
            'LRegionMatrix' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LRegionMatrix',
            'LCalledPartyTransformationPattern' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCalledPartyTransformationPattern',
            'LExternalCallControlProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LExternalCallControlProfile',
            'LSafSecurityProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LSafSecurityProfile',
            'LSafForwarder' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LSafForwarder',
            'LCcdHostedDN' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCcdHostedDN',
            'LCcdHostedDNGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCcdHostedDNGroup',
            'LCcdRequestingService' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCcdRequestingService',
            'LInterClusterServiceProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LInterClusterServiceProfile',
            'LRemoteCluster' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LRemoteCluster',
            'LCcdAdvertisingService' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCcdAdvertisingService',
            'LUnitsToGateway' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LUnitsToGateway',
            'LGatewaySubunits' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LGatewaySubunits',
            'LLdapDirectory' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LLdapDirectory',
            'LEmccFeatureConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LEmccFeatureConfig',
            'LSafCcdPurgeBlockLearnedRoutes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LSafCcdPurgeBlockLearnedRoutes',
            'LVpnGateway' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LVpnGateway',
            'LVpnGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LVpnGroup',
            'LVpnProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LVpnProfile',
            'LImeServer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LImeServer',
            'LImeRouteFilterGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LImeRouteFilterGroup',
            'LImeRouteFilterElement' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LImeRouteFilterElement',
            'LImeClient' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LImeClient',
            'LImeEnrolledPattern' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LImeEnrolledPattern',
            'LImeEnrolledPatternGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LImeEnrolledPatternGroup',
            'LImeExclusionNumber' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LImeExclusionNumber',
            'LImeExclusionNumberGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LImeExclusionNumberGroup',
            'LImeFirewall' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LImeFirewall',
            'LImeE164Transformation' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LImeE164Transformation',
            'LTransformationProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LTransformationProfile',
            'LFallbackProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LFallbackProfile',
            'LLdapFilter' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LLdapFilter',
            'LAppServerInfo' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LAppServerInfo',
            'LTvsCertificate' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LTvsCertificate',
            'LFeatureControlPolicy' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LFeatureControlPolicy',
            'LMobilityProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LMobilityProfile',
            'LEnterpriseFeatureAccessConfiguration' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LEnterpriseFeatureAccessConfiguration',
            'LHandoffConfiguration' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LHandoffConfiguration',
            'LCalledPartyTracing' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCalledPartyTracing',
            'LSIPNormalizationScript' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LSIPNormalizationScript',
            'LCustomUserField' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCustomUserField',
            'LGatewaySccpEndpoints' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LGatewaySccpEndpoints',
            'LBillingServer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LBillingServer',
            'LLbmGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LLbmGroup',
            'LAnnouncement' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LAnnouncement',
            'LServiceProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LServiceProfile',
            'LLdapSyncCustomField' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LLdapSyncCustomField',
            'LAudioCodecPreferenceList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LAudioCodecPreferenceList',
            'LUcService' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LUcService',
            'LLbmHubGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LLbmHubGroup',
            'LImportedDirectoryUriCatalogs' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LImportedDirectoryUriCatalogs',
            'LVohServer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LVohServer',
            'LSdpTransparencyProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LSdpTransparencyProfile',
            'LFeatureGroupTemplate' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LFeatureGroupTemplate',
            'LDirNumberAliasLookupandSync' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LDirNumberAliasLookupandSync',
            'LLocalRouteGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LLocalRouteGroup',
            'LAdvertisedPatterns' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LAdvertisedPatterns',
            'LBlockedLearnedPatterns' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LBlockedLearnedPatterns',
            'LCCAProfiles' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCCAProfiles',
            'LUniversalDeviceTemplate' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LUniversalDeviceTemplate',
            'LUserProfileProvision' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LUserProfileProvision',
            'LCredentialPolicyDefault' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCredentialPolicyDefault',
            'LPresenceRedundancyGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LPresenceRedundancyGroup',
            'LAssignedPresenceServers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LAssignedPresenceServers',
            'LUnassignedPresenceServers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LUnassignedPresenceServers',
            'LAssignedPresenceUsers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LAssignedPresenceUsers',
            'LUnassignedPresenceUsers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LUnassignedPresenceUsers',
            'LWifiHotspot' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LWifiHotspot',
            'LWlanProfileGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LWlanProfileGroup',
            'LWLANProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LWLANProfile',
            'LUniversalLineTemplate' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LUniversalLineTemplate',
            'LNetworkAccessProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LNetworkAccessProfile',
            'LLicensedUser' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LLicensedUser',
            'LTODAccessMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LTODAccessMember',
            'LTimeScheduleTimePeriod' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LTimeScheduleTimePeriod',
            'LCallerFilterListMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallerFilterListMember',
            'LCallingSearchSpaceMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallingSearchSpaceMember',
            'LMediaResourceGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LMediaResourceGroupMember',
            'LMediaResourceListMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LMediaResourceListMember',
            'LRegionRelationship' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LRegionRelationship',
            'LAarGroupRelationship' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LAarGroupRelationship',
            'LRouteGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LRouteGroupMember',
            'LLocationRelationship' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LLocationRelationship',
            'LResourcePriorityNamespaceListMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LResourcePriorityNamespaceListMember',
            'LDevicePoolDeviceMobility' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LDevicePoolDeviceMobility',
            'LHuntListMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LHuntListMember',
            'LRouteFilterMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LRouteFilterMember',
            'LCallManagerMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallManagerMember',
            'LUserGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LUserGroupMember',
            'LDigitDiscardInstructionMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LDigitDiscardInstructionMember',
            'LRouteListMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LRouteListMember',
            'LButton' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LButton',
            'LNumplanIdentifier' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LNumplanIdentifier',
            'LDateTimeGroupNtpReference' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LDateTimeGroupNtpReference',
            'LPresenceGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LPresenceGroupMember',
            'LHuntForwardInfoBusy' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LHuntForwardInfoBusy',
            'LHuntForwardInfoNoAnswer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LHuntForwardInfoNoAnswer',
            'LLineGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LLineGroupMember',
            'LCallForwardAll' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallForwardAll',
            'LCallForwardBusy' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallForwardBusy',
            'LCallForwardBusyInt' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallForwardBusyInt',
            'LCallForwardNoAnswer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallForwardNoAnswer',
            'LCallForwardNoAnswerInt' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallForwardNoAnswerInt',
            'LCallForwardNoCoverage' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallForwardNoCoverage',
            'LCallForwardNoCoverageInt' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallForwardNoCoverageInt',
            'LCallForwardOnFailure' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallForwardOnFailure',
            'LCallForwardAlternateParty' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallForwardAlternateParty',
            'LCallForwardNotRegistered' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallForwardNotRegistered',
            'LCallForwardNotRegisteredInt' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallForwardNotRegisteredInt',
            'LPhoneLine' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LPhoneLine',
            'callInfoDisplay' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\CallInfoDisplay',
            'associatedEndusers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AssociatedEndusers',
            'LEnduserMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LEnduserMember',
            'LSpeeddial' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LSpeeddial',
            'LBusyLampField' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LBusyLampField',
            'associatedBlfSdFeatures' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AssociatedBlfSdFeatures',
            'LAddOnModule' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LAddOnModule',
            'LSubscribedService' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LSubscribedService',
            'LBLFDirectedCallPark' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LBLFDirectedCallPark',
            'directedCallParkDnAndPartition' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\DirectedCallParkDnAndPartition',
            'LLineAssociation' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LLineAssociation',
            'LAnalogPort' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LAnalogPort',
            'LGatewayEndpointAnalog' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LGatewayEndpointAnalog',
            'LGatewayEndpointDigitalPri' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LGatewayEndpointDigitalPri',
            'LGatewayEndpointDigitalBri' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LGatewayEndpointDigitalBri',
            'LT1Port' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LT1Port',
            'LGatewayEndpointDigitalT1' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LGatewayEndpointDigitalT1',
            'LPickupGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LPickupGroupMember',
            'pickupDnAndPartition' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\PickupDnAndPartition',
            'LPolicyRelationship' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LPolicyRelationship',
            'LIpPhoneServicesParameter' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LIpPhoneServicesParameter',
            'LSafForwarderMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LSafForwarderMember',
            'LCcdRequestingServiceMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCcdRequestingServiceMember',
            'LDirn' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LDirn',
            'LRemoteClusterMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LRemoteClusterMember',
            'LPatternMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LPatternMember',
            'dialParameters' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\DialParameters',
            'LParameterMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LParameterMember',
            'LVmPilot' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LVmPilot',
            'LMobileVoiceMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LMobileVoiceMember',
            'LVpnGatewayMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LVpnGatewayMember',
            'LVpnGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LVpnGroupMember',
            'LImeClientMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LImeClientMember',
            'LH323Line' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LH323Line',
            'LUserGroupRoles' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LUserGroupRoles',
            'LCertificateRole' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCertificateRole',
            'LTvsCertificateService' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LTvsCertificateService',
            'LFeatureControlConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LFeatureControlConfig',
            'LSipTrunkDestination' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LSipTrunkDestination',
            'LH323TrunkDestination' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LH323TrunkDestination',
            'LCcmExternalIpMap' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCcmExternalIpMap',
            'LDirectoryUri' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LDirectoryUri',
            'LGatewaySccp' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LGatewaySccp',
            'LLocationBetween' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LLocationBetween',
            'LNormalizationScriptInfo' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LNormalizationScriptInfo',
            'LCallsQueue' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LCallsQueue',
            'LServiceProfileList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LServiceProfileList',
            'LUserCustomUserField' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LUserCustomUserField',
            'LLineAppearanceAssociationForPresence' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LLineAppearanceAssociationForPresence',
            'LAccessControlGroupName' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LAccessControlGroupName',
            'LExtensions' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LExtensions',
            'LExtension' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LExtension',
            'LProcessNodes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LProcessNodes',
            'LWirelessLanProfileGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LWirelessLanProfileGroup',
            'LEnterpriseAltNum' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LEnterpriseAltNum',
            'LE164AltNum' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LE164AltNum',
            'RSipProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSipProfile',
            'RSipTrunkSecurityProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSipTrunkSecurityProfile',
            'RTimePeriod' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RTimePeriod',
            'RTimeSchedule' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RTimeSchedule',
            'RTodAccess' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RTodAccess',
            'associatedRemoteDestination' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AssociatedRemoteDestination',
            'RVoiceMailPilot' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RVoiceMailPilot',
            'RProcessNode' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RProcessNode',
            'RCallerFilterList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallerFilterList',
            'RRoutePartition' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RRoutePartition',
            'RCss' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCss',
            'RCallManager' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallManager',
            'RMediaResourceGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RMediaResourceGroup',
            'RMediaResourceList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RMediaResourceList',
            'RRegion' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RRegion',
            'RAarGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RAarGroup',
            'relatedGroups' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RelatedGroups',
            'RPhysicalLocation' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RPhysicalLocation',
            'RRouteGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RRouteGroup',
            'RDevicePool' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RDevicePool',
            'RDeviceMobilityGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RDeviceMobilityGroup',
            'RLocation' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RLocation',
            'RSoftKeyTemplate' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSoftKeyTemplate',
            'applications' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Applications',
            'RTranscoder' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RTranscoder',
            'RCommonDeviceConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCommonDeviceConfig',
            'RResourcePriorityNamespace' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RResourcePriorityNamespace',
            'RResourcePriorityNamespaceList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RResourcePriorityNamespaceList',
            'RDeviceMobility' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RDeviceMobility',
            'RCmcInfo' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCmcInfo',
            'RCredentialPolicy' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCredentialPolicy',
            'RFacInfo' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RFacInfo',
            'RHuntList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RHuntList',
            'RIvrUserLocale' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RIvrUserLocale',
            'RLineGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RLineGroup',
            'RRecordingProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RRecordingProfile',
            'RRouteFilter' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RRouteFilter',
            'RCallManagerGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallManagerGroup',
            'RUserGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RUserGroup',
            'RDialPlan' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RDialPlan',
            'RDialPlanTag' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RDialPlanTag',
            'RDdi' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RDdi',
            'RMobileSmartClientProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RMobileSmartClientProfile',
            'RProcessNodeService' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RProcessNodeService',
            'RMohAudioSource' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RMohAudioSource',
            'RDhcpServer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RDhcpServer',
            'RDhcpSubnet' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RDhcpSubnet',
            'RCallPark' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallPark',
            'RDirectedCallPark' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RDirectedCallPark',
            'RMeetMe' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RMeetMe',
            'RMobileVoiceAccess' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RMobileVoiceAccess',
            'RRouteList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RRouteList',
            'RUser' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RUser',
            'associatedRemoteDestinationProfiles' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AssociatedRemoteDestinationProfiles',
            'associatedTodAccess' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AssociatedTodAccess',
            'associatedCapfProfiles' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AssociatedCapfProfiles',
            'RAppUser' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RAppUser',
            'RSipRealm' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSipRealm',
            'RPhoneNtp' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RPhoneNtp',
            'RDateTimeGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RDateTimeGroup',
            'RPresenceGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RPresenceGroup',
            'RGeoLocation' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RGeoLocation',
            'RSrst' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSrst',
            'RMlppDomain' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RMlppDomain',
            'RCumaServerSecurityProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCumaServerSecurityProfile',
            'RApplicationServer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RApplicationServer',
            'RApplicationUserCapfProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RApplicationUserCapfProfile',
            'REndUserCapfProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\REndUserCapfProfile',
            'RServiceParameter' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RServiceParameter',
            'RUserPhoneAssociation' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RUserPhoneAssociation',
            'RGeoLocationFilter' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RGeoLocationFilter',
            'RVoiceMailProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RVoiceMailProfile',
            'RVoiceMailPort' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RVoiceMailPort',
            'RGatekeeper' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RGatekeeper',
            'RPhoneButtonTemplate' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RPhoneButtonTemplate',
            'RCommonPhoneConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCommonPhoneConfig',
            'RMessageWaiting' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RMessageWaiting',
            'RIpPhoneServices' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RIpPhoneServices',
            'RCtiRoutePoint' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCtiRoutePoint',
            'RTransPattern' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RTransPattern',
            'RCallingPartyTransformationPattern' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallingPartyTransformationPattern',
            'RSipRoutePattern' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSipRoutePattern',
            'RHuntPilot' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RHuntPilot',
            'RRoutePattern' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RRoutePattern',
            'RApplicationDialRules' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RApplicationDialRules',
            'RDirectoryLookupDialRules' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RDirectoryLookupDialRules',
            'RPhoneSecurityProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RPhoneSecurityProfile',
            'RSipDialRules' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSipDialRules',
            'RConferenceBridge' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RConferenceBridge',
            'RAnnunciator' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RAnnunciator',
            'RMtp' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RMtp',
            'RFixedMohAudioSource' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RFixedMohAudioSource',
            'RAarGroupMatrix' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RAarGroupMatrix',
            'RRemoteDestinationProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RRemoteDestinationProfile',
            'RLine' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RLine',
            'RDefaultDeviceProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RDefaultDeviceProfile',
            'RH323Phone' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RH323Phone',
            'RMohServer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RMohServer',
            'RH323Trunk' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RH323Trunk',
            'RPhone' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RPhone',
            'RH323Gateway' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RH323Gateway',
            'RDeviceProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RDeviceProfile',
            'RRemoteDestination' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RRemoteDestination',
            'RVg224' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RVg224',
            'RGateway' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RGateway',
            'RGatewayEndpointAnalogAccess' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RGatewayEndpointAnalogAccess',
            'RGatewayEndpointDigitalAccessPri' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RGatewayEndpointDigitalAccessPri',
            'RGatewayEndpointDigitalAccessBri' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RGatewayEndpointDigitalAccessBri',
            'RGatewayEndpointDigitalAccessT1' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RGatewayEndpointDigitalAccessT1',
            'RCiscoCatalyst600024PortFXSGateway' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCiscoCatalyst600024PortFXSGateway',
            'RCiscoCatalyst6000E1VoIPGateway' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCiscoCatalyst6000E1VoIPGateway',
            'RCiscoCatalyst6000T1VoIPGatewayPri' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCiscoCatalyst6000T1VoIPGatewayPri',
            'RCiscoCatalyst6000T1VoIPGatewayT1' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCiscoCatalyst6000T1VoIPGatewayT1',
            'RCallPickupGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallPickupGroup',
            'RRoutePlan' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RRoutePlan',
            'RGeoLocationPolicy' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RGeoLocationPolicy',
            'RSipTrunk' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSipTrunk',
            'RRegionMatrix' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RRegionMatrix',
            'RCalledPartyTransformationPattern' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCalledPartyTransformationPattern',
            'RExternalCallControlProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RExternalCallControlProfile',
            'RSafSecurityProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSafSecurityProfile',
            'RSafForwarder' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSafForwarder',
            'RCcdHostedDN' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCcdHostedDN',
            'RCcdHostedDNGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCcdHostedDNGroup',
            'RCcdRequestingService' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCcdRequestingService',
            'RInterClusterServiceProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RInterClusterServiceProfile',
            'RRemoteCluster' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RRemoteCluster',
            'RCcdAdvertisingService' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCcdAdvertisingService',
            'RUnitsToGateway' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RUnitsToGateway',
            'RGatewaySubunits' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RGatewaySubunits',
            'RLdapDirectory' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RLdapDirectory',
            'REmccFeatureConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\REmccFeatureConfig',
            'RSafCcdPurgeBlockLearnedRoutes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSafCcdPurgeBlockLearnedRoutes',
            'RVpnGateway' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RVpnGateway',
            'RVpnGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RVpnGroup',
            'RVpnProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RVpnProfile',
            'RImeServer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RImeServer',
            'RImeRouteFilterGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RImeRouteFilterGroup',
            'RImeRouteFilterElement' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RImeRouteFilterElement',
            'RImeClient' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RImeClient',
            'RImeEnrolledPattern' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RImeEnrolledPattern',
            'RImeEnrolledPatternGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RImeEnrolledPatternGroup',
            'RImeExclusionNumber' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RImeExclusionNumber',
            'RImeExclusionNumberGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RImeExclusionNumberGroup',
            'RImeFirewall' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RImeFirewall',
            'RImeE164Transformation' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RImeE164Transformation',
            'RTransformationProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RTransformationProfile',
            'RFallbackProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RFallbackProfile',
            'RLdapFilter' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RLdapFilter',
            'RAppServerInfo' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RAppServerInfo',
            'RTvsCertificate' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RTvsCertificate',
            'RFeatureControlPolicy' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RFeatureControlPolicy',
            'RMobilityProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RMobilityProfile',
            'REnterpriseFeatureAccessConfiguration' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\REnterpriseFeatureAccessConfiguration',
            'RHandoffConfiguration' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RHandoffConfiguration',
            'RCalledPartyTracing' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCalledPartyTracing',
            'RSIPNormalizationScript' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSIPNormalizationScript',
            'RCustomUserField' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCustomUserField',
            'RGatewaySccpEndpoints' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RGatewaySccpEndpoints',
            'RBillingServer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RBillingServer',
            'RLbmGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RLbmGroup',
            'RAnnouncement' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RAnnouncement',
            'RServiceProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RServiceProfile',
            'RLdapSyncCustomField' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RLdapSyncCustomField',
            'RAudioCodecPreferenceList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RAudioCodecPreferenceList',
            'RUcService' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RUcService',
            'RLbmHubGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RLbmHubGroup',
            'RImportedDirectoryUriCatalogs' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RImportedDirectoryUriCatalogs',
            'RVohServer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RVohServer',
            'RSdpTransparencyProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSdpTransparencyProfile',
            'RFeatureGroupTemplate' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RFeatureGroupTemplate',
            'RDirNumberAliasLookupandSync' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RDirNumberAliasLookupandSync',
            'RLocalRouteGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RLocalRouteGroup',
            'RAdvertisedPatterns' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RAdvertisedPatterns',
            'RBlockedLearnedPatterns' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RBlockedLearnedPatterns',
            'RCCAProfiles' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCCAProfiles',
            'RUniversalDeviceTemplate' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RUniversalDeviceTemplate',
            'RUserProfileProvision' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RUserProfileProvision',
            'RCredentialPolicyDefault' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCredentialPolicyDefault',
            'RPresenceRedundancyGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RPresenceRedundancyGroup',
            'RAssignedPresenceServers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RAssignedPresenceServers',
            'RUnassignedPresenceServers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RUnassignedPresenceServers',
            'RAssignedPresenceUsers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RAssignedPresenceUsers',
            'RUnassignedPresenceUsers' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RUnassignedPresenceUsers',
            'RWifiHotspot' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RWifiHotspot',
            'RWlanProfileGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RWlanProfileGroup',
            'RWLANProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RWLANProfile',
            'RUniversalLineTemplate' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RUniversalLineTemplate',
            'RNetworkAccessProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RNetworkAccessProfile',
            'RLicensedUser' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RLicensedUser',
            'OXSipProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXSipProfile',
            'ORSipProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORSipProfile',
            'OXTransPattern' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXTransPattern',
            'ORTransPattern' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORTransPattern',
            'OXLine' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXLine',
            'ORLine' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORLine',
            'OXPhone' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXPhone',
            'ORPhone' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORPhone',
            'OXDeviceProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXDeviceProfile',
            'ORDeviceProfile' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORDeviceProfile',
            'OXFkTypeProduct' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXFkTypeProduct',
            'OXFkTypeProduct_Protocol' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXFkTypeProduct_Protocol',
            'OXCallForwardNoCoverageInt' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXCallForwardNoCoverageInt',
            'ORCallForwardNoCoverageInt' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORCallForwardNoCoverageInt',
            'OXBusyLampField' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXBusyLampField',
            'ORBusyLampField' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORBusyLampField',
            'OXBLFDirectedCallPark' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXBLFDirectedCallPark',
            'ORBLFDirectedCallPark' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORBLFDirectedCallPark',
            'OXAddOnModule' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXAddOnModule',
            'ORAddOnModule' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORAddOnModule',
            'OXSubscribedService' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXSubscribedService',
            'ORSubscribedService' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORSubscribedService',
            'OXCallForwardBusyInt' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXCallForwardBusyInt',
            'ORCallForwardBusyInt' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORCallForwardBusyInt',
            'OXPhoneLine' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXPhoneLine',
            'ORPhoneLine' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORPhoneLine',
            'OXCallForwardNoAnswerInt' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXCallForwardNoAnswerInt',
            'ORCallForwardNoAnswerInt' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORCallForwardNoAnswerInt',
            'OXCallForwardNoCoverage' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXCallForwardNoCoverage',
            'ORCallForwardNoCoverage' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORCallForwardNoCoverage',
            'OXCallForwardNotRegistered' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXCallForwardNotRegistered',
            'ORCallForwardNotRegistered' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORCallForwardNotRegistered',
            'OXDirn' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXDirn',
            'ORDirn' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORDirn',
            'OXCallForwardAlternateParty' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXCallForwardAlternateParty',
            'ORCallForwardAlternateParty' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORCallForwardAlternateParty',
            'OXNumplanIdentifier' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXNumplanIdentifier',
            'ORNumplanIdentifier' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORNumplanIdentifier',
            'OXEnduserMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXEnduserMember',
            'OREnduserMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OREnduserMember',
            'OXCallForwardOnFailure' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXCallForwardOnFailure',
            'ORCallForwardOnFailure' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORCallForwardOnFailure',
            'OXSpeeddial' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXSpeeddial',
            'ORSpeeddial' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORSpeeddial',
            'OXCallForwardAll' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXCallForwardAll',
            'ORCallForwardAll' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORCallForwardAll',
            'OXDirectoryUri' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXDirectoryUri',
            'ORDirectoryUri' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORDirectoryUri',
            'OXCallForwardBusy' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXCallForwardBusy',
            'ORCallForwardBusy' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORCallForwardBusy',
            'OXCallForwardNotRegisteredInt' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXCallForwardNotRegisteredInt',
            'ORCallForwardNotRegisteredInt' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORCallForwardNotRegisteredInt',
            'OXCallForwardNoAnswer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXCallForwardNoAnswer',
            'ORCallForwardNoAnswer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORCallForwardNoAnswer',
            'RTODAccessMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RTODAccessMember',
            'RTimeScheduleTimePeriod' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RTimeScheduleTimePeriod',
            'RCallerFilterListMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallerFilterListMember',
            'RCallingSearchSpaceMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallingSearchSpaceMember',
            'RMediaResourceGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RMediaResourceGroupMember',
            'RMediaResourceListMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RMediaResourceListMember',
            'RRegionRelationship' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RRegionRelationship',
            'RAarGroupRelationship' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RAarGroupRelationship',
            'RRouteGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RRouteGroupMember',
            'RLocationRelationship' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RLocationRelationship',
            'RResourcePriorityNamespaceListMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RResourcePriorityNamespaceListMember',
            'RDevicePoolDeviceMobility' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RDevicePoolDeviceMobility',
            'RHuntListMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RHuntListMember',
            'RRouteFilterMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RRouteFilterMember',
            'RCallManagerMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallManagerMember',
            'RUserGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RUserGroupMember',
            'RDigitDiscardInstructionMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RDigitDiscardInstructionMember',
            'RRouteListMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RRouteListMember',
            'RButton' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RButton',
            'RNumplanIdentifier' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RNumplanIdentifier',
            'RDateTimeGroupNtpReference' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RDateTimeGroupNtpReference',
            'RPresenceGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RPresenceGroupMember',
            'RHuntForwardInfoBusy' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RHuntForwardInfoBusy',
            'RHuntForwardInfoNoAnswer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RHuntForwardInfoNoAnswer',
            'RLineGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RLineGroupMember',
            'RCallForwardAll' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallForwardAll',
            'RCallForwardBusy' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallForwardBusy',
            'RCallForwardBusyInt' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallForwardBusyInt',
            'RCallForwardNoAnswer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallForwardNoAnswer',
            'RCallForwardNoAnswerInt' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallForwardNoAnswerInt',
            'RCallForwardNoCoverage' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallForwardNoCoverage',
            'RCallForwardNoCoverageInt' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallForwardNoCoverageInt',
            'RCallForwardOnFailure' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallForwardOnFailure',
            'RCallForwardAlternateParty' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallForwardAlternateParty',
            'RCallForwardNotRegistered' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallForwardNotRegistered',
            'RCallForwardNotRegisteredInt' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallForwardNotRegisteredInt',
            'RPhoneLine' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RPhoneLine',
            'REnduserMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\REnduserMember',
            'RSpeeddial' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSpeeddial',
            'RBusyLampField' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RBusyLampField',
            'RAddOnModule' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RAddOnModule',
            'RSubscribedService' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSubscribedService',
            'RBLFDirectedCallPark' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RBLFDirectedCallPark',
            'RLineAssociation' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RLineAssociation',
            'RAnalogPort' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RAnalogPort',
            'RGatewayEndpointAnalog' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RGatewayEndpointAnalog',
            'RGatewayEndpointDigitalPri' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RGatewayEndpointDigitalPri',
            'RGatewayEndpointDigitalBri' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RGatewayEndpointDigitalBri',
            'RT1Port' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RT1Port',
            'RGatewayEndpointDigitalT1' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RGatewayEndpointDigitalT1',
            'RPickupGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RPickupGroupMember',
            'RPolicyRelationship' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RPolicyRelationship',
            'RIpPhoneServicesParameter' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RIpPhoneServicesParameter',
            'RSafForwarderMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSafForwarderMember',
            'RCcdRequestingServiceMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCcdRequestingServiceMember',
            'RDirn' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RDirn',
            'RRemoteClusterMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RRemoteClusterMember',
            'RPatternMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RPatternMember',
            'RParameterMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RParameterMember',
            'RVmPilot' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RVmPilot',
            'RMobileVoiceMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RMobileVoiceMember',
            'RVpnGatewayMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RVpnGatewayMember',
            'RVpnGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RVpnGroupMember',
            'RImeClientMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RImeClientMember',
            'RH323Line' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RH323Line',
            'RUserGroupRoles' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RUserGroupRoles',
            'RCertificateRole' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCertificateRole',
            'RTvsCertificateService' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RTvsCertificateService',
            'RFeatureControlConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RFeatureControlConfig',
            'RSipTrunkDestination' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSipTrunkDestination',
            'RH323TrunkDestination' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RH323TrunkDestination',
            'RCcmExternalIpMap' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCcmExternalIpMap',
            'RDirectoryUri' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RDirectoryUri',
            'RGatewaySccp' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RGatewaySccp',
            'RLocationBetween' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RLocationBetween',
            'RNormalizationScriptInfo' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RNormalizationScriptInfo',
            'RCallsQueue' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallsQueue',
            'RServiceProfileList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RServiceProfileList',
            'RUserCustomUserField' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RUserCustomUserField',
            'RLineAppearanceAssociationForPresence' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RLineAppearanceAssociationForPresence',
            'RAccessControlGroupName' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RAccessControlGroupName',
            'RExtensions' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RExtensions',
            'RExtension' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RExtension',
            'RProcessNodes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RProcessNodes',
            'RWirelessLanProfileGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RWirelessLanProfileGroup',
            'REnterpriseAltNum' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\REnterpriseAltNum',
            'RE164AltNum' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RE164AltNum',
            'UT1Port' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UT1Port',
            'UGatewayEndpointDigitalT1' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UGatewayEndpointDigitalT1',
            'XTODAccessMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XTODAccessMember',
            'XTimeScheduleTimePeriod' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XTimeScheduleTimePeriod',
            'XCallerFilterListMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallerFilterListMember',
            'XCallingSearchSpaceMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallingSearchSpaceMember',
            'XMediaResourceGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XMediaResourceGroupMember',
            'XMediaResourceListMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XMediaResourceListMember',
            'XRegionRelationship' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XRegionRelationship',
            'XAarGroupRelationship' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XAarGroupRelationship',
            'XRouteGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XRouteGroupMember',
            'XLocationRelationship' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XLocationRelationship',
            'XResourcePriorityNamespaceListMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XResourcePriorityNamespaceListMember',
            'XDevicePoolDeviceMobility' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XDevicePoolDeviceMobility',
            'XHuntListMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XHuntListMember',
            'XRouteFilterMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XRouteFilterMember',
            'XCallManagerMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallManagerMember',
            'XUserGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XUserGroupMember',
            'XDigitDiscardInstructionMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XDigitDiscardInstructionMember',
            'XRouteListMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XRouteListMember',
            'XButton' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XButton',
            'XNumplanIdentifier' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XNumplanIdentifier',
            'XDateTimeGroupNtpReference' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XDateTimeGroupNtpReference',
            'XPresenceGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XPresenceGroupMember',
            'XHuntForwardInfoBusy' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XHuntForwardInfoBusy',
            'XHuntForwardInfoNoAnswer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XHuntForwardInfoNoAnswer',
            'XLineGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XLineGroupMember',
            'XCallForwardAll' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallForwardAll',
            'XCallForwardBusy' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallForwardBusy',
            'XCallForwardBusyInt' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallForwardBusyInt',
            'XCallForwardNoAnswer' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallForwardNoAnswer',
            'XCallForwardNoAnswerInt' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallForwardNoAnswerInt',
            'XCallForwardNoCoverage' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallForwardNoCoverage',
            'XCallForwardNoCoverageInt' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallForwardNoCoverageInt',
            'XCallForwardOnFailure' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallForwardOnFailure',
            'XCallForwardAlternateParty' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallForwardAlternateParty',
            'XCallForwardNotRegistered' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallForwardNotRegistered',
            'XCallForwardNotRegisteredInt' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallForwardNotRegisteredInt',
            'XPhoneLine' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XPhoneLine',
            'XEnduserMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XEnduserMember',
            'XSpeeddial' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSpeeddial',
            'XBusyLampField' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XBusyLampField',
            'XAddOnModule' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XAddOnModule',
            'XSubscribedService' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSubscribedService',
            'XBLFDirectedCallPark' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XBLFDirectedCallPark',
            'XLineAssociation' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XLineAssociation',
            'XAnalogPort' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XAnalogPort',
            'XGatewayEndpointAnalog' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XGatewayEndpointAnalog',
            'XGatewayEndpointDigitalPri' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XGatewayEndpointDigitalPri',
            'XGatewayEndpointDigitalBri' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XGatewayEndpointDigitalBri',
            'XT1Port' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XT1Port',
            'XGatewayEndpointDigitalT1' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XGatewayEndpointDigitalT1',
            'XPickupGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XPickupGroupMember',
            'XPolicyRelationship' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XPolicyRelationship',
            'XIpPhoneServicesParameter' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XIpPhoneServicesParameter',
            'XSafForwarderMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSafForwarderMember',
            'XCcdRequestingServiceMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCcdRequestingServiceMember',
            'XDirn' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XDirn',
            'XRemoteClusterMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XRemoteClusterMember',
            'XPatternMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XPatternMember',
            'XParameterMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XParameterMember',
            'XVmPilot' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XVmPilot',
            'XMobileVoiceMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XMobileVoiceMember',
            'XVpnGatewayMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XVpnGatewayMember',
            'XVpnGroupMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XVpnGroupMember',
            'XImeClientMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XImeClientMember',
            'XH323Line' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XH323Line',
            'XUserGroupRoles' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XUserGroupRoles',
            'XCertificateRole' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCertificateRole',
            'XTvsCertificateService' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XTvsCertificateService',
            'XFeatureControlConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XFeatureControlConfig',
            'XSipTrunkDestination' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSipTrunkDestination',
            'XH323TrunkDestination' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XH323TrunkDestination',
            'XCcmExternalIpMap' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCcmExternalIpMap',
            'XDirectoryUri' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XDirectoryUri',
            'XGatewaySccp' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XGatewaySccp',
            'XLocationBetween' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XLocationBetween',
            'XNormalizationScriptInfo' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XNormalizationScriptInfo',
            'XCallsQueue' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallsQueue',
            'XServiceProfileList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XServiceProfileList',
            'XUserCustomUserField' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XUserCustomUserField',
            'XLineAppearanceAssociationForPresence' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XLineAppearanceAssociationForPresence',
            'XAccessControlGroupName' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XAccessControlGroupName',
            'XExtensions' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XExtensions',
            'XExtension' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XExtension',
            'XProcessNodes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XProcessNodes',
            'XWirelessLanProfileGroup' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XWirelessLanProfileGroup',
            'XEnterpriseAltNum' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XEnterpriseAltNum',
            'XE164AltNum' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XE164AltNum',
            'StandardResponse' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\StandardResponse',
            'NameAndGUIDRequest' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\NameAndGUIDRequest',
            'APIRequest' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\APIRequest',
            'APIResponse' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\APIResponse',
            'ExecuteSQLQueryReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ExecuteSQLQueryReq',
            'ExecuteSQLQueryRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ExecuteSQLQueryRes',
            'XLoadInformation' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XLoadInformation',
            'XVendorConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XVendorConfig',
            'XContent' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XContent',
            'ExecuteSQLUpdateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ExecuteSQLUpdateReq',
            'ExecuteSQLUpdateRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ExecuteSQLUpdateRes',
            'DoAuthenticateUserReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\DoAuthenticateUserReq',
            'DoAuthenticateUserRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\DoAuthenticateUserRes',
            'DoDeviceLoginReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\DoDeviceLoginReq',
            'DoDeviceLoginRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\DoDeviceLoginRes',
            'DoDeviceLogoutReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\DoDeviceLogoutReq',
            'DoDeviceLogoutRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\DoDeviceLogoutRes',
            'DoDeviceResetReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\DoDeviceResetReq',
            'DoDeviceResetRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\DoDeviceResetRes',
            'GetOSVersionReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetOSVersionReq',
            'GetOSVersionRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetOSVersionRes',
            'GetNumDevicesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetNumDevicesReq',
            'GetNumDevicesRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetNumDevicesRes',
            'getNumDevicesResponse' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetNumDevicesResponse',
            'AddMobilityReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddMobilityReq',
            'UpdateMobilityReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateMobilityReq',
            'GetMobilityReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMobilityReq',
            'GetMobilityRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetMobilityRes',
            'XMobility' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XMobility',
            'RMobility' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RMobility',
            'XOSVersion' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XOSVersion',
            'GetEnterprisePhoneConfigReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetEnterprisePhoneConfigReq',
            'GetEnterprisePhoneConfigRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetEnterprisePhoneConfigRes',
            'XEnterprisePhoneConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XEnterprisePhoneConfig',
            'UpdateEnterprisePhoneConfigReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateEnterprisePhoneConfigReq',
            'GetLdapSystemReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLdapSystemReq',
            'GetLdapSystemRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLdapSystemRes',
            'XLdapSystem' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XLdapSystem',
            'UpdateLdapSystemReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateLdapSystemReq',
            'XLdapAuthentication' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XLdapAuthentication',
            'GetLdapAuthenticationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLdapAuthenticationReq',
            'GetLdapAuthenticationRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLdapAuthenticationRes',
            'UpdateLdapAuthenticationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateLdapAuthenticationReq',
            'XApplicationToSoftKeyTemplate' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XApplicationToSoftKeyTemplate',
            'AddApplicationToSoftkeyTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddApplicationToSoftkeyTemplateReq',
            'removeApplicationToSoftkeyTemplateReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveApplicationToSoftkeyTemplateReq',
            'GetCCMVersionReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCCMVersionReq',
            'GetCCMVersionRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCCMVersionRes',
            'componentVersion' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ComponentVersion',
            'XNameAttribute' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XNameAttribute',
            'RemoveUnitsToGatewayReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveUnitsToGatewayReq',
            'RemoveGatewaySubunitsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveGatewaySubunitsReq',
            'XFkType' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XFkType',
            'OXFkType' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\OXFkType',
            'ORFkType' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ORFkType',
            'GetOptionType' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetOptionType',
            'UpdateImeFeatureConfigReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateImeFeatureConfigReq',
            'UpdateFallbackFeatureConfigReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateFallbackFeatureConfigReq',
            'GetImeFeatureConfigReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeFeatureConfigReq',
            'GetFallbackFeatureConfigReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetFallbackFeatureConfigReq',
            'GetFallbackFeatureConfigRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetFallbackFeatureConfigRes',
            'RFallbackFeatureConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RFallbackFeatureConfig',
            'RemoveImeLearnedRoutesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveImeLearnedRoutesReq',
            'UpdateImeLearnedRoutesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateImeLearnedRoutesReq',
            'GetImeLearnedRoutesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeLearnedRoutesReq',
            'GetImeLearnedRoutesRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeLearnedRoutesRes',
            'RImeLearnedRoutes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RImeLearnedRoutes',
            'GetImeFeatureConfigRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetImeFeatureConfigRes',
            'RImeFeatureConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RImeFeatureConfig',
            'RemoveAppServerInfoReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveAppServerInfoReq',
            'GetAppServerInfoReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetAppServerInfoReq',
            'GetAppServerInfoRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetAppServerInfoRes',
            'DoLdapSyncReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\DoLdapSyncReq',
            'DoLdapSyncRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\DoLdapSyncRes',
            'GetLdapSyncStatusReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLdapSyncStatusReq',
            'GetLdapSyncStatusRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetLdapSyncStatusRes',
            'XCommonMembersExtension' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCommonMembersExtension',
            'UpdateSoftKeySetReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSoftKeySetReq',
            'removeCallStates' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveCallStates',
            'addCallStates' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddCallStates',
            'callStates' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\CallStates',
            'XCallStateMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCallStateMember',
            'softKeys' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\SoftKeys',
            'RCallStateMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCallStateMember',
            'XSoftKeyMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSoftKeyMember',
            'RSoftKeyMember' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSoftKeyMember',
            'GetSoftKeySetReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSoftKeySetReq',
            'GetSoftKeySetRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSoftKeySetRes',
            'RSoftKeySet' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSoftKeySet',
            'DoUpdateRemoteClusterReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\DoUpdateRemoteClusterReq',
            'DoUpdateRemoteClusterRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\DoUpdateRemoteClusterRes',
            'XSyslogConfiguration' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSyslogConfiguration',
            'LSyslogConfiguration' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LSyslogConfiguration',
            'RSyslogConfiguration' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSyslogConfiguration',
            'alarmConfigs' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AlarmConfigs',
            'LSyslogConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\LSyslogConfig',
            'RSyslogConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSyslogConfig',
            'XSyslogConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSyslogConfig',
            'UpdateSyslogConfigurationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSyslogConfigurationReq',
            'UpdateSyslogConfigurationRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSyslogConfigurationRes',
            'GetSyslogConfigurationReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSyslogConfigurationReq',
            'GetSyslogConfigurationRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSyslogConfigurationRes',
            'ListLdapSyncCustomFieldReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListLdapSyncCustomFieldReq',
            'ListLdapSyncCustomFieldRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListLdapSyncCustomFieldRes',
            'NewLLdapSyncCustomField' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\NewLLdapSyncCustomField',
            'GetPhoneTypeDisplayInstanceReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetPhoneTypeDisplayInstanceReq',
            'GetPhoneTypeDisplayInstanceRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetPhoneTypeDisplayInstanceRes',
            'UpdateInterClusterDirectoryUriReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateInterClusterDirectoryUriReq',
            'UpdateIlsConfigReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateIlsConfigReq',
            'GetIlsConfigReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetIlsConfigReq',
            'GetIlsConfigRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetIlsConfigRes',
            'NewIlsConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\NewIlsConfig',
            'RArrayOfHosts' => '\\Losc\\CucmBundle\\Model\\Webservice\\ArrayType\\RArrayOfHosts',
            'RArrayOfCommunityString' => '\\Losc\\CucmBundle\\Model\\Webservice\\ArrayType\\RArrayOfCommunityString',
            'RCommunityString' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCommunityString',
            'AddSNMPCommunityStringReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddSNMPCommunityStringReq',
            'AddSNMPCommunityStringRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddSNMPCommunityStringRes',
            'RemoveSNMPCommunityStringReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveSNMPCommunityStringReq',
            'RemoveSNMPCommunityStringRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveSNMPCommunityStringRes',
            'RSNMPCommunityString' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSNMPCommunityString',
            'RSNMPCommunityString1' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSNMPCommunityString1',
            'GetSNMPCommunityStringReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSNMPCommunityStringReq',
            'GetSNMPCommunityStringRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSNMPCommunityStringRes',
            'UpdateSNMPCommunityStringReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSNMPCommunityStringReq',
            'UpdateSNMPCommunityStringRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSNMPCommunityStringRes',
            'RSNMPUser' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSNMPUser',
            'RSNMPGetUser' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSNMPGetUser',
            'AddSNMPUserReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddSNMPUserReq',
            'AddSNMPUserRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddSNMPUserRes',
            'GetSNMPUserReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSNMPUserReq',
            'GetSNMPUserRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSNMPUserRes',
            'RemoveSNMPUserReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveSNMPUserReq',
            'RemoveSNMPUserRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveSNMPUserRes',
            'UpdateSNMPUserReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSNMPUserReq',
            'UpdateSNMPUserRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSNMPUserRes',
            'RSNMPMIB2List' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RSNMPMIB2List',
            'GetSNMPMIB2ListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSNMPMIB2ListReq',
            'GetSNMPMIB2ListRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetSNMPMIB2ListRes',
            'UpdateSNMPMIB2ListReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSNMPMIB2ListReq',
            'UpdateSNMPMIB2ListRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSNMPMIB2ListRes',
            'RCcdParam' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RCcdParam',
            'UpdateCcdFeatureConfigReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCcdFeatureConfigReq',
            'UpdateCcdFeatureConfigRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCcdFeatureConfigRes',
            'UpdateBillingServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateBillingServerReq',
            'RemoveBillingServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveBillingServerReq',
            'GetBillingServerReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetBillingServerReq',
            'GetBillingServerRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetBillingServerRes',
            'XCcdFeatureConfig' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XCcdFeatureConfig',
            'GetCcdFeatureConfigReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCcdFeatureConfigReq',
            'GetCcdFeatureConfigRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCcdFeatureConfigRes',
            'UpdateRoutePartitionsForLearnedPatternsReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateRoutePartitionsForLearnedPatternsReq',
            'RemoveLocalRouteGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveLocalRouteGroupReq',
            'UpdateLocalRouteGroupReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateLocalRouteGroupReq',
            'RPageLayoutPreferences' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RPageLayoutPreferences',
            'pageSections' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\PageSections',
            'pageSection' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\PageSection',
            'UpdatePageLayoutPreferencesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdatePageLayoutPreferencesReq',
            'GetPageLayoutPreferencesReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetPageLayoutPreferencesReq',
            'GetPageLayoutPreferencesRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetPageLayoutPreferencesRes',
            'RPresenceUser' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RPresenceUser',
            'AssignPresenceUserReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AssignPresenceUserReq',
            'UnassignPresenceUserReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UnassignPresenceUserReq',
            'UpdateCredentialPolicyDefaultReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateCredentialPolicyDefaultReq',
            'GetCredentialPolicyDefaultRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCredentialPolicyDefaultRes',
            'GetCredentialPolicyDefaultReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\GetCredentialPolicyDefaultReq',
            'XSelfProvision' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSelfProvision',
            'XSelfProvisionRemove' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\XSelfProvisionRemove',
            'UpdateSelfProvisioningReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\UpdateSelfProvisioningReq',
            'removeLanguages' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\RemoveLanguages',
            'addLanguages' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\AddLanguages',
            'languages' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Languages',
            'ListChangeReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListChangeReq',
            'objectList' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ObjectList',
            'StartChangeId' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\StartChangeId',
            'ListChangeRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListChangeRes',
            'changes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Changes',
            'Change' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\Change',
            'changedTags' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ChangedTags',
            'ChangedTag' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ChangedTag',
            'ListChangeQueue' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\ListChangeQueue',
            'DoChangeDNDStatusReq' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\DoChangeDNDStatusReq',
            'DoChangeDNDStatusRes' => '\\Losc\\CucmBundle\\Model\\Webservice\\StructType\\DoChangeDNDStatusRes',
        );
    }
}
