<?php
/**
 * This file aims to show you how to use this generated package.
 * In addition, the goal is to show which methods are available and the first needed parameter(s)
 * You have to use an associative array such as:
 * - the key must be a constant beginning with WSDL_ from AbstractSoapClientBase class (each generated ServiceType class extends this class)
 * - the value must be the corresponding key value (each option matches a {@link http://www.php.net/manual/en/soapclient.soapclient.php} option)
 * $options = array(
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_URL => 'main.wsdl',
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_TRACE => true,
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_LOGIN => 'you_secret_login',
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_PASSWORD => 'you_secret_password',
 * );
 * etc...
 */
require_once __DIR__ . '/vendor/autoload.php';
/**
 * Minimal options
 */
$options = array(
    \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_URL => 'main.wsdl',
    \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_CLASSMAP => \Losc\CucmBundle\Model\Webservice\ClassMap::get(),
);
/**
 * Samples for Add ServiceType
 */
$add = new \Losc\CucmBundle\Model\Webservice\ServiceType\Add($options);
/**
 * Sample call for addSipProfile operation/method
 */
if ($add->addSipProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddSipProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addSipTrunkSecurityProfile operation/method
 */
if ($add->addSipTrunkSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddSipTrunkSecurityProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addTimePeriod operation/method
 */
if ($add->addTimePeriod(new \Losc\CucmBundle\Model\Webservice\StructType\AddTimePeriodReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addTimeSchedule operation/method
 */
if ($add->addTimeSchedule(new \Losc\CucmBundle\Model\Webservice\StructType\AddTimeScheduleReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addTodAccess operation/method
 */
if ($add->addTodAccess(new \Losc\CucmBundle\Model\Webservice\StructType\AddTodAccessReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addVoiceMailPilot operation/method
 */
if ($add->addVoiceMailPilot(new \Losc\CucmBundle\Model\Webservice\StructType\AddVoiceMailPilotReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addProcessNode operation/method
 */
if ($add->addProcessNode(new \Losc\CucmBundle\Model\Webservice\StructType\AddProcessNodeReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCallerFilterList operation/method
 */
if ($add->addCallerFilterList(new \Losc\CucmBundle\Model\Webservice\StructType\AddCallerFilterListReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addRoutePartition operation/method
 */
if ($add->addRoutePartition(new \Losc\CucmBundle\Model\Webservice\StructType\AddRoutePartitionReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCss operation/method
 */
if ($add->addCss(new \Losc\CucmBundle\Model\Webservice\StructType\AddCssReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addMediaResourceGroup operation/method
 */
if ($add->addMediaResourceGroup(new \Losc\CucmBundle\Model\Webservice\StructType\AddMediaResourceGroupReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addMediaResourceList operation/method
 */
if ($add->addMediaResourceList(new \Losc\CucmBundle\Model\Webservice\StructType\AddMediaResourceListReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addRegion operation/method
 */
if ($add->addRegion(new \Losc\CucmBundle\Model\Webservice\StructType\AddRegionReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addAarGroup operation/method
 */
if ($add->addAarGroup(new \Losc\CucmBundle\Model\Webservice\StructType\AddAarGroupReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addPhysicalLocation operation/method
 */
if ($add->addPhysicalLocation(new \Losc\CucmBundle\Model\Webservice\StructType\AddPhysicalLocationReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addRouteGroup operation/method
 */
if ($add->addRouteGroup(new \Losc\CucmBundle\Model\Webservice\StructType\AddRouteGroupReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addDevicePool operation/method
 */
if ($add->addDevicePool(new \Losc\CucmBundle\Model\Webservice\StructType\AddDevicePoolReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addDeviceMobilityGroup operation/method
 */
if ($add->addDeviceMobilityGroup(new \Losc\CucmBundle\Model\Webservice\StructType\AddDeviceMobilityGroupReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addLocation operation/method
 */
if ($add->addLocation(new \Losc\CucmBundle\Model\Webservice\StructType\AddLocationReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addSoftKeyTemplate operation/method
 */
if ($add->addSoftKeyTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\AddSoftKeyTemplateReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addTranscoder operation/method
 */
if ($add->addTranscoder(new \Losc\CucmBundle\Model\Webservice\StructType\AddTranscoderReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCommonDeviceConfig operation/method
 */
if ($add->addCommonDeviceConfig(new \Losc\CucmBundle\Model\Webservice\StructType\AddCommonDeviceConfigReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addResourcePriorityNamespace operation/method
 */
if ($add->addResourcePriorityNamespace(new \Losc\CucmBundle\Model\Webservice\StructType\AddResourcePriorityNamespaceReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addResourcePriorityNamespaceList operation/method
 */
if ($add->addResourcePriorityNamespaceList(new \Losc\CucmBundle\Model\Webservice\StructType\AddResourcePriorityNamespaceListReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addDeviceMobility operation/method
 */
if ($add->addDeviceMobility(new \Losc\CucmBundle\Model\Webservice\StructType\AddDeviceMobilityReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCmcInfo operation/method
 */
if ($add->addCmcInfo(new \Losc\CucmBundle\Model\Webservice\StructType\AddCmcInfoReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCredentialPolicy operation/method
 */
if ($add->addCredentialPolicy(new \Losc\CucmBundle\Model\Webservice\StructType\AddCredentialPolicyReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addFacInfo operation/method
 */
if ($add->addFacInfo(new \Losc\CucmBundle\Model\Webservice\StructType\AddFacInfoReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addHuntList operation/method
 */
if ($add->addHuntList(new \Losc\CucmBundle\Model\Webservice\StructType\AddHuntListReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addIvrUserLocale operation/method
 */
if ($add->addIvrUserLocale(new \Losc\CucmBundle\Model\Webservice\StructType\AddIvrUserLocaleReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addLineGroup operation/method
 */
if ($add->addLineGroup(new \Losc\CucmBundle\Model\Webservice\StructType\AddLineGroupReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addRecordingProfile operation/method
 */
if ($add->addRecordingProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddRecordingProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addRouteFilter operation/method
 */
if ($add->addRouteFilter(new \Losc\CucmBundle\Model\Webservice\StructType\AddRouteFilterReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCallManagerGroup operation/method
 */
if ($add->addCallManagerGroup(new \Losc\CucmBundle\Model\Webservice\StructType\AddCallManagerGroupReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addUserGroup operation/method
 */
if ($add->addUserGroup(new \Losc\CucmBundle\Model\Webservice\StructType\AddUserGroupReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addDhcpServer operation/method
 */
if ($add->addDhcpServer(new \Losc\CucmBundle\Model\Webservice\StructType\AddDhcpServerReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addDhcpSubnet operation/method
 */
if ($add->addDhcpSubnet(new \Losc\CucmBundle\Model\Webservice\StructType\AddDhcpSubnetReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCallPark operation/method
 */
if ($add->addCallPark(new \Losc\CucmBundle\Model\Webservice\StructType\AddCallParkReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addDirectedCallPark operation/method
 */
if ($add->addDirectedCallPark(new \Losc\CucmBundle\Model\Webservice\StructType\AddDirectedCallParkReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addMeetMe operation/method
 */
if ($add->addMeetMe(new \Losc\CucmBundle\Model\Webservice\StructType\AddMeetMeReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addMobileVoiceAccess operation/method
 */
if ($add->addMobileVoiceAccess(new \Losc\CucmBundle\Model\Webservice\StructType\AddMobileVoiceAccessReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addRouteList operation/method
 */
if ($add->addRouteList(new \Losc\CucmBundle\Model\Webservice\StructType\AddRouteListReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addUser operation/method
 */
if ($add->addUser(new \Losc\CucmBundle\Model\Webservice\StructType\AddUserReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addAppUser operation/method
 */
if ($add->addAppUser(new \Losc\CucmBundle\Model\Webservice\StructType\AddAppUserReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addSipRealm operation/method
 */
if ($add->addSipRealm(new \Losc\CucmBundle\Model\Webservice\StructType\AddSipRealmReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addPhoneNtp operation/method
 */
if ($add->addPhoneNtp(new \Losc\CucmBundle\Model\Webservice\StructType\AddPhoneNtpReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addDateTimeGroup operation/method
 */
if ($add->addDateTimeGroup(new \Losc\CucmBundle\Model\Webservice\StructType\AddDateTimeGroupReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addPresenceGroup operation/method
 */
if ($add->addPresenceGroup(new \Losc\CucmBundle\Model\Webservice\StructType\AddPresenceGroupReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addGeoLocation operation/method
 */
if ($add->addGeoLocation(new \Losc\CucmBundle\Model\Webservice\StructType\AddGeoLocationReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addSrst operation/method
 */
if ($add->addSrst(new \Losc\CucmBundle\Model\Webservice\StructType\AddSrstReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addMlppDomain operation/method
 */
if ($add->addMlppDomain(new \Losc\CucmBundle\Model\Webservice\StructType\AddMlppDomainReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCumaServerSecurityProfile operation/method
 */
if ($add->addCumaServerSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddCumaServerSecurityProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addApplicationServer operation/method
 */
if ($add->addApplicationServer(new \Losc\CucmBundle\Model\Webservice\StructType\AddApplicationServerReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addApplicationUserCapfProfile operation/method
 */
if ($add->addApplicationUserCapfProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddApplicationUserCapfProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addEndUserCapfProfile operation/method
 */
if ($add->addEndUserCapfProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddEndUserCapfProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addUserPhoneAssociation operation/method
 */
if ($add->addUserPhoneAssociation(new \Losc\CucmBundle\Model\Webservice\StructType\AddUserPhoneAssociationReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addGeoLocationFilter operation/method
 */
if ($add->addGeoLocationFilter(new \Losc\CucmBundle\Model\Webservice\StructType\AddGeoLocationFilterReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addVoiceMailProfile operation/method
 */
if ($add->addVoiceMailProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddVoiceMailProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addVoiceMailPort operation/method
 */
if ($add->addVoiceMailPort(new \Losc\CucmBundle\Model\Webservice\StructType\AddVoiceMailPortReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addGatekeeper operation/method
 */
if ($add->addGatekeeper(new \Losc\CucmBundle\Model\Webservice\StructType\AddGatekeeperReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addPhoneButtonTemplate operation/method
 */
if ($add->addPhoneButtonTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\AddPhoneButtonTemplateReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCommonPhoneConfig operation/method
 */
if ($add->addCommonPhoneConfig(new \Losc\CucmBundle\Model\Webservice\StructType\AddCommonPhoneConfigReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addMessageWaiting operation/method
 */
if ($add->addMessageWaiting(new \Losc\CucmBundle\Model\Webservice\StructType\AddMessageWaitingReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addIpPhoneServices operation/method
 */
if ($add->addIpPhoneServices(new \Losc\CucmBundle\Model\Webservice\StructType\AddIpPhoneServicesReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCtiRoutePoint operation/method
 */
if ($add->addCtiRoutePoint(new \Losc\CucmBundle\Model\Webservice\StructType\AddCtiRoutePointReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addTransPattern operation/method
 */
if ($add->addTransPattern(new \Losc\CucmBundle\Model\Webservice\StructType\AddTransPatternReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCallingPartyTransformationPattern operation/method
 */
if ($add->addCallingPartyTransformationPattern(new \Losc\CucmBundle\Model\Webservice\StructType\AddCallingPartyTransformationPatternReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addSipRoutePattern operation/method
 */
if ($add->addSipRoutePattern(new \Losc\CucmBundle\Model\Webservice\StructType\AddSipRoutePatternReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addHuntPilot operation/method
 */
if ($add->addHuntPilot(new \Losc\CucmBundle\Model\Webservice\StructType\AddHuntPilotReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addRoutePattern operation/method
 */
if ($add->addRoutePattern(new \Losc\CucmBundle\Model\Webservice\StructType\AddRoutePatternReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addApplicationDialRules operation/method
 */
if ($add->addApplicationDialRules(new \Losc\CucmBundle\Model\Webservice\StructType\AddApplicationDialRulesReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addDirectoryLookupDialRules operation/method
 */
if ($add->addDirectoryLookupDialRules(new \Losc\CucmBundle\Model\Webservice\StructType\AddDirectoryLookupDialRulesReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addPhoneSecurityProfile operation/method
 */
if ($add->addPhoneSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddPhoneSecurityProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addSipDialRules operation/method
 */
if ($add->addSipDialRules(new \Losc\CucmBundle\Model\Webservice\StructType\AddSipDialRulesReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addConferenceBridge operation/method
 */
if ($add->addConferenceBridge(new \Losc\CucmBundle\Model\Webservice\StructType\AddConferenceBridgeReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addMtp operation/method
 */
if ($add->addMtp(new \Losc\CucmBundle\Model\Webservice\StructType\AddMtpReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addRemoteDestinationProfile operation/method
 */
if ($add->addRemoteDestinationProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddRemoteDestinationProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addLine operation/method
 */
if ($add->addLine(new \Losc\CucmBundle\Model\Webservice\StructType\AddLineReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addDefaultDeviceProfile operation/method
 */
if ($add->addDefaultDeviceProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddDefaultDeviceProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addH323Phone operation/method
 */
if ($add->addH323Phone(new \Losc\CucmBundle\Model\Webservice\StructType\AddH323PhoneReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addH323Trunk operation/method
 */
if ($add->addH323Trunk(new \Losc\CucmBundle\Model\Webservice\StructType\AddH323TrunkReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addPhone operation/method
 */
if ($add->addPhone(new \Losc\CucmBundle\Model\Webservice\StructType\AddPhoneReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addH323Gateway operation/method
 */
if ($add->addH323Gateway(new \Losc\CucmBundle\Model\Webservice\StructType\AddH323GatewayReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addDeviceProfile operation/method
 */
if ($add->addDeviceProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddDeviceProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addRemoteDestination operation/method
 */
if ($add->addRemoteDestination(new \Losc\CucmBundle\Model\Webservice\StructType\AddRemoteDestinationReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addVg224 operation/method
 */
if ($add->addVg224(new \Losc\CucmBundle\Model\Webservice\StructType\AddVg224Req()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addGateway operation/method
 */
if ($add->addGateway(new \Losc\CucmBundle\Model\Webservice\StructType\AddGatewayReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addGatewayEndpointAnalogAccess operation/method
 */
if ($add->addGatewayEndpointAnalogAccess(new \Losc\CucmBundle\Model\Webservice\StructType\AddGatewayEndpointAnalogAccessReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addGatewayEndpointDigitalAccessPri operation/method
 */
if ($add->addGatewayEndpointDigitalAccessPri(new \Losc\CucmBundle\Model\Webservice\StructType\AddGatewayEndpointDigitalAccessPriReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addGatewayEndpointDigitalAccessBri operation/method
 */
if ($add->addGatewayEndpointDigitalAccessBri(new \Losc\CucmBundle\Model\Webservice\StructType\AddGatewayEndpointDigitalAccessBriReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addGatewayEndpointDigitalAccessT1 operation/method
 */
if ($add->addGatewayEndpointDigitalAccessT1(new \Losc\CucmBundle\Model\Webservice\StructType\AddGatewayEndpointDigitalAccessT1Req()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCiscoCatalyst600024PortFXSGateway operation/method
 */
if ($add->addCiscoCatalyst600024PortFXSGateway(new \Losc\CucmBundle\Model\Webservice\StructType\AddCiscoCatalyst600024PortFXSGatewayReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCiscoCatalyst6000E1VoIPGateway operation/method
 */
if ($add->addCiscoCatalyst6000E1VoIPGateway(new \Losc\CucmBundle\Model\Webservice\StructType\AddCiscoCatalyst6000E1VoIPGatewayReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCiscoCatalyst6000T1VoIPGatewayPri operation/method
 */
if ($add->addCiscoCatalyst6000T1VoIPGatewayPri(new \Losc\CucmBundle\Model\Webservice\StructType\AddCiscoCatalyst6000T1VoIPGatewayPriReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCiscoCatalyst6000T1VoIPGatewayT1 operation/method
 */
if ($add->addCiscoCatalyst6000T1VoIPGatewayT1(new \Losc\CucmBundle\Model\Webservice\StructType\AddCiscoCatalyst6000T1VoIPGatewayT1Req()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCallPickupGroup operation/method
 */
if ($add->addCallPickupGroup(new \Losc\CucmBundle\Model\Webservice\StructType\AddCallPickupGroupReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addGeoLocationPolicy operation/method
 */
if ($add->addGeoLocationPolicy(new \Losc\CucmBundle\Model\Webservice\StructType\AddGeoLocationPolicyReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addSipTrunk operation/method
 */
if ($add->addSipTrunk(new \Losc\CucmBundle\Model\Webservice\StructType\AddSipTrunkReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCalledPartyTransformationPattern operation/method
 */
if ($add->addCalledPartyTransformationPattern(new \Losc\CucmBundle\Model\Webservice\StructType\AddCalledPartyTransformationPatternReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addExternalCallControlProfile operation/method
 */
if ($add->addExternalCallControlProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddExternalCallControlProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addSafSecurityProfile operation/method
 */
if ($add->addSafSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddSafSecurityProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addSafForwarder operation/method
 */
if ($add->addSafForwarder(new \Losc\CucmBundle\Model\Webservice\StructType\AddSafForwarderReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCcdHostedDN operation/method
 */
if ($add->addCcdHostedDN(new \Losc\CucmBundle\Model\Webservice\StructType\AddCcdHostedDNReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCcdHostedDNGroup operation/method
 */
if ($add->addCcdHostedDNGroup(new \Losc\CucmBundle\Model\Webservice\StructType\AddCcdHostedDNGroupReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCcdRequestingService operation/method
 */
if ($add->addCcdRequestingService(new \Losc\CucmBundle\Model\Webservice\StructType\AddCcdRequestingServiceReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addRemoteCluster operation/method
 */
if ($add->addRemoteCluster(new \Losc\CucmBundle\Model\Webservice\StructType\AddRemoteClusterReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCcdAdvertisingService operation/method
 */
if ($add->addCcdAdvertisingService(new \Losc\CucmBundle\Model\Webservice\StructType\AddCcdAdvertisingServiceReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addUnitsToGateway operation/method
 */
if ($add->addUnitsToGateway(new \Losc\CucmBundle\Model\Webservice\StructType\AddUnitsToGatewayReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addGatewaySubunits operation/method
 */
if ($add->addGatewaySubunits(new \Losc\CucmBundle\Model\Webservice\StructType\AddGatewaySubunitsReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addLdapDirectory operation/method
 */
if ($add->addLdapDirectory(new \Losc\CucmBundle\Model\Webservice\StructType\AddLdapDirectoryReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addSafCcdPurgeBlockLearnedRoutes operation/method
 */
if ($add->addSafCcdPurgeBlockLearnedRoutes(new \Losc\CucmBundle\Model\Webservice\StructType\AddSafCcdPurgeBlockLearnedRoutesReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addVpnGateway operation/method
 */
if ($add->addVpnGateway(new \Losc\CucmBundle\Model\Webservice\StructType\AddVpnGatewayReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addVpnGroup operation/method
 */
if ($add->addVpnGroup(new \Losc\CucmBundle\Model\Webservice\StructType\AddVpnGroupReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addVpnProfile operation/method
 */
if ($add->addVpnProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddVpnProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addImeServer operation/method
 */
if ($add->addImeServer(new \Losc\CucmBundle\Model\Webservice\StructType\AddImeServerReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addImeRouteFilterGroup operation/method
 */
if ($add->addImeRouteFilterGroup(new \Losc\CucmBundle\Model\Webservice\StructType\AddImeRouteFilterGroupReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addImeRouteFilterElement operation/method
 */
if ($add->addImeRouteFilterElement(new \Losc\CucmBundle\Model\Webservice\StructType\AddImeRouteFilterElementReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addImeClient operation/method
 */
if ($add->addImeClient(new \Losc\CucmBundle\Model\Webservice\StructType\AddImeClientReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addImeEnrolledPattern operation/method
 */
if ($add->addImeEnrolledPattern(new \Losc\CucmBundle\Model\Webservice\StructType\AddImeEnrolledPatternReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addImeEnrolledPatternGroup operation/method
 */
if ($add->addImeEnrolledPatternGroup(new \Losc\CucmBundle\Model\Webservice\StructType\AddImeEnrolledPatternGroupReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addImeExclusionNumber operation/method
 */
if ($add->addImeExclusionNumber(new \Losc\CucmBundle\Model\Webservice\StructType\AddImeExclusionNumberReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addImeExclusionNumberGroup operation/method
 */
if ($add->addImeExclusionNumberGroup(new \Losc\CucmBundle\Model\Webservice\StructType\AddImeExclusionNumberGroupReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addImeFirewall operation/method
 */
if ($add->addImeFirewall(new \Losc\CucmBundle\Model\Webservice\StructType\AddImeFirewallReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addImeE164Transformation operation/method
 */
if ($add->addImeE164Transformation(new \Losc\CucmBundle\Model\Webservice\StructType\AddImeE164TransformationReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addTransformationProfile operation/method
 */
if ($add->addTransformationProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddTransformationProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addFallbackProfile operation/method
 */
if ($add->addFallbackProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddFallbackProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addLdapFilter operation/method
 */
if ($add->addLdapFilter(new \Losc\CucmBundle\Model\Webservice\StructType\AddLdapFilterReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addAppServerInfo operation/method
 */
if ($add->addAppServerInfo(new \Losc\CucmBundle\Model\Webservice\StructType\AddAppServerInfoReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addFeatureControlPolicy operation/method
 */
if ($add->addFeatureControlPolicy(new \Losc\CucmBundle\Model\Webservice\StructType\AddFeatureControlPolicyReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addMobilityProfile operation/method
 */
if ($add->addMobilityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddMobilityProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addEnterpriseFeatureAccessConfiguration operation/method
 */
if ($add->addEnterpriseFeatureAccessConfiguration(new \Losc\CucmBundle\Model\Webservice\StructType\AddEnterpriseFeatureAccessConfigurationReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addHandoffConfiguration operation/method
 */
if ($add->addHandoffConfiguration(new \Losc\CucmBundle\Model\Webservice\StructType\AddHandoffConfigurationReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCalledPartyTracing operation/method
 */
if ($add->addCalledPartyTracing(new \Losc\CucmBundle\Model\Webservice\StructType\AddCalledPartyTracingReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addSIPNormalizationScript operation/method
 */
if ($add->addSIPNormalizationScript(new \Losc\CucmBundle\Model\Webservice\StructType\AddSIPNormalizationScriptReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCustomUserField operation/method
 */
if ($add->addCustomUserField(new \Losc\CucmBundle\Model\Webservice\StructType\AddCustomUserFieldReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addGatewaySccpEndpoints operation/method
 */
if ($add->addGatewaySccpEndpoints(new \Losc\CucmBundle\Model\Webservice\StructType\AddGatewaySccpEndpointsReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addBillingServer operation/method
 */
if ($add->addBillingServer(new \Losc\CucmBundle\Model\Webservice\StructType\AddBillingServerReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addLbmGroup operation/method
 */
if ($add->addLbmGroup(new \Losc\CucmBundle\Model\Webservice\StructType\AddLbmGroupReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addAnnouncement operation/method
 */
if ($add->addAnnouncement(new \Losc\CucmBundle\Model\Webservice\StructType\AddAnnouncementReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addServiceProfile operation/method
 */
if ($add->addServiceProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddServiceProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addLdapSyncCustomField operation/method
 */
if ($add->addLdapSyncCustomField(new \Losc\CucmBundle\Model\Webservice\StructType\AddLdapSyncCustomFieldReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addAudioCodecPreferenceList operation/method
 */
if ($add->addAudioCodecPreferenceList(new \Losc\CucmBundle\Model\Webservice\StructType\AddAudioCodecPreferenceListReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addUcService operation/method
 */
if ($add->addUcService(new \Losc\CucmBundle\Model\Webservice\StructType\AddUcServiceReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addLbmHubGroup operation/method
 */
if ($add->addLbmHubGroup(new \Losc\CucmBundle\Model\Webservice\StructType\AddLbmHubGroupReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addImportedDirectoryUriCatalogs operation/method
 */
if ($add->addImportedDirectoryUriCatalogs(new \Losc\CucmBundle\Model\Webservice\StructType\AddImportedDirectoryUriCatalogsReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addVohServer operation/method
 */
if ($add->addVohServer(new \Losc\CucmBundle\Model\Webservice\StructType\AddVohServerReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addSdpTransparencyProfile operation/method
 */
if ($add->addSdpTransparencyProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddSdpTransparencyProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addFeatureGroupTemplate operation/method
 */
if ($add->addFeatureGroupTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\AddFeatureGroupTemplateReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addDirNumberAliasLookupandSync operation/method
 */
if ($add->addDirNumberAliasLookupandSync(new \Losc\CucmBundle\Model\Webservice\StructType\AddDirNumberAliasLookupandSyncReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addLocalRouteGroup operation/method
 */
if ($add->addLocalRouteGroup(new \Losc\CucmBundle\Model\Webservice\StructType\AddLocalRouteGroupReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addAdvertisedPatterns operation/method
 */
if ($add->addAdvertisedPatterns(new \Losc\CucmBundle\Model\Webservice\StructType\AddAdvertisedPatternsReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addBlockedLearnedPatterns operation/method
 */
if ($add->addBlockedLearnedPatterns(new \Losc\CucmBundle\Model\Webservice\StructType\AddBlockedLearnedPatternsReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addCCAProfiles operation/method
 */
if ($add->addCCAProfiles(new \Losc\CucmBundle\Model\Webservice\StructType\AddCCAProfilesReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addUniversalDeviceTemplate operation/method
 */
if ($add->addUniversalDeviceTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\AddUniversalDeviceTemplateReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addUserProfileProvision operation/method
 */
if ($add->addUserProfileProvision(new \Losc\CucmBundle\Model\Webservice\StructType\AddUserProfileProvisionReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addPresenceRedundancyGroup operation/method
 */
if ($add->addPresenceRedundancyGroup(new \Losc\CucmBundle\Model\Webservice\StructType\AddPresenceRedundancyGroupReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addWifiHotspot operation/method
 */
if ($add->addWifiHotspot(new \Losc\CucmBundle\Model\Webservice\StructType\AddWifiHotspotReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addWlanProfileGroup operation/method
 */
if ($add->addWlanProfileGroup(new \Losc\CucmBundle\Model\Webservice\StructType\AddWlanProfileGroupReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addWLANProfile operation/method
 */
if ($add->addWLANProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddWLANProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addUniversalLineTemplate operation/method
 */
if ($add->addUniversalLineTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\AddUniversalLineTemplateReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addNetworkAccessProfile operation/method
 */
if ($add->addNetworkAccessProfile(new \Losc\CucmBundle\Model\Webservice\StructType\AddNetworkAccessProfileReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addMobility operation/method
 */
if ($add->addMobility(new \Losc\CucmBundle\Model\Webservice\StructType\AddMobilityReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addApplicationToSoftkeyTemplate operation/method
 */
if ($add->addApplicationToSoftkeyTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\AddApplicationToSoftkeyTemplateReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addSNMPCommunityString operation/method
 */
if ($add->addSNMPCommunityString(new \Losc\CucmBundle\Model\Webservice\StructType\AddSNMPCommunityStringReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for addSNMPUser operation/method
 */
if ($add->addSNMPUser(new \Losc\CucmBundle\Model\Webservice\StructType\AddSNMPUserReq()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Samples for Update ServiceType
 */
$update = new \Losc\CucmBundle\Model\Webservice\ServiceType\Update($options);
/**
 * Sample call for updateSipProfile operation/method
 */
if ($update->updateSipProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateSipProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateSipTrunkSecurityProfile operation/method
 */
if ($update->updateSipTrunkSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateSipTrunkSecurityProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateTimePeriod operation/method
 */
if ($update->updateTimePeriod(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateTimePeriodReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateTimeSchedule operation/method
 */
if ($update->updateTimeSchedule(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateTimeScheduleReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateTodAccess operation/method
 */
if ($update->updateTodAccess(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateTodAccessReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateVoiceMailPilot operation/method
 */
if ($update->updateVoiceMailPilot(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateVoiceMailPilotReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateProcessNode operation/method
 */
if ($update->updateProcessNode(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateProcessNodeReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCallerFilterList operation/method
 */
if ($update->updateCallerFilterList(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCallerFilterListReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateRoutePartition operation/method
 */
if ($update->updateRoutePartition(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateRoutePartitionReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCss operation/method
 */
if ($update->updateCss(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCssReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCallManager operation/method
 */
if ($update->updateCallManager(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCallManagerReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateMediaResourceGroup operation/method
 */
if ($update->updateMediaResourceGroup(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateMediaResourceGroupReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateMediaResourceList operation/method
 */
if ($update->updateMediaResourceList(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateMediaResourceListReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateRegion operation/method
 */
if ($update->updateRegion(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateRegionReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateAarGroup operation/method
 */
if ($update->updateAarGroup(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateAarGroupReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updatePhysicalLocation operation/method
 */
if ($update->updatePhysicalLocation(new \Losc\CucmBundle\Model\Webservice\StructType\UpdatePhysicalLocationReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateRouteGroup operation/method
 */
if ($update->updateRouteGroup(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateRouteGroupReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateDevicePool operation/method
 */
if ($update->updateDevicePool(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateDevicePoolReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateDeviceMobilityGroup operation/method
 */
if ($update->updateDeviceMobilityGroup(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateDeviceMobilityGroupReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateLocation operation/method
 */
if ($update->updateLocation(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateLocationReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateSoftKeyTemplate operation/method
 */
if ($update->updateSoftKeyTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateSoftKeyTemplateReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateTranscoder operation/method
 */
if ($update->updateTranscoder(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateTranscoderReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCommonDeviceConfig operation/method
 */
if ($update->updateCommonDeviceConfig(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCommonDeviceConfigReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateResourcePriorityNamespace operation/method
 */
if ($update->updateResourcePriorityNamespace(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateResourcePriorityNamespaceReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateResourcePriorityNamespaceList operation/method
 */
if ($update->updateResourcePriorityNamespaceList(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateResourcePriorityNamespaceListReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateDeviceMobility operation/method
 */
if ($update->updateDeviceMobility(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateDeviceMobilityReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCmcInfo operation/method
 */
if ($update->updateCmcInfo(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCmcInfoReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCredentialPolicy operation/method
 */
if ($update->updateCredentialPolicy(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCredentialPolicyReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateFacInfo operation/method
 */
if ($update->updateFacInfo(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateFacInfoReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateHuntList operation/method
 */
if ($update->updateHuntList(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateHuntListReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateIvrUserLocale operation/method
 */
if ($update->updateIvrUserLocale(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateIvrUserLocaleReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateLineGroup operation/method
 */
if ($update->updateLineGroup(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateLineGroupReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateRecordingProfile operation/method
 */
if ($update->updateRecordingProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateRecordingProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateRouteFilter operation/method
 */
if ($update->updateRouteFilter(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateRouteFilterReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCallManagerGroup operation/method
 */
if ($update->updateCallManagerGroup(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCallManagerGroupReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateUserGroup operation/method
 */
if ($update->updateUserGroup(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateUserGroupReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateProcessNodeService operation/method
 */
if ($update->updateProcessNodeService(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateProcessNodeServiceReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateMohAudioSource operation/method
 */
if ($update->updateMohAudioSource(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateMohAudioSourceReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateDhcpServer operation/method
 */
if ($update->updateDhcpServer(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateDhcpServerReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateDhcpSubnet operation/method
 */
if ($update->updateDhcpSubnet(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateDhcpSubnetReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCallPark operation/method
 */
if ($update->updateCallPark(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCallParkReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateDirectedCallPark operation/method
 */
if ($update->updateDirectedCallPark(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateDirectedCallParkReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateMeetMe operation/method
 */
if ($update->updateMeetMe(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateMeetMeReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateMobileVoiceAccess operation/method
 */
if ($update->updateMobileVoiceAccess(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateMobileVoiceAccessReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateRouteList operation/method
 */
if ($update->updateRouteList(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateRouteListReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateUser operation/method
 */
if ($update->updateUser(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateUserReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateAppUser operation/method
 */
if ($update->updateAppUser(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateAppUserReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateSipRealm operation/method
 */
if ($update->updateSipRealm(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateSipRealmReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updatePhoneNtp operation/method
 */
if ($update->updatePhoneNtp(new \Losc\CucmBundle\Model\Webservice\StructType\UpdatePhoneNtpReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateDateTimeGroup operation/method
 */
if ($update->updateDateTimeGroup(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateDateTimeGroupReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updatePresenceGroup operation/method
 */
if ($update->updatePresenceGroup(new \Losc\CucmBundle\Model\Webservice\StructType\UpdatePresenceGroupReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateGeoLocation operation/method
 */
if ($update->updateGeoLocation(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateGeoLocationReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateSrst operation/method
 */
if ($update->updateSrst(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateSrstReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateMlppDomain operation/method
 */
if ($update->updateMlppDomain(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateMlppDomainReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCumaServerSecurityProfile operation/method
 */
if ($update->updateCumaServerSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCumaServerSecurityProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateApplicationServer operation/method
 */
if ($update->updateApplicationServer(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateApplicationServerReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateApplicationUserCapfProfile operation/method
 */
if ($update->updateApplicationUserCapfProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateApplicationUserCapfProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateEndUserCapfProfile operation/method
 */
if ($update->updateEndUserCapfProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateEndUserCapfProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateServiceParameter operation/method
 */
if ($update->updateServiceParameter(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateServiceParameterReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateGeoLocationFilter operation/method
 */
if ($update->updateGeoLocationFilter(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateGeoLocationFilterReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateVoiceMailProfile operation/method
 */
if ($update->updateVoiceMailProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateVoiceMailProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateVoiceMailPort operation/method
 */
if ($update->updateVoiceMailPort(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateVoiceMailPortReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateGatekeeper operation/method
 */
if ($update->updateGatekeeper(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateGatekeeperReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updatePhoneButtonTemplate operation/method
 */
if ($update->updatePhoneButtonTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\UpdatePhoneButtonTemplateReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCommonPhoneConfig operation/method
 */
if ($update->updateCommonPhoneConfig(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCommonPhoneConfigReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateMessageWaiting operation/method
 */
if ($update->updateMessageWaiting(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateMessageWaitingReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateIpPhoneServices operation/method
 */
if ($update->updateIpPhoneServices(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateIpPhoneServicesReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCtiRoutePoint operation/method
 */
if ($update->updateCtiRoutePoint(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCtiRoutePointReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateTransPattern operation/method
 */
if ($update->updateTransPattern(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateTransPatternReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCallingPartyTransformationPattern operation/method
 */
if ($update->updateCallingPartyTransformationPattern(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCallingPartyTransformationPatternReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateSipRoutePattern operation/method
 */
if ($update->updateSipRoutePattern(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateSipRoutePatternReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateHuntPilot operation/method
 */
if ($update->updateHuntPilot(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateHuntPilotReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateRoutePattern operation/method
 */
if ($update->updateRoutePattern(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateRoutePatternReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateApplicationDialRules operation/method
 */
if ($update->updateApplicationDialRules(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateApplicationDialRulesReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateDirectoryLookupDialRules operation/method
 */
if ($update->updateDirectoryLookupDialRules(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateDirectoryLookupDialRulesReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updatePhoneSecurityProfile operation/method
 */
if ($update->updatePhoneSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdatePhoneSecurityProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateSipDialRules operation/method
 */
if ($update->updateSipDialRules(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateSipDialRulesReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateConferenceBridge operation/method
 */
if ($update->updateConferenceBridge(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateConferenceBridgeReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateAnnunciator operation/method
 */
if ($update->updateAnnunciator(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateAnnunciatorReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateMtp operation/method
 */
if ($update->updateMtp(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateMtpReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateFixedMohAudioSource operation/method
 */
if ($update->updateFixedMohAudioSource(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateFixedMohAudioSourceReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateAarGroupMatrix operation/method
 */
if ($update->updateAarGroupMatrix(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateAarGroupMatrixReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateRemoteDestinationProfile operation/method
 */
if ($update->updateRemoteDestinationProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateRemoteDestinationProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateLine operation/method
 */
if ($update->updateLine(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateLineReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateDefaultDeviceProfile operation/method
 */
if ($update->updateDefaultDeviceProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateDefaultDeviceProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateH323Phone operation/method
 */
if ($update->updateH323Phone(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateH323PhoneReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateMohServer operation/method
 */
if ($update->updateMohServer(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateMohServerReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateH323Trunk operation/method
 */
if ($update->updateH323Trunk(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateH323TrunkReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updatePhone operation/method
 */
if ($update->updatePhone(new \Losc\CucmBundle\Model\Webservice\StructType\UpdatePhoneReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateH323Gateway operation/method
 */
if ($update->updateH323Gateway(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateH323GatewayReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateDeviceProfile operation/method
 */
if ($update->updateDeviceProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateDeviceProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateRemoteDestination operation/method
 */
if ($update->updateRemoteDestination(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateRemoteDestinationReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateVg224 operation/method
 */
if ($update->updateVg224(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateVg224Req()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateGateway operation/method
 */
if ($update->updateGateway(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateGatewayReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateGatewayEndpointAnalogAccess operation/method
 */
if ($update->updateGatewayEndpointAnalogAccess(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateGatewayEndpointAnalogAccessReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateGatewayEndpointDigitalAccessPri operation/method
 */
if ($update->updateGatewayEndpointDigitalAccessPri(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateGatewayEndpointDigitalAccessPriReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateGatewayEndpointDigitalAccessBri operation/method
 */
if ($update->updateGatewayEndpointDigitalAccessBri(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateGatewayEndpointDigitalAccessBriReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateGatewayEndpointDigitalAccessT1 operation/method
 */
if ($update->updateGatewayEndpointDigitalAccessT1(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateGatewayEndpointDigitalAccessT1Req()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCiscoCatalyst600024PortFXSGateway operation/method
 */
if ($update->updateCiscoCatalyst600024PortFXSGateway(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCiscoCatalyst600024PortFXSGatewayReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCiscoCatalyst6000E1VoIPGateway operation/method
 */
if ($update->updateCiscoCatalyst6000E1VoIPGateway(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCiscoCatalyst6000E1VoIPGatewayReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCiscoCatalyst6000T1VoIPGatewayPri operation/method
 */
if ($update->updateCiscoCatalyst6000T1VoIPGatewayPri(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCiscoCatalyst6000T1VoIPGatewayPriReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCiscoCatalyst6000T1VoIPGatewayT1 operation/method
 */
if ($update->updateCiscoCatalyst6000T1VoIPGatewayT1(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCiscoCatalyst6000T1VoIPGatewayT1Req()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCallPickupGroup operation/method
 */
if ($update->updateCallPickupGroup(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCallPickupGroupReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateGeoLocationPolicy operation/method
 */
if ($update->updateGeoLocationPolicy(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateGeoLocationPolicyReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateSipTrunk operation/method
 */
if ($update->updateSipTrunk(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateSipTrunkReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateRegionMatrix operation/method
 */
if ($update->updateRegionMatrix(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateRegionMatrixReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCalledPartyTransformationPattern operation/method
 */
if ($update->updateCalledPartyTransformationPattern(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCalledPartyTransformationPatternReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateExternalCallControlProfile operation/method
 */
if ($update->updateExternalCallControlProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateExternalCallControlProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateSafSecurityProfile operation/method
 */
if ($update->updateSafSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateSafSecurityProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateSafForwarder operation/method
 */
if ($update->updateSafForwarder(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateSafForwarderReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCcdHostedDN operation/method
 */
if ($update->updateCcdHostedDN(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCcdHostedDNReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCcdHostedDNGroup operation/method
 */
if ($update->updateCcdHostedDNGroup(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCcdHostedDNGroupReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCcdRequestingService operation/method
 */
if ($update->updateCcdRequestingService(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCcdRequestingServiceReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateInterClusterServiceProfile operation/method
 */
if ($update->updateInterClusterServiceProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateInterClusterServiceProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateRemoteCluster operation/method
 */
if ($update->updateRemoteCluster(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateRemoteClusterReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCcdAdvertisingService operation/method
 */
if ($update->updateCcdAdvertisingService(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCcdAdvertisingServiceReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateLdapDirectory operation/method
 */
if ($update->updateLdapDirectory(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateLdapDirectoryReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateEmccFeatureConfig operation/method
 */
if ($update->updateEmccFeatureConfig(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateEmccFeatureConfigReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateSafCcdPurgeBlockLearnedRoutes operation/method
 */
if ($update->updateSafCcdPurgeBlockLearnedRoutes(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateSafCcdPurgeBlockLearnedRoutesReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateVpnGateway operation/method
 */
if ($update->updateVpnGateway(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateVpnGatewayReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateVpnGroup operation/method
 */
if ($update->updateVpnGroup(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateVpnGroupReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateVpnProfile operation/method
 */
if ($update->updateVpnProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateVpnProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateImeServer operation/method
 */
if ($update->updateImeServer(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateImeServerReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateImeRouteFilterGroup operation/method
 */
if ($update->updateImeRouteFilterGroup(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateImeRouteFilterGroupReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateImeRouteFilterElement operation/method
 */
if ($update->updateImeRouteFilterElement(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateImeRouteFilterElementReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateImeClient operation/method
 */
if ($update->updateImeClient(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateImeClientReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateImeEnrolledPattern operation/method
 */
if ($update->updateImeEnrolledPattern(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateImeEnrolledPatternReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateImeEnrolledPatternGroup operation/method
 */
if ($update->updateImeEnrolledPatternGroup(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateImeEnrolledPatternGroupReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateImeExclusionNumber operation/method
 */
if ($update->updateImeExclusionNumber(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateImeExclusionNumberReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateImeExclusionNumberGroup operation/method
 */
if ($update->updateImeExclusionNumberGroup(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateImeExclusionNumberGroupReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateImeFirewall operation/method
 */
if ($update->updateImeFirewall(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateImeFirewallReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateImeE164Transformation operation/method
 */
if ($update->updateImeE164Transformation(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateImeE164TransformationReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateTransformationProfile operation/method
 */
if ($update->updateTransformationProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateTransformationProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateFallbackProfile operation/method
 */
if ($update->updateFallbackProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateFallbackProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateLdapFilter operation/method
 */
if ($update->updateLdapFilter(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateLdapFilterReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateAppServerInfo operation/method
 */
if ($update->updateAppServerInfo(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateAppServerInfoReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateTvsCertificate operation/method
 */
if ($update->updateTvsCertificate(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateTvsCertificateReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateFeatureControlPolicy operation/method
 */
if ($update->updateFeatureControlPolicy(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateFeatureControlPolicyReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateMobilityProfile operation/method
 */
if ($update->updateMobilityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateMobilityProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateEnterpriseFeatureAccessConfiguration operation/method
 */
if ($update->updateEnterpriseFeatureAccessConfiguration(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateEnterpriseFeatureAccessConfigurationReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateHandoffConfiguration operation/method
 */
if ($update->updateHandoffConfiguration(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateHandoffConfigurationReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateSIPNormalizationScript operation/method
 */
if ($update->updateSIPNormalizationScript(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateSIPNormalizationScriptReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCustomUserField operation/method
 */
if ($update->updateCustomUserField(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCustomUserFieldReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateGatewaySccpEndpoints operation/method
 */
if ($update->updateGatewaySccpEndpoints(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateGatewaySccpEndpointsReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateLbmGroup operation/method
 */
if ($update->updateLbmGroup(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateLbmGroupReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateAnnouncement operation/method
 */
if ($update->updateAnnouncement(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateAnnouncementReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateServiceProfile operation/method
 */
if ($update->updateServiceProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateServiceProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateLdapSyncCustomField operation/method
 */
if ($update->updateLdapSyncCustomField(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateLdapSyncCustomFieldReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateAudioCodecPreferenceList operation/method
 */
if ($update->updateAudioCodecPreferenceList(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateAudioCodecPreferenceListReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateUcService operation/method
 */
if ($update->updateUcService(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateUcServiceReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateLbmHubGroup operation/method
 */
if ($update->updateLbmHubGroup(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateLbmHubGroupReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateImportedDirectoryUriCatalogs operation/method
 */
if ($update->updateImportedDirectoryUriCatalogs(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateImportedDirectoryUriCatalogsReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateVohServer operation/method
 */
if ($update->updateVohServer(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateVohServerReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateSdpTransparencyProfile operation/method
 */
if ($update->updateSdpTransparencyProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateSdpTransparencyProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateFeatureGroupTemplate operation/method
 */
if ($update->updateFeatureGroupTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateFeatureGroupTemplateReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateDirNumberAliasLookupandSync operation/method
 */
if ($update->updateDirNumberAliasLookupandSync(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateDirNumberAliasLookupandSyncReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateAdvertisedPatterns operation/method
 */
if ($update->updateAdvertisedPatterns(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateAdvertisedPatternsReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateBlockedLearnedPatterns operation/method
 */
if ($update->updateBlockedLearnedPatterns(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateBlockedLearnedPatternsReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCCAProfiles operation/method
 */
if ($update->updateCCAProfiles(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCCAProfilesReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateUniversalDeviceTemplate operation/method
 */
if ($update->updateUniversalDeviceTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateUniversalDeviceTemplateReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateUserProfileProvision operation/method
 */
if ($update->updateUserProfileProvision(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateUserProfileProvisionReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updatePresenceRedundancyGroup operation/method
 */
if ($update->updatePresenceRedundancyGroup(new \Losc\CucmBundle\Model\Webservice\StructType\UpdatePresenceRedundancyGroupReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateWifiHotspot operation/method
 */
if ($update->updateWifiHotspot(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateWifiHotspotReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateWlanProfileGroup operation/method
 */
if ($update->updateWlanProfileGroup(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateWlanProfileGroupReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateWLANProfile operation/method
 */
if ($update->updateWLANProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateWLANProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateUniversalLineTemplate operation/method
 */
if ($update->updateUniversalLineTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateUniversalLineTemplateReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateNetworkAccessProfile operation/method
 */
if ($update->updateNetworkAccessProfile(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateNetworkAccessProfileReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateMobility operation/method
 */
if ($update->updateMobility(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateMobilityReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateEnterprisePhoneConfig operation/method
 */
if ($update->updateEnterprisePhoneConfig(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateEnterprisePhoneConfigReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateLdapSystem operation/method
 */
if ($update->updateLdapSystem(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateLdapSystemReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateLdapAuthentication operation/method
 */
if ($update->updateLdapAuthentication(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateLdapAuthenticationReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateImeFeatureConfig operation/method
 */
if ($update->updateImeFeatureConfig(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateImeFeatureConfigReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateFallbackFeatureConfig operation/method
 */
if ($update->updateFallbackFeatureConfig(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateFallbackFeatureConfigReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateImeLearnedRoutes operation/method
 */
if ($update->updateImeLearnedRoutes(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateImeLearnedRoutesReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateSoftKeySet operation/method
 */
if ($update->updateSoftKeySet(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateSoftKeySetReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateSyslogConfiguration operation/method
 */
if ($update->updateSyslogConfiguration(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateSyslogConfigurationReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateInterClusterDirectoryUri operation/method
 */
if ($update->updateInterClusterDirectoryUri(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateInterClusterDirectoryUriReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateIlsConfig operation/method
 */
if ($update->updateIlsConfig(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateIlsConfigReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateSNMPCommunityString operation/method
 */
if ($update->updateSNMPCommunityString(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateSNMPCommunityStringReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateSNMPUser operation/method
 */
if ($update->updateSNMPUser(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateSNMPUserReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateSNMPMIB2List operation/method
 */
if ($update->updateSNMPMIB2List(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateSNMPMIB2ListReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateBillingServer operation/method
 */
if ($update->updateBillingServer(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateBillingServerReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCcdFeatureConfig operation/method
 */
if ($update->updateCcdFeatureConfig(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCcdFeatureConfigReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateRoutePartitionsForLearnedPatterns operation/method
 */
if ($update->updateRoutePartitionsForLearnedPatterns(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateRoutePartitionsForLearnedPatternsReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateLocalRouteGroup operation/method
 */
if ($update->updateLocalRouteGroup(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateLocalRouteGroupReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updatePageLayoutPreferences operation/method
 */
if ($update->updatePageLayoutPreferences(new \Losc\CucmBundle\Model\Webservice\StructType\UpdatePageLayoutPreferencesReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateCredentialPolicyDefault operation/method
 */
if ($update->updateCredentialPolicyDefault(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateCredentialPolicyDefaultReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateSelfProvisioning operation/method
 */
if ($update->updateSelfProvisioning(new \Losc\CucmBundle\Model\Webservice\StructType\UpdateSelfProvisioningReq()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Samples for Get ServiceType
 */
$get = new \Losc\CucmBundle\Model\Webservice\ServiceType\Get($options);
/**
 * Sample call for getSipProfile operation/method
 */
if ($get->getSipProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetSipProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSipProfileOptions operation/method
 */
if ($get->getSipProfileOptions(new \Losc\CucmBundle\Model\Webservice\StructType\GetSipProfileOptionsReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSipTrunkSecurityProfile operation/method
 */
if ($get->getSipTrunkSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetSipTrunkSecurityProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getTimePeriod operation/method
 */
if ($get->getTimePeriod(new \Losc\CucmBundle\Model\Webservice\StructType\GetTimePeriodReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getTimeSchedule operation/method
 */
if ($get->getTimeSchedule(new \Losc\CucmBundle\Model\Webservice\StructType\GetTimeScheduleReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getTodAccess operation/method
 */
if ($get->getTodAccess(new \Losc\CucmBundle\Model\Webservice\StructType\GetTodAccessReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getVoiceMailPilot operation/method
 */
if ($get->getVoiceMailPilot(new \Losc\CucmBundle\Model\Webservice\StructType\GetVoiceMailPilotReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getProcessNode operation/method
 */
if ($get->getProcessNode(new \Losc\CucmBundle\Model\Webservice\StructType\GetProcessNodeReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCallerFilterList operation/method
 */
if ($get->getCallerFilterList(new \Losc\CucmBundle\Model\Webservice\StructType\GetCallerFilterListReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getRoutePartition operation/method
 */
if ($get->getRoutePartition(new \Losc\CucmBundle\Model\Webservice\StructType\GetRoutePartitionReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCss operation/method
 */
if ($get->getCss(new \Losc\CucmBundle\Model\Webservice\StructType\GetCssReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCallManager operation/method
 */
if ($get->getCallManager(new \Losc\CucmBundle\Model\Webservice\StructType\GetCallManagerReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getMediaResourceGroup operation/method
 */
if ($get->getMediaResourceGroup(new \Losc\CucmBundle\Model\Webservice\StructType\GetMediaResourceGroupReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getMediaResourceList operation/method
 */
if ($get->getMediaResourceList(new \Losc\CucmBundle\Model\Webservice\StructType\GetMediaResourceListReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getRegion operation/method
 */
if ($get->getRegion(new \Losc\CucmBundle\Model\Webservice\StructType\GetRegionReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getAarGroup operation/method
 */
if ($get->getAarGroup(new \Losc\CucmBundle\Model\Webservice\StructType\GetAarGroupReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getPhysicalLocation operation/method
 */
if ($get->getPhysicalLocation(new \Losc\CucmBundle\Model\Webservice\StructType\GetPhysicalLocationReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getRouteGroup operation/method
 */
if ($get->getRouteGroup(new \Losc\CucmBundle\Model\Webservice\StructType\GetRouteGroupReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDevicePool operation/method
 */
if ($get->getDevicePool(new \Losc\CucmBundle\Model\Webservice\StructType\GetDevicePoolReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDeviceMobilityGroup operation/method
 */
if ($get->getDeviceMobilityGroup(new \Losc\CucmBundle\Model\Webservice\StructType\GetDeviceMobilityGroupReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getLocation operation/method
 */
if ($get->getLocation(new \Losc\CucmBundle\Model\Webservice\StructType\GetLocationReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSoftKeyTemplate operation/method
 */
if ($get->getSoftKeyTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\GetSoftKeyTemplateReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getTranscoder operation/method
 */
if ($get->getTranscoder(new \Losc\CucmBundle\Model\Webservice\StructType\GetTranscoderReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCommonDeviceConfig operation/method
 */
if ($get->getCommonDeviceConfig(new \Losc\CucmBundle\Model\Webservice\StructType\GetCommonDeviceConfigReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getResourcePriorityNamespace operation/method
 */
if ($get->getResourcePriorityNamespace(new \Losc\CucmBundle\Model\Webservice\StructType\GetResourcePriorityNamespaceReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getResourcePriorityNamespaceList operation/method
 */
if ($get->getResourcePriorityNamespaceList(new \Losc\CucmBundle\Model\Webservice\StructType\GetResourcePriorityNamespaceListReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDeviceMobility operation/method
 */
if ($get->getDeviceMobility(new \Losc\CucmBundle\Model\Webservice\StructType\GetDeviceMobilityReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCmcInfo operation/method
 */
if ($get->getCmcInfo(new \Losc\CucmBundle\Model\Webservice\StructType\GetCmcInfoReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCredentialPolicy operation/method
 */
if ($get->getCredentialPolicy(new \Losc\CucmBundle\Model\Webservice\StructType\GetCredentialPolicyReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getFacInfo operation/method
 */
if ($get->getFacInfo(new \Losc\CucmBundle\Model\Webservice\StructType\GetFacInfoReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getHuntList operation/method
 */
if ($get->getHuntList(new \Losc\CucmBundle\Model\Webservice\StructType\GetHuntListReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getIvrUserLocale operation/method
 */
if ($get->getIvrUserLocale(new \Losc\CucmBundle\Model\Webservice\StructType\GetIvrUserLocaleReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getLineGroup operation/method
 */
if ($get->getLineGroup(new \Losc\CucmBundle\Model\Webservice\StructType\GetLineGroupReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getRecordingProfile operation/method
 */
if ($get->getRecordingProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetRecordingProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getRouteFilter operation/method
 */
if ($get->getRouteFilter(new \Losc\CucmBundle\Model\Webservice\StructType\GetRouteFilterReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCallManagerGroup operation/method
 */
if ($get->getCallManagerGroup(new \Losc\CucmBundle\Model\Webservice\StructType\GetCallManagerGroupReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getUserGroup operation/method
 */
if ($get->getUserGroup(new \Losc\CucmBundle\Model\Webservice\StructType\GetUserGroupReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDialPlan operation/method
 */
if ($get->getDialPlan(new \Losc\CucmBundle\Model\Webservice\StructType\GetDialPlanReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDialPlanTag operation/method
 */
if ($get->getDialPlanTag(new \Losc\CucmBundle\Model\Webservice\StructType\GetDialPlanTagReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDdi operation/method
 */
if ($get->getDdi(new \Losc\CucmBundle\Model\Webservice\StructType\GetDdiReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getMobileSmartClientProfile operation/method
 */
if ($get->getMobileSmartClientProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetMobileSmartClientProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getProcessNodeService operation/method
 */
if ($get->getProcessNodeService(new \Losc\CucmBundle\Model\Webservice\StructType\GetProcessNodeServiceReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getMohAudioSource operation/method
 */
if ($get->getMohAudioSource(new \Losc\CucmBundle\Model\Webservice\StructType\GetMohAudioSourceReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDhcpServer operation/method
 */
if ($get->getDhcpServer(new \Losc\CucmBundle\Model\Webservice\StructType\GetDhcpServerReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDhcpSubnet operation/method
 */
if ($get->getDhcpSubnet(new \Losc\CucmBundle\Model\Webservice\StructType\GetDhcpSubnetReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCallPark operation/method
 */
if ($get->getCallPark(new \Losc\CucmBundle\Model\Webservice\StructType\GetCallParkReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDirectedCallPark operation/method
 */
if ($get->getDirectedCallPark(new \Losc\CucmBundle\Model\Webservice\StructType\GetDirectedCallParkReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getMeetMe operation/method
 */
if ($get->getMeetMe(new \Losc\CucmBundle\Model\Webservice\StructType\GetMeetMeReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getMobileVoiceAccess operation/method
 */
if ($get->getMobileVoiceAccess(new \Losc\CucmBundle\Model\Webservice\StructType\GetMobileVoiceAccessReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getRouteList operation/method
 */
if ($get->getRouteList(new \Losc\CucmBundle\Model\Webservice\StructType\GetRouteListReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getUser operation/method
 */
if ($get->getUser(new \Losc\CucmBundle\Model\Webservice\StructType\GetUserReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getAppUser operation/method
 */
if ($get->getAppUser(new \Losc\CucmBundle\Model\Webservice\StructType\GetAppUserReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSipRealm operation/method
 */
if ($get->getSipRealm(new \Losc\CucmBundle\Model\Webservice\StructType\GetSipRealmReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getPhoneNtp operation/method
 */
if ($get->getPhoneNtp(new \Losc\CucmBundle\Model\Webservice\StructType\GetPhoneNtpReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDateTimeGroup operation/method
 */
if ($get->getDateTimeGroup(new \Losc\CucmBundle\Model\Webservice\StructType\GetDateTimeGroupReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getPresenceGroup operation/method
 */
if ($get->getPresenceGroup(new \Losc\CucmBundle\Model\Webservice\StructType\GetPresenceGroupReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getGeoLocation operation/method
 */
if ($get->getGeoLocation(new \Losc\CucmBundle\Model\Webservice\StructType\GetGeoLocationReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSrst operation/method
 */
if ($get->getSrst(new \Losc\CucmBundle\Model\Webservice\StructType\GetSrstReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getMlppDomain operation/method
 */
if ($get->getMlppDomain(new \Losc\CucmBundle\Model\Webservice\StructType\GetMlppDomainReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCumaServerSecurityProfile operation/method
 */
if ($get->getCumaServerSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetCumaServerSecurityProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getApplicationServer operation/method
 */
if ($get->getApplicationServer(new \Losc\CucmBundle\Model\Webservice\StructType\GetApplicationServerReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getApplicationUserCapfProfile operation/method
 */
if ($get->getApplicationUserCapfProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetApplicationUserCapfProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getEndUserCapfProfile operation/method
 */
if ($get->getEndUserCapfProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetEndUserCapfProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getServiceParameter operation/method
 */
if ($get->getServiceParameter(new \Losc\CucmBundle\Model\Webservice\StructType\GetServiceParameterReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getGeoLocationFilter operation/method
 */
if ($get->getGeoLocationFilter(new \Losc\CucmBundle\Model\Webservice\StructType\GetGeoLocationFilterReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getVoiceMailProfile operation/method
 */
if ($get->getVoiceMailProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetVoiceMailProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getVoiceMailPort operation/method
 */
if ($get->getVoiceMailPort(new \Losc\CucmBundle\Model\Webservice\StructType\GetVoiceMailPortReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getGatekeeper operation/method
 */
if ($get->getGatekeeper(new \Losc\CucmBundle\Model\Webservice\StructType\GetGatekeeperReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getPhoneButtonTemplate operation/method
 */
if ($get->getPhoneButtonTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\GetPhoneButtonTemplateReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCommonPhoneConfig operation/method
 */
if ($get->getCommonPhoneConfig(new \Losc\CucmBundle\Model\Webservice\StructType\GetCommonPhoneConfigReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getMessageWaiting operation/method
 */
if ($get->getMessageWaiting(new \Losc\CucmBundle\Model\Webservice\StructType\GetMessageWaitingReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getIpPhoneServices operation/method
 */
if ($get->getIpPhoneServices(new \Losc\CucmBundle\Model\Webservice\StructType\GetIpPhoneServicesReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCtiRoutePoint operation/method
 */
if ($get->getCtiRoutePoint(new \Losc\CucmBundle\Model\Webservice\StructType\GetCtiRoutePointReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getTransPattern operation/method
 */
if ($get->getTransPattern(new \Losc\CucmBundle\Model\Webservice\StructType\GetTransPatternReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getTransPatternOptions operation/method
 */
if ($get->getTransPatternOptions(new \Losc\CucmBundle\Model\Webservice\StructType\GetTransPatternOptionsReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCallingPartyTransformationPattern operation/method
 */
if ($get->getCallingPartyTransformationPattern(new \Losc\CucmBundle\Model\Webservice\StructType\GetCallingPartyTransformationPatternReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSipRoutePattern operation/method
 */
if ($get->getSipRoutePattern(new \Losc\CucmBundle\Model\Webservice\StructType\GetSipRoutePatternReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getHuntPilot operation/method
 */
if ($get->getHuntPilot(new \Losc\CucmBundle\Model\Webservice\StructType\GetHuntPilotReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getRoutePattern operation/method
 */
if ($get->getRoutePattern(new \Losc\CucmBundle\Model\Webservice\StructType\GetRoutePatternReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getApplicationDialRules operation/method
 */
if ($get->getApplicationDialRules(new \Losc\CucmBundle\Model\Webservice\StructType\GetApplicationDialRulesReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDirectoryLookupDialRules operation/method
 */
if ($get->getDirectoryLookupDialRules(new \Losc\CucmBundle\Model\Webservice\StructType\GetDirectoryLookupDialRulesReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getPhoneSecurityProfile operation/method
 */
if ($get->getPhoneSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetPhoneSecurityProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSipDialRules operation/method
 */
if ($get->getSipDialRules(new \Losc\CucmBundle\Model\Webservice\StructType\GetSipDialRulesReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getConferenceBridge operation/method
 */
if ($get->getConferenceBridge(new \Losc\CucmBundle\Model\Webservice\StructType\GetConferenceBridgeReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getAnnunciator operation/method
 */
if ($get->getAnnunciator(new \Losc\CucmBundle\Model\Webservice\StructType\GetAnnunciatorReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getMtp operation/method
 */
if ($get->getMtp(new \Losc\CucmBundle\Model\Webservice\StructType\GetMtpReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getFixedMohAudioSource operation/method
 */
if ($get->getFixedMohAudioSource(new \Losc\CucmBundle\Model\Webservice\StructType\GetFixedMohAudioSourceReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getRemoteDestinationProfile operation/method
 */
if ($get->getRemoteDestinationProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetRemoteDestinationProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getLine operation/method
 */
if ($get->getLine(new \Losc\CucmBundle\Model\Webservice\StructType\GetLineReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getLineOptions operation/method
 */
if ($get->getLineOptions(new \Losc\CucmBundle\Model\Webservice\StructType\GetLineOptionsReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDefaultDeviceProfile operation/method
 */
if ($get->getDefaultDeviceProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetDefaultDeviceProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getH323Phone operation/method
 */
if ($get->getH323Phone(new \Losc\CucmBundle\Model\Webservice\StructType\GetH323PhoneReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getMohServer operation/method
 */
if ($get->getMohServer(new \Losc\CucmBundle\Model\Webservice\StructType\GetMohServerReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getH323Trunk operation/method
 */
if ($get->getH323Trunk(new \Losc\CucmBundle\Model\Webservice\StructType\GetH323TrunkReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getPhone operation/method
 */
if ($get->getPhone(new \Losc\CucmBundle\Model\Webservice\StructType\GetPhoneReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getPhoneOptions operation/method
 */
if ($get->getPhoneOptions(new \Losc\CucmBundle\Model\Webservice\StructType\GetPhoneOptionsReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getH323Gateway operation/method
 */
if ($get->getH323Gateway(new \Losc\CucmBundle\Model\Webservice\StructType\GetH323GatewayReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDeviceProfile operation/method
 */
if ($get->getDeviceProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetDeviceProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDeviceProfileOptions operation/method
 */
if ($get->getDeviceProfileOptions(new \Losc\CucmBundle\Model\Webservice\StructType\GetDeviceProfileOptionsReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getRemoteDestination operation/method
 */
if ($get->getRemoteDestination(new \Losc\CucmBundle\Model\Webservice\StructType\GetRemoteDestinationReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getVg224 operation/method
 */
if ($get->getVg224(new \Losc\CucmBundle\Model\Webservice\StructType\GetVg224Req()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getGateway operation/method
 */
if ($get->getGateway(new \Losc\CucmBundle\Model\Webservice\StructType\GetGatewayReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getGatewayEndpointAnalogAccess operation/method
 */
if ($get->getGatewayEndpointAnalogAccess(new \Losc\CucmBundle\Model\Webservice\StructType\GetGatewayEndpointAnalogAccessReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getGatewayEndpointDigitalAccessPri operation/method
 */
if ($get->getGatewayEndpointDigitalAccessPri(new \Losc\CucmBundle\Model\Webservice\StructType\GetGatewayEndpointDigitalAccessPriReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getGatewayEndpointDigitalAccessBri operation/method
 */
if ($get->getGatewayEndpointDigitalAccessBri(new \Losc\CucmBundle\Model\Webservice\StructType\GetGatewayEndpointDigitalAccessBriReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getGatewayEndpointDigitalAccessT1 operation/method
 */
if ($get->getGatewayEndpointDigitalAccessT1(new \Losc\CucmBundle\Model\Webservice\StructType\GetGatewayEndpointDigitalAccessT1Req()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCiscoCatalyst600024PortFXSGateway operation/method
 */
if ($get->getCiscoCatalyst600024PortFXSGateway(new \Losc\CucmBundle\Model\Webservice\StructType\GetCiscoCatalyst600024PortFXSGatewayReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCiscoCatalyst6000E1VoIPGateway operation/method
 */
if ($get->getCiscoCatalyst6000E1VoIPGateway(new \Losc\CucmBundle\Model\Webservice\StructType\GetCiscoCatalyst6000E1VoIPGatewayReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCiscoCatalyst6000T1VoIPGatewayPri operation/method
 */
if ($get->getCiscoCatalyst6000T1VoIPGatewayPri(new \Losc\CucmBundle\Model\Webservice\StructType\GetCiscoCatalyst6000T1VoIPGatewayPriReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCiscoCatalyst6000T1VoIPGatewayT1 operation/method
 */
if ($get->getCiscoCatalyst6000T1VoIPGatewayT1(new \Losc\CucmBundle\Model\Webservice\StructType\GetCiscoCatalyst6000T1VoIPGatewayT1Req()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCallPickupGroup operation/method
 */
if ($get->getCallPickupGroup(new \Losc\CucmBundle\Model\Webservice\StructType\GetCallPickupGroupReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getGeoLocationPolicy operation/method
 */
if ($get->getGeoLocationPolicy(new \Losc\CucmBundle\Model\Webservice\StructType\GetGeoLocationPolicyReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSipTrunk operation/method
 */
if ($get->getSipTrunk(new \Losc\CucmBundle\Model\Webservice\StructType\GetSipTrunkReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCalledPartyTransformationPattern operation/method
 */
if ($get->getCalledPartyTransformationPattern(new \Losc\CucmBundle\Model\Webservice\StructType\GetCalledPartyTransformationPatternReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getExternalCallControlProfile operation/method
 */
if ($get->getExternalCallControlProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetExternalCallControlProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSafSecurityProfile operation/method
 */
if ($get->getSafSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetSafSecurityProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSafForwarder operation/method
 */
if ($get->getSafForwarder(new \Losc\CucmBundle\Model\Webservice\StructType\GetSafForwarderReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCcdHostedDN operation/method
 */
if ($get->getCcdHostedDN(new \Losc\CucmBundle\Model\Webservice\StructType\GetCcdHostedDNReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCcdHostedDNGroup operation/method
 */
if ($get->getCcdHostedDNGroup(new \Losc\CucmBundle\Model\Webservice\StructType\GetCcdHostedDNGroupReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCcdRequestingService operation/method
 */
if ($get->getCcdRequestingService(new \Losc\CucmBundle\Model\Webservice\StructType\GetCcdRequestingServiceReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getInterClusterServiceProfile operation/method
 */
if ($get->getInterClusterServiceProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetInterClusterServiceProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getRemoteCluster operation/method
 */
if ($get->getRemoteCluster(new \Losc\CucmBundle\Model\Webservice\StructType\GetRemoteClusterReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCcdAdvertisingService operation/method
 */
if ($get->getCcdAdvertisingService(new \Losc\CucmBundle\Model\Webservice\StructType\GetCcdAdvertisingServiceReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getLdapDirectory operation/method
 */
if ($get->getLdapDirectory(new \Losc\CucmBundle\Model\Webservice\StructType\GetLdapDirectoryReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getEmccFeatureConfig operation/method
 */
if ($get->getEmccFeatureConfig(new \Losc\CucmBundle\Model\Webservice\StructType\GetEmccFeatureConfigReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSafCcdPurgeBlockLearnedRoutes operation/method
 */
if ($get->getSafCcdPurgeBlockLearnedRoutes(new \Losc\CucmBundle\Model\Webservice\StructType\GetSafCcdPurgeBlockLearnedRoutesReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getVpnGateway operation/method
 */
if ($get->getVpnGateway(new \Losc\CucmBundle\Model\Webservice\StructType\GetVpnGatewayReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getVpnGroup operation/method
 */
if ($get->getVpnGroup(new \Losc\CucmBundle\Model\Webservice\StructType\GetVpnGroupReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getVpnProfile operation/method
 */
if ($get->getVpnProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetVpnProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getImeServer operation/method
 */
if ($get->getImeServer(new \Losc\CucmBundle\Model\Webservice\StructType\GetImeServerReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getImeRouteFilterGroup operation/method
 */
if ($get->getImeRouteFilterGroup(new \Losc\CucmBundle\Model\Webservice\StructType\GetImeRouteFilterGroupReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getImeRouteFilterElement operation/method
 */
if ($get->getImeRouteFilterElement(new \Losc\CucmBundle\Model\Webservice\StructType\GetImeRouteFilterElementReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getImeClient operation/method
 */
if ($get->getImeClient(new \Losc\CucmBundle\Model\Webservice\StructType\GetImeClientReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getImeEnrolledPattern operation/method
 */
if ($get->getImeEnrolledPattern(new \Losc\CucmBundle\Model\Webservice\StructType\GetImeEnrolledPatternReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getImeEnrolledPatternGroup operation/method
 */
if ($get->getImeEnrolledPatternGroup(new \Losc\CucmBundle\Model\Webservice\StructType\GetImeEnrolledPatternGroupReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getImeExclusionNumber operation/method
 */
if ($get->getImeExclusionNumber(new \Losc\CucmBundle\Model\Webservice\StructType\GetImeExclusionNumberReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getImeExclusionNumberGroup operation/method
 */
if ($get->getImeExclusionNumberGroup(new \Losc\CucmBundle\Model\Webservice\StructType\GetImeExclusionNumberGroupReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getImeFirewall operation/method
 */
if ($get->getImeFirewall(new \Losc\CucmBundle\Model\Webservice\StructType\GetImeFirewallReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getImeE164Transformation operation/method
 */
if ($get->getImeE164Transformation(new \Losc\CucmBundle\Model\Webservice\StructType\GetImeE164TransformationReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getTransformationProfile operation/method
 */
if ($get->getTransformationProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetTransformationProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getFallbackProfile operation/method
 */
if ($get->getFallbackProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetFallbackProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getLdapFilter operation/method
 */
if ($get->getLdapFilter(new \Losc\CucmBundle\Model\Webservice\StructType\GetLdapFilterReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getTvsCertificate operation/method
 */
if ($get->getTvsCertificate(new \Losc\CucmBundle\Model\Webservice\StructType\GetTvsCertificateReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getFeatureControlPolicy operation/method
 */
if ($get->getFeatureControlPolicy(new \Losc\CucmBundle\Model\Webservice\StructType\GetFeatureControlPolicyReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getMobilityProfile operation/method
 */
if ($get->getMobilityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetMobilityProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getEnterpriseFeatureAccessConfiguration operation/method
 */
if ($get->getEnterpriseFeatureAccessConfiguration(new \Losc\CucmBundle\Model\Webservice\StructType\GetEnterpriseFeatureAccessConfigurationReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getHandoffConfiguration operation/method
 */
if ($get->getHandoffConfiguration(new \Losc\CucmBundle\Model\Webservice\StructType\GetHandoffConfigurationReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSIPNormalizationScript operation/method
 */
if ($get->getSIPNormalizationScript(new \Losc\CucmBundle\Model\Webservice\StructType\GetSIPNormalizationScriptReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCustomUserField operation/method
 */
if ($get->getCustomUserField(new \Losc\CucmBundle\Model\Webservice\StructType\GetCustomUserFieldReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getGatewaySccpEndpoints operation/method
 */
if ($get->getGatewaySccpEndpoints(new \Losc\CucmBundle\Model\Webservice\StructType\GetGatewaySccpEndpointsReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getLbmGroup operation/method
 */
if ($get->getLbmGroup(new \Losc\CucmBundle\Model\Webservice\StructType\GetLbmGroupReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getAnnouncement operation/method
 */
if ($get->getAnnouncement(new \Losc\CucmBundle\Model\Webservice\StructType\GetAnnouncementReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getServiceProfile operation/method
 */
if ($get->getServiceProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetServiceProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getLdapSyncCustomField operation/method
 */
if ($get->getLdapSyncCustomField(new \Losc\CucmBundle\Model\Webservice\StructType\GetLdapSyncCustomFieldReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getAudioCodecPreferenceList operation/method
 */
if ($get->getAudioCodecPreferenceList(new \Losc\CucmBundle\Model\Webservice\StructType\GetAudioCodecPreferenceListReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getUcService operation/method
 */
if ($get->getUcService(new \Losc\CucmBundle\Model\Webservice\StructType\GetUcServiceReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getLbmHubGroup operation/method
 */
if ($get->getLbmHubGroup(new \Losc\CucmBundle\Model\Webservice\StructType\GetLbmHubGroupReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getImportedDirectoryUriCatalogs operation/method
 */
if ($get->getImportedDirectoryUriCatalogs(new \Losc\CucmBundle\Model\Webservice\StructType\GetImportedDirectoryUriCatalogsReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getVohServer operation/method
 */
if ($get->getVohServer(new \Losc\CucmBundle\Model\Webservice\StructType\GetVohServerReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSdpTransparencyProfile operation/method
 */
if ($get->getSdpTransparencyProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetSdpTransparencyProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getFeatureGroupTemplate operation/method
 */
if ($get->getFeatureGroupTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\GetFeatureGroupTemplateReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDirNumberAliasLookupandSync operation/method
 */
if ($get->getDirNumberAliasLookupandSync(new \Losc\CucmBundle\Model\Webservice\StructType\GetDirNumberAliasLookupandSyncReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getLocalRouteGroup operation/method
 */
if ($get->getLocalRouteGroup(new \Losc\CucmBundle\Model\Webservice\StructType\GetLocalRouteGroupReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getAdvertisedPatterns operation/method
 */
if ($get->getAdvertisedPatterns(new \Losc\CucmBundle\Model\Webservice\StructType\GetAdvertisedPatternsReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getBlockedLearnedPatterns operation/method
 */
if ($get->getBlockedLearnedPatterns(new \Losc\CucmBundle\Model\Webservice\StructType\GetBlockedLearnedPatternsReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCCAProfiles operation/method
 */
if ($get->getCCAProfiles(new \Losc\CucmBundle\Model\Webservice\StructType\GetCCAProfilesReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getUniversalDeviceTemplate operation/method
 */
if ($get->getUniversalDeviceTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\GetUniversalDeviceTemplateReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getUserProfileProvision operation/method
 */
if ($get->getUserProfileProvision(new \Losc\CucmBundle\Model\Webservice\StructType\GetUserProfileProvisionReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getPresenceRedundancyGroup operation/method
 */
if ($get->getPresenceRedundancyGroup(new \Losc\CucmBundle\Model\Webservice\StructType\GetPresenceRedundancyGroupReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getWifiHotspot operation/method
 */
if ($get->getWifiHotspot(new \Losc\CucmBundle\Model\Webservice\StructType\GetWifiHotspotReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getWlanProfileGroup operation/method
 */
if ($get->getWlanProfileGroup(new \Losc\CucmBundle\Model\Webservice\StructType\GetWlanProfileGroupReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getWLANProfile operation/method
 */
if ($get->getWLANProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetWLANProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getUniversalLineTemplate operation/method
 */
if ($get->getUniversalLineTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\GetUniversalLineTemplateReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getNetworkAccessProfile operation/method
 */
if ($get->getNetworkAccessProfile(new \Losc\CucmBundle\Model\Webservice\StructType\GetNetworkAccessProfileReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getLicensedUser operation/method
 */
if ($get->getLicensedUser(new \Losc\CucmBundle\Model\Webservice\StructType\GetLicensedUserReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getOSVersion operation/method
 */
if ($get->getOSVersion(new \Losc\CucmBundle\Model\Webservice\StructType\GetOSVersionReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getNumDevices operation/method
 */
if ($get->getNumDevices(new \Losc\CucmBundle\Model\Webservice\StructType\GetNumDevicesReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getMobility operation/method
 */
if ($get->getMobility(new \Losc\CucmBundle\Model\Webservice\StructType\GetMobilityReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getEnterprisePhoneConfig operation/method
 */
if ($get->getEnterprisePhoneConfig(new \Losc\CucmBundle\Model\Webservice\StructType\GetEnterprisePhoneConfigReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getLdapSystem operation/method
 */
if ($get->getLdapSystem(new \Losc\CucmBundle\Model\Webservice\StructType\GetLdapSystemReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getLdapAuthentication operation/method
 */
if ($get->getLdapAuthentication(new \Losc\CucmBundle\Model\Webservice\StructType\GetLdapAuthenticationReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCCMVersion operation/method
 */
if ($get->getCCMVersion(new \Losc\CucmBundle\Model\Webservice\StructType\GetCCMVersionReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getImeLearnedRoutes operation/method
 */
if ($get->getImeLearnedRoutes(new \Losc\CucmBundle\Model\Webservice\StructType\GetImeLearnedRoutesReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getImeFeatureConfig operation/method
 */
if ($get->getImeFeatureConfig(new \Losc\CucmBundle\Model\Webservice\StructType\GetImeFeatureConfigReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getFallbackFeatureConfig operation/method
 */
if ($get->getFallbackFeatureConfig(new \Losc\CucmBundle\Model\Webservice\StructType\GetFallbackFeatureConfigReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getAppServerInfo operation/method
 */
if ($get->getAppServerInfo(new \Losc\CucmBundle\Model\Webservice\StructType\GetAppServerInfoReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getLdapSyncStatus operation/method
 */
if ($get->getLdapSyncStatus(new \Losc\CucmBundle\Model\Webservice\StructType\GetLdapSyncStatusReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSoftKeySet operation/method
 */
if ($get->getSoftKeySet(new \Losc\CucmBundle\Model\Webservice\StructType\GetSoftKeySetReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSyslogConfiguration operation/method
 */
if ($get->getSyslogConfiguration(new \Losc\CucmBundle\Model\Webservice\StructType\GetSyslogConfigurationReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getPhoneTypeDisplayInstance operation/method
 */
if ($get->getPhoneTypeDisplayInstance(new \Losc\CucmBundle\Model\Webservice\StructType\GetPhoneTypeDisplayInstanceReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getIlsConfig operation/method
 */
if ($get->getIlsConfig(new \Losc\CucmBundle\Model\Webservice\StructType\GetIlsConfigReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSNMPCommunityString operation/method
 */
if ($get->getSNMPCommunityString(new \Losc\CucmBundle\Model\Webservice\StructType\GetSNMPCommunityStringReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSNMPUser operation/method
 */
if ($get->getSNMPUser(new \Losc\CucmBundle\Model\Webservice\StructType\GetSNMPUserReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSNMPMIB2List operation/method
 */
if ($get->getSNMPMIB2List(new \Losc\CucmBundle\Model\Webservice\StructType\GetSNMPMIB2ListReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getBillingServer operation/method
 */
if ($get->getBillingServer(new \Losc\CucmBundle\Model\Webservice\StructType\GetBillingServerReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCcdFeatureConfig operation/method
 */
if ($get->getCcdFeatureConfig(new \Losc\CucmBundle\Model\Webservice\StructType\GetCcdFeatureConfigReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getPageLayoutPreferences operation/method
 */
if ($get->getPageLayoutPreferences(new \Losc\CucmBundle\Model\Webservice\StructType\GetPageLayoutPreferencesReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCredentialPolicyDefault operation/method
 */
if ($get->getCredentialPolicyDefault(new \Losc\CucmBundle\Model\Webservice\StructType\GetCredentialPolicyDefaultReq()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Samples for Remove ServiceType
 */
$remove = new \Losc\CucmBundle\Model\Webservice\ServiceType\Remove($options);
/**
 * Sample call for removeSipProfile operation/method
 */
if ($remove->removeSipProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeSipTrunkSecurityProfile operation/method
 */
if ($remove->removeSipTrunkSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeTimePeriod operation/method
 */
if ($remove->removeTimePeriod(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeTimeSchedule operation/method
 */
if ($remove->removeTimeSchedule(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeTodAccess operation/method
 */
if ($remove->removeTodAccess(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeVoiceMailPilot operation/method
 */
if ($remove->removeVoiceMailPilot(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveVoiceMailPilotReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeProcessNode operation/method
 */
if ($remove->removeProcessNode(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCallerFilterList operation/method
 */
if ($remove->removeCallerFilterList(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeRoutePartition operation/method
 */
if ($remove->removeRoutePartition(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCss operation/method
 */
if ($remove->removeCss(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeMediaResourceGroup operation/method
 */
if ($remove->removeMediaResourceGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeMediaResourceList operation/method
 */
if ($remove->removeMediaResourceList(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeRegion operation/method
 */
if ($remove->removeRegion(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeAarGroup operation/method
 */
if ($remove->removeAarGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removePhysicalLocation operation/method
 */
if ($remove->removePhysicalLocation(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeRouteGroup operation/method
 */
if ($remove->removeRouteGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeDevicePool operation/method
 */
if ($remove->removeDevicePool(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeDeviceMobilityGroup operation/method
 */
if ($remove->removeDeviceMobilityGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeLocation operation/method
 */
if ($remove->removeLocation(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeSoftKeyTemplate operation/method
 */
if ($remove->removeSoftKeyTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeTranscoder operation/method
 */
if ($remove->removeTranscoder(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCommonDeviceConfig operation/method
 */
if ($remove->removeCommonDeviceConfig(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeResourcePriorityNamespace operation/method
 */
if ($remove->removeResourcePriorityNamespace(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveResourcePriorityNamespaceReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeResourcePriorityNamespaceList operation/method
 */
if ($remove->removeResourcePriorityNamespaceList(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeDeviceMobility operation/method
 */
if ($remove->removeDeviceMobility(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCmcInfo operation/method
 */
if ($remove->removeCmcInfo(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveCmcInfoReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCredentialPolicy operation/method
 */
if ($remove->removeCredentialPolicy(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeFacInfo operation/method
 */
if ($remove->removeFacInfo(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeHuntList operation/method
 */
if ($remove->removeHuntList(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeIvrUserLocale operation/method
 */
if ($remove->removeIvrUserLocale(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveIvrUserLocaleReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeLineGroup operation/method
 */
if ($remove->removeLineGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeRecordingProfile operation/method
 */
if ($remove->removeRecordingProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeRouteFilter operation/method
 */
if ($remove->removeRouteFilter(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCallManagerGroup operation/method
 */
if ($remove->removeCallManagerGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeUserGroup operation/method
 */
if ($remove->removeUserGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeMohAudioSource operation/method
 */
if ($remove->removeMohAudioSource(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveMohAudioSourceReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeDhcpServer operation/method
 */
if ($remove->removeDhcpServer(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveDhcpServerReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeDhcpSubnet operation/method
 */
if ($remove->removeDhcpSubnet(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveDhcpSubnetReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCallPark operation/method
 */
if ($remove->removeCallPark(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveCallParkReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeDirectedCallPark operation/method
 */
if ($remove->removeDirectedCallPark(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveDirectedCallParkReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeMeetMe operation/method
 */
if ($remove->removeMeetMe(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveMeetMeReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeMobileVoiceAccess operation/method
 */
if ($remove->removeMobileVoiceAccess(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveMobileVoiceAccessReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeRouteList operation/method
 */
if ($remove->removeRouteList(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeUser operation/method
 */
if ($remove->removeUser(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveUserReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeAppUser operation/method
 */
if ($remove->removeAppUser(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveAppUserReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeSipRealm operation/method
 */
if ($remove->removeSipRealm(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveSipRealmReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removePhoneNtp operation/method
 */
if ($remove->removePhoneNtp(new \Losc\CucmBundle\Model\Webservice\StructType\RemovePhoneNtpReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeDateTimeGroup operation/method
 */
if ($remove->removeDateTimeGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removePresenceGroup operation/method
 */
if ($remove->removePresenceGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeGeoLocation operation/method
 */
if ($remove->removeGeoLocation(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeSrst operation/method
 */
if ($remove->removeSrst(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeMlppDomain operation/method
 */
if ($remove->removeMlppDomain(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveMlppDomainReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCumaServerSecurityProfile operation/method
 */
if ($remove->removeCumaServerSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeApplicationServer operation/method
 */
if ($remove->removeApplicationServer(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveApplicationServerReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeApplicationUserCapfProfile operation/method
 */
if ($remove->removeApplicationUserCapfProfile(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveApplicationUserCapfProfileReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeEndUserCapfProfile operation/method
 */
if ($remove->removeEndUserCapfProfile(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveEndUserCapfProfileReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeGeoLocationFilter operation/method
 */
if ($remove->removeGeoLocationFilter(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeVoiceMailProfile operation/method
 */
if ($remove->removeVoiceMailProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeVoiceMailPort operation/method
 */
if ($remove->removeVoiceMailPort(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeGatekeeper operation/method
 */
if ($remove->removeGatekeeper(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removePhoneButtonTemplate operation/method
 */
if ($remove->removePhoneButtonTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCommonPhoneConfig operation/method
 */
if ($remove->removeCommonPhoneConfig(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeMessageWaiting operation/method
 */
if ($remove->removeMessageWaiting(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveMessageWaitingReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeIpPhoneServices operation/method
 */
if ($remove->removeIpPhoneServices(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveIpPhoneServicesReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCtiRoutePoint operation/method
 */
if ($remove->removeCtiRoutePoint(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeTransPattern operation/method
 */
if ($remove->removeTransPattern(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveTransPatternReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCallingPartyTransformationPattern operation/method
 */
if ($remove->removeCallingPartyTransformationPattern(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveCallingPartyTransformationPatternReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeSipRoutePattern operation/method
 */
if ($remove->removeSipRoutePattern(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveSipRoutePatternReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeHuntPilot operation/method
 */
if ($remove->removeHuntPilot(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveHuntPilotReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeRoutePattern operation/method
 */
if ($remove->removeRoutePattern(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveRoutePatternReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeApplicationDialRules operation/method
 */
if ($remove->removeApplicationDialRules(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeDirectoryLookupDialRules operation/method
 */
if ($remove->removeDirectoryLookupDialRules(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removePhoneSecurityProfile operation/method
 */
if ($remove->removePhoneSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeSipDialRules operation/method
 */
if ($remove->removeSipDialRules(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeConferenceBridge operation/method
 */
if ($remove->removeConferenceBridge(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeMtp operation/method
 */
if ($remove->removeMtp(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeRemoteDestinationProfile operation/method
 */
if ($remove->removeRemoteDestinationProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeLine operation/method
 */
if ($remove->removeLine(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveLineReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeDefaultDeviceProfile operation/method
 */
if ($remove->removeDefaultDeviceProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeH323Phone operation/method
 */
if ($remove->removeH323Phone(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeH323Trunk operation/method
 */
if ($remove->removeH323Trunk(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removePhone operation/method
 */
if ($remove->removePhone(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeH323Gateway operation/method
 */
if ($remove->removeH323Gateway(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeDeviceProfile operation/method
 */
if ($remove->removeDeviceProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeRemoteDestination operation/method
 */
if ($remove->removeRemoteDestination(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveRemoteDestinationReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeVg224 operation/method
 */
if ($remove->removeVg224(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveVg224Req()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeGateway operation/method
 */
if ($remove->removeGateway(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveGatewayReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeGatewayEndpointAnalogAccess operation/method
 */
if ($remove->removeGatewayEndpointAnalogAccess(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeGatewayEndpointDigitalAccessPri operation/method
 */
if ($remove->removeGatewayEndpointDigitalAccessPri(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeGatewayEndpointDigitalAccessBri operation/method
 */
if ($remove->removeGatewayEndpointDigitalAccessBri(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeGatewayEndpointDigitalAccessT1 operation/method
 */
if ($remove->removeGatewayEndpointDigitalAccessT1(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCiscoCatalyst600024PortFXSGateway operation/method
 */
if ($remove->removeCiscoCatalyst600024PortFXSGateway(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCiscoCatalyst6000E1VoIPGateway operation/method
 */
if ($remove->removeCiscoCatalyst6000E1VoIPGateway(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCiscoCatalyst6000T1VoIPGatewayPri operation/method
 */
if ($remove->removeCiscoCatalyst6000T1VoIPGatewayPri(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCiscoCatalyst6000T1VoIPGatewayT1 operation/method
 */
if ($remove->removeCiscoCatalyst6000T1VoIPGatewayT1(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCallPickupGroup operation/method
 */
if ($remove->removeCallPickupGroup(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveCallPickupGroupReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeGeoLocationPolicy operation/method
 */
if ($remove->removeGeoLocationPolicy(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeSipTrunk operation/method
 */
if ($remove->removeSipTrunk(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCalledPartyTransformationPattern operation/method
 */
if ($remove->removeCalledPartyTransformationPattern(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveCalledPartyTransformationPatternReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeExternalCallControlProfile operation/method
 */
if ($remove->removeExternalCallControlProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeSafSecurityProfile operation/method
 */
if ($remove->removeSafSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeSafForwarder operation/method
 */
if ($remove->removeSafForwarder(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCcdHostedDN operation/method
 */
if ($remove->removeCcdHostedDN(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveCcdHostedDNReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCcdHostedDNGroup operation/method
 */
if ($remove->removeCcdHostedDNGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCcdRequestingService operation/method
 */
if ($remove->removeCcdRequestingService(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeRemoteCluster operation/method
 */
if ($remove->removeRemoteCluster(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveRemoteClusterReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCcdAdvertisingService operation/method
 */
if ($remove->removeCcdAdvertisingService(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeLdapDirectory operation/method
 */
if ($remove->removeLdapDirectory(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeSafCcdPurgeBlockLearnedRoutes operation/method
 */
if ($remove->removeSafCcdPurgeBlockLearnedRoutes(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveSafCcdPurgeBlockLearnedRoutesReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeVpnGateway operation/method
 */
if ($remove->removeVpnGateway(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeVpnGroup operation/method
 */
if ($remove->removeVpnGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeVpnProfile operation/method
 */
if ($remove->removeVpnProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeImeServer operation/method
 */
if ($remove->removeImeServer(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeImeRouteFilterGroup operation/method
 */
if ($remove->removeImeRouteFilterGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeImeRouteFilterElement operation/method
 */
if ($remove->removeImeRouteFilterElement(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeImeClient operation/method
 */
if ($remove->removeImeClient(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeImeEnrolledPattern operation/method
 */
if ($remove->removeImeEnrolledPattern(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveImeEnrolledPatternReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeImeEnrolledPatternGroup operation/method
 */
if ($remove->removeImeEnrolledPatternGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeImeExclusionNumber operation/method
 */
if ($remove->removeImeExclusionNumber(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveImeExclusionNumberReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeImeExclusionNumberGroup operation/method
 */
if ($remove->removeImeExclusionNumberGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeImeFirewall operation/method
 */
if ($remove->removeImeFirewall(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeImeE164Transformation operation/method
 */
if ($remove->removeImeE164Transformation(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeTransformationProfile operation/method
 */
if ($remove->removeTransformationProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeFallbackProfile operation/method
 */
if ($remove->removeFallbackProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeLdapFilter operation/method
 */
if ($remove->removeLdapFilter(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeFeatureControlPolicy operation/method
 */
if ($remove->removeFeatureControlPolicy(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeMobilityProfile operation/method
 */
if ($remove->removeMobilityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeEnterpriseFeatureAccessConfiguration operation/method
 */
if ($remove->removeEnterpriseFeatureAccessConfiguration(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveEnterpriseFeatureAccessConfigurationReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeHandoffConfiguration operation/method
 */
if ($remove->removeHandoffConfiguration(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveHandoffConfigurationReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCalledPartyTracing operation/method
 */
if ($remove->removeCalledPartyTracing(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveCalledPartyTracingReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeSIPNormalizationScript operation/method
 */
if ($remove->removeSIPNormalizationScript(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCustomUserField operation/method
 */
if ($remove->removeCustomUserField(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveCustomUserFieldReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeGatewaySccpEndpoints operation/method
 */
if ($remove->removeGatewaySccpEndpoints(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeLbmGroup operation/method
 */
if ($remove->removeLbmGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeAnnouncement operation/method
 */
if ($remove->removeAnnouncement(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeServiceProfile operation/method
 */
if ($remove->removeServiceProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeLdapSyncCustomField operation/method
 */
if ($remove->removeLdapSyncCustomField(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveLdapSyncCustomFieldReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeAudioCodecPreferenceList operation/method
 */
if ($remove->removeAudioCodecPreferenceList(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeUcService operation/method
 */
if ($remove->removeUcService(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeLbmHubGroup operation/method
 */
if ($remove->removeLbmHubGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeImportedDirectoryUriCatalogs operation/method
 */
if ($remove->removeImportedDirectoryUriCatalogs(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeVohServer operation/method
 */
if ($remove->removeVohServer(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeSdpTransparencyProfile operation/method
 */
if ($remove->removeSdpTransparencyProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeFeatureGroupTemplate operation/method
 */
if ($remove->removeFeatureGroupTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeDirNumberAliasLookupandSync operation/method
 */
if ($remove->removeDirNumberAliasLookupandSync(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeAdvertisedPatterns operation/method
 */
if ($remove->removeAdvertisedPatterns(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveAdvertisedPatternsReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeBlockedLearnedPatterns operation/method
 */
if ($remove->removeBlockedLearnedPatterns(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveBlockedLearnedPatternsReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeCCAProfiles operation/method
 */
if ($remove->removeCCAProfiles(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveCCAProfilesReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeUniversalDeviceTemplate operation/method
 */
if ($remove->removeUniversalDeviceTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeUserProfileProvision operation/method
 */
if ($remove->removeUserProfileProvision(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removePresenceRedundancyGroup operation/method
 */
if ($remove->removePresenceRedundancyGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeWifiHotspot operation/method
 */
if ($remove->removeWifiHotspot(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeWlanProfileGroup operation/method
 */
if ($remove->removeWlanProfileGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeWLANProfile operation/method
 */
if ($remove->removeWLANProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeUniversalLineTemplate operation/method
 */
if ($remove->removeUniversalLineTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeNetworkAccessProfile operation/method
 */
if ($remove->removeNetworkAccessProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeApplicationToSoftkeyTemplate operation/method
 */
if ($remove->removeApplicationToSoftkeyTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveApplicationToSoftkeyTemplateReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeUnitsToGateway operation/method
 */
if ($remove->removeUnitsToGateway(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveUnitsToGatewayReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeGatewaySubunits operation/method
 */
if ($remove->removeGatewaySubunits(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveGatewaySubunitsReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeImeLearnedRoutes operation/method
 */
if ($remove->removeImeLearnedRoutes(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveImeLearnedRoutesReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeAppServerInfo operation/method
 */
if ($remove->removeAppServerInfo(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveAppServerInfoReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeSNMPCommunityString operation/method
 */
if ($remove->removeSNMPCommunityString(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveSNMPCommunityStringReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeSNMPUser operation/method
 */
if ($remove->removeSNMPUser(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveSNMPUserReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeBillingServer operation/method
 */
if ($remove->removeBillingServer(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveBillingServerReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Sample call for removeLocalRouteGroup operation/method
 */
if ($remove->removeLocalRouteGroup(new \Losc\CucmBundle\Model\Webservice\StructType\RemoveLocalRouteGroupReq()) !== false) {
    print_r($remove->getResult());
} else {
    print_r($remove->getLastError());
}
/**
 * Samples for List ServiceType
 */
$list = new \Losc\CucmBundle\Model\Webservice\ServiceType\_List($options);
/**
 * Sample call for listSipProfile operation/method
 */
if ($list->listSipProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListSipProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listSipTrunkSecurityProfile operation/method
 */
if ($list->listSipTrunkSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListSipTrunkSecurityProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listTimePeriod operation/method
 */
if ($list->listTimePeriod(new \Losc\CucmBundle\Model\Webservice\StructType\ListTimePeriodReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listTimeSchedule operation/method
 */
if ($list->listTimeSchedule(new \Losc\CucmBundle\Model\Webservice\StructType\ListTimeScheduleReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listTodAccess operation/method
 */
if ($list->listTodAccess(new \Losc\CucmBundle\Model\Webservice\StructType\ListTodAccessReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listVoiceMailPilot operation/method
 */
if ($list->listVoiceMailPilot(new \Losc\CucmBundle\Model\Webservice\StructType\ListVoiceMailPilotReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listProcessNode operation/method
 */
if ($list->listProcessNode(new \Losc\CucmBundle\Model\Webservice\StructType\ListProcessNodeReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCallerFilterList operation/method
 */
if ($list->listCallerFilterList(new \Losc\CucmBundle\Model\Webservice\StructType\ListCallerFilterListReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listRoutePartition operation/method
 */
if ($list->listRoutePartition(new \Losc\CucmBundle\Model\Webservice\StructType\ListRoutePartitionReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCss operation/method
 */
if ($list->listCss(new \Losc\CucmBundle\Model\Webservice\StructType\ListCssReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCallManager operation/method
 */
if ($list->listCallManager(new \Losc\CucmBundle\Model\Webservice\StructType\ListCallManagerReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listMediaResourceGroup operation/method
 */
if ($list->listMediaResourceGroup(new \Losc\CucmBundle\Model\Webservice\StructType\ListMediaResourceGroupReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listMediaResourceList operation/method
 */
if ($list->listMediaResourceList(new \Losc\CucmBundle\Model\Webservice\StructType\ListMediaResourceListReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listRegion operation/method
 */
if ($list->listRegion(new \Losc\CucmBundle\Model\Webservice\StructType\ListRegionReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listAarGroup operation/method
 */
if ($list->listAarGroup(new \Losc\CucmBundle\Model\Webservice\StructType\ListAarGroupReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listPhysicalLocation operation/method
 */
if ($list->listPhysicalLocation(new \Losc\CucmBundle\Model\Webservice\StructType\ListPhysicalLocationReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listRouteGroup operation/method
 */
if ($list->listRouteGroup(new \Losc\CucmBundle\Model\Webservice\StructType\ListRouteGroupReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listDevicePool operation/method
 */
if ($list->listDevicePool(new \Losc\CucmBundle\Model\Webservice\StructType\ListDevicePoolReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listDeviceMobilityGroup operation/method
 */
if ($list->listDeviceMobilityGroup(new \Losc\CucmBundle\Model\Webservice\StructType\ListDeviceMobilityGroupReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listLocation operation/method
 */
if ($list->listLocation(new \Losc\CucmBundle\Model\Webservice\StructType\ListLocationReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listSoftKeyTemplate operation/method
 */
if ($list->listSoftKeyTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\ListSoftKeyTemplateReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listTranscoder operation/method
 */
if ($list->listTranscoder(new \Losc\CucmBundle\Model\Webservice\StructType\ListTranscoderReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCommonDeviceConfig operation/method
 */
if ($list->listCommonDeviceConfig(new \Losc\CucmBundle\Model\Webservice\StructType\ListCommonDeviceConfigReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listResourcePriorityNamespace operation/method
 */
if ($list->listResourcePriorityNamespace(new \Losc\CucmBundle\Model\Webservice\StructType\ListResourcePriorityNamespaceReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listResourcePriorityNamespaceList operation/method
 */
if ($list->listResourcePriorityNamespaceList(new \Losc\CucmBundle\Model\Webservice\StructType\ListResourcePriorityNamespaceListReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listDeviceMobility operation/method
 */
if ($list->listDeviceMobility(new \Losc\CucmBundle\Model\Webservice\StructType\ListDeviceMobilityReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCmcInfo operation/method
 */
if ($list->listCmcInfo(new \Losc\CucmBundle\Model\Webservice\StructType\ListCmcInfoReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCredentialPolicy operation/method
 */
if ($list->listCredentialPolicy(new \Losc\CucmBundle\Model\Webservice\StructType\ListCredentialPolicyReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listFacInfo operation/method
 */
if ($list->listFacInfo(new \Losc\CucmBundle\Model\Webservice\StructType\ListFacInfoReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listHuntList operation/method
 */
if ($list->listHuntList(new \Losc\CucmBundle\Model\Webservice\StructType\ListHuntListReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listIvrUserLocale operation/method
 */
if ($list->listIvrUserLocale(new \Losc\CucmBundle\Model\Webservice\StructType\ListIvrUserLocaleReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listLineGroup operation/method
 */
if ($list->listLineGroup(new \Losc\CucmBundle\Model\Webservice\StructType\ListLineGroupReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listRecordingProfile operation/method
 */
if ($list->listRecordingProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListRecordingProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listRouteFilter operation/method
 */
if ($list->listRouteFilter(new \Losc\CucmBundle\Model\Webservice\StructType\ListRouteFilterReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCallManagerGroup operation/method
 */
if ($list->listCallManagerGroup(new \Losc\CucmBundle\Model\Webservice\StructType\ListCallManagerGroupReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listUserGroup operation/method
 */
if ($list->listUserGroup(new \Losc\CucmBundle\Model\Webservice\StructType\ListUserGroupReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listDialPlan operation/method
 */
if ($list->listDialPlan(new \Losc\CucmBundle\Model\Webservice\StructType\ListDialPlanReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listDialPlanTag operation/method
 */
if ($list->listDialPlanTag(new \Losc\CucmBundle\Model\Webservice\StructType\ListDialPlanTagReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listDdi operation/method
 */
if ($list->listDdi(new \Losc\CucmBundle\Model\Webservice\StructType\ListDdiReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listMobileSmartClientProfile operation/method
 */
if ($list->listMobileSmartClientProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListMobileSmartClientProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listProcessNodeService operation/method
 */
if ($list->listProcessNodeService(new \Losc\CucmBundle\Model\Webservice\StructType\ListProcessNodeServiceReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listMohAudioSource operation/method
 */
if ($list->listMohAudioSource(new \Losc\CucmBundle\Model\Webservice\StructType\ListMohAudioSourceReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listDhcpServer operation/method
 */
if ($list->listDhcpServer(new \Losc\CucmBundle\Model\Webservice\StructType\ListDhcpServerReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listDhcpSubnet operation/method
 */
if ($list->listDhcpSubnet(new \Losc\CucmBundle\Model\Webservice\StructType\ListDhcpSubnetReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCallPark operation/method
 */
if ($list->listCallPark(new \Losc\CucmBundle\Model\Webservice\StructType\ListCallParkReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listDirectedCallPark operation/method
 */
if ($list->listDirectedCallPark(new \Losc\CucmBundle\Model\Webservice\StructType\ListDirectedCallParkReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listMeetMe operation/method
 */
if ($list->listMeetMe(new \Losc\CucmBundle\Model\Webservice\StructType\ListMeetMeReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listRouteList operation/method
 */
if ($list->listRouteList(new \Losc\CucmBundle\Model\Webservice\StructType\ListRouteListReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listUser operation/method
 */
if ($list->listUser(new \Losc\CucmBundle\Model\Webservice\StructType\ListUserReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listAppUser operation/method
 */
if ($list->listAppUser(new \Losc\CucmBundle\Model\Webservice\StructType\ListAppUserReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listSipRealm operation/method
 */
if ($list->listSipRealm(new \Losc\CucmBundle\Model\Webservice\StructType\ListSipRealmReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listPhoneNtp operation/method
 */
if ($list->listPhoneNtp(new \Losc\CucmBundle\Model\Webservice\StructType\ListPhoneNtpReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listDateTimeGroup operation/method
 */
if ($list->listDateTimeGroup(new \Losc\CucmBundle\Model\Webservice\StructType\ListDateTimeGroupReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listPresenceGroup operation/method
 */
if ($list->listPresenceGroup(new \Losc\CucmBundle\Model\Webservice\StructType\ListPresenceGroupReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listGeoLocation operation/method
 */
if ($list->listGeoLocation(new \Losc\CucmBundle\Model\Webservice\StructType\ListGeoLocationReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listSrst operation/method
 */
if ($list->listSrst(new \Losc\CucmBundle\Model\Webservice\StructType\ListSrstReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listMlppDomain operation/method
 */
if ($list->listMlppDomain(new \Losc\CucmBundle\Model\Webservice\StructType\ListMlppDomainReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCumaServerSecurityProfile operation/method
 */
if ($list->listCumaServerSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListCumaServerSecurityProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listApplicationServer operation/method
 */
if ($list->listApplicationServer(new \Losc\CucmBundle\Model\Webservice\StructType\ListApplicationServerReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listApplicationUserCapfProfile operation/method
 */
if ($list->listApplicationUserCapfProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListApplicationUserCapfProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listEndUserCapfProfile operation/method
 */
if ($list->listEndUserCapfProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListEndUserCapfProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listServiceParameter operation/method
 */
if ($list->listServiceParameter(new \Losc\CucmBundle\Model\Webservice\StructType\ListServiceParameterReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listGeoLocationFilter operation/method
 */
if ($list->listGeoLocationFilter(new \Losc\CucmBundle\Model\Webservice\StructType\ListGeoLocationFilterReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listVoiceMailProfile operation/method
 */
if ($list->listVoiceMailProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListVoiceMailProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listVoiceMailPort operation/method
 */
if ($list->listVoiceMailPort(new \Losc\CucmBundle\Model\Webservice\StructType\ListVoiceMailPortReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listGatekeeper operation/method
 */
if ($list->listGatekeeper(new \Losc\CucmBundle\Model\Webservice\StructType\ListGatekeeperReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listPhoneButtonTemplate operation/method
 */
if ($list->listPhoneButtonTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\ListPhoneButtonTemplateReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCommonPhoneConfig operation/method
 */
if ($list->listCommonPhoneConfig(new \Losc\CucmBundle\Model\Webservice\StructType\ListCommonPhoneConfigReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listMessageWaiting operation/method
 */
if ($list->listMessageWaiting(new \Losc\CucmBundle\Model\Webservice\StructType\ListMessageWaitingReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listIpPhoneServices operation/method
 */
if ($list->listIpPhoneServices(new \Losc\CucmBundle\Model\Webservice\StructType\ListIpPhoneServicesReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCtiRoutePoint operation/method
 */
if ($list->listCtiRoutePoint(new \Losc\CucmBundle\Model\Webservice\StructType\ListCtiRoutePointReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listTransPattern operation/method
 */
if ($list->listTransPattern(new \Losc\CucmBundle\Model\Webservice\StructType\ListTransPatternReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCallingPartyTransformationPattern operation/method
 */
if ($list->listCallingPartyTransformationPattern(new \Losc\CucmBundle\Model\Webservice\StructType\ListCallingPartyTransformationPatternReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listSipRoutePattern operation/method
 */
if ($list->listSipRoutePattern(new \Losc\CucmBundle\Model\Webservice\StructType\ListSipRoutePatternReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listHuntPilot operation/method
 */
if ($list->listHuntPilot(new \Losc\CucmBundle\Model\Webservice\StructType\ListHuntPilotReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listRoutePattern operation/method
 */
if ($list->listRoutePattern(new \Losc\CucmBundle\Model\Webservice\StructType\ListRoutePatternReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listApplicationDialRules operation/method
 */
if ($list->listApplicationDialRules(new \Losc\CucmBundle\Model\Webservice\StructType\ListApplicationDialRulesReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listDirectoryLookupDialRules operation/method
 */
if ($list->listDirectoryLookupDialRules(new \Losc\CucmBundle\Model\Webservice\StructType\ListDirectoryLookupDialRulesReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listPhoneSecurityProfile operation/method
 */
if ($list->listPhoneSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListPhoneSecurityProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listSipDialRules operation/method
 */
if ($list->listSipDialRules(new \Losc\CucmBundle\Model\Webservice\StructType\ListSipDialRulesReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listConferenceBridge operation/method
 */
if ($list->listConferenceBridge(new \Losc\CucmBundle\Model\Webservice\StructType\ListConferenceBridgeReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listAnnunciator operation/method
 */
if ($list->listAnnunciator(new \Losc\CucmBundle\Model\Webservice\StructType\ListAnnunciatorReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listMtp operation/method
 */
if ($list->listMtp(new \Losc\CucmBundle\Model\Webservice\StructType\ListMtpReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listRemoteDestinationProfile operation/method
 */
if ($list->listRemoteDestinationProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListRemoteDestinationProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listLine operation/method
 */
if ($list->listLine(new \Losc\CucmBundle\Model\Webservice\StructType\ListLineReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listDefaultDeviceProfile operation/method
 */
if ($list->listDefaultDeviceProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListDefaultDeviceProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listH323Phone operation/method
 */
if ($list->listH323Phone(new \Losc\CucmBundle\Model\Webservice\StructType\ListH323PhoneReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listMohServer operation/method
 */
if ($list->listMohServer(new \Losc\CucmBundle\Model\Webservice\StructType\ListMohServerReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listH323Trunk operation/method
 */
if ($list->listH323Trunk(new \Losc\CucmBundle\Model\Webservice\StructType\ListH323TrunkReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listPhone operation/method
 */
if ($list->listPhone(new \Losc\CucmBundle\Model\Webservice\StructType\ListPhoneReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listH323Gateway operation/method
 */
if ($list->listH323Gateway(new \Losc\CucmBundle\Model\Webservice\StructType\ListH323GatewayReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listDeviceProfile operation/method
 */
if ($list->listDeviceProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListDeviceProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listRemoteDestination operation/method
 */
if ($list->listRemoteDestination(new \Losc\CucmBundle\Model\Webservice\StructType\ListRemoteDestinationReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listGateway operation/method
 */
if ($list->listGateway(new \Losc\CucmBundle\Model\Webservice\StructType\ListGatewayReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCiscoCatalyst600024PortFXSGateway operation/method
 */
if ($list->listCiscoCatalyst600024PortFXSGateway(new \Losc\CucmBundle\Model\Webservice\StructType\ListCiscoCatalyst600024PortFXSGatewayReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCiscoCatalyst6000E1VoIPGateway operation/method
 */
if ($list->listCiscoCatalyst6000E1VoIPGateway(new \Losc\CucmBundle\Model\Webservice\StructType\ListCiscoCatalyst6000E1VoIPGatewayReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCiscoCatalyst6000T1VoIPGatewayPri operation/method
 */
if ($list->listCiscoCatalyst6000T1VoIPGatewayPri(new \Losc\CucmBundle\Model\Webservice\StructType\ListCiscoCatalyst6000T1VoIPGatewayPriReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCiscoCatalyst6000T1VoIPGatewayT1 operation/method
 */
if ($list->listCiscoCatalyst6000T1VoIPGatewayT1(new \Losc\CucmBundle\Model\Webservice\StructType\ListCiscoCatalyst6000T1VoIPGatewayT1Req()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCallPickupGroup operation/method
 */
if ($list->listCallPickupGroup(new \Losc\CucmBundle\Model\Webservice\StructType\ListCallPickupGroupReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listRoutePlan operation/method
 */
if ($list->listRoutePlan(new \Losc\CucmBundle\Model\Webservice\StructType\ListRoutePlanReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listGeoLocationPolicy operation/method
 */
if ($list->listGeoLocationPolicy(new \Losc\CucmBundle\Model\Webservice\StructType\ListGeoLocationPolicyReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listSipTrunk operation/method
 */
if ($list->listSipTrunk(new \Losc\CucmBundle\Model\Webservice\StructType\ListSipTrunkReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCalledPartyTransformationPattern operation/method
 */
if ($list->listCalledPartyTransformationPattern(new \Losc\CucmBundle\Model\Webservice\StructType\ListCalledPartyTransformationPatternReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listExternalCallControlProfile operation/method
 */
if ($list->listExternalCallControlProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListExternalCallControlProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listSafSecurityProfile operation/method
 */
if ($list->listSafSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListSafSecurityProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listSafForwarder operation/method
 */
if ($list->listSafForwarder(new \Losc\CucmBundle\Model\Webservice\StructType\ListSafForwarderReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCcdHostedDN operation/method
 */
if ($list->listCcdHostedDN(new \Losc\CucmBundle\Model\Webservice\StructType\ListCcdHostedDNReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCcdHostedDNGroup operation/method
 */
if ($list->listCcdHostedDNGroup(new \Losc\CucmBundle\Model\Webservice\StructType\ListCcdHostedDNGroupReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listRemoteCluster operation/method
 */
if ($list->listRemoteCluster(new \Losc\CucmBundle\Model\Webservice\StructType\ListRemoteClusterReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCcdAdvertisingService operation/method
 */
if ($list->listCcdAdvertisingService(new \Losc\CucmBundle\Model\Webservice\StructType\ListCcdAdvertisingServiceReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listLdapDirectory operation/method
 */
if ($list->listLdapDirectory(new \Losc\CucmBundle\Model\Webservice\StructType\ListLdapDirectoryReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listSafCcdPurgeBlockLearnedRoutes operation/method
 */
if ($list->listSafCcdPurgeBlockLearnedRoutes(new \Losc\CucmBundle\Model\Webservice\StructType\ListSafCcdPurgeBlockLearnedRoutesReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listVpnGateway operation/method
 */
if ($list->listVpnGateway(new \Losc\CucmBundle\Model\Webservice\StructType\ListVpnGatewayReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listVpnGroup operation/method
 */
if ($list->listVpnGroup(new \Losc\CucmBundle\Model\Webservice\StructType\ListVpnGroupReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listVpnProfile operation/method
 */
if ($list->listVpnProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListVpnProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listImeServer operation/method
 */
if ($list->listImeServer(new \Losc\CucmBundle\Model\Webservice\StructType\ListImeServerReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listImeRouteFilterGroup operation/method
 */
if ($list->listImeRouteFilterGroup(new \Losc\CucmBundle\Model\Webservice\StructType\ListImeRouteFilterGroupReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listImeRouteFilterElement operation/method
 */
if ($list->listImeRouteFilterElement(new \Losc\CucmBundle\Model\Webservice\StructType\ListImeRouteFilterElementReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listImeClient operation/method
 */
if ($list->listImeClient(new \Losc\CucmBundle\Model\Webservice\StructType\ListImeClientReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listImeEnrolledPattern operation/method
 */
if ($list->listImeEnrolledPattern(new \Losc\CucmBundle\Model\Webservice\StructType\ListImeEnrolledPatternReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listImeEnrolledPatternGroup operation/method
 */
if ($list->listImeEnrolledPatternGroup(new \Losc\CucmBundle\Model\Webservice\StructType\ListImeEnrolledPatternGroupReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listImeExclusionNumber operation/method
 */
if ($list->listImeExclusionNumber(new \Losc\CucmBundle\Model\Webservice\StructType\ListImeExclusionNumberReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listImeExclusionNumberGroup operation/method
 */
if ($list->listImeExclusionNumberGroup(new \Losc\CucmBundle\Model\Webservice\StructType\ListImeExclusionNumberGroupReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listImeFirewall operation/method
 */
if ($list->listImeFirewall(new \Losc\CucmBundle\Model\Webservice\StructType\ListImeFirewallReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listImeE164Transformation operation/method
 */
if ($list->listImeE164Transformation(new \Losc\CucmBundle\Model\Webservice\StructType\ListImeE164TransformationReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listTransformationProfile operation/method
 */
if ($list->listTransformationProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListTransformationProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listFallbackProfile operation/method
 */
if ($list->listFallbackProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListFallbackProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listLdapFilter operation/method
 */
if ($list->listLdapFilter(new \Losc\CucmBundle\Model\Webservice\StructType\ListLdapFilterReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listTvsCertificate operation/method
 */
if ($list->listTvsCertificate(new \Losc\CucmBundle\Model\Webservice\StructType\ListTvsCertificateReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listFeatureControlPolicy operation/method
 */
if ($list->listFeatureControlPolicy(new \Losc\CucmBundle\Model\Webservice\StructType\ListFeatureControlPolicyReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listMobilityProfile operation/method
 */
if ($list->listMobilityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListMobilityProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listEnterpriseFeatureAccessConfiguration operation/method
 */
if ($list->listEnterpriseFeatureAccessConfiguration(new \Losc\CucmBundle\Model\Webservice\StructType\ListEnterpriseFeatureAccessConfigurationReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCalledPartyTracing operation/method
 */
if ($list->listCalledPartyTracing(new \Losc\CucmBundle\Model\Webservice\StructType\ListCalledPartyTracingReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listSIPNormalizationScript operation/method
 */
if ($list->listSIPNormalizationScript(new \Losc\CucmBundle\Model\Webservice\StructType\ListSIPNormalizationScriptReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCustomUserField operation/method
 */
if ($list->listCustomUserField(new \Losc\CucmBundle\Model\Webservice\StructType\ListCustomUserFieldReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listBillingServer operation/method
 */
if ($list->listBillingServer(new \Losc\CucmBundle\Model\Webservice\StructType\ListBillingServerReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listLbmGroup operation/method
 */
if ($list->listLbmGroup(new \Losc\CucmBundle\Model\Webservice\StructType\ListLbmGroupReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listAnnouncement operation/method
 */
if ($list->listAnnouncement(new \Losc\CucmBundle\Model\Webservice\StructType\ListAnnouncementReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listServiceProfile operation/method
 */
if ($list->listServiceProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListServiceProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listAudioCodecPreferenceList operation/method
 */
if ($list->listAudioCodecPreferenceList(new \Losc\CucmBundle\Model\Webservice\StructType\ListAudioCodecPreferenceListReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listUcService operation/method
 */
if ($list->listUcService(new \Losc\CucmBundle\Model\Webservice\StructType\ListUcServiceReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listLbmHubGroup operation/method
 */
if ($list->listLbmHubGroup(new \Losc\CucmBundle\Model\Webservice\StructType\ListLbmHubGroupReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listImportedDirectoryUriCatalogs operation/method
 */
if ($list->listImportedDirectoryUriCatalogs(new \Losc\CucmBundle\Model\Webservice\StructType\ListImportedDirectoryUriCatalogsReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listVohServer operation/method
 */
if ($list->listVohServer(new \Losc\CucmBundle\Model\Webservice\StructType\ListVohServerReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listSdpTransparencyProfile operation/method
 */
if ($list->listSdpTransparencyProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListSdpTransparencyProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listFeatureGroupTemplate operation/method
 */
if ($list->listFeatureGroupTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\ListFeatureGroupTemplateReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listDirNumberAliasLookupandSync operation/method
 */
if ($list->listDirNumberAliasLookupandSync(new \Losc\CucmBundle\Model\Webservice\StructType\ListDirNumberAliasLookupandSyncReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listLocalRouteGroup operation/method
 */
if ($list->listLocalRouteGroup(new \Losc\CucmBundle\Model\Webservice\StructType\ListLocalRouteGroupReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listAdvertisedPatterns operation/method
 */
if ($list->listAdvertisedPatterns(new \Losc\CucmBundle\Model\Webservice\StructType\ListAdvertisedPatternsReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listBlockedLearnedPatterns operation/method
 */
if ($list->listBlockedLearnedPatterns(new \Losc\CucmBundle\Model\Webservice\StructType\ListBlockedLearnedPatternsReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listCCAProfiles operation/method
 */
if ($list->listCCAProfiles(new \Losc\CucmBundle\Model\Webservice\StructType\ListCCAProfilesReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listUniversalDeviceTemplate operation/method
 */
if ($list->listUniversalDeviceTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\ListUniversalDeviceTemplateReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listUserProfileProvision operation/method
 */
if ($list->listUserProfileProvision(new \Losc\CucmBundle\Model\Webservice\StructType\ListUserProfileProvisionReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listPresenceRedundancyGroup operation/method
 */
if ($list->listPresenceRedundancyGroup(new \Losc\CucmBundle\Model\Webservice\StructType\ListPresenceRedundancyGroupReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listAssignedPresenceServers operation/method
 */
if ($list->listAssignedPresenceServers(new \Losc\CucmBundle\Model\Webservice\StructType\ListAssignedPresenceServersReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listUnassignedPresenceServers operation/method
 */
if ($list->listUnassignedPresenceServers(new \Losc\CucmBundle\Model\Webservice\StructType\ListUnassignedPresenceServersReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listAssignedPresenceUsers operation/method
 */
if ($list->listAssignedPresenceUsers(new \Losc\CucmBundle\Model\Webservice\StructType\ListAssignedPresenceUsersReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listUnassignedPresenceUsers operation/method
 */
if ($list->listUnassignedPresenceUsers(new \Losc\CucmBundle\Model\Webservice\StructType\ListUnassignedPresenceUsersReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listWifiHotspot operation/method
 */
if ($list->listWifiHotspot(new \Losc\CucmBundle\Model\Webservice\StructType\ListWifiHotspotReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listWlanProfileGroup operation/method
 */
if ($list->listWlanProfileGroup(new \Losc\CucmBundle\Model\Webservice\StructType\ListWlanProfileGroupReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listWLANProfile operation/method
 */
if ($list->listWLANProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListWLANProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listUniversalLineTemplate operation/method
 */
if ($list->listUniversalLineTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\ListUniversalLineTemplateReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listNetworkAccessProfile operation/method
 */
if ($list->listNetworkAccessProfile(new \Losc\CucmBundle\Model\Webservice\StructType\ListNetworkAccessProfileReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listLdapSyncCustomField operation/method
 */
if ($list->listLdapSyncCustomField(new \Losc\CucmBundle\Model\Webservice\StructType\ListLdapSyncCustomFieldReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Sample call for listChange operation/method
 */
if ($list->listChange(new \Losc\CucmBundle\Model\Webservice\StructType\ListChangeReq()) !== false) {
    print_r($list->getResult());
} else {
    print_r($list->getLastError());
}
/**
 * Samples for Restart ServiceType
 */
$restart = new \Losc\CucmBundle\Model\Webservice\ServiceType\Restart($options);
/**
 * Sample call for restartSipProfile operation/method
 */
if ($restart->restartSipProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartRoutePartition operation/method
 */
if ($restart->restartRoutePartition(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartCallManager operation/method
 */
if ($restart->restartCallManager(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartRegion operation/method
 */
if ($restart->restartRegion(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartDevicePool operation/method
 */
if ($restart->restartDevicePool(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartSoftKeyTemplate operation/method
 */
if ($restart->restartSoftKeyTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartResourcePriorityNamespace operation/method
 */
if ($restart->restartResourcePriorityNamespace(new \Losc\CucmBundle\Model\Webservice\StructType\RestartResourcePriorityNamespaceReq()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartResourcePriorityNamespaceList operation/method
 */
if ($restart->restartResourcePriorityNamespaceList(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartSrst operation/method
 */
if ($restart->restartSrst(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartVoiceMailProfile operation/method
 */
if ($restart->restartVoiceMailProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartVoiceMailPort operation/method
 */
if ($restart->restartVoiceMailPort(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartGatekeeper operation/method
 */
if ($restart->restartGatekeeper(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartPhoneButtonTemplate operation/method
 */
if ($restart->restartPhoneButtonTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartCtiRoutePoint operation/method
 */
if ($restart->restartCtiRoutePoint(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartConferenceBridge operation/method
 */
if ($restart->restartConferenceBridge(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartMtp operation/method
 */
if ($restart->restartMtp(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartLine operation/method
 */
if ($restart->restartLine(new \Losc\CucmBundle\Model\Webservice\StructType\RestartLineReq()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartH323Phone operation/method
 */
if ($restart->restartH323Phone(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartH323Trunk operation/method
 */
if ($restart->restartH323Trunk(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartPhone operation/method
 */
if ($restart->restartPhone(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartH323Gateway operation/method
 */
if ($restart->restartH323Gateway(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartCiscoCatalyst600024PortFXSGateway operation/method
 */
if ($restart->restartCiscoCatalyst600024PortFXSGateway(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartCiscoCatalyst6000E1VoIPGateway operation/method
 */
if ($restart->restartCiscoCatalyst6000E1VoIPGateway(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartCiscoCatalyst6000T1VoIPGatewayPri operation/method
 */
if ($restart->restartCiscoCatalyst6000T1VoIPGatewayPri(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartCiscoCatalyst6000T1VoIPGatewayT1 operation/method
 */
if ($restart->restartCiscoCatalyst6000T1VoIPGatewayT1(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Sample call for restartSipTrunk operation/method
 */
if ($restart->restartSipTrunk(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($restart->getResult());
} else {
    print_r($restart->getLastError());
}
/**
 * Samples for Apply ServiceType
 */
$apply = new \Losc\CucmBundle\Model\Webservice\ServiceType\Apply($options);
/**
 * Sample call for applySipProfile operation/method
 */
if ($apply->applySipProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applySipTrunkSecurityProfile operation/method
 */
if ($apply->applySipTrunkSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyRoutePartition operation/method
 */
if ($apply->applyRoutePartition(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyCallManager operation/method
 */
if ($apply->applyCallManager(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyRegion operation/method
 */
if ($apply->applyRegion(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyDevicePool operation/method
 */
if ($apply->applyDevicePool(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applySoftKeyTemplate operation/method
 */
if ($apply->applySoftKeyTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyTranscoder operation/method
 */
if ($apply->applyTranscoder(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyCommonDeviceConfig operation/method
 */
if ($apply->applyCommonDeviceConfig(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyResourcePriorityNamespace operation/method
 */
if ($apply->applyResourcePriorityNamespace(new \Losc\CucmBundle\Model\Webservice\StructType\ApplyResourcePriorityNamespaceReq()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyResourcePriorityNamespaceList operation/method
 */
if ($apply->applyResourcePriorityNamespaceList(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyHuntList operation/method
 */
if ($apply->applyHuntList(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyCallManagerGroup operation/method
 */
if ($apply->applyCallManagerGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyDirectedCallPark operation/method
 */
if ($apply->applyDirectedCallPark(new \Losc\CucmBundle\Model\Webservice\StructType\ApplyDirectedCallParkReq()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyRouteList operation/method
 */
if ($apply->applyRouteList(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyDateTimeGroup operation/method
 */
if ($apply->applyDateTimeGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applySrst operation/method
 */
if ($apply->applySrst(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyVoiceMailProfile operation/method
 */
if ($apply->applyVoiceMailProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyVoiceMailPort operation/method
 */
if ($apply->applyVoiceMailPort(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyGatekeeper operation/method
 */
if ($apply->applyGatekeeper(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyPhoneButtonTemplate operation/method
 */
if ($apply->applyPhoneButtonTemplate(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyCommonPhoneConfig operation/method
 */
if ($apply->applyCommonPhoneConfig(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyCtiRoutePoint operation/method
 */
if ($apply->applyCtiRoutePoint(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyPhoneSecurityProfile operation/method
 */
if ($apply->applyPhoneSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyConferenceBridge operation/method
 */
if ($apply->applyConferenceBridge(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyMtp operation/method
 */
if ($apply->applyMtp(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyLine operation/method
 */
if ($apply->applyLine(new \Losc\CucmBundle\Model\Webservice\StructType\ApplyLineReq()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyH323Phone operation/method
 */
if ($apply->applyH323Phone(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyPhone operation/method
 */
if ($apply->applyPhone(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyH323Gateway operation/method
 */
if ($apply->applyH323Gateway(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyGateway operation/method
 */
if ($apply->applyGateway(new \Losc\CucmBundle\Model\Webservice\StructType\ApplyGatewayReq()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyCiscoCatalyst600024PortFXSGateway operation/method
 */
if ($apply->applyCiscoCatalyst600024PortFXSGateway(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyCiscoCatalyst6000E1VoIPGateway operation/method
 */
if ($apply->applyCiscoCatalyst6000E1VoIPGateway(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyCiscoCatalyst6000T1VoIPGatewayPri operation/method
 */
if ($apply->applyCiscoCatalyst6000T1VoIPGatewayPri(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Sample call for applyCiscoCatalyst6000T1VoIPGatewayT1 operation/method
 */
if ($apply->applyCiscoCatalyst6000T1VoIPGatewayT1(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($apply->getResult());
} else {
    print_r($apply->getLastError());
}
/**
 * Samples for Reset ServiceType
 */
$reset = new \Losc\CucmBundle\Model\Webservice\ServiceType\Reset($options);
/**
 * Sample call for resetSipTrunkSecurityProfile operation/method
 */
if ($reset->resetSipTrunkSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetCallManager operation/method
 */
if ($reset->resetCallManager(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetDevicePool operation/method
 */
if ($reset->resetDevicePool(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetTranscoder operation/method
 */
if ($reset->resetTranscoder(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetCommonDeviceConfig operation/method
 */
if ($reset->resetCommonDeviceConfig(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetResourcePriorityNamespace operation/method
 */
if ($reset->resetResourcePriorityNamespace(new \Losc\CucmBundle\Model\Webservice\StructType\ResetResourcePriorityNamespaceReq()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetResourcePriorityNamespaceList operation/method
 */
if ($reset->resetResourcePriorityNamespaceList(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetHuntList operation/method
 */
if ($reset->resetHuntList(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetCallManagerGroup operation/method
 */
if ($reset->resetCallManagerGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetDirectedCallPark operation/method
 */
if ($reset->resetDirectedCallPark(new \Losc\CucmBundle\Model\Webservice\StructType\ResetDirectedCallParkReq()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetRouteList operation/method
 */
if ($reset->resetRouteList(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetDateTimeGroup operation/method
 */
if ($reset->resetDateTimeGroup(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetSrst operation/method
 */
if ($reset->resetSrst(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetVoiceMailProfile operation/method
 */
if ($reset->resetVoiceMailProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetVoiceMailPort operation/method
 */
if ($reset->resetVoiceMailPort(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetGatekeeper operation/method
 */
if ($reset->resetGatekeeper(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetCommonPhoneConfig operation/method
 */
if ($reset->resetCommonPhoneConfig(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetCtiRoutePoint operation/method
 */
if ($reset->resetCtiRoutePoint(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetPhoneSecurityProfile operation/method
 */
if ($reset->resetPhoneSecurityProfile(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetConferenceBridge operation/method
 */
if ($reset->resetConferenceBridge(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetMtp operation/method
 */
if ($reset->resetMtp(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetLine operation/method
 */
if ($reset->resetLine(new \Losc\CucmBundle\Model\Webservice\StructType\ResetLineReq()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetH323Phone operation/method
 */
if ($reset->resetH323Phone(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetH323Trunk operation/method
 */
if ($reset->resetH323Trunk(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetPhone operation/method
 */
if ($reset->resetPhone(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetH323Gateway operation/method
 */
if ($reset->resetH323Gateway(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetGateway operation/method
 */
if ($reset->resetGateway(new \Losc\CucmBundle\Model\Webservice\StructType\ResetGatewayReq()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetCiscoCatalyst600024PortFXSGateway operation/method
 */
if ($reset->resetCiscoCatalyst600024PortFXSGateway(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetCiscoCatalyst6000E1VoIPGateway operation/method
 */
if ($reset->resetCiscoCatalyst6000E1VoIPGateway(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetCiscoCatalyst6000T1VoIPGatewayPri operation/method
 */
if ($reset->resetCiscoCatalyst6000T1VoIPGatewayPri(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetCiscoCatalyst6000T1VoIPGatewayT1 operation/method
 */
if ($reset->resetCiscoCatalyst6000T1VoIPGatewayT1(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetSipTrunk operation/method
 */
if ($reset->resetSipTrunk(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Samples for Wipe ServiceType
 */
$wipe = new \Losc\CucmBundle\Model\Webservice\ServiceType\Wipe($options);
/**
 * Sample call for wipePhone operation/method
 */
if ($wipe->wipePhone(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($wipe->getResult());
} else {
    print_r($wipe->getLastError());
}
/**
 * Samples for Lock ServiceType
 */
$lock = new \Losc\CucmBundle\Model\Webservice\ServiceType\Lock($options);
/**
 * Sample call for lockPhone operation/method
 */
if ($lock->lockPhone(new \Losc\CucmBundle\Model\Webservice\StructType\NameAndGUIDRequest()) !== false) {
    print_r($lock->getResult());
} else {
    print_r($lock->getLastError());
}
/**
 * Samples for Execute ServiceType
 */
$execute = new \Losc\CucmBundle\Model\Webservice\ServiceType\Execute($options);
/**
 * Sample call for executeSQLQuery operation/method
 */
if ($execute->executeSQLQuery(new \Losc\CucmBundle\Model\Webservice\StructType\ExecuteSQLQueryReq()) !== false) {
    print_r($execute->getResult());
} else {
    print_r($execute->getLastError());
}
/**
 * Sample call for executeSQLUpdate operation/method
 */
if ($execute->executeSQLUpdate(new \Losc\CucmBundle\Model\Webservice\StructType\ExecuteSQLUpdateReq()) !== false) {
    print_r($execute->getResult());
} else {
    print_r($execute->getLastError());
}
/**
 * Samples for Do ServiceType
 */
$do = new \Losc\CucmBundle\Model\Webservice\ServiceType\_Do($options);
/**
 * Sample call for doAuthenticateUser operation/method
 */
if ($do->doAuthenticateUser(new \Losc\CucmBundle\Model\Webservice\StructType\DoAuthenticateUserReq()) !== false) {
    print_r($do->getResult());
} else {
    print_r($do->getLastError());
}
/**
 * Sample call for doDeviceLogin operation/method
 */
if ($do->doDeviceLogin(new \Losc\CucmBundle\Model\Webservice\StructType\DoDeviceLoginReq()) !== false) {
    print_r($do->getResult());
} else {
    print_r($do->getLastError());
}
/**
 * Sample call for doDeviceLogout operation/method
 */
if ($do->doDeviceLogout(new \Losc\CucmBundle\Model\Webservice\StructType\DoDeviceLogoutReq()) !== false) {
    print_r($do->getResult());
} else {
    print_r($do->getLastError());
}
/**
 * Sample call for doDeviceReset operation/method
 */
if ($do->doDeviceReset(new \Losc\CucmBundle\Model\Webservice\StructType\DoDeviceResetReq()) !== false) {
    print_r($do->getResult());
} else {
    print_r($do->getLastError());
}
/**
 * Sample call for doLdapSync operation/method
 */
if ($do->doLdapSync(new \Losc\CucmBundle\Model\Webservice\StructType\DoLdapSyncReq()) !== false) {
    print_r($do->getResult());
} else {
    print_r($do->getLastError());
}
/**
 * Sample call for doUpdateRemoteCluster operation/method
 */
if ($do->doUpdateRemoteCluster(new \Losc\CucmBundle\Model\Webservice\StructType\DoUpdateRemoteClusterReq()) !== false) {
    print_r($do->getResult());
} else {
    print_r($do->getLastError());
}
/**
 * Sample call for doChangeDNDStatus operation/method
 */
if ($do->doChangeDNDStatus(new \Losc\CucmBundle\Model\Webservice\StructType\DoChangeDNDStatusReq()) !== false) {
    print_r($do->getResult());
} else {
    print_r($do->getLastError());
}
/**
 * Samples for Assign ServiceType
 */
$assign = new \Losc\CucmBundle\Model\Webservice\ServiceType\Assign($options);
/**
 * Sample call for assignPresenceUser operation/method
 */
if ($assign->assignPresenceUser(new \Losc\CucmBundle\Model\Webservice\StructType\AssignPresenceUserReq()) !== false) {
    print_r($assign->getResult());
} else {
    print_r($assign->getLastError());
}
/**
 * Samples for Unassign ServiceType
 */
$unassign = new \Losc\CucmBundle\Model\Webservice\ServiceType\Unassign($options);
/**
 * Sample call for unassignPresenceUser operation/method
 */
if ($unassign->unassignPresenceUser(new \Losc\CucmBundle\Model\Webservice\StructType\UnassignPresenceUserReq()) !== false) {
    print_r($unassign->getResult());
} else {
    print_r($unassign->getLastError());
}
